/* Application.c generated by valac 0.56.13, the Vala compiler
 * generated from Application.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>

enum  {
	HE_APPLICATION_0_PROPERTY,
	HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY,
	HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY,
	HE_APPLICATION_SCHEME_FACTORY_PROPERTY,
	HE_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* he_application_properties[HE_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _he_color_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_color_rgb_color_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeApplicationPrivate {
	HeDesktop* desktop;
	HeStyleManager* style_manager;
	HeColorRGBColor* _default_accent_color;
	gboolean _override_accent_color;
	HeSchemeFactory* _scheme_factory;
};

static gint HeApplication_private_offset;
static gpointer he_application_parent_class = NULL;

static void he_application_update_style_manager (HeApplication* self);
static void he_application_init_app_styles (HeApplication* self);
VALA_EXTERN void he_misc_init_css_provider_from_file (GtkCssProvider* provider,
                                          GFile* file);
static void he_application_real_startup (GApplication* base);
static void _he_application_update_style_manager_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
static void he_application_finalize (GObject * obj);
static GType he_application_get_type_once (void);
static void _vala_he_application_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_application_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
he_application_get_instance_private (HeApplication* self)
{
	return G_STRUCT_MEMBER_P (self, HeApplication_private_offset);
}

HeColorRGBColor*
he_application_get_default_accent_color (HeApplication* self)
{
	HeColorRGBColor* result;
	HeColorRGBColor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_accent_color;
	result = _tmp0_;
	return result;
}

static gpointer
_he_color_rgb_color_dup0 (gpointer self)
{
	return self ? he_color_rgb_color_dup (self) : NULL;
}

void
he_application_set_default_accent_color (HeApplication* self,
                                         HeColorRGBColor* value)
{
	HeColorRGBColor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _he_color_rgb_color_dup0 (value);
	_he_color_rgb_color_free0 (self->priv->_default_accent_color);
	self->priv->_default_accent_color = _tmp0_;
	he_application_update_style_manager (self);
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY]);
}

gboolean
he_application_get_override_accent_color (HeApplication* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_override_accent_color;
	return result;
}

void
he_application_set_override_accent_color (HeApplication* self,
                                          gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_override_accent_color = value;
	he_application_update_style_manager (self);
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY]);
}

HeSchemeFactory*
he_application_get_scheme_factory (HeApplication* self)
{
	HeSchemeFactory* result;
	HeSchemeFactory* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_scheme_factory;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
he_application_set_scheme_factory (HeApplication* self,
                                   HeSchemeFactory* value)
{
	HeSchemeFactory* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_scheme_factory);
	self->priv->_scheme_factory = _tmp0_;
	he_application_update_style_manager (self);
	g_object_notify_by_pspec ((GObject *) self, he_application_properties[HE_APPLICATION_SCHEME_FACTORY_PROPERTY]);
}

static void
he_application_update_style_manager (HeApplication* self)
{
	gboolean _tmp0_ = FALSE;
	HeColorRGBColor* _tmp1_;
	HeColorRGBColor* _tmp2_;
	HeSchemeFactory* _tmp21_;
	HeSchemeFactory* _tmp22_;
	HeStyleManager* _tmp32_;
	HeDesktop* _tmp33_;
	HeDesktopColorScheme _tmp34_;
	HeDesktopColorScheme _tmp35_;
	HeStyleManager* _tmp36_;
	HeDesktop* _tmp37_;
	HeDarkModeStrength _tmp38_;
	HeDarkModeStrength _tmp39_;
	HeStyleManager* _tmp40_;
	HeDesktop* _tmp41_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	HeStyleManager* _tmp44_;
	g_return_if_fail (self != NULL);
	_tmp1_ = he_application_get_default_accent_color (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp3_ = he_application_get_override_accent_color (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		HeStyleManager* _tmp5_;
		HeColorRGBColor* _tmp6_;
		HeColorRGBColor* _tmp7_;
		HeColorRGBColor* _tmp8_;
		_tmp5_ = self->priv->style_manager;
		_tmp6_ = he_application_get_default_accent_color (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = _he_color_rgb_color_dup0 (_tmp7_);
		_he_color_rgb_color_free0 (_tmp5_->accent_color);
		_tmp5_->accent_color = _tmp8_;
	} else {
		HeDesktop* _tmp9_;
		HeColorRGBColor* _tmp10_;
		HeColorRGBColor* _tmp11_;
		_tmp9_ = self->priv->desktop;
		_tmp10_ = he_desktop_get_accent_color (_tmp9_);
		_tmp11_ = _tmp10_;
		if (_tmp11_ != NULL) {
			HeStyleManager* _tmp12_;
			HeDesktop* _tmp13_;
			HeColorRGBColor* _tmp14_;
			HeColorRGBColor* _tmp15_;
			HeColorRGBColor* _tmp16_;
			_tmp12_ = self->priv->style_manager;
			_tmp13_ = self->priv->desktop;
			_tmp14_ = he_desktop_get_accent_color (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = _he_color_rgb_color_dup0 (_tmp15_);
			_he_color_rgb_color_free0 (_tmp12_->accent_color);
			_tmp12_->accent_color = _tmp16_;
		} else {
			HeStyleManager* _tmp17_;
			HeColorRGBColor* _tmp18_;
			HeColorRGBColor* _tmp19_;
			HeColorRGBColor* _tmp20_;
			_tmp17_ = self->priv->style_manager;
			_tmp18_ = he_application_get_default_accent_color (self);
			_tmp19_ = _tmp18_;
			_tmp20_ = _he_color_rgb_color_dup0 (_tmp19_);
			_he_color_rgb_color_free0 (_tmp17_->accent_color);
			_tmp17_->accent_color = _tmp20_;
		}
	}
	_tmp21_ = he_application_get_scheme_factory (self);
	_tmp22_ = _tmp21_;
	if (_tmp22_ != NULL) {
		HeStyleManager* _tmp23_;
		HeSchemeFactory* _tmp24_;
		HeSchemeFactory* _tmp25_;
		HeSchemeFactory* _tmp26_;
		_tmp23_ = self->priv->style_manager;
		_tmp24_ = he_application_get_scheme_factory (self);
		_tmp25_ = _tmp24_;
		_tmp26_ = _g_object_ref0 (_tmp25_);
		_g_object_unref0 (_tmp23_->scheme_factory);
		_tmp23_->scheme_factory = _tmp26_;
	} else {
		HeStyleManager* _tmp27_;
		HeDesktop* _tmp28_;
		HeDesktopEnsorScheme _tmp29_;
		HeDesktopEnsorScheme _tmp30_;
		HeSchemeFactory* _tmp31_;
		_tmp27_ = self->priv->style_manager;
		_tmp28_ = self->priv->desktop;
		_tmp29_ = he_desktop_get_ensor_scheme (_tmp28_);
		_tmp30_ = _tmp29_;
		_tmp31_ = he_desktop_ensor_scheme_to_factory (_tmp30_);
		_g_object_unref0 (_tmp27_->scheme_factory);
		_tmp27_->scheme_factory = _tmp31_;
	}
	_tmp32_ = self->priv->style_manager;
	_tmp33_ = self->priv->desktop;
	_tmp34_ = he_desktop_get_prefers_color_scheme (_tmp33_);
	_tmp35_ = _tmp34_;
	_tmp32_->is_dark = _tmp35_ == HE_DESKTOP_COLOR_SCHEME_DARK;
	_tmp36_ = self->priv->style_manager;
	_tmp37_ = self->priv->desktop;
	_tmp38_ = he_desktop_get_dark_mode_strength (_tmp37_);
	_tmp39_ = _tmp38_;
	_tmp36_->dark_mode_strength = _tmp39_;
	_tmp40_ = self->priv->style_manager;
	_tmp41_ = self->priv->desktop;
	_tmp42_ = he_desktop_get_font_weight (_tmp41_);
	_tmp43_ = _tmp42_;
	_tmp40_->font_weight = _tmp43_;
	_tmp44_ = self->priv->style_manager;
	he_style_manager_update (_tmp44_);
}

static void
he_application_init_app_styles (HeApplication* self)
{
	gchar* base_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* base_uri = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* base_file = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	HeStyleManager* _tmp7_;
	GtkCssProvider* _tmp8_;
	GtkCssProvider* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	HeStyleManager* _tmp13_;
	GtkCssProvider* _tmp14_;
	GtkCssProvider* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_application_get_resource_base_path ((GApplication*) self);
	_tmp1_ = g_strdup (_tmp0_);
	base_path = _tmp1_;
	_tmp2_ = base_path;
	if (_tmp2_ == NULL) {
		_g_free0 (base_path);
		return;
	}
	_tmp3_ = base_path;
	_tmp4_ = g_strconcat ("resource://", _tmp3_, NULL);
	base_uri = _tmp4_;
	_tmp5_ = base_uri;
	_tmp6_ = g_file_new_for_uri (_tmp5_);
	base_file = _tmp6_;
	_tmp7_ = self->priv->style_manager;
	_tmp8_ = he_style_manager_get_user_base (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = base_file;
	_tmp11_ = g_file_get_child (_tmp10_, "style.css");
	_tmp12_ = _tmp11_;
	he_misc_init_css_provider_from_file (_tmp9_, _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = self->priv->style_manager;
	_tmp14_ = he_style_manager_get_user_dark (_tmp13_);
	_tmp15_ = _tmp14_;
	_tmp16_ = base_file;
	_tmp17_ = g_file_get_child (_tmp16_, "style-dark.css");
	_tmp18_ = _tmp17_;
	he_misc_init_css_provider_from_file (_tmp15_, _tmp18_);
	_g_object_unref0 (_tmp18_);
	_g_object_unref0 (base_file);
	_g_free0 (base_uri);
	_g_free0 (base_path);
}

static void
_he_application_update_style_manager_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
	he_application_update_style_manager ((HeApplication*) self);
}

static void
he_application_real_startup (GApplication* base)
{
	HeApplication * self;
	HeDesktop* _tmp0_;
	HeDesktop* _tmp1_;
	HeDesktop* _tmp2_;
	HeDesktop* _tmp3_;
	HeDesktop* _tmp4_;
	HeStyleManager* _tmp5_;
	self = (HeApplication*) base;
	G_APPLICATION_CLASS (he_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
	he_init ();
	he_application_init_app_styles (self);
	he_application_update_style_manager (self);
	_tmp0_ = self->priv->desktop;
	g_signal_connect_object ((GObject*) _tmp0_, "notify::accent-color", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
	_tmp1_ = self->priv->desktop;
	g_signal_connect_object ((GObject*) _tmp1_, "notify::dark-mode-strength", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
	_tmp2_ = self->priv->desktop;
	g_signal_connect_object ((GObject*) _tmp2_, "notify::ensor-scheme", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
	_tmp3_ = self->priv->desktop;
	g_signal_connect_object ((GObject*) _tmp3_, "notify::font-weight", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
	_tmp4_ = self->priv->desktop;
	g_signal_connect_object ((GObject*) _tmp4_, "notify::prefers-color-scheme", (GCallback) _he_application_update_style_manager_g_object_notify, self, 0);
	_tmp5_ = self->priv->style_manager;
	he_style_manager_register (_tmp5_);
}

/**
   * Creates a new application.
   *
   * @param application_id The application ID in reverse domain name notation
   * @param flags The application flags, as defined in GIO.ApplicationFlags
   */
HeApplication*
he_application_construct (GType object_type,
                          const gchar* application_id,
                          GApplicationFlags flags)
{
	HeApplication * self = NULL;
	self = (HeApplication*) g_object_new (object_type, NULL);
	g_application_set_application_id ((GApplication*) self, application_id);
	g_application_set_flags ((GApplication*) self, flags);
	return self;
}

HeApplication*
he_application_new (const gchar* application_id,
                    GApplicationFlags flags)
{
	return he_application_construct (HE_TYPE_APPLICATION, application_id, flags);
}

static void
he_application_class_init (HeApplicationClass * klass,
                           gpointer klass_data)
{
	he_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeApplication_private_offset);
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) he_application_real_startup;
	G_OBJECT_CLASS (klass)->get_property = _vala_he_application_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_application_set_property;
	G_OBJECT_CLASS (klass)->finalize = he_application_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY, he_application_properties[HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("default-accent-color", "default-accent-color", "default-accent-color", HE_COLOR_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY, he_application_properties[HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY] = g_param_spec_boolean ("override-accent-color", "override-accent-color", "override-accent-color", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_SCHEME_FACTORY_PROPERTY, he_application_properties[HE_APPLICATION_SCHEME_FACTORY_PROPERTY] = g_param_spec_object ("scheme-factory", "scheme-factory", "scheme-factory", HE_TYPE_SCHEME_FACTORY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_application_instance_init (HeApplication * self,
                              gpointer klass)
{
	HeDesktop* _tmp0_;
	HeStyleManager* _tmp1_;
	self->priv = he_application_get_instance_private (self);
	_tmp0_ = he_desktop_new ();
	self->priv->desktop = _tmp0_;
	_tmp1_ = he_style_manager_new ();
	self->priv->style_manager = _tmp1_;
	self->priv->_default_accent_color = NULL;
	self->priv->_override_accent_color = FALSE;
	self->priv->_scheme_factory = NULL;
}

static void
he_application_finalize (GObject * obj)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_APPLICATION, HeApplication);
	_g_object_unref0 (self->priv->desktop);
	_g_object_unref0 (self->priv->style_manager);
	_he_color_rgb_color_free0 (self->priv->_default_accent_color);
	_g_object_unref0 (self->priv->_scheme_factory);
	G_OBJECT_CLASS (he_application_parent_class)->finalize (obj);
}

/**
* An application.
*/
static GType
he_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeApplication), 0, (GInstanceInitFunc) he_application_instance_init, NULL };
	GType he_application_type_id;
	he_application_type_id = g_type_register_static (gtk_application_get_type (), "HeApplication", &g_define_type_info, 0);
	HeApplication_private_offset = g_type_add_instance_private (he_application_type_id, sizeof (HeApplicationPrivate));
	return he_application_type_id;
}

GType
he_application_get_type (void)
{
	static volatile gsize he_application_type_id__once = 0;
	if (g_once_init_enter (&he_application_type_id__once)) {
		GType he_application_type_id;
		he_application_type_id = he_application_get_type_once ();
		g_once_init_leave (&he_application_type_id__once, he_application_type_id);
	}
	return he_application_type_id__once;
}

static void
_vala_he_application_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION, HeApplication);
	switch (property_id) {
		case HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY:
		{
			HeColorRGBColor* boxed;
			boxed = he_application_get_default_accent_color (self);
			g_value_set_boxed (value, boxed);
		}
		break;
		case HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY:
		g_value_set_boolean (value, he_application_get_override_accent_color (self));
		break;
		case HE_APPLICATION_SCHEME_FACTORY_PROPERTY:
		g_value_set_object (value, he_application_get_scheme_factory (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_application_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION, HeApplication);
	switch (property_id) {
		case HE_APPLICATION_DEFAULT_ACCENT_COLOR_PROPERTY:
		he_application_set_default_accent_color (self, g_value_get_boxed (value));
		break;
		case HE_APPLICATION_OVERRIDE_ACCENT_COLOR_PROPERTY:
		he_application_set_override_accent_color (self, g_value_get_boolean (value));
		break;
		case HE_APPLICATION_SCHEME_FACTORY_PROPERTY:
		he_application_set_scheme_factory (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

