/* Colors.c generated by valac 0.56.13, the Vala compiler
 * generated from Colors.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>

/**
 * An enum that maps colors to internal CSS classes as per HIG.
 */
/**
     * Returns the CSS class name for the color.
     */
gchar*
he_colors_to_css_class (HeColors self)
{
	gchar* result;
	switch (self) {
		case HE_COLORS_RED:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("meson-red");
			result = _tmp0_;
			return result;
		}
		case HE_COLORS_ORANGE:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("lepton-orange");
			result = _tmp1_;
			return result;
		}
		case HE_COLORS_YELLOW:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("electron-yellow");
			result = _tmp2_;
			return result;
		}
		case HE_COLORS_GREEN:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("muon-green");
			result = _tmp3_;
			return result;
		}
		case HE_COLORS_BLUE:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("proton-blue");
			result = _tmp4_;
			return result;
		}
		case HE_COLORS_INDIGO:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("photon-indigo");
			result = _tmp5_;
			return result;
		}
		case HE_COLORS_PURPLE:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("tau-purple");
			result = _tmp6_;
			return result;
		}
		case HE_COLORS_PINK:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("fermion-pink");
			result = _tmp7_;
			return result;
		}
		case HE_COLORS_MINT:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("baryon-mint");
			result = _tmp8_;
			return result;
		}
		case HE_COLORS_BROWN:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("gluon-brown");
			result = _tmp9_;
			return result;
		}
		case HE_COLORS_LIGHT:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup ("neutron-light");
			result = _tmp10_;
			return result;
		}
		case HE_COLORS_DARK:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup ("graviton-dark");
			result = _tmp11_;
			return result;
		}
		default:
		case HE_COLORS_NONE:
		{
			gchar* _tmp12_;
			_tmp12_ = g_strdup ("");
			result = _tmp12_;
			return result;
		}
	}
}

/**
     * Returns the color name.
     *
     * @since 1.0
     */
gchar*
he_colors_to_string (HeColors self)
{
	gchar* _tmp0_;
	gchar* result;
	_tmp0_ = he_colors_to_css_class (self);
	result = _tmp0_;
	return result;
}

static GType
he_colors_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_COLORS_NONE, "HE_COLORS_NONE", "none"}, {HE_COLORS_RED, "HE_COLORS_RED", "red"}, {HE_COLORS_ORANGE, "HE_COLORS_ORANGE", "orange"}, {HE_COLORS_YELLOW, "HE_COLORS_YELLOW", "yellow"}, {HE_COLORS_GREEN, "HE_COLORS_GREEN", "green"}, {HE_COLORS_BLUE, "HE_COLORS_BLUE", "blue"}, {HE_COLORS_INDIGO, "HE_COLORS_INDIGO", "indigo"}, {HE_COLORS_PURPLE, "HE_COLORS_PURPLE", "purple"}, {HE_COLORS_PINK, "HE_COLORS_PINK", "pink"}, {HE_COLORS_MINT, "HE_COLORS_MINT", "mint"}, {HE_COLORS_BROWN, "HE_COLORS_BROWN", "brown"}, {HE_COLORS_LIGHT, "HE_COLORS_LIGHT", "light"}, {HE_COLORS_DARK, "HE_COLORS_DARK", "dark"}, {0, NULL, NULL}};
	GType he_colors_type_id;
	he_colors_type_id = g_enum_register_static ("HeColors", values);
	return he_colors_type_id;
}

GType
he_colors_get_type (void)
{
	static volatile gsize he_colors_type_id__once = 0;
	if (g_once_init_enter (&he_colors_type_id__once)) {
		GType he_colors_type_id;
		he_colors_type_id = he_colors_get_type_once ();
		g_once_init_leave (&he_colors_type_id__once, he_colors_type_id);
	}
	return he_colors_type_id__once;
}

