/* StyleManager.c generated by valac 0.56.13, the Vala compiler
 * generated from StyleManager.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 1)
#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_ACCENT (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 2)
#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_BASE (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 3)
#define HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_DARK (GTK_STYLE_PROVIDER_PRIORITY_APPLICATION + 4)

enum  {
	HE_STYLE_MANAGER_0_PROPERTY,
	HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY,
	HE_STYLE_MANAGER_USER_BASE_PROPERTY,
	HE_STYLE_MANAGER_USER_DARK_PROPERTY,
	HE_STYLE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* he_style_manager_properties[HE_STYLE_MANAGER_NUM_PROPERTIES];
#define _he_color_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_color_rgb_color_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeStyleManagerPrivate {
	gboolean _is_registered;
	GtkCssProvider* light;
	GtkCssProvider* dark;
	GtkCssProvider* accent;
	GtkCssProvider* _user_base;
	GtkCssProvider* _user_dark;
};

static gint HeStyleManager_private_offset;
static gpointer he_style_manager_parent_class = NULL;

static void he_style_manager_set_is_registered (HeStyleManager* self,
                                         gboolean value);
VALA_EXTERN void he_misc_init_css_provider_from_string (GtkCssProvider* provider,
                                            const gchar* css);
VALA_EXTERN void he_misc_toggle_style_provider (GtkStyleProvider* provider,
                                    gboolean enabled,
                                    gint priority);
static void he_style_manager_finalize (GObject * obj);
static GType he_style_manager_get_type_once (void);
static void _vala_he_style_manager_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_he_style_manager_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

VALA_EXTERN const HeColorRGBColor HE_COLOR_DEFAULT_DARK_ACCENT;
VALA_EXTERN const HeColorRGBColor HE_COLOR_DEFAULT_LIGHT_ACCENT;
VALA_EXTERN const HeColorRGBColor HE_COLOR_CARD_BLACK;
VALA_EXTERN const HeColorRGBColor HE_COLOR_SOFT_CARD_BLACK;
VALA_EXTERN const HeColorRGBColor HE_COLOR_HARSH_CARD_BLACK;

static inline gpointer
he_style_manager_get_instance_private (HeStyleManager* self)
{
	return G_STRUCT_MEMBER_P (self, HeStyleManager_private_offset);
}

gboolean
he_style_manager_get_is_registered (HeStyleManager* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_registered;
	return result;
}

static void
he_style_manager_set_is_registered (HeStyleManager* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = he_style_manager_get_is_registered (self);
	if (old_value != value) {
		self->priv->_is_registered = value;
		g_object_notify_by_pspec ((GObject *) self, he_style_manager_properties[HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY]);
	}
}

GtkCssProvider*
he_style_manager_get_user_base (HeStyleManager* self)
{
	GtkCssProvider* result;
	GtkCssProvider* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user_base;
	result = _tmp0_;
	return result;
}

GtkCssProvider*
he_style_manager_get_user_dark (HeStyleManager* self)
{
	GtkCssProvider* result;
	GtkCssProvider* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user_dark;
	result = _tmp0_;
	return result;
}

/**
  * Runs all the necessary updates to apply the current style. If is_registered is false, this will do nothing.
  */
static gpointer
_he_color_rgb_color_dup0 (gpointer self)
{
	return self ? he_color_rgb_color_dup (self) : NULL;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
he_style_manager_update (HeStyleManager* self)
{
	gboolean _tmp0_;
	HeColorRGBColor* _tmp1_ = NULL;
	HeColorRGBColor* _tmp2_;
	HeColorRGBColor* rgb_color = NULL;
	HeColorRGBColor* _tmp5_;
	gdouble base_weight = 0.0;
	HeColorCAM16Color cam16_color = {0};
	HeColorRGBColor* _tmp6_;
	HeColorRGBColor _tmp7_;
	HeColorXYZColor _tmp8_ = {0};
	HeColorCAM16Color _tmp9_ = {0};
	HeColorRGBColor _tmp10_ = {0};
	HeColorRGBColor derived_card_bg = {0};
	gchar* bg_hex = NULL;
	HeColorRGBColor _tmp12_;
	HeColorRGBColor _tmp13_;
	HeColorRGBColor _tmp14_;
	gchar* _tmp15_;
	HeScheme chosen_scheme = {0};
	HeSchemeFactory* _tmp16_;
	HeColorCAM16Color _tmp17_;
	HeScheme _tmp18_ = {0};
	const gchar* _tmp19_ = NULL;
	gchar* error_hex = NULL;
	gchar* _tmp20_;
	const gchar* _tmp21_ = NULL;
	gchar* on_error_hex = NULL;
	gchar* _tmp22_;
	const gchar* _tmp23_ = NULL;
	gchar* error_container_hex = NULL;
	gchar* _tmp24_;
	const gchar* _tmp25_ = NULL;
	gchar* on_error_container_hex = NULL;
	gchar* _tmp26_;
	HeColorHCTColor _tmp27_ = {0};
	HeColorHCTColor meson_red_hct = {0};
	gchar* meson_red_hex = NULL;
	HeColorHCTColor _tmp38_;
	HeColorHCTColor _tmp39_;
	HeColorHCTColor _tmp40_;
	gchar* _tmp41_;
	HeColorHCTColor _tmp42_ = {0};
	HeColorHCTColor lepton_orange_hct = {0};
	gchar* lepton_orange_hex = NULL;
	HeColorHCTColor _tmp53_;
	HeColorHCTColor _tmp54_;
	HeColorHCTColor _tmp55_;
	gchar* _tmp56_;
	HeColorHCTColor _tmp57_ = {0};
	HeColorHCTColor electron_yellow_hct = {0};
	gchar* electron_yellow_hex = NULL;
	HeColorHCTColor _tmp68_;
	HeColorHCTColor _tmp69_;
	HeColorHCTColor _tmp70_;
	gchar* _tmp71_;
	HeColorHCTColor _tmp72_ = {0};
	HeColorHCTColor muon_green_hct = {0};
	gchar* muon_green_hex = NULL;
	HeColorHCTColor _tmp83_;
	HeColorHCTColor _tmp84_;
	HeColorHCTColor _tmp85_;
	gchar* _tmp86_;
	HeColorHCTColor _tmp87_ = {0};
	HeColorHCTColor baryon_mint_hct = {0};
	gchar* baryon_mint_hex = NULL;
	HeColorHCTColor _tmp98_;
	HeColorHCTColor _tmp99_;
	HeColorHCTColor _tmp100_;
	gchar* _tmp101_;
	HeColorHCTColor _tmp102_ = {0};
	HeColorHCTColor proton_blue_hct = {0};
	gchar* proton_blue_hex = NULL;
	HeColorHCTColor _tmp113_;
	HeColorHCTColor _tmp114_;
	HeColorHCTColor _tmp115_;
	gchar* _tmp116_;
	HeColorHCTColor _tmp117_ = {0};
	HeColorHCTColor photon_indigo_hct = {0};
	gchar* photon_indigo_hex = NULL;
	HeColorHCTColor _tmp128_;
	HeColorHCTColor _tmp129_;
	HeColorHCTColor _tmp130_;
	gchar* _tmp131_;
	HeColorHCTColor _tmp132_ = {0};
	HeColorHCTColor tau_purple_hct = {0};
	gchar* tau_purple_hex = NULL;
	HeColorHCTColor _tmp143_;
	HeColorHCTColor _tmp144_;
	HeColorHCTColor _tmp145_;
	gchar* _tmp146_;
	HeColorHCTColor _tmp147_ = {0};
	HeColorHCTColor fermion_pink_hct = {0};
	gchar* fermion_pink_hex = NULL;
	HeColorHCTColor _tmp158_;
	HeColorHCTColor _tmp159_;
	HeColorHCTColor _tmp160_;
	gchar* _tmp161_;
	HeColorHCTColor _tmp162_ = {0};
	HeColorHCTColor gluon_brown_hct = {0};
	gchar* gluon_brown_hex = NULL;
	HeColorHCTColor _tmp173_;
	HeColorHCTColor _tmp174_;
	HeColorHCTColor _tmp175_;
	gchar* _tmp176_;
	gchar* css = NULL;
	gchar* _tmp177_;
	const gchar* _tmp512_;
	const gchar* _tmp513_;
	const gchar* _tmp514_;
	const gchar* _tmp515_;
	const gchar* _tmp516_;
	const gchar* _tmp517_;
	const gchar* _tmp518_;
	const gchar* _tmp519_;
	const gchar* _tmp520_;
	const gchar* _tmp521_;
	const gchar* _tmp522_;
	const gchar* _tmp523_;
	const gchar* _tmp524_;
	const gchar* _tmp525_;
	const gchar* _tmp526_;
	const gchar* _tmp527_;
	const gchar* _tmp528_;
	const gchar* _tmp529_;
	const gchar* _tmp530_;
	const gchar* _tmp531_;
	const gchar* _tmp532_;
	gchar* _tmp533_;
	gchar* _tmp534_;
	gchar* _tmp535_;
	gdouble light_weight = 0.0;
	gdouble heavy_weight = 0.0;
	const gchar* _tmp536_;
	gchar* _tmp537_;
	gchar* _tmp538_;
	gchar* _tmp539_;
	gchar* _tmp540_;
	gchar* _tmp541_;
	gchar* _tmp542_;
	gchar* _tmp543_;
	gchar* _tmp544_;
	gchar* _tmp545_;
	gchar* _tmp546_;
	gchar* _tmp547_;
	gchar* _tmp548_;
	gchar* _tmp549_;
	gchar* _tmp550_;
	gchar* _tmp551_;
	gchar* _tmp552_;
	gchar* _tmp553_;
	gchar* _tmp554_;
	gchar* _tmp555_;
	gchar* _tmp556_;
	gchar* _tmp557_;
	gchar* _tmp558_;
	gchar* _tmp559_;
	gchar* _tmp560_;
	gchar* _tmp561_;
	gchar* _tmp562_;
	gchar* _tmp563_;
	gchar* _tmp564_;
	gchar* _tmp565_;
	gchar* _tmp566_;
	gchar* _tmp567_;
	gchar* _tmp568_;
	gchar* _tmp569_;
	gchar* _tmp570_;
	gchar* _tmp571_;
	gchar* _tmp572_;
	gchar* _tmp573_;
	gchar* _tmp574_;
	gchar* _tmp575_;
	gchar* _tmp576_;
	gchar* _tmp577_;
	gchar* _tmp578_;
	gchar* _tmp579_;
	GtkCssProvider* _tmp580_;
	const gchar* _tmp581_;
	GtkCssProvider* _tmp582_;
	GtkCssProvider* _tmp583_;
	GtkCssProvider* _tmp584_;
	GtkSettings* settings = NULL;
	GtkSettings* _tmp585_;
	GtkSettings* _tmp586_;
	GtkSettings* _tmp587_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_is_registered;
	if (!_tmp0_) {
		return;
	}
	_tmp2_ = self->accent_color;
	if (_tmp2_ != NULL) {
		HeColorRGBColor* _tmp3_;
		_tmp3_ = self->accent_color;
		_tmp1_ = _tmp3_;
	} else {
		HeColorRGBColor _tmp4_ = {0};
		if (self->is_dark) {
			_tmp4_ = HE_COLOR_DEFAULT_DARK_ACCENT;
		} else {
			_tmp4_ = HE_COLOR_DEFAULT_LIGHT_ACCENT;
		}
		_tmp1_ = &_tmp4_;
	}
	_tmp5_ = _he_color_rgb_color_dup0 (_tmp1_);
	rgb_color = _tmp5_;
	base_weight = 400 * self->font_weight;
	_tmp6_ = rgb_color;
	_tmp7_ = *_tmp6_;
	he_color_rgb_to_xyz (&_tmp7_, &_tmp8_);
	he_color_xyz_to_cam16 (&_tmp8_, &_tmp9_);
	cam16_color = _tmp9_;
	if (self->dark_mode_strength == HE_DARK_MODE_STRENGTH_MEDIUM) {
		_tmp10_ = HE_COLOR_CARD_BLACK;
	} else {
		HeColorRGBColor _tmp11_ = {0};
		if (self->dark_mode_strength == HE_DARK_MODE_STRENGTH_SOFT) {
			_tmp11_ = HE_COLOR_SOFT_CARD_BLACK;
		} else {
			_tmp11_ = HE_COLOR_HARSH_CARD_BLACK;
		}
		_tmp10_ = _tmp11_;
	}
	derived_card_bg = _tmp10_;
	_tmp12_ = derived_card_bg;
	_tmp13_ = derived_card_bg;
	_tmp14_ = derived_card_bg;
	_tmp15_ = he_color_hexcode (_tmp12_.r, _tmp13_.g, _tmp14_.b);
	bg_hex = _tmp15_;
	_tmp16_ = self->scheme_factory;
	_tmp17_ = cam16_color;
	he_scheme_factory_generate (_tmp16_, &_tmp17_, self->is_dark, &_tmp18_);
	chosen_scheme = _tmp18_;
	if (self->is_dark) {
		_tmp19_ = "#F2B8B5";
	} else {
		_tmp19_ = "#B3261E";
	}
	_tmp20_ = g_strdup (_tmp19_);
	error_hex = _tmp20_;
	if (self->is_dark) {
		_tmp21_ = "#601410";
	} else {
		_tmp21_ = "#FFFFFF";
	}
	_tmp22_ = g_strdup (_tmp21_);
	on_error_hex = _tmp22_;
	if (self->is_dark) {
		_tmp23_ = "#410E0B";
	} else {
		_tmp23_ = "#F9DEDC";
	}
	_tmp24_ = g_strdup (_tmp23_);
	error_container_hex = _tmp24_;
	if (self->is_dark) {
		_tmp25_ = "#F9DEDC";
	} else {
		_tmp25_ = "#8C1D18";
	}
	_tmp26_ = g_strdup (_tmp25_);
	on_error_container_hex = _tmp26_;
	if (self->is_dark) {
		HeColorHCTColor _tmp28_ = {0};
		HeColorCAM16Color _tmp29_;
		HeColorCAM16Color _tmp30_;
		HeColorHCTColor _tmp31_ = {0};
		HeColorHCTColor _tmp32_ = {0};
		he_color_from_params (8.0, 85.0, 80.0, &_tmp28_);
		_tmp29_ = cam16_color;
		_tmp30_ = cam16_color;
		he_color_from_params (_tmp29_.h, _tmp30_.c, 80.0, &_tmp31_);
		he_color_hct_blend (&_tmp28_, &_tmp31_, &_tmp32_);
		_tmp27_ = _tmp32_;
	} else {
		HeColorHCTColor _tmp33_ = {0};
		HeColorCAM16Color _tmp34_;
		HeColorCAM16Color _tmp35_;
		HeColorHCTColor _tmp36_ = {0};
		HeColorHCTColor _tmp37_ = {0};
		he_color_from_params (2.0, 49.0, 40.0, &_tmp33_);
		_tmp34_ = cam16_color;
		_tmp35_ = cam16_color;
		he_color_from_params (_tmp34_.h, _tmp35_.c, 40.0, &_tmp36_);
		he_color_hct_blend (&_tmp33_, &_tmp36_, &_tmp37_);
		_tmp27_ = _tmp37_;
	}
	meson_red_hct = _tmp27_;
	_tmp38_ = meson_red_hct;
	_tmp39_ = meson_red_hct;
	_tmp40_ = meson_red_hct;
	_tmp41_ = he_color_hct_to_hex (_tmp38_.h, _tmp39_.c, _tmp40_.t);
	meson_red_hex = _tmp41_;
	if (self->is_dark) {
		HeColorHCTColor _tmp43_ = {0};
		HeColorCAM16Color _tmp44_;
		HeColorCAM16Color _tmp45_;
		HeColorHCTColor _tmp46_ = {0};
		HeColorHCTColor _tmp47_ = {0};
		he_color_from_params (55.0, 29.0, 80.0, &_tmp43_);
		_tmp44_ = cam16_color;
		_tmp45_ = cam16_color;
		he_color_from_params (_tmp44_.h, _tmp45_.c, 80.0, &_tmp46_);
		he_color_hct_blend (&_tmp43_, &_tmp46_, &_tmp47_);
		_tmp42_ = _tmp47_;
	} else {
		HeColorHCTColor _tmp48_ = {0};
		HeColorCAM16Color _tmp49_;
		HeColorCAM16Color _tmp50_;
		HeColorHCTColor _tmp51_ = {0};
		HeColorHCTColor _tmp52_ = {0};
		he_color_from_params (50.0, 61.0, 40.0, &_tmp48_);
		_tmp49_ = cam16_color;
		_tmp50_ = cam16_color;
		he_color_from_params (_tmp49_.h, _tmp50_.c, 40.0, &_tmp51_);
		he_color_hct_blend (&_tmp48_, &_tmp51_, &_tmp52_);
		_tmp42_ = _tmp52_;
	}
	lepton_orange_hct = _tmp42_;
	_tmp53_ = lepton_orange_hct;
	_tmp54_ = lepton_orange_hct;
	_tmp55_ = lepton_orange_hct;
	_tmp56_ = he_color_hct_to_hex (_tmp53_.h, _tmp54_.c, _tmp55_.t);
	lepton_orange_hex = _tmp56_;
	if (self->is_dark) {
		HeColorHCTColor _tmp58_ = {0};
		HeColorCAM16Color _tmp59_;
		HeColorCAM16Color _tmp60_;
		HeColorHCTColor _tmp61_ = {0};
		HeColorHCTColor _tmp62_ = {0};
		he_color_from_params (89.0, 37.0, 80.0, &_tmp58_);
		_tmp59_ = cam16_color;
		_tmp60_ = cam16_color;
		he_color_from_params (_tmp59_.h, _tmp60_.c, 80.0, &_tmp61_);
		he_color_hct_blend (&_tmp58_, &_tmp61_, &_tmp62_);
		_tmp57_ = _tmp62_;
	} else {
		HeColorHCTColor _tmp63_ = {0};
		HeColorCAM16Color _tmp64_;
		HeColorCAM16Color _tmp65_;
		HeColorHCTColor _tmp66_ = {0};
		HeColorHCTColor _tmp67_ = {0};
		he_color_from_params (81.0, 55.0, 40.0, &_tmp63_);
		_tmp64_ = cam16_color;
		_tmp65_ = cam16_color;
		he_color_from_params (_tmp64_.h, _tmp65_.c, 40.0, &_tmp66_);
		he_color_hct_blend (&_tmp63_, &_tmp66_, &_tmp67_);
		_tmp57_ = _tmp67_;
	}
	electron_yellow_hct = _tmp57_;
	_tmp68_ = electron_yellow_hct;
	_tmp69_ = electron_yellow_hct;
	_tmp70_ = electron_yellow_hct;
	_tmp71_ = he_color_hct_to_hex (_tmp68_.h, _tmp69_.c, _tmp70_.t);
	electron_yellow_hex = _tmp71_;
	if (self->is_dark) {
		HeColorHCTColor _tmp73_ = {0};
		HeColorCAM16Color _tmp74_;
		HeColorCAM16Color _tmp75_;
		HeColorHCTColor _tmp76_ = {0};
		HeColorHCTColor _tmp77_ = {0};
		he_color_from_params (152.0, 43.0, 80.0, &_tmp73_);
		_tmp74_ = cam16_color;
		_tmp75_ = cam16_color;
		he_color_from_params (_tmp74_.h, _tmp75_.c, 80.0, &_tmp76_);
		he_color_hct_blend (&_tmp73_, &_tmp76_, &_tmp77_);
		_tmp72_ = _tmp77_;
	} else {
		HeColorHCTColor _tmp78_ = {0};
		HeColorCAM16Color _tmp79_;
		HeColorCAM16Color _tmp80_;
		HeColorHCTColor _tmp81_ = {0};
		HeColorHCTColor _tmp82_ = {0};
		he_color_from_params (147.0, 71.0, 40.0, &_tmp78_);
		_tmp79_ = cam16_color;
		_tmp80_ = cam16_color;
		he_color_from_params (_tmp79_.h, _tmp80_.c, 40.0, &_tmp81_);
		he_color_hct_blend (&_tmp78_, &_tmp81_, &_tmp82_);
		_tmp72_ = _tmp82_;
	}
	muon_green_hct = _tmp72_;
	_tmp83_ = muon_green_hct;
	_tmp84_ = muon_green_hct;
	_tmp85_ = muon_green_hct;
	_tmp86_ = he_color_hct_to_hex (_tmp83_.h, _tmp84_.c, _tmp85_.t);
	muon_green_hex = _tmp86_;
	if (self->is_dark) {
		HeColorHCTColor _tmp88_ = {0};
		HeColorCAM16Color _tmp89_;
		HeColorCAM16Color _tmp90_;
		HeColorHCTColor _tmp91_ = {0};
		HeColorHCTColor _tmp92_ = {0};
		he_color_from_params (182.0, 25.0, 80.0, &_tmp88_);
		_tmp89_ = cam16_color;
		_tmp90_ = cam16_color;
		he_color_from_params (_tmp89_.h, _tmp90_.c, 80.0, &_tmp91_);
		he_color_hct_blend (&_tmp88_, &_tmp91_, &_tmp92_);
		_tmp87_ = _tmp92_;
	} else {
		HeColorHCTColor _tmp93_ = {0};
		HeColorCAM16Color _tmp94_;
		HeColorCAM16Color _tmp95_;
		HeColorHCTColor _tmp96_ = {0};
		HeColorHCTColor _tmp97_ = {0};
		he_color_from_params (177.0, 42.0, 40.0, &_tmp93_);
		_tmp94_ = cam16_color;
		_tmp95_ = cam16_color;
		he_color_from_params (_tmp94_.h, _tmp95_.c, 40.0, &_tmp96_);
		he_color_hct_blend (&_tmp93_, &_tmp96_, &_tmp97_);
		_tmp87_ = _tmp97_;
	}
	baryon_mint_hct = _tmp87_;
	_tmp98_ = baryon_mint_hct;
	_tmp99_ = baryon_mint_hct;
	_tmp100_ = baryon_mint_hct;
	_tmp101_ = he_color_hct_to_hex (_tmp98_.h, _tmp99_.c, _tmp100_.t);
	baryon_mint_hex = _tmp101_;
	if (self->is_dark) {
		HeColorHCTColor _tmp103_ = {0};
		HeColorCAM16Color _tmp104_;
		HeColorCAM16Color _tmp105_;
		HeColorHCTColor _tmp106_ = {0};
		HeColorHCTColor _tmp107_ = {0};
		he_color_from_params (233.0, 34.0, 80.0, &_tmp103_);
		_tmp104_ = cam16_color;
		_tmp105_ = cam16_color;
		he_color_from_params (_tmp104_.h, _tmp105_.c, 80.0, &_tmp106_);
		he_color_hct_blend (&_tmp103_, &_tmp106_, &_tmp107_);
		_tmp102_ = _tmp107_;
	} else {
		HeColorHCTColor _tmp108_ = {0};
		HeColorCAM16Color _tmp109_;
		HeColorCAM16Color _tmp110_;
		HeColorHCTColor _tmp111_ = {0};
		HeColorHCTColor _tmp112_ = {0};
		he_color_from_params (240.0, 53.0, 40.0, &_tmp108_);
		_tmp109_ = cam16_color;
		_tmp110_ = cam16_color;
		he_color_from_params (_tmp109_.h, _tmp110_.c, 40.0, &_tmp111_);
		he_color_hct_blend (&_tmp108_, &_tmp111_, &_tmp112_);
		_tmp102_ = _tmp112_;
	}
	proton_blue_hct = _tmp102_;
	_tmp113_ = proton_blue_hct;
	_tmp114_ = proton_blue_hct;
	_tmp115_ = proton_blue_hct;
	_tmp116_ = he_color_hct_to_hex (_tmp113_.h, _tmp114_.c, _tmp115_.t);
	proton_blue_hex = _tmp116_;
	if (self->is_dark) {
		HeColorHCTColor _tmp118_ = {0};
		HeColorCAM16Color _tmp119_;
		HeColorCAM16Color _tmp120_;
		HeColorHCTColor _tmp121_ = {0};
		HeColorHCTColor _tmp122_ = {0};
		he_color_from_params (291.0, 67.0, 80.0, &_tmp118_);
		_tmp119_ = cam16_color;
		_tmp120_ = cam16_color;
		he_color_from_params (_tmp119_.h, _tmp120_.c, 80.0, &_tmp121_);
		he_color_hct_blend (&_tmp118_, &_tmp121_, &_tmp122_);
		_tmp117_ = _tmp122_;
	} else {
		HeColorHCTColor _tmp123_ = {0};
		HeColorCAM16Color _tmp124_;
		HeColorCAM16Color _tmp125_;
		HeColorHCTColor _tmp126_ = {0};
		HeColorHCTColor _tmp127_ = {0};
		he_color_from_params (288.0, 84.0, 40.0, &_tmp123_);
		_tmp124_ = cam16_color;
		_tmp125_ = cam16_color;
		he_color_from_params (_tmp124_.h, _tmp125_.c, 40.0, &_tmp126_);
		he_color_hct_blend (&_tmp123_, &_tmp126_, &_tmp127_);
		_tmp117_ = _tmp127_;
	}
	photon_indigo_hct = _tmp117_;
	_tmp128_ = photon_indigo_hct;
	_tmp129_ = photon_indigo_hct;
	_tmp130_ = photon_indigo_hct;
	_tmp131_ = he_color_hct_to_hex (_tmp128_.h, _tmp129_.c, _tmp130_.t);
	photon_indigo_hex = _tmp131_;
	if (self->is_dark) {
		HeColorHCTColor _tmp133_ = {0};
		HeColorCAM16Color _tmp134_;
		HeColorCAM16Color _tmp135_;
		HeColorHCTColor _tmp136_ = {0};
		HeColorHCTColor _tmp137_ = {0};
		he_color_from_params (309.0, 34.0, 80.0, &_tmp133_);
		_tmp134_ = cam16_color;
		_tmp135_ = cam16_color;
		he_color_from_params (_tmp134_.h, _tmp135_.c, 80.0, &_tmp136_);
		he_color_hct_blend (&_tmp133_, &_tmp136_, &_tmp137_);
		_tmp132_ = _tmp137_;
	} else {
		HeColorHCTColor _tmp138_ = {0};
		HeColorCAM16Color _tmp139_;
		HeColorCAM16Color _tmp140_;
		HeColorHCTColor _tmp141_ = {0};
		HeColorHCTColor _tmp142_ = {0};
		he_color_from_params (311.0, 57.0, 40.0, &_tmp138_);
		_tmp139_ = cam16_color;
		_tmp140_ = cam16_color;
		he_color_from_params (_tmp139_.h, _tmp140_.c, 40.0, &_tmp141_);
		he_color_hct_blend (&_tmp138_, &_tmp141_, &_tmp142_);
		_tmp132_ = _tmp142_;
	}
	tau_purple_hct = _tmp132_;
	_tmp143_ = tau_purple_hct;
	_tmp144_ = tau_purple_hct;
	_tmp145_ = tau_purple_hct;
	_tmp146_ = he_color_hct_to_hex (_tmp143_.h, _tmp144_.c, _tmp145_.t);
	tau_purple_hex = _tmp146_;
	if (self->is_dark) {
		HeColorHCTColor _tmp148_ = {0};
		HeColorCAM16Color _tmp149_;
		HeColorCAM16Color _tmp150_;
		HeColorHCTColor _tmp151_ = {0};
		HeColorHCTColor _tmp152_ = {0};
		he_color_from_params (337.0, 34.0, 80.0, &_tmp148_);
		_tmp149_ = cam16_color;
		_tmp150_ = cam16_color;
		he_color_from_params (_tmp149_.h, _tmp150_.c, 80.0, &_tmp151_);
		he_color_hct_blend (&_tmp148_, &_tmp151_, &_tmp152_);
		_tmp147_ = _tmp152_;
	} else {
		HeColorHCTColor _tmp153_ = {0};
		HeColorCAM16Color _tmp154_;
		HeColorCAM16Color _tmp155_;
		HeColorHCTColor _tmp156_ = {0};
		HeColorHCTColor _tmp157_ = {0};
		he_color_from_params (340.0, 60.0, 40.0, &_tmp153_);
		_tmp154_ = cam16_color;
		_tmp155_ = cam16_color;
		he_color_from_params (_tmp154_.h, _tmp155_.c, 40.0, &_tmp156_);
		he_color_hct_blend (&_tmp153_, &_tmp156_, &_tmp157_);
		_tmp147_ = _tmp157_;
	}
	fermion_pink_hct = _tmp147_;
	_tmp158_ = fermion_pink_hct;
	_tmp159_ = fermion_pink_hct;
	_tmp160_ = fermion_pink_hct;
	_tmp161_ = he_color_hct_to_hex (_tmp158_.h, _tmp159_.c, _tmp160_.t);
	fermion_pink_hex = _tmp161_;
	if (self->is_dark) {
		HeColorHCTColor _tmp163_ = {0};
		HeColorCAM16Color _tmp164_;
		HeColorCAM16Color _tmp165_;
		HeColorHCTColor _tmp166_ = {0};
		HeColorHCTColor _tmp167_ = {0};
		he_color_from_params (66.0, 12.0, 80.0, &_tmp163_);
		_tmp164_ = cam16_color;
		_tmp165_ = cam16_color;
		he_color_from_params (_tmp164_.h, _tmp165_.c, 80.0, &_tmp166_);
		he_color_hct_blend (&_tmp163_, &_tmp166_, &_tmp167_);
		_tmp162_ = _tmp167_;
	} else {
		HeColorHCTColor _tmp168_ = {0};
		HeColorCAM16Color _tmp169_;
		HeColorCAM16Color _tmp170_;
		HeColorHCTColor _tmp171_ = {0};
		HeColorHCTColor _tmp172_ = {0};
		he_color_from_params (61.0, 30.0, 40.0, &_tmp168_);
		_tmp169_ = cam16_color;
		_tmp170_ = cam16_color;
		he_color_from_params (_tmp169_.h, _tmp170_.c, 40.0, &_tmp171_);
		he_color_hct_blend (&_tmp168_, &_tmp171_, &_tmp172_);
		_tmp162_ = _tmp172_;
	}
	gluon_brown_hct = _tmp162_;
	_tmp173_ = gluon_brown_hct;
	_tmp174_ = gluon_brown_hct;
	_tmp175_ = gluon_brown_hct;
	_tmp176_ = he_color_hct_to_hex (_tmp173_.h, _tmp174_.c, _tmp175_.t);
	gluon_brown_hex = _tmp176_;
	_tmp177_ = g_strdup ("");
	css = _tmp177_;
	if (self->is_dark) {
		HeScheme _tmp178_;
		const gchar* _tmp179_;
		const gchar* _tmp180_;
		HeScheme _tmp181_;
		const gchar* _tmp182_;
		const gchar* _tmp183_;
		HeScheme _tmp184_;
		const gchar* _tmp185_;
		const gchar* _tmp186_;
		HeScheme _tmp187_;
		const gchar* _tmp188_;
		const gchar* _tmp189_;
		HeScheme _tmp190_;
		const gchar* _tmp191_;
		const gchar* _tmp192_;
		HeScheme _tmp193_;
		const gchar* _tmp194_;
		const gchar* _tmp195_;
		HeScheme _tmp196_;
		const gchar* _tmp197_;
		const gchar* _tmp198_;
		const gchar* _tmp199_;
		const gchar* _tmp200_;
		HeScheme _tmp201_;
		const gchar* _tmp202_;
		const gchar* _tmp203_;
		const gchar* _tmp204_;
		const gchar* _tmp205_;
		HeScheme _tmp206_;
		const gchar* _tmp207_;
		const gchar* _tmp208_;
		const gchar* _tmp209_;
		const gchar* _tmp210_;
		HeScheme _tmp211_;
		const gchar* _tmp212_;
		const gchar* _tmp213_;
		const gchar* _tmp214_;
		const gchar* _tmp215_;
		HeScheme _tmp216_;
		const gchar* _tmp217_;
		const gchar* _tmp218_;
		const gchar* _tmp219_;
		const gchar* _tmp220_;
		HeScheme _tmp221_;
		const gchar* _tmp222_;
		const gchar* _tmp223_;
		HeScheme _tmp224_;
		const gchar* _tmp225_;
		const gchar* _tmp226_;
		HeScheme _tmp227_;
		const gchar* _tmp228_;
		const gchar* _tmp229_;
		HeScheme _tmp230_;
		const gchar* _tmp231_;
		const gchar* _tmp232_;
		HeScheme _tmp233_;
		const gchar* _tmp234_;
		const gchar* _tmp235_;
		HeScheme _tmp236_;
		const gchar* _tmp237_;
		const gchar* _tmp238_;
		HeScheme _tmp239_;
		const gchar* _tmp240_;
		const gchar* _tmp241_;
		HeScheme _tmp242_;
		const gchar* _tmp243_;
		const gchar* _tmp244_;
		HeScheme _tmp245_;
		const gchar* _tmp246_;
		const gchar* _tmp247_;
		HeScheme _tmp248_;
		const gchar* _tmp249_;
		const gchar* _tmp250_;
		HeScheme _tmp251_;
		const gchar* _tmp252_;
		const gchar* _tmp253_;
		HeScheme _tmp254_;
		const gchar* _tmp255_;
		const gchar* _tmp256_;
		HeScheme _tmp257_;
		const gchar* _tmp258_;
		const gchar* _tmp259_;
		gchar* _tmp260_;
		const gchar* _tmp261_;
		const gchar* _tmp262_;
		const gchar* _tmp263_;
		const gchar* _tmp264_;
		const gchar* _tmp265_;
		const gchar* _tmp266_;
		const gchar* _tmp267_;
		const gchar* _tmp268_;
		const gchar* _tmp269_;
		const gchar* _tmp270_;
		const gchar* _tmp271_;
		const gchar* _tmp272_;
		const gchar* _tmp273_;
		HeScheme _tmp274_;
		const gchar* _tmp275_;
		const gchar* _tmp276_;
		HeScheme _tmp277_;
		const gchar* _tmp278_;
		const gchar* _tmp279_;
		HeScheme _tmp280_;
		const gchar* _tmp281_;
		const gchar* _tmp282_;
		HeScheme _tmp283_;
		const gchar* _tmp284_;
		const gchar* _tmp285_;
		HeScheme _tmp286_;
		const gchar* _tmp287_;
		const gchar* _tmp288_;
		HeScheme _tmp289_;
		const gchar* _tmp290_;
		const gchar* _tmp291_;
		const gchar* _tmp292_;
		const gchar* _tmp293_;
		const gchar* _tmp294_;
		const gchar* _tmp295_;
		const gchar* _tmp296_;
		const gchar* _tmp297_;
		const gchar* _tmp298_;
		const gchar* _tmp299_;
		const gchar* _tmp300_;
		const gchar* _tmp301_;
		const gchar* _tmp302_;
		const gchar* _tmp303_;
		HeScheme _tmp304_;
		const gchar* _tmp305_;
		const gchar* _tmp306_;
		HeScheme _tmp307_;
		const gchar* _tmp308_;
		const gchar* _tmp309_;
		HeScheme _tmp310_;
		const gchar* _tmp311_;
		const gchar* _tmp312_;
		HeScheme _tmp313_;
		const gchar* _tmp314_;
		const gchar* _tmp315_;
		HeScheme _tmp316_;
		const gchar* _tmp317_;
		const gchar* _tmp318_;
		gchar* _tmp319_;
		gchar* _tmp320_;
		gchar* _tmp321_;
		const gchar* _tmp322_;
		HeScheme _tmp323_;
		const gchar* _tmp324_;
		const gchar* _tmp325_;
		HeScheme _tmp326_;
		const gchar* _tmp327_;
		const gchar* _tmp328_;
		HeScheme _tmp329_;
		const gchar* _tmp330_;
		const gchar* _tmp331_;
		HeScheme _tmp332_;
		const gchar* _tmp333_;
		const gchar* _tmp334_;
		HeScheme _tmp335_;
		const gchar* _tmp336_;
		const gchar* _tmp337_;
		HeScheme _tmp338_;
		const gchar* _tmp339_;
		const gchar* _tmp340_;
		HeScheme _tmp341_;
		const gchar* _tmp342_;
		const gchar* _tmp343_;
		HeScheme _tmp344_;
		const gchar* _tmp345_;
		const gchar* _tmp346_;
		gchar* _tmp347_;
		gchar* _tmp348_;
		gchar* _tmp349_;
		_tmp178_ = chosen_scheme;
		_tmp179_ = _tmp178_.primary_hex;
		_tmp180_ = string_to_string (_tmp179_);
		_tmp181_ = chosen_scheme;
		_tmp182_ = _tmp181_.primary_hex;
		_tmp183_ = string_to_string (_tmp182_);
		_tmp184_ = chosen_scheme;
		_tmp185_ = _tmp184_.on_primary_hex;
		_tmp186_ = string_to_string (_tmp185_);
		_tmp187_ = chosen_scheme;
		_tmp188_ = _tmp187_.primary_container_hex;
		_tmp189_ = string_to_string (_tmp188_);
		_tmp190_ = chosen_scheme;
		_tmp191_ = _tmp190_.primary_container_hex;
		_tmp192_ = string_to_string (_tmp191_);
		_tmp193_ = chosen_scheme;
		_tmp194_ = _tmp193_.on_primary_container_hex;
		_tmp195_ = string_to_string (_tmp194_);
		_tmp196_ = chosen_scheme;
		_tmp197_ = _tmp196_.surface_bg_hex;
		_tmp198_ = string_to_string (_tmp197_);
		_tmp199_ = bg_hex;
		_tmp200_ = string_to_string (_tmp199_);
		_tmp201_ = chosen_scheme;
		_tmp202_ = _tmp201_.surface_bg_hex;
		_tmp203_ = string_to_string (_tmp202_);
		_tmp204_ = bg_hex;
		_tmp205_ = string_to_string (_tmp204_);
		_tmp206_ = chosen_scheme;
		_tmp207_ = _tmp206_.surface_bg_variant_hex;
		_tmp208_ = string_to_string (_tmp207_);
		_tmp209_ = bg_hex;
		_tmp210_ = string_to_string (_tmp209_);
		_tmp211_ = chosen_scheme;
		_tmp212_ = _tmp211_.surface_container_high_bg_hex;
		_tmp213_ = string_to_string (_tmp212_);
		_tmp214_ = bg_hex;
		_tmp215_ = string_to_string (_tmp214_);
		_tmp216_ = chosen_scheme;
		_tmp217_ = _tmp216_.surface_container_bg_hex;
		_tmp218_ = string_to_string (_tmp217_);
		_tmp219_ = bg_hex;
		_tmp220_ = string_to_string (_tmp219_);
		_tmp221_ = chosen_scheme;
		_tmp222_ = _tmp221_.surface_fg_hex;
		_tmp223_ = string_to_string (_tmp222_);
		_tmp224_ = chosen_scheme;
		_tmp225_ = _tmp224_.surface_fg_variant_hex;
		_tmp226_ = string_to_string (_tmp225_);
		_tmp227_ = chosen_scheme;
		_tmp228_ = _tmp227_.surface_fg_variant_hex;
		_tmp229_ = string_to_string (_tmp228_);
		_tmp230_ = chosen_scheme;
		_tmp231_ = _tmp230_.surface_fg_hex;
		_tmp232_ = string_to_string (_tmp231_);
		_tmp233_ = chosen_scheme;
		_tmp234_ = _tmp233_.surface_fg_hex;
		_tmp235_ = string_to_string (_tmp234_);
		_tmp236_ = chosen_scheme;
		_tmp237_ = _tmp236_.surface_bright_bg_hex;
		_tmp238_ = string_to_string (_tmp237_);
		_tmp239_ = chosen_scheme;
		_tmp240_ = _tmp239_.surface_bg_hex;
		_tmp241_ = string_to_string (_tmp240_);
		_tmp242_ = chosen_scheme;
		_tmp243_ = _tmp242_.surface_dim_bg_hex;
		_tmp244_ = string_to_string (_tmp243_);
		_tmp245_ = chosen_scheme;
		_tmp246_ = _tmp245_.surface_container_lowest_bg_hex;
		_tmp247_ = string_to_string (_tmp246_);
		_tmp248_ = chosen_scheme;
		_tmp249_ = _tmp248_.surface_container_low_bg_hex;
		_tmp250_ = string_to_string (_tmp249_);
		_tmp251_ = chosen_scheme;
		_tmp252_ = _tmp251_.surface_container_bg_hex;
		_tmp253_ = string_to_string (_tmp252_);
		_tmp254_ = chosen_scheme;
		_tmp255_ = _tmp254_.surface_container_high_bg_hex;
		_tmp256_ = string_to_string (_tmp255_);
		_tmp257_ = chosen_scheme;
		_tmp258_ = _tmp257_.surface_container_highest_bg_hex;
		_tmp259_ = string_to_string (_tmp258_);
		_tmp260_ = g_strconcat ("\n      @define-color accent_color ", _tmp180_, ";\n      @define-color accent_bg_color ", _tmp183_, ";\n      @define-color accent_fg_color ", _tmp186_, ";\n      @define-color accent_container_color ", _tmp189_, ";\n      @define-color accent_container_bg_color ", _tmp192_, ";\n      @define-color accent_container_fg_color ", _tmp195_, ";\n\n      @define-color window_bg_color mix(", _tmp198_, ", ", _tmp200_, ", 0.50);\n      @define-color view_bg_color mix(", _tmp203_, ", ", _tmp205_, ", 0.30);\n      @define-color headerbar_bg_color mix(", _tmp208_, ", ", _tmp210_, ", 0.50);\n      @define-color popover_bg_color mix(", _tmp213_, ", ", _tmp215_, ", 0.20);\n      @define-color card_bg_color mix(", _tmp218_, ", ", _tmp220_, ", 0.30);\n      @define-color window_fg_color ", _tmp223_, ";\n      @define-color view_fg_color ", _tmp226_, ";\n      @define-color headerbar_fg_color ", _tmp229_, ";\n      @define-color popover_fg_color ", _tmp232_, ";\n      @define-color card_fg_color ", _tmp235_, ";\n\n      @define-color surface_bright_bg_color ", _tmp238_, ";\n      @define-color surface_bg_color ", _tmp241_, ";\n      @define-color surface_dim_bg_color ", _tmp244_, ";\n      @define-color surface_container_lowest_bg_color ", _tmp247_, ";\n      @define-color surface_container_low_bg_color ", _tmp250_, ";\n      @define-color surface_container_bg_color ", _tmp253_, ";\n      @define-color surface_container_high_bg_color ", _tmp256_, ";\n      @define-color surface_container_highest_bg_color ", _tmp259_, ";\n      ", NULL);
		_g_free0 (css);
		css = _tmp260_;
		_tmp261_ = css;
		_tmp262_ = error_hex;
		_tmp263_ = string_to_string (_tmp262_);
		_tmp264_ = on_error_hex;
		_tmp265_ = string_to_string (_tmp264_);
		_tmp266_ = error_hex;
		_tmp267_ = string_to_string (_tmp266_);
		_tmp268_ = on_error_container_hex;
		_tmp269_ = string_to_string (_tmp268_);
		_tmp270_ = error_container_hex;
		_tmp271_ = string_to_string (_tmp270_);
		_tmp272_ = on_error_container_hex;
		_tmp273_ = string_to_string (_tmp272_);
		_tmp274_ = chosen_scheme;
		_tmp275_ = _tmp274_.secondary_hex;
		_tmp276_ = string_to_string (_tmp275_);
		_tmp277_ = chosen_scheme;
		_tmp278_ = _tmp277_.on_secondary_hex;
		_tmp279_ = string_to_string (_tmp278_);
		_tmp280_ = chosen_scheme;
		_tmp281_ = _tmp280_.secondary_hex;
		_tmp282_ = string_to_string (_tmp281_);
		_tmp283_ = chosen_scheme;
		_tmp284_ = _tmp283_.secondary_container_hex;
		_tmp285_ = string_to_string (_tmp284_);
		_tmp286_ = chosen_scheme;
		_tmp287_ = _tmp286_.secondary_container_hex;
		_tmp288_ = string_to_string (_tmp287_);
		_tmp289_ = chosen_scheme;
		_tmp290_ = _tmp289_.on_secondary_container_hex;
		_tmp291_ = string_to_string (_tmp290_);
		_tmp292_ = error_hex;
		_tmp293_ = string_to_string (_tmp292_);
		_tmp294_ = on_error_hex;
		_tmp295_ = string_to_string (_tmp294_);
		_tmp296_ = error_hex;
		_tmp297_ = string_to_string (_tmp296_);
		_tmp298_ = error_container_hex;
		_tmp299_ = string_to_string (_tmp298_);
		_tmp300_ = error_container_hex;
		_tmp301_ = string_to_string (_tmp300_);
		_tmp302_ = on_error_container_hex;
		_tmp303_ = string_to_string (_tmp302_);
		_tmp304_ = chosen_scheme;
		_tmp305_ = _tmp304_.tertiary_hex;
		_tmp306_ = string_to_string (_tmp305_);
		_tmp307_ = chosen_scheme;
		_tmp308_ = _tmp307_.on_tertiary_hex;
		_tmp309_ = string_to_string (_tmp308_);
		_tmp310_ = chosen_scheme;
		_tmp311_ = _tmp310_.tertiary_hex;
		_tmp312_ = string_to_string (_tmp311_);
		_tmp313_ = chosen_scheme;
		_tmp314_ = _tmp313_.tertiary_container_hex;
		_tmp315_ = string_to_string (_tmp314_);
		_tmp316_ = chosen_scheme;
		_tmp317_ = _tmp316_.tertiary_container_hex;
		_tmp318_ = string_to_string (_tmp317_);
		_tmp319_ = g_strconcat ("\n      @define-color destructive_bg_color ", _tmp263_, ";\n      @define-color destructive_fg_color ", _tmp265_, ";\n      @define-color destructive_color ", _tmp267_, ";\n      @define-color destructive_container_color ", _tmp269_, ";\n      @define-color destructive_container_bg_color ", _tmp271_, ";\n      @define-color destructive_container_fg_color ", _tmp273_, ";\n\n      @define-color suggested_bg_color ", _tmp276_, ";\n      @define-color suggested_fg_color ", _tmp279_, ";\n      @define-color suggested_color ", _tmp282_, ";\n      @define-color suggested_container_color ", _tmp285_, ";\n      @define-color suggested_container_bg_color ", _tmp288_, ";\n      @define-color suggested_container_fg_color ", _tmp291_, ";\n\n      @define-color error_bg_color ", _tmp293_, ";\n      @define-color error_fg_color ", _tmp295_, ";\n      @define-color error_color ", _tmp297_, ";\n      @define-color error_container_color ", _tmp299_, ";\n      @define-color error_container_bg_color ", _tmp301_, ";\n      @define-color error_container_fg_color ", _tmp303_, ";\n\n      @define-color success_bg_color ", _tmp306_, ";\n      @define-color success_fg_color ", _tmp309_, ";\n      @define-color success_color ", _tmp312_, ";\n      @define-color success_container_color ", _tmp315_, ";\n      @define-color success_container_bg_color ", _tmp318_, ";\n      ", NULL);
		_tmp320_ = _tmp319_;
		_tmp321_ = g_strconcat (_tmp261_, _tmp320_, NULL);
		_g_free0 (css);
		css = _tmp321_;
		_g_free0 (_tmp320_);
		_tmp322_ = css;
		_tmp323_ = chosen_scheme;
		_tmp324_ = _tmp323_.on_tertiary_container_hex;
		_tmp325_ = string_to_string (_tmp324_);
		_tmp326_ = chosen_scheme;
		_tmp327_ = _tmp326_.outline_hex;
		_tmp328_ = string_to_string (_tmp327_);
		_tmp329_ = chosen_scheme;
		_tmp330_ = _tmp329_.outline_variant_hex;
		_tmp331_ = string_to_string (_tmp330_);
		_tmp332_ = chosen_scheme;
		_tmp333_ = _tmp332_.shadow_hex;
		_tmp334_ = string_to_string (_tmp333_);
		_tmp335_ = chosen_scheme;
		_tmp336_ = _tmp335_.scrim_hex;
		_tmp337_ = string_to_string (_tmp336_);
		_tmp338_ = chosen_scheme;
		_tmp339_ = _tmp338_.inverse_surface_bg_hex;
		_tmp340_ = string_to_string (_tmp339_);
		_tmp341_ = chosen_scheme;
		_tmp342_ = _tmp341_.inverse_surface_fg_hex;
		_tmp343_ = string_to_string (_tmp342_);
		_tmp344_ = chosen_scheme;
		_tmp345_ = _tmp344_.inverse_primary_hex;
		_tmp346_ = string_to_string (_tmp345_);
		_tmp347_ = g_strconcat ("\n      @define-color success_container_fg_color ", _tmp325_, ";\n\n      @define-color outline ", _tmp328_, ";\n      @define-color borders ", _tmp331_, ";\n      @define-color shadow ", _tmp334_, ";\n      @define-color scrim ", _tmp337_, ";\n      @define-color osd_bg_color ", _tmp340_, ";\n      @define-color osd_fg_color ", _tmp343_, ";\n      @define-color osdaccent_color ", _tmp346_, ";\n      ", NULL);
		_tmp348_ = _tmp347_;
		_tmp349_ = g_strconcat (_tmp322_, _tmp348_, NULL);
		_g_free0 (css);
		css = _tmp349_;
		_g_free0 (_tmp348_);
	} else {
		HeScheme _tmp350_;
		const gchar* _tmp351_;
		const gchar* _tmp352_;
		HeScheme _tmp353_;
		const gchar* _tmp354_;
		const gchar* _tmp355_;
		HeScheme _tmp356_;
		const gchar* _tmp357_;
		const gchar* _tmp358_;
		HeScheme _tmp359_;
		const gchar* _tmp360_;
		const gchar* _tmp361_;
		HeScheme _tmp362_;
		const gchar* _tmp363_;
		const gchar* _tmp364_;
		HeScheme _tmp365_;
		const gchar* _tmp366_;
		const gchar* _tmp367_;
		HeScheme _tmp368_;
		const gchar* _tmp369_;
		const gchar* _tmp370_;
		HeScheme _tmp371_;
		const gchar* _tmp372_;
		const gchar* _tmp373_;
		HeScheme _tmp374_;
		const gchar* _tmp375_;
		const gchar* _tmp376_;
		HeScheme _tmp377_;
		const gchar* _tmp378_;
		const gchar* _tmp379_;
		HeScheme _tmp380_;
		const gchar* _tmp381_;
		const gchar* _tmp382_;
		HeScheme _tmp383_;
		const gchar* _tmp384_;
		const gchar* _tmp385_;
		HeScheme _tmp386_;
		const gchar* _tmp387_;
		const gchar* _tmp388_;
		HeScheme _tmp389_;
		const gchar* _tmp390_;
		const gchar* _tmp391_;
		HeScheme _tmp392_;
		const gchar* _tmp393_;
		const gchar* _tmp394_;
		HeScheme _tmp395_;
		const gchar* _tmp396_;
		const gchar* _tmp397_;
		HeScheme _tmp398_;
		const gchar* _tmp399_;
		const gchar* _tmp400_;
		HeScheme _tmp401_;
		const gchar* _tmp402_;
		const gchar* _tmp403_;
		HeScheme _tmp404_;
		const gchar* _tmp405_;
		const gchar* _tmp406_;
		HeScheme _tmp407_;
		const gchar* _tmp408_;
		const gchar* _tmp409_;
		HeScheme _tmp410_;
		const gchar* _tmp411_;
		const gchar* _tmp412_;
		HeScheme _tmp413_;
		const gchar* _tmp414_;
		const gchar* _tmp415_;
		HeScheme _tmp416_;
		const gchar* _tmp417_;
		const gchar* _tmp418_;
		HeScheme _tmp419_;
		const gchar* _tmp420_;
		const gchar* _tmp421_;
		gchar* _tmp422_;
		const gchar* _tmp423_;
		const gchar* _tmp424_;
		const gchar* _tmp425_;
		const gchar* _tmp426_;
		const gchar* _tmp427_;
		const gchar* _tmp428_;
		const gchar* _tmp429_;
		const gchar* _tmp430_;
		const gchar* _tmp431_;
		const gchar* _tmp432_;
		const gchar* _tmp433_;
		const gchar* _tmp434_;
		const gchar* _tmp435_;
		HeScheme _tmp436_;
		const gchar* _tmp437_;
		const gchar* _tmp438_;
		HeScheme _tmp439_;
		const gchar* _tmp440_;
		const gchar* _tmp441_;
		HeScheme _tmp442_;
		const gchar* _tmp443_;
		const gchar* _tmp444_;
		HeScheme _tmp445_;
		const gchar* _tmp446_;
		const gchar* _tmp447_;
		HeScheme _tmp448_;
		const gchar* _tmp449_;
		const gchar* _tmp450_;
		HeScheme _tmp451_;
		const gchar* _tmp452_;
		const gchar* _tmp453_;
		const gchar* _tmp454_;
		const gchar* _tmp455_;
		const gchar* _tmp456_;
		const gchar* _tmp457_;
		const gchar* _tmp458_;
		const gchar* _tmp459_;
		const gchar* _tmp460_;
		const gchar* _tmp461_;
		const gchar* _tmp462_;
		const gchar* _tmp463_;
		const gchar* _tmp464_;
		const gchar* _tmp465_;
		HeScheme _tmp466_;
		const gchar* _tmp467_;
		const gchar* _tmp468_;
		HeScheme _tmp469_;
		const gchar* _tmp470_;
		const gchar* _tmp471_;
		HeScheme _tmp472_;
		const gchar* _tmp473_;
		const gchar* _tmp474_;
		HeScheme _tmp475_;
		const gchar* _tmp476_;
		const gchar* _tmp477_;
		HeScheme _tmp478_;
		const gchar* _tmp479_;
		const gchar* _tmp480_;
		gchar* _tmp481_;
		gchar* _tmp482_;
		gchar* _tmp483_;
		const gchar* _tmp484_;
		HeScheme _tmp485_;
		const gchar* _tmp486_;
		const gchar* _tmp487_;
		HeScheme _tmp488_;
		const gchar* _tmp489_;
		const gchar* _tmp490_;
		HeScheme _tmp491_;
		const gchar* _tmp492_;
		const gchar* _tmp493_;
		HeScheme _tmp494_;
		const gchar* _tmp495_;
		const gchar* _tmp496_;
		HeScheme _tmp497_;
		const gchar* _tmp498_;
		const gchar* _tmp499_;
		HeScheme _tmp500_;
		const gchar* _tmp501_;
		const gchar* _tmp502_;
		HeScheme _tmp503_;
		const gchar* _tmp504_;
		const gchar* _tmp505_;
		HeScheme _tmp506_;
		const gchar* _tmp507_;
		const gchar* _tmp508_;
		gchar* _tmp509_;
		gchar* _tmp510_;
		gchar* _tmp511_;
		_tmp350_ = chosen_scheme;
		_tmp351_ = _tmp350_.primary_hex;
		_tmp352_ = string_to_string (_tmp351_);
		_tmp353_ = chosen_scheme;
		_tmp354_ = _tmp353_.primary_hex;
		_tmp355_ = string_to_string (_tmp354_);
		_tmp356_ = chosen_scheme;
		_tmp357_ = _tmp356_.on_primary_hex;
		_tmp358_ = string_to_string (_tmp357_);
		_tmp359_ = chosen_scheme;
		_tmp360_ = _tmp359_.primary_container_hex;
		_tmp361_ = string_to_string (_tmp360_);
		_tmp362_ = chosen_scheme;
		_tmp363_ = _tmp362_.primary_container_hex;
		_tmp364_ = string_to_string (_tmp363_);
		_tmp365_ = chosen_scheme;
		_tmp366_ = _tmp365_.on_primary_container_hex;
		_tmp367_ = string_to_string (_tmp366_);
		_tmp368_ = chosen_scheme;
		_tmp369_ = _tmp368_.surface_bg_hex;
		_tmp370_ = string_to_string (_tmp369_);
		_tmp371_ = chosen_scheme;
		_tmp372_ = _tmp371_.surface_bg_hex;
		_tmp373_ = string_to_string (_tmp372_);
		_tmp374_ = chosen_scheme;
		_tmp375_ = _tmp374_.surface_bg_variant_hex;
		_tmp376_ = string_to_string (_tmp375_);
		_tmp377_ = chosen_scheme;
		_tmp378_ = _tmp377_.surface_container_high_bg_hex;
		_tmp379_ = string_to_string (_tmp378_);
		_tmp380_ = chosen_scheme;
		_tmp381_ = _tmp380_.surface_container_bg_hex;
		_tmp382_ = string_to_string (_tmp381_);
		_tmp383_ = chosen_scheme;
		_tmp384_ = _tmp383_.surface_fg_hex;
		_tmp385_ = string_to_string (_tmp384_);
		_tmp386_ = chosen_scheme;
		_tmp387_ = _tmp386_.surface_fg_variant_hex;
		_tmp388_ = string_to_string (_tmp387_);
		_tmp389_ = chosen_scheme;
		_tmp390_ = _tmp389_.surface_fg_variant_hex;
		_tmp391_ = string_to_string (_tmp390_);
		_tmp392_ = chosen_scheme;
		_tmp393_ = _tmp392_.surface_fg_hex;
		_tmp394_ = string_to_string (_tmp393_);
		_tmp395_ = chosen_scheme;
		_tmp396_ = _tmp395_.surface_fg_hex;
		_tmp397_ = string_to_string (_tmp396_);
		_tmp398_ = chosen_scheme;
		_tmp399_ = _tmp398_.surface_bright_bg_hex;
		_tmp400_ = string_to_string (_tmp399_);
		_tmp401_ = chosen_scheme;
		_tmp402_ = _tmp401_.surface_bg_hex;
		_tmp403_ = string_to_string (_tmp402_);
		_tmp404_ = chosen_scheme;
		_tmp405_ = _tmp404_.surface_dim_bg_hex;
		_tmp406_ = string_to_string (_tmp405_);
		_tmp407_ = chosen_scheme;
		_tmp408_ = _tmp407_.surface_container_lowest_bg_hex;
		_tmp409_ = string_to_string (_tmp408_);
		_tmp410_ = chosen_scheme;
		_tmp411_ = _tmp410_.surface_container_low_bg_hex;
		_tmp412_ = string_to_string (_tmp411_);
		_tmp413_ = chosen_scheme;
		_tmp414_ = _tmp413_.surface_container_bg_hex;
		_tmp415_ = string_to_string (_tmp414_);
		_tmp416_ = chosen_scheme;
		_tmp417_ = _tmp416_.surface_container_high_bg_hex;
		_tmp418_ = string_to_string (_tmp417_);
		_tmp419_ = chosen_scheme;
		_tmp420_ = _tmp419_.surface_container_highest_bg_hex;
		_tmp421_ = string_to_string (_tmp420_);
		_tmp422_ = g_strconcat ("\n      @define-color accent_color ", _tmp352_, ";\n      @define-color accent_bg_color ", _tmp355_, ";\n      @define-color accent_fg_color ", _tmp358_, ";\n      @define-color accent_container_color ", _tmp361_, ";\n      @define-color accent_container_bg_color ", _tmp364_, ";\n      @define-color accent_container_fg_color ", _tmp367_, ";\n\n      @define-color window_bg_color ", _tmp370_, ";\n      @define-color view_bg_color ", _tmp373_, ";\n      @define-color headerbar_bg_color ", _tmp376_, ";\n      @define-color popover_bg_color ", _tmp379_, ";\n      @define-color card_bg_color ", _tmp382_, ";\n      @define-color window_fg_color ", _tmp385_, ";\n      @define-color view_fg_color ", _tmp388_, ";\n      @define-color headerbar_fg_color ", _tmp391_, ";\n      @define-color popover_fg_color ", _tmp394_, ";\n      @define-color card_fg_color ", _tmp397_, ";\n\n      @define-color surface_bright_bg_color ", _tmp400_, ";\n      @define-color surface_bg_color ", _tmp403_, ";\n      @define-color surface_dim_bg_color ", _tmp406_, ";\n      @define-color surface_container_lowest_bg_color ", _tmp409_, ";\n      @define-color surface_container_low_bg_color ", _tmp412_, ";\n      @define-color surface_container_bg_color ", _tmp415_, ";\n      @define-color surface_container_high_bg_color ", _tmp418_, ";\n      @define-color surface_container_highest_bg_color ", _tmp421_, ";\n      ", NULL);
		_g_free0 (css);
		css = _tmp422_;
		_tmp423_ = css;
		_tmp424_ = error_hex;
		_tmp425_ = string_to_string (_tmp424_);
		_tmp426_ = on_error_hex;
		_tmp427_ = string_to_string (_tmp426_);
		_tmp428_ = error_hex;
		_tmp429_ = string_to_string (_tmp428_);
		_tmp430_ = on_error_container_hex;
		_tmp431_ = string_to_string (_tmp430_);
		_tmp432_ = error_container_hex;
		_tmp433_ = string_to_string (_tmp432_);
		_tmp434_ = on_error_container_hex;
		_tmp435_ = string_to_string (_tmp434_);
		_tmp436_ = chosen_scheme;
		_tmp437_ = _tmp436_.secondary_hex;
		_tmp438_ = string_to_string (_tmp437_);
		_tmp439_ = chosen_scheme;
		_tmp440_ = _tmp439_.on_secondary_hex;
		_tmp441_ = string_to_string (_tmp440_);
		_tmp442_ = chosen_scheme;
		_tmp443_ = _tmp442_.secondary_hex;
		_tmp444_ = string_to_string (_tmp443_);
		_tmp445_ = chosen_scheme;
		_tmp446_ = _tmp445_.secondary_container_hex;
		_tmp447_ = string_to_string (_tmp446_);
		_tmp448_ = chosen_scheme;
		_tmp449_ = _tmp448_.secondary_container_hex;
		_tmp450_ = string_to_string (_tmp449_);
		_tmp451_ = chosen_scheme;
		_tmp452_ = _tmp451_.on_secondary_container_hex;
		_tmp453_ = string_to_string (_tmp452_);
		_tmp454_ = error_hex;
		_tmp455_ = string_to_string (_tmp454_);
		_tmp456_ = on_error_hex;
		_tmp457_ = string_to_string (_tmp456_);
		_tmp458_ = error_hex;
		_tmp459_ = string_to_string (_tmp458_);
		_tmp460_ = error_container_hex;
		_tmp461_ = string_to_string (_tmp460_);
		_tmp462_ = error_container_hex;
		_tmp463_ = string_to_string (_tmp462_);
		_tmp464_ = on_error_container_hex;
		_tmp465_ = string_to_string (_tmp464_);
		_tmp466_ = chosen_scheme;
		_tmp467_ = _tmp466_.tertiary_hex;
		_tmp468_ = string_to_string (_tmp467_);
		_tmp469_ = chosen_scheme;
		_tmp470_ = _tmp469_.on_tertiary_hex;
		_tmp471_ = string_to_string (_tmp470_);
		_tmp472_ = chosen_scheme;
		_tmp473_ = _tmp472_.tertiary_hex;
		_tmp474_ = string_to_string (_tmp473_);
		_tmp475_ = chosen_scheme;
		_tmp476_ = _tmp475_.tertiary_container_hex;
		_tmp477_ = string_to_string (_tmp476_);
		_tmp478_ = chosen_scheme;
		_tmp479_ = _tmp478_.tertiary_container_hex;
		_tmp480_ = string_to_string (_tmp479_);
		_tmp481_ = g_strconcat ("\n      @define-color destructive_bg_color ", _tmp425_, ";\n      @define-color destructive_fg_color ", _tmp427_, ";\n      @define-color destructive_color ", _tmp429_, ";\n      @define-color destructive_container_color ", _tmp431_, ";\n      @define-color destructive_container_bg_color ", _tmp433_, ";\n      @define-color destructive_container_fg_color ", _tmp435_, ";\n\n      @define-color suggested_bg_color ", _tmp438_, ";\n      @define-color suggested_fg_color ", _tmp441_, ";\n      @define-color suggested_color ", _tmp444_, ";\n      @define-color suggested_container_color ", _tmp447_, ";\n      @define-color suggested_container_bg_color ", _tmp450_, ";\n      @define-color suggested_container_fg_color ", _tmp453_, ";\n\n      @define-color error_bg_color ", _tmp455_, ";\n      @define-color error_fg_color ", _tmp457_, ";\n      @define-color error_color ", _tmp459_, ";\n      @define-color error_container_color ", _tmp461_, ";\n      @define-color error_container_bg_color ", _tmp463_, ";\n      @define-color error_container_fg_color ", _tmp465_, ";\n\n      @define-color success_bg_color ", _tmp468_, ";\n      @define-color success_fg_color ", _tmp471_, ";\n      @define-color success_color ", _tmp474_, ";\n      @define-color success_container_color ", _tmp477_, ";\n      @define-color success_container_bg_color ", _tmp480_, ";\n      ", NULL);
		_tmp482_ = _tmp481_;
		_tmp483_ = g_strconcat (_tmp423_, _tmp482_, NULL);
		_g_free0 (css);
		css = _tmp483_;
		_g_free0 (_tmp482_);
		_tmp484_ = css;
		_tmp485_ = chosen_scheme;
		_tmp486_ = _tmp485_.on_tertiary_container_hex;
		_tmp487_ = string_to_string (_tmp486_);
		_tmp488_ = chosen_scheme;
		_tmp489_ = _tmp488_.outline_hex;
		_tmp490_ = string_to_string (_tmp489_);
		_tmp491_ = chosen_scheme;
		_tmp492_ = _tmp491_.outline_variant_hex;
		_tmp493_ = string_to_string (_tmp492_);
		_tmp494_ = chosen_scheme;
		_tmp495_ = _tmp494_.shadow_hex;
		_tmp496_ = string_to_string (_tmp495_);
		_tmp497_ = chosen_scheme;
		_tmp498_ = _tmp497_.scrim_hex;
		_tmp499_ = string_to_string (_tmp498_);
		_tmp500_ = chosen_scheme;
		_tmp501_ = _tmp500_.inverse_surface_bg_hex;
		_tmp502_ = string_to_string (_tmp501_);
		_tmp503_ = chosen_scheme;
		_tmp504_ = _tmp503_.inverse_surface_fg_hex;
		_tmp505_ = string_to_string (_tmp504_);
		_tmp506_ = chosen_scheme;
		_tmp507_ = _tmp506_.inverse_primary_hex;
		_tmp508_ = string_to_string (_tmp507_);
		_tmp509_ = g_strconcat ("\n      @define-color success_container_fg_color ", _tmp487_, ";\n\n      @define-color outline ", _tmp490_, ";\n      @define-color borders ", _tmp493_, ";\n      @define-color shadow ", _tmp496_, ";\n      @define-color scrim ", _tmp499_, ";\n      @define-color osd_bg_color ", _tmp502_, ";\n      @define-color osd_fg_color ", _tmp505_, ";\n      @define-color osdaccent_color ", _tmp508_, ";\n      ", NULL);
		_tmp510_ = _tmp509_;
		_tmp511_ = g_strconcat (_tmp484_, _tmp510_, NULL);
		_g_free0 (css);
		css = _tmp511_;
		_g_free0 (_tmp510_);
	}
	_tmp512_ = css;
	_tmp513_ = meson_red_hex;
	_tmp514_ = string_to_string (_tmp513_);
	_tmp515_ = lepton_orange_hex;
	_tmp516_ = string_to_string (_tmp515_);
	_tmp517_ = electron_yellow_hex;
	_tmp518_ = string_to_string (_tmp517_);
	_tmp519_ = muon_green_hex;
	_tmp520_ = string_to_string (_tmp519_);
	_tmp521_ = baryon_mint_hex;
	_tmp522_ = string_to_string (_tmp521_);
	_tmp523_ = proton_blue_hex;
	_tmp524_ = string_to_string (_tmp523_);
	_tmp525_ = photon_indigo_hex;
	_tmp526_ = string_to_string (_tmp525_);
	_tmp527_ = tau_purple_hex;
	_tmp528_ = string_to_string (_tmp527_);
	_tmp529_ = fermion_pink_hex;
	_tmp530_ = string_to_string (_tmp529_);
	_tmp531_ = gluon_brown_hex;
	_tmp532_ = string_to_string (_tmp531_);
	_tmp533_ = g_strconcat ("\n      @define-color meson_red ", _tmp514_, ";\n      @define-color lepton_orange ", _tmp516_, ";\n      @define-color electron_yellow ", _tmp518_, ";\n      @define-color muon_green ", _tmp520_, ";\n      @define-color baryon_mint ", _tmp522_, ";\n      @define-color proton_blue ", _tmp524_, ";\n      @define-color photon_indigo ", _tmp526_, ";\n      @define-color tau_purple ", _tmp528_, ";\n      @define-color fermion_pink ", _tmp530_, ";\n      @define-color gluon_brown ", _tmp532_, ";\n    ", NULL);
	_tmp534_ = _tmp533_;
	_tmp535_ = g_strconcat (_tmp512_, _tmp534_, NULL);
	_g_free0 (css);
	css = _tmp535_;
	_g_free0 (_tmp534_);
	light_weight = 300 * self->font_weight;
	heavy_weight = 700 * self->font_weight;
	_tmp536_ = css;
	_tmp537_ = double_to_string (base_weight);
	_tmp538_ = _tmp537_;
	_tmp539_ = double_to_string (heavy_weight);
	_tmp540_ = _tmp539_;
	_tmp541_ = double_to_string (base_weight);
	_tmp542_ = _tmp541_;
	_tmp543_ = double_to_string (base_weight);
	_tmp544_ = _tmp543_;
	_tmp545_ = double_to_string (light_weight);
	_tmp546_ = _tmp545_;
	_tmp547_ = double_to_string (light_weight);
	_tmp548_ = _tmp547_;
	_tmp549_ = double_to_string (base_weight);
	_tmp550_ = _tmp549_;
	_tmp551_ = double_to_string (heavy_weight);
	_tmp552_ = _tmp551_;
	_tmp553_ = double_to_string (base_weight);
	_tmp554_ = _tmp553_;
	_tmp555_ = double_to_string (heavy_weight);
	_tmp556_ = _tmp555_;
	_tmp557_ = double_to_string (base_weight);
	_tmp558_ = _tmp557_;
	_tmp559_ = double_to_string (heavy_weight);
	_tmp560_ = _tmp559_;
	_tmp561_ = double_to_string (light_weight);
	_tmp562_ = _tmp561_;
	_tmp563_ = double_to_string (heavy_weight);
	_tmp564_ = _tmp563_;
	_tmp565_ = double_to_string (heavy_weight);
	_tmp566_ = _tmp565_;
	_tmp567_ = double_to_string (heavy_weight);
	_tmp568_ = _tmp567_;
	_tmp569_ = double_to_string (heavy_weight);
	_tmp570_ = _tmp569_;
	_tmp571_ = double_to_string (heavy_weight);
	_tmp572_ = _tmp571_;
	_tmp573_ = double_to_string (heavy_weight);
	_tmp574_ = _tmp573_;
	_tmp575_ = double_to_string (heavy_weight);
	_tmp576_ = _tmp575_;
	_tmp577_ = g_strconcat ("\n    label {\n      font-weight: ", _tmp538_, ";\n    }\n    button label {\n      font-weight: ", _tmp540_, ";\n    }\n    .view-switcher button label {\n      font-weight: ", _tmp542_, ";\n    }\n    .big-display {\n      font-weight: ", _tmp544_, ";\n    }\n    .display {\n      font-weight: ", _tmp546_, ";\n    }\n    .view-title {\n      font-weight: ", _tmp548_, ";\n    }\n    .view-subtitle {\n      font-weight: ", _tmp550_, ";\n    }\n    .cb-title {\n      font-weight: ", _tmp552_, ";\n    }\n    .cb-subtitle {\n      font-weight: ", _tmp554_, ";\n    }\n    .header {\n      font-weight: ", _tmp556_, ";\n    }\n    .body {\n      font-weight: ", _tmp558_, ";\n    }\n    .caption {\n      font-weight: ", _tmp560_, ";\n    }\n    .large-title {\n      font-weight: ", _tmp562_, ";\n    }\n    .title-1 {\n      font-weight: ", _tmp564_, ";\n    }\n    .title-2 {\n      font-weight: ", _tmp566_, ";\n    }\n    .title-3 {\n      font-weight: ", _tmp568_, ";\n    }\n    .title-4 {\n      font-weight: ", _tmp570_, ";\n    }\n    .heading {\n      font-weight: ", _tmp572_, ";\n    }\n    .caption-heading {\n      font-weight: ", _tmp574_, ";\n" \
"    }\n" \
"    .badge label,\n" \
"    .badge-info label,\n" \
"    .tint-badge label,\n" \
"    .modifier-badge label {\n" \
"      font-weight: ", _tmp576_, ";\n    }\n    ", NULL);
	_tmp578_ = _tmp577_;
	_tmp579_ = g_strconcat (_tmp536_, _tmp578_, NULL);
	_g_free0 (css);
	css = _tmp579_;
	_g_free0 (_tmp578_);
	_g_free0 (_tmp576_);
	_g_free0 (_tmp574_);
	_g_free0 (_tmp572_);
	_g_free0 (_tmp570_);
	_g_free0 (_tmp568_);
	_g_free0 (_tmp566_);
	_g_free0 (_tmp564_);
	_g_free0 (_tmp562_);
	_g_free0 (_tmp560_);
	_g_free0 (_tmp558_);
	_g_free0 (_tmp556_);
	_g_free0 (_tmp554_);
	_g_free0 (_tmp552_);
	_g_free0 (_tmp550_);
	_g_free0 (_tmp548_);
	_g_free0 (_tmp546_);
	_g_free0 (_tmp544_);
	_g_free0 (_tmp542_);
	_g_free0 (_tmp540_);
	_g_free0 (_tmp538_);
	_tmp580_ = self->priv->accent;
	_tmp581_ = css;
	he_misc_init_css_provider_from_string (_tmp580_, _tmp581_);
	_tmp582_ = self->priv->light;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp582_, !self->is_dark, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
	_tmp583_ = self->priv->dark;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp583_, self->is_dark, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
	_tmp584_ = self->priv->_user_dark;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp584_, self->is_dark, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_DARK);
	_tmp585_ = gtk_settings_get_default ();
	_tmp586_ = _g_object_ref0 (_tmp585_);
	settings = _tmp586_;
	_tmp587_ = settings;
	g_object_set (_tmp587_, "gtk-application-prefer-dark-theme", self->is_dark, NULL);
	_g_object_unref0 (settings);
	_g_free0 (css);
	_g_free0 (gluon_brown_hex);
	_g_free0 (fermion_pink_hex);
	_g_free0 (tau_purple_hex);
	_g_free0 (photon_indigo_hex);
	_g_free0 (proton_blue_hex);
	_g_free0 (baryon_mint_hex);
	_g_free0 (muon_green_hex);
	_g_free0 (electron_yellow_hex);
	_g_free0 (lepton_orange_hex);
	_g_free0 (meson_red_hex);
	_g_free0 (on_error_container_hex);
	_g_free0 (error_container_hex);
	_g_free0 (on_error_hex);
	_g_free0 (error_hex);
	he_scheme_destroy (&chosen_scheme);
	_g_free0 (bg_hex);
	_he_color_rgb_color_free0 (rgb_color);
}

/**
  * Register the style manager with GTK. This will also call update.
  */
void
he_style_manager_register (HeStyleManager* self)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkSettings* settings = NULL;
	GtkSettings* _tmp4_;
	GtkSettings* _tmp5_;
	g_return_if_fail (self != NULL);
	g_debug ("StyleManager.vala:392: Loading bundled Helium stylesheet");
	_tmp0_ = self->priv->light;
	gtk_css_provider_load_from_resource (_tmp0_, "/com/fyralabs/Helium/gtk.css");
	_tmp1_ = self->priv->dark;
	gtk_css_provider_load_from_resource (_tmp1_, "/com/fyralabs/Helium/gtk-dark.css");
	_tmp2_ = self->priv->accent;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp2_, TRUE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_ACCENT);
	_tmp3_ = self->priv->_user_base;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp3_, TRUE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_BASE);
	_tmp4_ = gtk_settings_get_default ();
	_tmp5_ = _g_object_ref0 (_tmp4_);
	settings = _tmp5_;
	g_object_set (settings, "gtk-theme-name", "Helium-empty", NULL);
	g_object_set (settings, "gtk-icon-theme-name", "Hydrogen", NULL);
	he_style_manager_set_is_registered (self, TRUE);
	he_style_manager_update (self);
	_g_object_unref0 (settings);
}

/**
  * Unregister the style manager with GTK.
  */
void
he_style_manager_unregister (HeStyleManager* self)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->accent;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp0_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_ACCENT);
	_tmp1_ = self->priv->_user_base;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp1_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_BASE);
	_tmp2_ = self->priv->light;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp2_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
	_tmp3_ = self->priv->dark;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp3_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_PLATFORM);
	_tmp4_ = self->priv->_user_dark;
	he_misc_toggle_style_provider ((GtkStyleProvider*) _tmp4_, FALSE, HE_STYLE_MANAGER_STYLE_PROVIDER_PRIORITY_USER_DARK);
	he_style_manager_set_is_registered (self, FALSE);
}

HeStyleManager*
he_style_manager_construct (GType object_type)
{
	HeStyleManager * self = NULL;
	self = (HeStyleManager*) g_object_new (object_type, NULL);
	return self;
}

HeStyleManager*
he_style_manager_new (void)
{
	return he_style_manager_construct (HE_TYPE_STYLE_MANAGER);
}

static void
he_style_manager_class_init (HeStyleManagerClass * klass,
                             gpointer klass_data)
{
	he_style_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeStyleManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_style_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_style_manager_set_property;
	G_OBJECT_CLASS (klass)->finalize = he_style_manager_finalize;
	/**
	  * Whether the style manager has been registered. Unregistered style managers will not apply their styles.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY, he_style_manager_properties[HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY] = g_param_spec_boolean ("is-registered", "is-registered", "is-registered", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	  * The base style provider for application provided styles. In this case user refers to the application, not the user of the application.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_STYLE_MANAGER_USER_BASE_PROPERTY, he_style_manager_properties[HE_STYLE_MANAGER_USER_BASE_PROPERTY] = g_param_spec_object ("user-base", "user-base", "user-base", gtk_css_provider_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	  * The dark style provider for application provided styles. This will be applied in addition to the base style provider when dark mode is enabled.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_STYLE_MANAGER_USER_DARK_PROPERTY, he_style_manager_properties[HE_STYLE_MANAGER_USER_DARK_PROPERTY] = g_param_spec_object ("user-dark", "user-dark", "user-dark", gtk_css_provider_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
he_style_manager_instance_init (HeStyleManager * self,
                                gpointer klass)
{
	HeDefaultScheme* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp4_;
	GtkCssProvider* _tmp5_;
	self->priv = he_style_manager_get_instance_private (self);
	self->font_weight = 1.0;
	self->is_dark = FALSE;
	_tmp0_ = he_default_scheme_new ();
	self->scheme_factory = (HeSchemeFactory*) _tmp0_;
	self->dark_mode_strength = HE_DARK_MODE_STRENGTH_MEDIUM;
	self->priv->_is_registered = FALSE;
	_tmp1_ = gtk_css_provider_new ();
	self->priv->light = _tmp1_;
	_tmp2_ = gtk_css_provider_new ();
	self->priv->dark = _tmp2_;
	_tmp3_ = gtk_css_provider_new ();
	self->priv->accent = _tmp3_;
	_tmp4_ = gtk_css_provider_new ();
	self->priv->_user_base = _tmp4_;
	_tmp5_ = gtk_css_provider_new ();
	self->priv->_user_dark = _tmp5_;
}

static void
he_style_manager_finalize (GObject * obj)
{
	HeStyleManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_STYLE_MANAGER, HeStyleManager);
	he_style_manager_unregister (self);
	_he_color_rgb_color_free0 (self->accent_color);
	_g_object_unref0 (self->scheme_factory);
	_g_object_unref0 (self->priv->light);
	_g_object_unref0 (self->priv->dark);
	_g_object_unref0 (self->priv->accent);
	_g_object_unref0 (self->priv->_user_base);
	_g_object_unref0 (self->priv->_user_dark);
	G_OBJECT_CLASS (he_style_manager_parent_class)->finalize (obj);
}

/**
* A class that manages the style of the application in conjunction with the provided preferences.
* This is a low-level class that should not be used directly. Instead, let the `He.Application` class manage this for you.
*/
static GType
he_style_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeStyleManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_style_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeStyleManager), 0, (GInstanceInitFunc) he_style_manager_instance_init, NULL };
	GType he_style_manager_type_id;
	he_style_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "HeStyleManager", &g_define_type_info, 0);
	HeStyleManager_private_offset = g_type_add_instance_private (he_style_manager_type_id, sizeof (HeStyleManagerPrivate));
	return he_style_manager_type_id;
}

GType
he_style_manager_get_type (void)
{
	static volatile gsize he_style_manager_type_id__once = 0;
	if (g_once_init_enter (&he_style_manager_type_id__once)) {
		GType he_style_manager_type_id;
		he_style_manager_type_id = he_style_manager_get_type_once ();
		g_once_init_leave (&he_style_manager_type_id__once, he_style_manager_type_id);
	}
	return he_style_manager_type_id__once;
}

static void
_vala_he_style_manager_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	HeStyleManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_STYLE_MANAGER, HeStyleManager);
	switch (property_id) {
		case HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY:
		g_value_set_boolean (value, he_style_manager_get_is_registered (self));
		break;
		case HE_STYLE_MANAGER_USER_BASE_PROPERTY:
		g_value_set_object (value, he_style_manager_get_user_base (self));
		break;
		case HE_STYLE_MANAGER_USER_DARK_PROPERTY:
		g_value_set_object (value, he_style_manager_get_user_dark (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_style_manager_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	HeStyleManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_STYLE_MANAGER, HeStyleManager);
	switch (property_id) {
		case HE_STYLE_MANAGER_IS_REGISTERED_PROPERTY:
		he_style_manager_set_is_registered (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

