/* Window.c generated by valac 0.56.13, the Vala compiler
 * generated from Window.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	HE_WINDOW_0_PROPERTY,
	HE_WINDOW_PARENT_PROPERTY,
	HE_WINDOW_HAS_TITLE_PROPERTY,
	HE_WINDOW_HAS_BACK_BUTTON_PROPERTY,
	HE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_window_properties[HE_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeWindowPrivate {
	HeAppBar* title;
	GtkWindow* _parent;
	gboolean _has_title;
	gboolean _has_back_button;
};

static gint HeWindow_private_offset;
static gpointer he_window_parent_class = NULL;

static GObject * he_window_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void he_window_finalize (GObject * obj);
static GType he_window_get_type_once (void);
static void _vala_he_window_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_he_window_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
he_window_get_instance_private (HeWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeWindow_private_offset);
}

GtkWindow*
he_window_get_parent (HeWindow* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_window_get_transient_for ((GtkWindow*) self);
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
he_window_set_parent (HeWindow* self,
                      GtkWindow* value)
{
	GtkWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_parent);
	self->priv->_parent = _tmp0_;
	gtk_window_set_modal ((GtkWindow*) self, value != NULL);
	gtk_window_set_transient_for ((GtkWindow*) self, value);
	g_object_notify_by_pspec ((GObject *) self, he_window_properties[HE_WINDOW_PARENT_PROPERTY]);
}

gboolean
he_window_get_has_title (HeWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_title;
	return result;
}

void
he_window_set_has_title (HeWindow* self,
                         gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_has_title = value;
	if (!value) {
		GtkBox* box = NULL;
		GtkBox* _tmp0_;
		GtkBox* _tmp1_;
		_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
		g_object_ref_sink (_tmp0_);
		box = _tmp0_;
		_tmp1_ = box;
		gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp1_);
		_g_object_unref0 (box);
	} else {
		HeAppBar* _tmp2_;
		HeAppBar* _tmp3_;
		_tmp2_ = self->priv->title;
		gtk_widget_add_css_class ((GtkWidget*) _tmp2_, "flat");
		_tmp3_ = self->priv->title;
		gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp3_);
	}
	g_object_notify_by_pspec ((GObject *) self, he_window_properties[HE_WINDOW_HAS_TITLE_PROPERTY]);
}

gboolean
he_window_get_has_back_button (HeWindow* self)
{
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = he_window_get_has_back_button (self);
	_tmp1_ = _tmp0_;
	result = _tmp1_;
	return result;
}

void
he_window_set_has_back_button (HeWindow* self,
                               gboolean value)
{
	HeAppBar* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_has_back_button = value;
	_tmp0_ = self->priv->title;
	he_app_bar_set_show_back (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_window_properties[HE_WINDOW_HAS_BACK_BUTTON_PROPERTY]);
}

HeWindow*
he_window_construct (GType object_type)
{
	HeWindow * self = NULL;
	self = (HeWindow*) g_object_new (object_type, NULL);
	return self;
}

HeWindow*
he_window_new (void)
{
	return he_window_construct (HE_TYPE_WINDOW);
}

static GObject *
he_window_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeWindow * self;
	parent_class = G_OBJECT_CLASS (he_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_WINDOW, HeWindow);
	he_window_set_has_title (self, FALSE);
	he_window_set_has_back_button (self, FALSE);
	return obj;
}

static void
he_window_class_init (HeWindowClass * klass,
                      gpointer klass_data)
{
	he_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeWindow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_window_finalize;
	/**
	     * The parent window of this window. If this is null, then this is a top-level window.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_WINDOW_PARENT_PROPERTY, he_window_properties[HE_WINDOW_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * If the window has a title bar.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_WINDOW_HAS_TITLE_PROPERTY, he_window_properties[HE_WINDOW_HAS_TITLE_PROPERTY] = g_param_spec_boolean ("has-title", "has-title", "has-title", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * If the window has a back button.
	     *
	     * @since 1.0
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_WINDOW_HAS_BACK_BUTTON_PROPERTY, he_window_properties[HE_WINDOW_HAS_BACK_BUTTON_PROPERTY] = g_param_spec_boolean ("has-back-button", "has-back-button", "has-back-button", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_window_instance_init (HeWindow * self,
                         gpointer klass)
{
	HeAppBar* _tmp0_;
	self->priv = he_window_get_instance_private (self);
	_tmp0_ = he_app_bar_new ();
	g_object_ref_sink (_tmp0_);
	self->priv->title = _tmp0_;
}

static void
he_window_finalize (GObject * obj)
{
	HeWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_WINDOW, HeWindow);
	_g_object_unref0 (self->priv->title);
	_g_object_unref0 (self->priv->_parent);
	G_OBJECT_CLASS (he_window_parent_class)->finalize (obj);
}

/**
 * A Window is a container that has an {@link AppBar} and can be moved, resized, and closed.
 * It may be a top-level window or a dialog. The title bar can be made always visible.
 * Has an optional back button. The back button is only visible if has_back_button is true.
 */
static GType
he_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeWindow), 0, (GInstanceInitFunc) he_window_instance_init, NULL };
	GType he_window_type_id;
	he_window_type_id = g_type_register_static (gtk_window_get_type (), "HeWindow", &g_define_type_info, 0);
	HeWindow_private_offset = g_type_add_instance_private (he_window_type_id, sizeof (HeWindowPrivate));
	return he_window_type_id;
}

GType
he_window_get_type (void)
{
	static volatile gsize he_window_type_id__once = 0;
	if (g_once_init_enter (&he_window_type_id__once)) {
		GType he_window_type_id;
		he_window_type_id = he_window_get_type_once ();
		g_once_init_leave (&he_window_type_id__once, he_window_type_id);
	}
	return he_window_type_id__once;
}

static void
_vala_he_window_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	HeWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_WINDOW, HeWindow);
	switch (property_id) {
		case HE_WINDOW_PARENT_PROPERTY:
		g_value_set_object (value, he_window_get_parent (self));
		break;
		case HE_WINDOW_HAS_TITLE_PROPERTY:
		g_value_set_boolean (value, he_window_get_has_title (self));
		break;
		case HE_WINDOW_HAS_BACK_BUTTON_PROPERTY:
		g_value_set_boolean (value, he_window_get_has_back_button (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_window_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	HeWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_WINDOW, HeWindow);
	switch (property_id) {
		case HE_WINDOW_PARENT_PROPERTY:
		he_window_set_parent (self, g_value_get_object (value));
		break;
		case HE_WINDOW_HAS_TITLE_PROPERTY:
		he_window_set_has_title (self, g_value_get_boolean (value));
		break;
		case HE_WINDOW_HAS_BACK_BUTTON_PROPERTY:
		he_window_set_has_back_button (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

