/* ARGB.c generated by valac 0.56.13, the Vala compiler
 * generated from ARGB.vala, do not modify */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "libhelium-1.h"

#define HE_COLOR_XN 0.95047
#define HE_COLOR_YN 1.00000
#define HE_COLOR_ZN 1.08883

const gdouble HE_COLOR_SRGB_TO_XYZ[3][3] = {{0.41233895, 0.35762064, 0.18051042}, {0.2126, 0.7152, 0.0722}, {0.01932141, 0.11916382, 0.95034478}};
VALA_EXTERN const gdouble HE_COLOR_XYZ_TO_SRGB[3][3];

gint
he_color_rgb_to_argb_int (HeColorRGBColor* color)
{
	gint clr = 0;
	HeColorRGBColor _tmp0_;
	HeColorRGBColor _tmp1_;
	HeColorRGBColor _tmp2_;
	gint result;
	g_return_val_if_fail (color != NULL, 0);
	clr = 0;
	_tmp0_ = *color;
	clr |= ((gint) _tmp0_.r) << 16;
	_tmp1_ = *color;
	clr |= ((gint) _tmp1_.g) << 8;
	_tmp2_ = *color;
	clr |= (gint) _tmp2_.b;
	result = clr;
	return result;
}

gint
he_color_lab_to_argb_int (HeColorLABColor* lab)
{
	gdouble* white_point = NULL;
	gdouble* _tmp0_;
	gint white_point_length1;
	gint _white_point_size_;
	gdouble fy = 0.0;
	HeColorLABColor _tmp1_;
	gdouble fx = 0.0;
	HeColorLABColor _tmp2_;
	gdouble fz = 0.0;
	HeColorLABColor _tmp3_;
	gdouble xn = 0.0;
	gdouble yn = 0.0;
	gdouble zn = 0.0;
	HeColorXYZColor xyz = {0};
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	HeColorXYZColor _tmp7_ = {0};
	HeColorXYZColor _tmp8_;
	gint result;
	g_return_val_if_fail (lab != NULL, 0);
	_tmp0_ = g_new0 (gdouble, 3);
	_tmp0_[0] = HE_COLOR_XN;
	_tmp0_[1] = HE_COLOR_YN;
	_tmp0_[2] = HE_COLOR_ZN;
	white_point = _tmp0_;
	white_point_length1 = 3;
	_white_point_size_ = white_point_length1;
	_tmp1_ = *lab;
	fy = (_tmp1_.l + 16.0) / 116.0;
	_tmp2_ = *lab;
	fx = (_tmp2_.a / 500.0) + fy;
	_tmp3_ = *lab;
	fz = fy - (_tmp3_.b / 200.0);
	xn = he_math_utils_lab_inverse_fovea (fx);
	yn = he_math_utils_lab_inverse_fovea (fy);
	zn = he_math_utils_lab_inverse_fovea (fz);
	_tmp4_ = white_point[0];
	_tmp5_ = white_point[1];
	_tmp6_ = white_point[2];
	_tmp7_.x = xn * _tmp4_;
	_tmp7_.y = yn * _tmp5_;
	_tmp7_.z = zn * _tmp6_;
	xyz = _tmp7_;
	_tmp8_ = xyz;
	result = he_color_xyz_to_argb (&_tmp8_);
	white_point = (g_free (white_point), NULL);
	return result;
}

gint
he_color_argb_from_rgb_int (gint red,
                            gint green,
                            gint blue)
{
	gint result;
	result = (((255 << 24) | ((red & 255) << 16)) | ((green & 255) << 8)) | (blue & 255);
	return result;
}

gint
he_color_xyz_to_argb (HeColorXYZColor* xyz)
{
	gdouble* matrix = NULL;
	HeColorXYZColor _tmp0_;
	HeColorXYZColor _tmp1_;
	HeColorXYZColor _tmp2_;
	gdouble* _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	gdouble* _tmp6_;
	gdouble* _tmp7_;
	gint _tmp7__length1;
	gint matrix_length1;
	gint _matrix_size_;
	gint r = 0;
	gdouble _tmp8_;
	gint g = 0;
	gdouble _tmp9_;
	gint b = 0;
	gdouble _tmp10_;
	gint result;
	g_return_val_if_fail (xyz != NULL, 0);
	_tmp0_ = *xyz;
	_tmp1_ = *xyz;
	_tmp2_ = *xyz;
	_tmp3_ = g_new0 (gdouble, 3);
	_tmp3_[0] = _tmp0_.x;
	_tmp3_[1] = _tmp1_.y;
	_tmp3_[2] = _tmp2_.z;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = 3;
	_tmp6_ = he_math_utils_elem_mul (_tmp4_, (gint) 3, HE_COLOR_XYZ_TO_SRGB, (gint) G_N_ELEMENTS (HE_COLOR_XYZ_TO_SRGB), (gint) G_N_ELEMENTS (HE_COLOR_XYZ_TO_SRGB[0]), &_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp7__length1 = _tmp5_;
	_tmp4_ = (g_free (_tmp4_), NULL);
	matrix = _tmp7_;
	matrix_length1 = _tmp7__length1;
	_matrix_size_ = matrix_length1;
	_tmp8_ = matrix[0];
	r = he_math_utils_delinearized (_tmp8_);
	_tmp9_ = matrix[1];
	g = he_math_utils_delinearized (_tmp9_);
	_tmp10_ = matrix[2];
	b = he_math_utils_delinearized (_tmp10_);
	result = he_color_argb_from_rgb_int (r, g, b);
	matrix = (g_free (matrix), NULL);
	return result;
}

gdouble*
he_color_argb_to_rgb (gint argb,
                      gint* result_length1)
{
	gdouble r = 0.0;
	gdouble g = 0.0;
	gdouble b = 0.0;
	gdouble* _tmp0_;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	gdouble* _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gdouble* result;
	r = he_math_utils_linearized (he_color_red_from_rgba_int (argb));
	g = he_math_utils_linearized (he_color_green_from_rgba_int (argb));
	b = he_math_utils_linearized (he_color_blue_from_rgba_int (argb));
	_tmp0_ = g_new0 (gdouble, 3);
	_tmp0_[0] = r;
	_tmp0_[1] = g;
	_tmp0_[2] = b;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 3;
	_tmp3_ = he_math_utils_elem_mul (_tmp1_, (gint) 3, HE_COLOR_SRGB_TO_XYZ, (gint) G_N_ELEMENTS (HE_COLOR_SRGB_TO_XYZ), (gint) G_N_ELEMENTS (HE_COLOR_SRGB_TO_XYZ[0]), &_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp2_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	if (result_length1) {
		*result_length1 = _tmp5__length1;
	}
	result = _tmp5_;
	return result;
}

gint
he_color_alpha_from_rgba_int (gint argb)
{
	gint result;
	result = (argb >> 24) & 255;
	return result;
}

gint
he_color_red_from_rgba_int (gint argb)
{
	gint result;
	result = (argb >> 16) & 255;
	return result;
}

gint
he_color_green_from_rgba_int (gint argb)
{
	gint result;
	result = (argb >> 8) & 255;
	return result;
}

gint
he_color_blue_from_rgba_int (gint argb)
{
	gint result;
	result = argb & 255;
	return result;
}

