/* HCT.c generated by valac 0.56.13, the Vala compiler
 * generated from HCT.vala, do not modify */

#include "libhelium-1.h"
#include <glib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>

static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

HeColorHCTColor*
he_color_hct_color_dup (const HeColorHCTColor* self)
{
	HeColorHCTColor* dup;
	dup = g_new0 (HeColorHCTColor, 1);
	memcpy (dup, self, sizeof (HeColorHCTColor));
	return dup;
}

void
he_color_hct_color_free (HeColorHCTColor* self)
{
	g_free (self);
}

static GType
he_color_hct_color_get_type_once (void)
{
	GType he_color_hct_color_type_id;
	he_color_hct_color_type_id = g_boxed_type_register_static ("HeColorHCTColor", (GBoxedCopyFunc) he_color_hct_color_dup, (GBoxedFreeFunc) he_color_hct_color_free);
	return he_color_hct_color_type_id;
}

GType
he_color_hct_color_get_type (void)
{
	static volatile gsize he_color_hct_color_type_id__once = 0;
	if (g_once_init_enter (&he_color_hct_color_type_id__once)) {
		GType he_color_hct_color_type_id;
		he_color_hct_color_type_id = he_color_hct_color_get_type_once ();
		g_once_init_leave (&he_color_hct_color_type_id__once, he_color_hct_color_type_id);
	}
	return he_color_hct_color_type_id__once;
}

void
he_color_from_params (gdouble hue,
                      gdouble chroma,
                      gdouble tone,
                      HeColorHCTColor* result)
{
	HeColorHCTColor _result_ = {0};
	HeColorHCTColor _tmp0_ = {0};
	_tmp0_.h = hue;
	_tmp0_.c = chroma;
	_tmp0_.t = tone;
	_result_ = _tmp0_;
	*result = _result_;
	return;
}

gboolean
he_color_disliked (HeColorHCTColor* hct)
{
	gboolean _tmp0_ = FALSE;
	HeColorHCTColor _tmp1_;
	gboolean hue_passes = FALSE;
	gboolean chroma_passes = FALSE;
	HeColorHCTColor _tmp3_;
	gboolean tone_passes = FALSE;
	HeColorHCTColor _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean result;
	g_return_val_if_fail (hct != NULL, FALSE);
	_tmp1_ = *hct;
	if (round (_tmp1_.h) >= 90.0) {
		HeColorHCTColor _tmp2_;
		_tmp2_ = *hct;
		_tmp0_ = round (_tmp2_.h) <= 111.0;
	} else {
		_tmp0_ = FALSE;
	}
	hue_passes = _tmp0_;
	_tmp3_ = *hct;
	chroma_passes = round (_tmp3_.c) > 16.0;
	_tmp4_ = *hct;
	tone_passes = round (_tmp4_.t) < 70.0;
	if (hue_passes) {
		_tmp6_ = chroma_passes;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		_tmp5_ = tone_passes;
	} else {
		_tmp5_ = FALSE;
	}
	result = _tmp5_;
	return result;
}

/** If color is disliked, lighten it to make it likable. */
void
he_color_fix_disliked (HeColorHCTColor* hct,
                       HeColorHCTColor* result)
{
	HeColorHCTColor _tmp0_;
	HeColorHCTColor _tmp4_;
	g_return_if_fail (hct != NULL);
	_tmp0_ = *hct;
	if (he_color_disliked (&_tmp0_)) {
		HeColorHCTColor _tmp1_;
		HeColorHCTColor _tmp2_;
		HeColorHCTColor _tmp3_ = {0};
		_tmp1_ = *hct;
		_tmp2_ = *hct;
		he_color_from_params (_tmp1_.h, _tmp2_.c, 70.0, &_tmp3_);
		*result = _tmp3_;
		return;
	}
	_tmp4_ = *hct;
	*result = _tmp4_;
	return;
}

gchar*
he_color_hct_to_hex (gdouble hue,
                     gdouble chroma,
                     gdouble lstar)
{
	HeColorHCTColor hct = {0};
	HeColorHCTColor _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	HeColorHCTColor _tmp3_;
	HeColorHCTColor _tmp8_;
	gdouble hr = 0.0;
	gdouble y = 0.0;
	HeColorHCTColor _tmp9_;
	gint exact_answer = 0;
	HeColorHCTColor _tmp10_;
	gdouble* linrgb = NULL;
	gint _tmp12_ = 0;
	gdouble* _tmp13_;
	gint linrgb_length1;
	gint _linrgb_size_;
	gdouble* _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_;
	gchar* result;
	_tmp0_.h = hue;
	_tmp0_.c = chroma;
	_tmp0_.t = lstar;
	hct = _tmp0_;
	_tmp3_ = hct;
	if (_tmp3_.c < 1.0001) {
		_tmp2_ = TRUE;
	} else {
		HeColorHCTColor _tmp4_;
		_tmp4_ = hct;
		_tmp2_ = _tmp4_.t < 0.0001;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		HeColorHCTColor _tmp5_;
		_tmp5_ = hct;
		_tmp1_ = _tmp5_.t > 99.9999;
	}
	if (_tmp1_) {
		HeColorHCTColor _tmp6_;
		gchar* _tmp7_;
		_tmp6_ = hct;
		_tmp7_ = he_color_hexcode_argb (he_math_utils_argb_from_lstar (_tmp6_.t));
		result = _tmp7_;
		return result;
	}
	_tmp8_ = hct;
	hue = he_math_utils_sanitize_degrees (_tmp8_.h);
	hr = (hue / 180) * G_PI;
	_tmp9_ = hct;
	y = he_math_utils_y_from_lstar (_tmp9_.t);
	_tmp10_ = hct;
	exact_answer = he_color_find_result_by_j (hr, _tmp10_.c, y);
	if (exact_answer != 0) {
		gchar* _tmp11_;
		_tmp11_ = he_color_hexcode_argb (exact_answer);
		result = _tmp11_;
		return result;
	}
	_tmp13_ = he_math_utils_bisect_to_limit (y, hr, &_tmp12_);
	linrgb = _tmp13_;
	linrgb_length1 = _tmp12_;
	_linrgb_size_ = linrgb_length1;
	_tmp14_ = linrgb;
	_tmp14__length1 = linrgb_length1;
	_tmp15_ = he_color_hexcode_argb (he_color_argb_from_linrgb (_tmp14_, (gint) _tmp14__length1));
	result = _tmp15_;
	linrgb = (g_free (linrgb), NULL);
	return result;
}

gint
he_color_hct_to_argb (gdouble hue,
                      gdouble chroma,
                      gdouble lstar)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gdouble hues = 0.0;
	gdouble hr = 0.0;
	gdouble y = 0.0;
	gint exact_answer = 0;
	gdouble* linrgb = NULL;
	gint _tmp2_ = 0;
	gdouble* _tmp3_;
	gint linrgb_length1;
	gint _linrgb_size_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gint result;
	if (chroma < 1.0001) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = lstar < 0.0001;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = lstar > 99.9999;
	}
	if (_tmp0_) {
		result = he_math_utils_argb_from_lstar (lstar);
		return result;
	}
	hues = he_math_utils_sanitize_degrees (hue);
	hr = (hues / 180) * G_PI;
	y = he_math_utils_y_from_lstar (lstar);
	exact_answer = he_color_find_result_by_j (hr, chroma, y);
	if (exact_answer != 0) {
		result = exact_answer;
		return result;
	}
	_tmp3_ = he_math_utils_bisect_to_limit (y, hr, &_tmp2_);
	linrgb = _tmp3_;
	linrgb_length1 = _tmp2_;
	_linrgb_size_ = linrgb_length1;
	_tmp4_ = linrgb;
	_tmp4__length1 = linrgb_length1;
	result = he_color_argb_from_linrgb (_tmp4_, (gint) _tmp4__length1);
	linrgb = (g_free (linrgb), NULL);
	return result;
}

void
he_color_hct_blend (HeColorHCTColor* a,
                    HeColorHCTColor* b,
                    HeColorHCTColor* result)
{
	gdouble difference_degrees = 0.0;
	HeColorHCTColor _tmp0_;
	HeColorHCTColor _tmp1_;
	gdouble rot_deg = 0.0;
	gdouble output = 0.0;
	HeColorHCTColor _tmp2_;
	HeColorHCTColor _tmp3_;
	HeColorHCTColor _tmp4_;
	HeColorHCTColor _tmp5_;
	HeColorHCTColor _tmp6_;
	HeColorHCTColor _tmp7_ = {0};
	HeColorHCTColor _tmp8_ = {0};
	g_return_if_fail (a != NULL);
	g_return_if_fail (b != NULL);
	_tmp0_ = *a;
	_tmp1_ = *b;
	difference_degrees = he_math_utils_difference_degrees (_tmp0_.h, _tmp1_.h);
	rot_deg = he_math_utils_min (difference_degrees / 2, 15.0);
	_tmp2_ = *a;
	_tmp3_ = *a;
	_tmp4_ = *b;
	output = he_math_utils_sanitize_degrees (_tmp2_.h + (rot_deg * he_math_utils_rotate_direction (_tmp3_.h, _tmp4_.h)));
	_tmp5_ = *a;
	_tmp6_ = *a;
	_tmp7_.h = output;
	_tmp7_.c = _tmp5_.c;
	_tmp7_.t = _tmp6_.t;
	he_color_fix_disliked (&_tmp7_, &_tmp8_);
	*result = _tmp8_;
	return;
}

gdouble
he_color_get_rotated_hue (gdouble hue,
                          gdouble* hues,
                          gint hues_length1,
                          gdouble* rotations,
                          gint rotations_length1)
{
	gdouble source_hue = 0.0;
	gint size = 0;
	gdouble result;
	source_hue = hue;
	if (rotations_length1 == 1) {
		gdouble _tmp0_;
		_tmp0_ = rotations[0];
		result = he_math_utils_sanitize_degrees (source_hue + _tmp0_);
		return result;
	}
	size = hues_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gdouble hue_a = 0.0;
				gdouble _tmp3_;
				gdouble hue_b = 0.0;
				gdouble _tmp4_;
				gboolean _tmp5_ = FALSE;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(i <= (size - 2))) {
					break;
				}
				_tmp3_ = hues[i];
				hue_a = _tmp3_;
				_tmp4_ = hues[i + 1];
				hue_b = _tmp4_;
				if (hue_a < source_hue) {
					_tmp5_ = source_hue < hue_b;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					gdouble _tmp6_;
					_tmp6_ = rotations[i];
					result = he_math_utils_sanitize_degrees (source_hue + _tmp6_);
					return result;
				}
			}
		}
	}
	result = source_hue;
	return result;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

