/* LAB.c generated by valac 0.56.13, the Vala compiler
 * generated from LAB.vala, do not modify */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "libhelium-1.h"
#include <string.h>

#define HE_COLOR_KN 16.0
#define HE_COLOR_XN 0.95047
#define HE_COLOR_YN 1.00000
#define HE_COLOR_ZN 1.08883
#define HE_COLOR_T0 0.137931034
#define HE_COLOR_T1 0.206896552
#define HE_COLOR_T2 0.128418549
#define HE_COLOR_T3 0.008856452

static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

VALA_EXTERN const gdouble HE_COLOR_SRGB_TO_XYZ[3][3];

gdouble
he_color_lab_color_distance (HeColorLABColor *self,
                             HeColorLABColor* lab)
{
	gdouble d_l = 0.0;
	HeColorLABColor _tmp0_;
	gdouble d_a = 0.0;
	HeColorLABColor _tmp1_;
	gdouble d_b = 0.0;
	HeColorLABColor _tmp2_;
	gdouble result;
	g_return_val_if_fail (lab != NULL, 0.0);
	_tmp0_ = *lab;
	d_l = (*self).l - _tmp0_.l;
	_tmp1_ = *lab;
	d_a = (*self).a - _tmp1_.a;
	_tmp2_ = *lab;
	d_b = (*self).b - _tmp2_.b;
	result = ((d_l * d_l) + (d_a * d_a)) + (d_b * d_b);
	return result;
}

HeColorLABColor*
he_color_lab_color_dup (const HeColorLABColor* self)
{
	HeColorLABColor* dup;
	dup = g_new0 (HeColorLABColor, 1);
	memcpy (dup, self, sizeof (HeColorLABColor));
	return dup;
}

void
he_color_lab_color_free (HeColorLABColor* self)
{
	g_free (self);
}

static GType
he_color_lab_color_get_type_once (void)
{
	GType he_color_lab_color_type_id;
	he_color_lab_color_type_id = g_boxed_type_register_static ("HeColorLABColor", (GBoxedCopyFunc) he_color_lab_color_dup, (GBoxedFreeFunc) he_color_lab_color_free);
	return he_color_lab_color_type_id;
}

GType
he_color_lab_color_get_type (void)
{
	static volatile gsize he_color_lab_color_type_id__once = 0;
	if (g_once_init_enter (&he_color_lab_color_type_id__once)) {
		GType he_color_lab_color_type_id;
		he_color_lab_color_type_id = he_color_lab_color_get_type_once ();
		g_once_init_leave (&he_color_lab_color_type_id__once, he_color_lab_color_type_id);
	}
	return he_color_lab_color_type_id__once;
}

gdouble
he_color_xyz_value_to_lab (gdouble v)
{
	gdouble result;
	if (v > HE_COLOR_T3) {
		result = pow (v, 1. / 3.);
		return result;
	}
	result = (v / HE_COLOR_T2) + HE_COLOR_T0;
	return result;
}

void
he_color_xyz_to_lab (HeColorXYZColor* color,
                     HeColorLABColor* result)
{
	gdouble l = 0.0;
	HeColorXYZColor _tmp0_;
	gdouble a = 0.0;
	HeColorXYZColor _tmp1_;
	gdouble b = 0.0;
	HeColorXYZColor _tmp2_;
	HeColorLABColor _result_ = {0};
	HeColorLABColor _tmp3_ = {0};
	g_return_if_fail (color != NULL);
	_tmp0_ = *color;
	l = he_color_xyz_value_to_lab (_tmp0_.x);
	_tmp1_ = *color;
	a = he_color_xyz_value_to_lab (_tmp1_.y);
	_tmp2_ = *color;
	b = he_color_xyz_value_to_lab (_tmp2_.z);
	_tmp3_.l = l;
	_tmp3_.a = a;
	_tmp3_.b = b;
	_result_ = _tmp3_;
	*result = _result_;
	return;
}

void
he_color_lch_to_lab (HeColorLCHColor* color,
                     HeColorLABColor* result)
{
	gdouble hr = 0.0;
	HeColorLCHColor _tmp0_;
	HeColorLABColor _result_ = {0};
	HeColorLCHColor _tmp1_;
	HeColorLCHColor _tmp2_;
	HeColorLCHColor _tmp3_;
	HeColorLABColor _tmp4_ = {0};
	g_return_if_fail (color != NULL);
	_tmp0_ = *color;
	hr = (_tmp0_.h * G_PI) / 180.0;
	_tmp1_ = *color;
	_tmp2_ = *color;
	_tmp3_ = *color;
	_tmp4_.l = _tmp1_.l;
	_tmp4_.a = _tmp2_.c * cos (hr);
	_tmp4_.b = _tmp3_.c * sin (hr);
	_result_ = _tmp4_;
	*result = _result_;
	return;
}

void
he_color_rgb_to_lab (HeColorRGBColor* color,
                     HeColorLABColor* result)
{
	HeColorXYZColor xyz_color = {0};
	HeColorRGBColor _tmp0_;
	HeColorXYZColor _tmp1_ = {0};
	gdouble l = 0.0;
	HeColorXYZColor _tmp2_;
	gdouble _tmp3_ = 0.0;
	HeColorLABColor _result_ = {0};
	HeColorXYZColor _tmp4_;
	HeColorXYZColor _tmp5_;
	HeColorXYZColor _tmp6_;
	HeColorXYZColor _tmp7_;
	HeColorLABColor _tmp8_ = {0};
	g_return_if_fail (color != NULL);
	_tmp0_ = *color;
	he_color_rgb_to_xyz (&_tmp0_, &_tmp1_);
	xyz_color = _tmp1_;
	_tmp2_ = xyz_color;
	l = (116. * _tmp2_.y) - 16.;
	if (l < ((gdouble) 0)) {
		_tmp3_ = (gdouble) 0;
	} else {
		_tmp3_ = l;
	}
	_tmp4_ = xyz_color;
	_tmp5_ = xyz_color;
	_tmp6_ = xyz_color;
	_tmp7_ = xyz_color;
	_tmp8_.l = _tmp3_;
	_tmp8_.a = 500. * (_tmp4_.x - _tmp5_.y);
	_tmp8_.b = 200. * (_tmp6_.y - _tmp7_.z);
	_result_ = _tmp8_;
	*result = _result_;
	return;
}

void
he_color_lab_from_argb (gint argb,
                        HeColorLABColor* result)
{
	gdouble linear_r = 0.0;
	gdouble linear_g = 0.0;
	gdouble linear_b = 0.0;
	gdouble* xyz = NULL;
	gdouble* _tmp0_;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	gdouble* _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gint xyz_length1;
	gint _xyz_size_;
	gdouble* d65 = NULL;
	gdouble* _tmp5_;
	gint d65_length1;
	gint _d65_size_;
	gdouble xn = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble yn = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble zn = 0.0;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble fz = 0.0;
	gdouble l = 0.0;
	gdouble a = 0.0;
	gdouble b = 0.0;
	HeColorLABColor _tmp12_ = {0};
	linear_r = he_math_utils_linearized (he_color_red_from_rgba_int (argb));
	linear_g = he_math_utils_linearized (he_color_green_from_rgba_int (argb));
	linear_b = he_math_utils_linearized (he_color_blue_from_rgba_int (argb));
	_tmp0_ = g_new0 (gdouble, 3);
	_tmp0_[0] = linear_r;
	_tmp0_[1] = linear_g;
	_tmp0_[2] = linear_b;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 3;
	_tmp3_ = he_math_utils_elem_mul (_tmp1_, (gint) 3, HE_COLOR_SRGB_TO_XYZ, (gint) G_N_ELEMENTS (HE_COLOR_SRGB_TO_XYZ), (gint) G_N_ELEMENTS (HE_COLOR_SRGB_TO_XYZ[0]), &_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp2_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	xyz = _tmp4_;
	xyz_length1 = _tmp4__length1;
	_xyz_size_ = xyz_length1;
	_tmp5_ = g_new0 (gdouble, 3);
	_tmp5_[0] = HE_COLOR_XN;
	_tmp5_[1] = HE_COLOR_YN;
	_tmp5_[2] = HE_COLOR_ZN;
	d65 = _tmp5_;
	d65_length1 = 3;
	_d65_size_ = d65_length1;
	_tmp6_ = xyz[0];
	_tmp7_ = d65[0];
	xn = _tmp6_ / _tmp7_;
	_tmp8_ = xyz[1];
	_tmp9_ = d65[1];
	yn = _tmp8_ / _tmp9_;
	_tmp10_ = xyz[2];
	_tmp11_ = d65[2];
	zn = _tmp10_ / _tmp11_;
	fx = he_math_utils_lab_fovea (xn);
	fy = he_math_utils_lab_fovea (yn);
	fz = he_math_utils_lab_fovea (zn);
	l = (116.0 * fy) - 16;
	a = 500.0 * (fx - fy);
	b = 200.0 * (fy - fz);
	_tmp12_.l = l;
	_tmp12_.a = a;
	_tmp12_.b = b;
	*result = _tmp12_;
	d65 = (g_free (d65), NULL);
	xyz = (g_free (xyz), NULL);
	return;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

