/* Desktop.c generated by valac 0.56.13, the Vala compiler
 * generated from Desktop.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define HE_PORTAL_TYPE_SETTINGS (he_portal_settings_get_type ())
#define HE_PORTAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HE_PORTAL_TYPE_SETTINGS, HePortalSettings))
#define HE_PORTAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HE_PORTAL_TYPE_SETTINGS))
#define HE_PORTAL_SETTINGS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), HE_PORTAL_TYPE_SETTINGS, HePortalSettingsIface))

typedef struct _HePortalSettings HePortalSettings;
typedef struct _HePortalSettingsIface HePortalSettingsIface;

#define HE_PORTAL_TYPE_SETTINGS_PROXY (he_portal_settings_proxy_get_type ())
enum  {
	HE_DESKTOP_0_PROPERTY,
	HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY,
	HE_DESKTOP_DARK_MODE_STRENGTH_PROPERTY,
	HE_DESKTOP_ENSOR_SCHEME_PROPERTY,
	HE_DESKTOP_ACCENT_COLOR_PROPERTY,
	HE_DESKTOP_FONT_WEIGHT_PROPERTY,
	HE_DESKTOP_NUM_PROPERTIES
};
static GParamSpec* he_desktop_properties[HE_DESKTOP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _he_color_rgb_color_free0(var) ((var == NULL) ? NULL : (var = (he_color_rgb_color_free (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))

struct _HePortalSettingsIface {
	GTypeInterface parent_iface;
	GHashTable* (*read_all) (HePortalSettings* self, gchar** namespaces, gint namespaces_length1, GError** error);
	GVariant* (*read) (HePortalSettings* self, const gchar* namespace, const gchar* key, GError** error);
};

struct _HeDesktopPrivate {
	HePortalSettings* portal;
	HeDesktopColorScheme* _prefers_color_scheme;
	HeDarkModeStrength* _dark_mode_strength;
	HeDesktopEnsorScheme* _ensor_scheme;
	HeColorRGBColor* _accent_color;
	gdouble _font_weight;
};

static gint HeDesktop_private_offset;
static gpointer he_desktop_parent_class = NULL;

VALA_EXTERN GType he_portal_settings_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint he_portal_settings_register_object (void* object,
                                          GDBusConnection* connection,
                                          const gchar* path,
                                          GError** error);
VALA_EXTERN GType he_portal_settings_get_type (void) G_GNUC_CONST ;
static HeDesktopColorScheme* _he_desktop_color_scheme_dup (HeDesktopColorScheme* self);
static void he_desktop_setup_prefers_color_scheme (HeDesktop* self);
VALA_EXTERN HePortalSettings* he_portal_settings_get (GError** error);
VALA_EXTERN GVariant* he_portal_settings_read (HePortalSettings* self,
                                   const gchar* namespace,
                                   const gchar* key,
                                   GError** error);
static void he_desktop_set_dark_mode_strength (HeDesktop* self,
                                        HeDarkModeStrength value);
static HeDarkModeStrength* _he_dark_mode_strength_dup (HeDarkModeStrength* self);
static void he_desktop_setup_dark_mode_strength (HeDesktop* self);
static void he_desktop_set_ensor_scheme (HeDesktop* self,
                                  HeDesktopEnsorScheme value);
static HeDesktopEnsorScheme* _he_desktop_ensor_scheme_dup (HeDesktopEnsorScheme* self);
static void he_desktop_setup_ensor_scheme (HeDesktop* self);
static HeColorRGBColor* he_desktop_parse_accent_color (HeDesktop* self,
                                                GVariant* val);
static void he_desktop_setup_accent_color (HeDesktop* self);
static void he_desktop_setup_font_weight (HeDesktop* self);
static void he_desktop_init_handle_settings_change (HeDesktop* self);
static void __lambda4_ (HeDesktop* self,
                 const gchar* scheme,
                 const gchar* key,
                 GVariant* val);
static void ___lambda4__he_portal_settings_setting_changed (HePortalSettings* _sender,
                                                     const gchar* namespace,
                                                     const gchar* key,
                                                     GVariant* val,
                                                     gpointer self);
static GObject * he_desktop_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void he_desktop_finalize (GObject * obj);
static GType he_desktop_get_type_once (void);
static void _vala_he_desktop_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_he_desktop_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_desktop_get_instance_private (HeDesktop* self)
{
	return G_STRUCT_MEMBER_P (self, HeDesktop_private_offset);
}

/**
    * The color scheme preference enum, which is used to determine the color scheme of the desktop.
    */
static GType
he_desktop_color_scheme_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_DESKTOP_COLOR_SCHEME_NO_PREFERENCE, "HE_DESKTOP_COLOR_SCHEME_NO_PREFERENCE", "no-preference"}, {HE_DESKTOP_COLOR_SCHEME_DARK, "HE_DESKTOP_COLOR_SCHEME_DARK", "dark"}, {HE_DESKTOP_COLOR_SCHEME_LIGHT, "HE_DESKTOP_COLOR_SCHEME_LIGHT", "light"}, {0, NULL, NULL}};
	GType he_desktop_color_scheme_type_id;
	he_desktop_color_scheme_type_id = g_enum_register_static ("HeDesktopColorScheme", values);
	return he_desktop_color_scheme_type_id;
}

GType
he_desktop_color_scheme_get_type (void)
{
	static volatile gsize he_desktop_color_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_color_scheme_type_id__once)) {
		GType he_desktop_color_scheme_type_id;
		he_desktop_color_scheme_type_id = he_desktop_color_scheme_get_type_once ();
		g_once_init_leave (&he_desktop_color_scheme_type_id__once, he_desktop_color_scheme_type_id);
	}
	return he_desktop_color_scheme_type_id__once;
}

/**
    * The Ensor scheme preference enum, which is used to determine the Ensor scheme of the desktop.
    */
HeSchemeFactory*
he_desktop_ensor_scheme_to_factory (HeDesktopEnsorScheme self)
{
	HeSchemeFactory* result;
	switch (self) {
		case HE_DESKTOP_ENSOR_SCHEME_DEFAULT:
		{
			HeDefaultScheme* _tmp0_;
			_tmp0_ = he_default_scheme_new ();
			result = (HeSchemeFactory*) _tmp0_;
			return result;
		}
		case HE_DESKTOP_ENSOR_SCHEME_VIBRANT:
		{
			HeVibrantScheme* _tmp1_;
			_tmp1_ = he_vibrant_scheme_new ();
			result = (HeSchemeFactory*) _tmp1_;
			return result;
		}
		case HE_DESKTOP_ENSOR_SCHEME_MUTED:
		{
			HeMutedScheme* _tmp2_;
			_tmp2_ = he_muted_scheme_new ();
			result = (HeSchemeFactory*) _tmp2_;
			return result;
		}
		case HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC:
		{
			HeMonochromaticScheme* _tmp3_;
			_tmp3_ = he_monochromatic_scheme_new ();
			result = (HeSchemeFactory*) _tmp3_;
			return result;
		}
		default:
		{
			HeDefaultScheme* _tmp4_;
			_tmp4_ = he_default_scheme_new ();
			result = (HeSchemeFactory*) _tmp4_;
			return result;
		}
	}
}

static GType
he_desktop_ensor_scheme_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_DESKTOP_ENSOR_SCHEME_DEFAULT, "HE_DESKTOP_ENSOR_SCHEME_DEFAULT", "default"}, {HE_DESKTOP_ENSOR_SCHEME_VIBRANT, "HE_DESKTOP_ENSOR_SCHEME_VIBRANT", "vibrant"}, {HE_DESKTOP_ENSOR_SCHEME_MUTED, "HE_DESKTOP_ENSOR_SCHEME_MUTED", "muted"}, {HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC, "HE_DESKTOP_ENSOR_SCHEME_MONOCHROMATIC", "monochromatic"}, {0, NULL, NULL}};
	GType he_desktop_ensor_scheme_type_id;
	he_desktop_ensor_scheme_type_id = g_enum_register_static ("HeDesktopEnsorScheme", values);
	return he_desktop_ensor_scheme_type_id;
}

GType
he_desktop_ensor_scheme_get_type (void)
{
	static volatile gsize he_desktop_ensor_scheme_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_ensor_scheme_type_id__once)) {
		GType he_desktop_ensor_scheme_type_id;
		he_desktop_ensor_scheme_type_id = he_desktop_ensor_scheme_get_type_once ();
		g_once_init_leave (&he_desktop_ensor_scheme_type_id__once, he_desktop_ensor_scheme_type_id);
	}
	return he_desktop_ensor_scheme_type_id__once;
}

HeDesktopColorScheme
he_desktop_get_prefers_color_scheme (HeDesktop* self)
{
	HeDesktopColorScheme result;
	HeDesktopColorScheme* _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_prefers_color_scheme;
	result = *_tmp0_;
	return result;
}

static HeDesktopColorScheme*
_he_desktop_color_scheme_dup (HeDesktopColorScheme* self)
{
	HeDesktopColorScheme* dup;
	dup = g_new0 (HeDesktopColorScheme, 1);
	memcpy (dup, self, sizeof (HeDesktopColorScheme));
	return dup;
}

static gpointer
__he_desktop_color_scheme_dup0 (gpointer self)
{
	return self ? _he_desktop_color_scheme_dup (self) : NULL;
}

void
he_desktop_set_prefers_color_scheme (HeDesktop* self,
                                     HeDesktopColorScheme value)
{
	HeDesktopColorScheme* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = __he_desktop_color_scheme_dup0 (&value);
	_g_free0 (self->priv->_prefers_color_scheme);
	self->priv->_prefers_color_scheme = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY]);
}

static void
he_desktop_setup_prefers_color_scheme (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		HePortalSettings* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		HePortalSettings* _tmp2_;
		GVariant* _tmp3_ = NULL;
		HePortalSettings* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		_tmp1_ = he_portal_settings_get (&_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->portal);
		self->priv->portal = _tmp2_;
		_tmp4_ = self->priv->portal;
		_tmp5_ = he_portal_settings_read (_tmp4_, "org.freedesktop.appearance", "color-scheme", &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp6_ = g_variant_get_variant (_tmp3_);
		_tmp7_ = _tmp6_;
		he_desktop_set_prefers_color_scheme (self, (HeDesktopColorScheme) g_variant_get_uint32 (_tmp7_));
		_g_variant_unref0 (_tmp7_);
		_g_variant_unref0 (_tmp3_);
		_g_object_unref0 (_tmp0_);
		return;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_debug ("Desktop.vala:60: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	he_desktop_set_prefers_color_scheme (self, HE_DESKTOP_COLOR_SCHEME_NO_PREFERENCE);
}

HeDarkModeStrength
he_desktop_get_dark_mode_strength (HeDesktop* self)
{
	HeDarkModeStrength result;
	HeDarkModeStrength* _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_dark_mode_strength;
	result = *_tmp0_;
	return result;
}

static HeDarkModeStrength*
_he_dark_mode_strength_dup (HeDarkModeStrength* self)
{
	HeDarkModeStrength* dup;
	dup = g_new0 (HeDarkModeStrength, 1);
	memcpy (dup, self, sizeof (HeDarkModeStrength));
	return dup;
}

static gpointer
__he_dark_mode_strength_dup0 (gpointer self)
{
	return self ? _he_dark_mode_strength_dup (self) : NULL;
}

static void
he_desktop_set_dark_mode_strength (HeDesktop* self,
                                   HeDarkModeStrength value)
{
	HeDarkModeStrength* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = __he_dark_mode_strength_dup0 (&value);
	_g_free0 (self->priv->_dark_mode_strength);
	self->priv->_dark_mode_strength = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_DARK_MODE_STRENGTH_PROPERTY]);
}

static void
he_desktop_setup_dark_mode_strength (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		HePortalSettings* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		HePortalSettings* _tmp2_;
		GVariant* _tmp3_ = NULL;
		HePortalSettings* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		_tmp1_ = he_portal_settings_get (&_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->portal);
		self->priv->portal = _tmp2_;
		_tmp4_ = self->priv->portal;
		_tmp5_ = he_portal_settings_read (_tmp4_, "org.freedesktop.appearance", "dark-mode-strength", &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp6_ = g_variant_get_variant (_tmp3_);
		_tmp7_ = _tmp6_;
		he_desktop_set_dark_mode_strength (self, (HeDarkModeStrength) g_variant_get_uint32 (_tmp7_));
		_g_variant_unref0 (_tmp7_);
		_g_variant_unref0 (_tmp3_);
		_g_object_unref0 (_tmp0_);
		return;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_debug ("Desktop.vala:90: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	he_desktop_set_dark_mode_strength (self, HE_DARK_MODE_STRENGTH_MEDIUM);
}

HeDesktopEnsorScheme
he_desktop_get_ensor_scheme (HeDesktop* self)
{
	HeDesktopEnsorScheme result;
	HeDesktopEnsorScheme* _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_ensor_scheme;
	result = *_tmp0_;
	return result;
}

static HeDesktopEnsorScheme*
_he_desktop_ensor_scheme_dup (HeDesktopEnsorScheme* self)
{
	HeDesktopEnsorScheme* dup;
	dup = g_new0 (HeDesktopEnsorScheme, 1);
	memcpy (dup, self, sizeof (HeDesktopEnsorScheme));
	return dup;
}

static gpointer
__he_desktop_ensor_scheme_dup0 (gpointer self)
{
	return self ? _he_desktop_ensor_scheme_dup (self) : NULL;
}

static void
he_desktop_set_ensor_scheme (HeDesktop* self,
                             HeDesktopEnsorScheme value)
{
	HeDesktopEnsorScheme* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = __he_desktop_ensor_scheme_dup0 (&value);
	_g_free0 (self->priv->_ensor_scheme);
	self->priv->_ensor_scheme = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_ENSOR_SCHEME_PROPERTY]);
}

static void
he_desktop_setup_ensor_scheme (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		HePortalSettings* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		HePortalSettings* _tmp2_;
		GVariant* _tmp3_ = NULL;
		HePortalSettings* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		_tmp1_ = he_portal_settings_get (&_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->portal);
		self->priv->portal = _tmp2_;
		_tmp4_ = self->priv->portal;
		_tmp5_ = he_portal_settings_read (_tmp4_, "org.freedesktop.appearance", "ensor-scheme", &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp6_ = g_variant_get_variant (_tmp3_);
		_tmp7_ = _tmp6_;
		he_desktop_set_ensor_scheme (self, (HeDesktopEnsorScheme) g_variant_get_uint32 (_tmp7_));
		_g_variant_unref0 (_tmp7_);
		_g_variant_unref0 (_tmp3_);
		_g_object_unref0 (_tmp0_);
		return;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_debug ("Desktop.vala:145: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	he_desktop_set_ensor_scheme (self, HE_DESKTOP_ENSOR_SCHEME_DEFAULT);
}

HeColorRGBColor*
he_desktop_get_accent_color (HeDesktop* self)
{
	HeColorRGBColor* result;
	HeColorRGBColor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_accent_color;
	result = _tmp0_;
	return result;
}

static gpointer
_he_color_rgb_color_dup0 (gpointer self)
{
	return self ? he_color_rgb_color_dup (self) : NULL;
}

void
he_desktop_set_accent_color (HeDesktop* self,
                             HeColorRGBColor* value)
{
	HeColorRGBColor* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _he_color_rgb_color_dup0 (value);
	_he_color_rgb_color_free0 (self->priv->_accent_color);
	self->priv->_accent_color = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_ACCENT_COLOR_PROPERTY]);
}

static HeColorRGBColor*
he_desktop_parse_accent_color (HeDesktop* self,
                               GVariant* val)
{
	gdouble cr = 0.0;
	gdouble cg = 0.0;
	gdouble cb = 0.0;
	GVariantIter* iter = NULL;
	GVariantIter* _tmp0_;
	GVariantIter* _tmp1_;
	gdouble _tmp2_ = 0.0;
	GVariantIter* _tmp3_;
	gdouble _tmp4_ = 0.0;
	GVariantIter* _tmp5_;
	gdouble _tmp6_ = 0.0;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	HeColorRGBColor rgb_color = {0};
	HeColorRGBColor _tmp12_ = {0};
	HeColorRGBColor* _tmp13_;
	HeColorRGBColor* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (val != NULL, NULL);
	cb = 0.0;
	_tmp0_ = g_variant_iter_new (val);
	iter = _tmp0_;
	_tmp1_ = iter;
	g_variant_iter_next (_tmp1_, "d", &_tmp2_, NULL);
	cr = _tmp2_;
	_tmp3_ = iter;
	g_variant_iter_next (_tmp3_, "d", &_tmp4_, NULL);
	cg = _tmp4_;
	_tmp5_ = iter;
	g_variant_iter_next (_tmp5_, "d", &_tmp6_, NULL);
	cb = _tmp6_;
	if (cr >= 0.0) {
		_tmp11_ = cr <= 1.0;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		_tmp10_ = cg >= 0.0;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		_tmp9_ = cg <= 1.0;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		_tmp8_ = cb >= 0.0;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		_tmp7_ = cb <= 1.0;
	} else {
		_tmp7_ = FALSE;
	}
	if (!_tmp7_) {
		result = NULL;
		_g_variant_iter_free0 (iter);
		return result;
	}
	_tmp12_.r = cr * 255;
	_tmp12_.g = cg * 255;
	_tmp12_.b = cb * 255;
	rgb_color = _tmp12_;
	_tmp13_ = _he_color_rgb_color_dup0 (&rgb_color);
	result = _tmp13_;
	_g_variant_iter_free0 (iter);
	return result;
}

static void
he_desktop_setup_accent_color (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		HePortalSettings* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		HePortalSettings* _tmp2_;
		GVariant* _tmp3_ = NULL;
		HePortalSettings* _tmp4_;
		GVariant* _tmp5_;
		GVariant* accent = NULL;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		HeColorRGBColor* _tmp8_;
		HeColorRGBColor* _tmp9_;
		_tmp1_ = he_portal_settings_get (&_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->portal);
		self->priv->portal = _tmp2_;
		_tmp4_ = self->priv->portal;
		_tmp5_ = he_portal_settings_read (_tmp4_, "org.freedesktop.appearance", "accent-color", &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp6_ = g_variant_get_variant (_tmp3_);
		accent = _tmp6_;
		_tmp7_ = accent;
		_tmp8_ = he_desktop_parse_accent_color (self, _tmp7_);
		_tmp9_ = _tmp8_;
		he_desktop_set_accent_color (self, _tmp9_);
		_he_color_rgb_color_free0 (_tmp9_);
		_g_variant_unref0 (accent);
		_g_variant_unref0 (_tmp3_);
		_g_object_unref0 (_tmp0_);
		return;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		g_debug ("Desktop.vala:203: %s", _tmp11_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	he_desktop_set_accent_color (self, NULL);
}

gdouble
he_desktop_get_font_weight (HeDesktop* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_font_weight;
	return result;
}

void
he_desktop_set_font_weight (HeDesktop* self,
                            gdouble value)
{
	g_return_if_fail (self != NULL);
	self->priv->_font_weight = value;
	g_object_notify_by_pspec ((GObject *) self, he_desktop_properties[HE_DESKTOP_FONT_WEIGHT_PROPERTY]);
}

static void
he_desktop_setup_font_weight (HeDesktop* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		HePortalSettings* _tmp0_ = NULL;
		HePortalSettings* _tmp1_;
		HePortalSettings* _tmp2_;
		GVariant* _tmp3_ = NULL;
		HePortalSettings* _tmp4_;
		GVariant* _tmp5_;
		gdouble fw = 0.0;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		gdouble _tmp8_;
		_tmp1_ = he_portal_settings_get (&_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->portal);
		self->priv->portal = _tmp2_;
		_tmp4_ = self->priv->portal;
		_tmp5_ = he_portal_settings_read (_tmp4_, "org.freedesktop.appearance", "font-weight", &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			goto __catch0_g_error;
		}
		_tmp6_ = g_variant_get_variant (_tmp3_);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_variant_get_double (_tmp7_);
		_g_variant_unref0 (_tmp7_);
		fw = _tmp8_;
		he_desktop_set_font_weight (self, (gdouble) fw);
		_g_variant_unref0 (_tmp3_);
		_g_object_unref0 (_tmp0_);
		return;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_debug ("Desktop.vala:235: %s", _tmp10_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	he_desktop_set_font_weight (self, 1.0);
}

static void
__lambda4_ (HeDesktop* self,
            const gchar* scheme,
            const gchar* key,
            GVariant* val)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	g_return_if_fail (scheme != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (val != NULL);
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
		_tmp0_ = g_strcmp0 (key, "accent-color") == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		HeColorRGBColor* _tmp1_;
		HeColorRGBColor* _tmp2_;
		_tmp1_ = he_desktop_parse_accent_color (self, val);
		_tmp2_ = _tmp1_;
		he_desktop_set_accent_color (self, _tmp2_);
		_he_color_rgb_color_free0 (_tmp2_);
	}
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
		_tmp3_ = g_strcmp0 (key, "font-weight") == 0;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		he_desktop_set_font_weight (self, (gdouble) g_variant_get_double (val));
	}
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
		_tmp4_ = g_strcmp0 (key, "dark-mode-strength") == 0;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		he_desktop_set_dark_mode_strength (self, (HeDarkModeStrength) g_variant_get_uint32 (val));
	}
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
		_tmp5_ = g_strcmp0 (key, "ensor-scheme") == 0;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		he_desktop_set_ensor_scheme (self, (HeDesktopEnsorScheme) g_variant_get_uint32 (val));
	}
	if (g_strcmp0 (scheme, "org.freedesktop.appearance") == 0) {
		_tmp6_ = g_strcmp0 (key, "color-scheme") == 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		he_desktop_set_prefers_color_scheme (self, (HeDesktopColorScheme) g_variant_get_uint32 (val));
	}
}

static void
___lambda4__he_portal_settings_setting_changed (HePortalSettings* _sender,
                                                const gchar* namespace,
                                                const gchar* key,
                                                GVariant* val,
                                                gpointer self)
{
	__lambda4_ ((HeDesktop*) self, namespace, key, val);
}

static void
he_desktop_init_handle_settings_change (HeDesktop* self)
{
	HePortalSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->portal;
	g_signal_connect_object (_tmp0_, "setting-changed", (GCallback) ___lambda4__he_portal_settings_setting_changed, self, 0);
}

HeDesktop*
he_desktop_construct (GType object_type)
{
	HeDesktop * self = NULL;
	self = (HeDesktop*) g_object_new (object_type, NULL);
	return self;
}

HeDesktop*
he_desktop_new (void)
{
	return he_desktop_construct (HE_TYPE_DESKTOP);
}

static GObject *
he_desktop_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	static GObject * HeDesktop_singleton__ref = NULL;
	static GMutex HeDesktop_singleton__lock;
	static volatile gsize HeDesktop_singleton__once = 0;
	HeDesktop * self;
	if (g_once_init_enter (&HeDesktop_singleton__once)) {
		g_mutex_init (&HeDesktop_singleton__lock);
		g_once_init_leave (&HeDesktop_singleton__once, 42);
	}
	g_mutex_lock (&HeDesktop_singleton__lock);
	if (HeDesktop_singleton__ref != NULL) {
		g_object_ref (HeDesktop_singleton__ref);
		g_mutex_unlock (&HeDesktop_singleton__lock);
		return HeDesktop_singleton__ref;
	}
	parent_class = G_OBJECT_CLASS (he_desktop_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DESKTOP, HeDesktop);
	he_desktop_setup_prefers_color_scheme (self);
	he_desktop_setup_accent_color (self);
	he_desktop_setup_dark_mode_strength (self);
	he_desktop_setup_ensor_scheme (self);
	he_desktop_setup_font_weight (self);
	he_desktop_init_handle_settings_change (self);
	HeDesktop_singleton__ref = obj;
	g_object_add_weak_pointer (HeDesktop_singleton__ref, (gpointer) (&HeDesktop_singleton__ref));
	g_mutex_unlock (&HeDesktop_singleton__lock);
	return obj;
}

static void
he_desktop_class_init (HeDesktopClass * klass,
                       gpointer klass_data)
{
	he_desktop_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeDesktop_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_desktop_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_desktop_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_desktop_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_desktop_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY, he_desktop_properties[HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY] = g_param_spec_enum ("prefers-color-scheme", "prefers-color-scheme", "prefers-color-scheme", HE_DESKTOP_TYPE_COLOR_SCHEME, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_DARK_MODE_STRENGTH_PROPERTY, he_desktop_properties[HE_DESKTOP_DARK_MODE_STRENGTH_PROPERTY] = g_param_spec_enum ("dark-mode-strength", "dark-mode-strength", "dark-mode-strength", HE_TYPE_DARK_MODE_STRENGTH, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_ENSOR_SCHEME_PROPERTY, he_desktop_properties[HE_DESKTOP_ENSOR_SCHEME_PROPERTY] = g_param_spec_enum ("ensor-scheme", "ensor-scheme", "ensor-scheme", HE_DESKTOP_TYPE_ENSOR_SCHEME, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_ACCENT_COLOR_PROPERTY, he_desktop_properties[HE_DESKTOP_ACCENT_COLOR_PROPERTY] = g_param_spec_boxed ("accent-color", "accent-color", "accent-color", HE_COLOR_TYPE_RGB_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DESKTOP_FONT_WEIGHT_PROPERTY, he_desktop_properties[HE_DESKTOP_FONT_WEIGHT_PROPERTY] = g_param_spec_double ("font-weight", "font-weight", "font-weight", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_desktop_instance_init (HeDesktop * self,
                          gpointer klass)
{
	self->priv = he_desktop_get_instance_private (self);
	self->priv->portal = NULL;
	self->priv->_prefers_color_scheme = NULL;
	self->priv->_dark_mode_strength = NULL;
	self->priv->_ensor_scheme = NULL;
	self->priv->_font_weight = 1.0;
}

static void
he_desktop_finalize (GObject * obj)
{
	HeDesktop * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DESKTOP, HeDesktop);
	_g_object_unref0 (self->priv->portal);
	_g_free0 (self->priv->_prefers_color_scheme);
	_g_free0 (self->priv->_dark_mode_strength);
	_g_free0 (self->priv->_ensor_scheme);
	_he_color_rgb_color_free0 (self->priv->_accent_color);
	G_OBJECT_CLASS (he_desktop_parent_class)->finalize (obj);
}

/**
* Helper class to deal with desktop-specific settings.
*/
static GType
he_desktop_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeDesktopClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_desktop_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeDesktop), 0, (GInstanceInitFunc) he_desktop_instance_init, NULL };
	GType he_desktop_type_id;
	he_desktop_type_id = g_type_register_static (G_TYPE_OBJECT, "HeDesktop", &g_define_type_info, 0);
	HeDesktop_private_offset = g_type_add_instance_private (he_desktop_type_id, sizeof (HeDesktopPrivate));
	return he_desktop_type_id;
}

GType
he_desktop_get_type (void)
{
	static volatile gsize he_desktop_type_id__once = 0;
	if (g_once_init_enter (&he_desktop_type_id__once)) {
		GType he_desktop_type_id;
		he_desktop_type_id = he_desktop_get_type_once ();
		g_once_init_leave (&he_desktop_type_id__once, he_desktop_type_id);
	}
	return he_desktop_type_id__once;
}

static void
_vala_he_desktop_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	HeDesktop * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DESKTOP, HeDesktop);
	switch (property_id) {
		case HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY:
		g_value_set_enum (value, he_desktop_get_prefers_color_scheme (self));
		break;
		case HE_DESKTOP_DARK_MODE_STRENGTH_PROPERTY:
		g_value_set_enum (value, he_desktop_get_dark_mode_strength (self));
		break;
		case HE_DESKTOP_ENSOR_SCHEME_PROPERTY:
		g_value_set_enum (value, he_desktop_get_ensor_scheme (self));
		break;
		case HE_DESKTOP_ACCENT_COLOR_PROPERTY:
		{
			HeColorRGBColor* boxed;
			boxed = he_desktop_get_accent_color (self);
			g_value_set_boxed (value, boxed);
		}
		break;
		case HE_DESKTOP_FONT_WEIGHT_PROPERTY:
		g_value_set_double (value, he_desktop_get_font_weight (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_desktop_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	HeDesktop * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DESKTOP, HeDesktop);
	switch (property_id) {
		case HE_DESKTOP_PREFERS_COLOR_SCHEME_PROPERTY:
		he_desktop_set_prefers_color_scheme (self, g_value_get_enum (value));
		break;
		case HE_DESKTOP_DARK_MODE_STRENGTH_PROPERTY:
		he_desktop_set_dark_mode_strength (self, g_value_get_enum (value));
		break;
		case HE_DESKTOP_ENSOR_SCHEME_PROPERTY:
		he_desktop_set_ensor_scheme (self, g_value_get_enum (value));
		break;
		case HE_DESKTOP_ACCENT_COLOR_PROPERTY:
		he_desktop_set_accent_color (self, g_value_get_boxed (value));
		break;
		case HE_DESKTOP_FONT_WEIGHT_PROPERTY:
		he_desktop_set_font_weight (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

