/* Ensor.c generated by valac 0.56.13, the Vala compiler
 * generated from Ensor.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include "libhelium-1.h"
#include <gio/gio.h>
#include <string.h>

#define _he_score_unref0(var) ((var == NULL) ? NULL : (var = (he_score_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _he_quantizer_celebi_unref0(var) ((var == NULL) ? NULL : (var = (he_quantizer_celebi_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _HeEnsorAccentFromPixelsAsyncData HeEnsorAccentFromPixelsAsyncData;

struct _Block1Data {
	int _ref_count_;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	GArray* _result_;
	guint8* pixels;
	gint pixels_length1;
	gboolean alpha;
	gpointer _async_data_;
};

struct _HeEnsorAccentFromPixelsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	guint8* pixels;
	gint pixels_length1;
	gboolean alpha;
	GArray* result;
	Block1Data* _data1_;
	GThreadFunc run;
	gpointer run_target;
	GThreadFunc _tmp0_;
	gpointer _tmp0__target;
	GThread* _tmp1_;
	GThread* _tmp2_;
	GArray* _tmp3_;
};

VALA_EXTERN GArray* he_ensor_accent_from_pixels (guint8* pixels,
                                     gint pixels_length1,
                                     gboolean alpha);
VALA_EXTERN gint* he_ensor_pixels_to_argb_array (guint8* pixels,
                                     gint pixels_length1,
                                     gboolean alpha,
                                     gint* result_length1);
static void _vala_array_add1 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void he_ensor_accent_from_pixels_async_data_free (gpointer _data);
static gboolean he_ensor_accent_from_pixels_async_co (HeEnsorAccentFromPixelsAsyncData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean _he_ensor_accent_from_pixels_async_co_gsource_func (gpointer self);
static gboolean __lambda58_ (Block1Data* _data1_);
static gpointer ___lambda58__gthread_func (gpointer self);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

GArray*
he_ensor_accent_from_pixels (guint8* pixels,
                             gint pixels_length1,
                             gboolean alpha)
{
	HeQuantizerCelebi* celebi = NULL;
	HeQuantizerCelebi* _tmp0_;
	GHashTable* _result_ = NULL;
	gint _tmp1_ = 0;
	gint* _tmp2_;
	gint* _tmp3_;
	gint _tmp3__length1;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	HeScore* score = NULL;
	HeScore* _tmp6_;
	GArray* _tmp7_;
	GArray* result;
	_tmp0_ = he_quantizer_celebi_new ();
	celebi = _tmp0_;
	_tmp2_ = he_ensor_pixels_to_argb_array (pixels, (gint) pixels_length1, alpha, &_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp1_;
	_tmp4_ = he_quantizer_celebi_quantize (celebi, _tmp3_, (gint) _tmp1_, 128);
	_tmp5_ = _tmp4_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	_result_ = _tmp5_;
	_tmp6_ = he_score_new ();
	score = _tmp6_;
	_tmp7_ = he_score_score (score, _result_);
	result = _tmp7_;
	_he_score_unref0 (score);
	_g_hash_table_unref0 (_result_);
	_he_quantizer_celebi_unref0 (celebi);
	return result;
}

static void
_vala_array_add1 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gint, *array, *size);
	}
	(*array)[(*length)++] = value;
}

gint*
he_ensor_pixels_to_argb_array (guint8* pixels,
                               gint pixels_length1,
                               gboolean alpha,
                               gint* result_length1)
{
	gint* list = NULL;
	gint* _tmp0_;
	gint list_length1;
	gint _list_size_;
	gint factor = 0;
	gint i = 0;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint* result;
	_tmp0_ = g_new0 (gint, 0);
	list = _tmp0_;
	list_length1 = 0;
	_list_size_ = list_length1;
	factor = 0;
	if (alpha) {
		factor = 4;
	} else {
		factor = 3;
	}
	i = 0;
	while (TRUE) {
		gint offset = 0;
		guint8 red = 0U;
		guint8 _tmp1_;
		guint8 green = 0U;
		guint8 _tmp2_;
		guint8 blue = 0U;
		guint8 _tmp3_;
		gint rgb = 0;
		if (!(i < (pixels_length1 / factor))) {
			break;
		}
		offset = i * factor;
		_tmp1_ = pixels[offset];
		red = _tmp1_;
		_tmp2_ = pixels[offset + 1];
		green = _tmp2_;
		_tmp3_ = pixels[offset + 2];
		blue = _tmp3_;
		rgb = he_color_argb_from_rgb_int ((gint) red, (gint) green, (gint) blue);
		_vala_array_add1 (&list, &list_length1, &_list_size_, rgb);
		i += 10;
	}
	_tmp4_ = list;
	_tmp4__length1 = list_length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}

static void
he_ensor_accent_from_pixels_async_data_free (gpointer _data)
{
	HeEnsorAccentFromPixelsAsyncData* _data_;
	_data_ = _data;
	_g_array_unref0 (_data_->result);
	g_slice_free (HeEnsorAccentFromPixelsAsyncData, _data_);
}

void
he_ensor_accent_from_pixels_async (guint8* pixels,
                                   gint pixels_length1,
                                   gboolean alpha,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	HeEnsorAccentFromPixelsAsyncData* _data_;
	_data_ = g_slice_new0 (HeEnsorAccentFromPixelsAsyncData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, he_ensor_accent_from_pixels_async_data_free);
	_data_->pixels = pixels;
	_data_->pixels_length1 = pixels_length1;
	_data_->alpha = alpha;
	he_ensor_accent_from_pixels_async_co (_data_);
}

GArray*
he_ensor_accent_from_pixels_finish (GAsyncResult* _res_)
{
	GArray* result;
	HeEnsorAccentFromPixelsAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_array_unref0 (_data1_->_result_);
		(_data1_->callback_target_destroy_notify == NULL) ? NULL : (_data1_->callback_target_destroy_notify (_data1_->callback_target), NULL);
		_data1_->callback = NULL;
		_data1_->callback_target = NULL;
		_data1_->callback_target_destroy_notify = NULL;
		g_slice_free (Block1Data, _data1_);
	}
}

static gboolean
_he_ensor_accent_from_pixels_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = he_ensor_accent_from_pixels_async_co (self);
	return result;
}

static gboolean
__lambda58_ (Block1Data* _data1_)
{
	GArray* _tmp0_;
	GSourceFunc _tmp1_;
	gpointer _tmp1__target;
	GDestroyNotify _tmp1__target_destroy_notify;
	gboolean result;
	_tmp0_ = he_ensor_accent_from_pixels (_data1_->pixels, (gint) _data1_->pixels_length1, _data1_->alpha);
	_g_array_unref0 (_data1_->_result_);
	_data1_->_result_ = _tmp0_;
	_tmp1_ = _data1_->callback;
	_tmp1__target = _data1_->callback_target;
	_tmp1__target_destroy_notify = _data1_->callback_target_destroy_notify;
	_data1_->callback = NULL;
	_data1_->callback_target = NULL;
	_data1_->callback_target_destroy_notify = NULL;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify);
	result = TRUE;
	return result;
}

static gpointer
___lambda58__gthread_func (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) __lambda58_ (self));
	block1_data_unref (self);
	return result;
}

static gpointer
_g_array_ref0 (gpointer self)
{
	return self ? g_array_ref (self) : NULL;
}

static gboolean
he_ensor_accent_from_pixels_async_co (HeEnsorAccentFromPixelsAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data1_ = g_slice_new0 (Block1Data);
	_data_->_data1_->_ref_count_ = 1;
	_data_->_data1_->pixels = _data_->pixels;
	_data_->_data1_->pixels_length1 = _data_->pixels_length1;
	_data_->_data1_->alpha = _data_->alpha;
	_data_->_data1_->_async_data_ = _data_;
	_data_->_data1_->callback = _he_ensor_accent_from_pixels_async_co_gsource_func;
	_data_->_data1_->callback_target = _data_;
	_data_->_data1_->callback_target_destroy_notify = NULL;
	_data_->_data1_->_result_ = NULL;
	_data_->run = ___lambda58__gthread_func;
	_data_->run_target = block1_data_ref (_data_->_data1_);
	_data_->_tmp0_ = _data_->run;
	_data_->_tmp0__target = _data_->run_target;
	_data_->run = NULL;
	_data_->run_target = NULL;
	_data_->_tmp1_ = g_thread_new ("ensor-process", _data_->_tmp0_, _data_->_tmp0__target);
	_data_->_tmp2_ = _data_->_tmp1_;
	_g_thread_unref0 (_data_->_tmp2_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp3_ = _g_array_ref0 (_data_->_data1_->_result_);
	_data_->result = _data_->_tmp3_;
	block1_data_unref (_data_->_data1_);
	_data_->_data1_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

