/* QuantizerMap.c generated by valac 0.56.13, the Vala compiler
 * generated from QuantizerMap.vala, do not modify */

/* Adapted from the Java implementation of material-color-utilities licensed under the Apache License, Version 2.0*/
/* Copyright (c) 2021 Google LLC*/

#include "libhelium-1.h"
#include <glib.h>
#include <string.h>
#include <glib-object.h>

enum  {
	HE_QUANTIZER_MAP_0_PROPERTY,
	HE_QUANTIZER_MAP_NUM_PROPERTIES
};
static GParamSpec* he_quantizer_map_properties[HE_QUANTIZER_MAP_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

struct _HeQuantizerMapPrivate {
	GHashTable* color_to_count;
};

static gint HeQuantizerMap_private_offset;
static gpointer he_quantizer_map_parent_class = NULL;

static HeQuantizerResult* he_quantizer_map_real_quantize (HeQuantizer* base,
                                                   gint* pixels,
                                                   gint pixels_length1,
                                                   gint color_count);
static void _g_free0_ (gpointer var);
static gint* _int_dup (gint* self);
static void he_quantizer_map_finalize (GObject * obj);
static GType he_quantizer_map_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_quantizer_map_get_instance_private (HeQuantizerMap* self)
{
	return G_STRUCT_MEMBER_P (self, HeQuantizerMap_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
	dup = g_new0 (gint, 1);
	memcpy (dup, self, sizeof (gint));
	return dup;
}

static gpointer
__int_dup0 (gpointer self)
{
	return self ? _int_dup (self) : NULL;
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

static HeQuantizerResult*
he_quantizer_map_real_quantize (HeQuantizer* base,
                                gint* pixels,
                                gint pixels_length1,
                                gint color_count)
{
	HeQuantizerMap * self;
	GHashTable* pixel_by_count = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp12_;
	GHashTable* _tmp13_;
	GHashTable* _tmp14_;
	HeQuantizerResult* _tmp15_;
	HeQuantizerResult* result;
	self = (HeQuantizerMap*) base;
	_tmp0_ = g_int_hash;
	_tmp1_ = g_int_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
	pixel_by_count = _tmp2_;
	{
		gint* pixel_collection = NULL;
		gint pixel_collection_length1 = 0;
		gint _pixel_collection_size_ = 0;
		gint pixel_it = 0;
		pixel_collection = pixels;
		pixel_collection_length1 = pixels_length1;
		for (pixel_it = 0; pixel_it < pixel_collection_length1; pixel_it = pixel_it + 1) {
			gint pixel = 0;
			pixel = pixel_collection[pixel_it];
			{
				gint* current_pixel_count = NULL;
				GHashTable* _tmp3_;
				gconstpointer _tmp4_;
				gint* _tmp5_;
				gint _tmp6_ = 0;
				gint* _tmp7_;
				gint new_pixel_count = 0;
				GHashTable* _tmp9_;
				gint* _tmp10_;
				gint* _tmp11_;
				_tmp3_ = pixel_by_count;
				_tmp4_ = g_hash_table_lookup (_tmp3_, &pixel);
				_tmp5_ = __int_dup0 ((gint*) _tmp4_);
				current_pixel_count = _tmp5_;
				_tmp7_ = current_pixel_count;
				if (_tmp7_ == NULL) {
					_tmp6_ = 1;
				} else {
					gint* _tmp8_;
					_tmp8_ = current_pixel_count;
					_tmp6_ = (*_tmp8_) + 1;
				}
				new_pixel_count = _tmp6_;
				_tmp9_ = pixel_by_count;
				_tmp10_ = __int_dup0 (&pixel);
				_tmp11_ = __int_dup0 (&new_pixel_count);
				g_hash_table_insert (_tmp9_, _tmp10_, _tmp11_);
				_g_free0 (current_pixel_count);
			}
		}
	}
	_tmp12_ = pixel_by_count;
	_tmp13_ = _g_hash_table_ref0 (_tmp12_);
	_g_hash_table_unref0 (self->priv->color_to_count);
	self->priv->color_to_count = _tmp13_;
	_tmp14_ = pixel_by_count;
	_tmp15_ = he_quantizer_result_new (_tmp14_);
	result = _tmp15_;
	_g_hash_table_unref0 (pixel_by_count);
	return result;
}

GHashTable*
he_quantizer_map_get_color_to_count (HeQuantizerMap* self)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	GHashTable* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->color_to_count;
	_tmp1_ = _g_hash_table_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

HeQuantizerMap*
he_quantizer_map_construct (GType object_type)
{
	HeQuantizerMap * self = NULL;
	self = (HeQuantizerMap*) he_quantizer_construct (object_type);
	return self;
}

HeQuantizerMap*
he_quantizer_map_new (void)
{
	return he_quantizer_map_construct (HE_TYPE_QUANTIZER_MAP);
}

static void
he_quantizer_map_class_init (HeQuantizerMapClass * klass,
                             gpointer klass_data)
{
	he_quantizer_map_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeQuantizerMap_private_offset);
	((HeQuantizerClass *) klass)->quantize = (HeQuantizerResult* (*) (HeQuantizer*, gint*, gint, gint)) he_quantizer_map_real_quantize;
	G_OBJECT_CLASS (klass)->finalize = he_quantizer_map_finalize;
}

static void
he_quantizer_map_instance_init (HeQuantizerMap * self,
                                gpointer klass)
{
	self->priv = he_quantizer_map_get_instance_private (self);
}

static void
he_quantizer_map_finalize (GObject * obj)
{
	HeQuantizerMap * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_QUANTIZER_MAP, HeQuantizerMap);
	_g_hash_table_unref0 (self->priv->color_to_count);
	G_OBJECT_CLASS (he_quantizer_map_parent_class)->finalize (obj);
}

/** Creates a dictionary with keys of colors, and values of count of the color */
static GType
he_quantizer_map_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeQuantizerMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_quantizer_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeQuantizerMap), 0, (GInstanceInitFunc) he_quantizer_map_instance_init, NULL };
	GType he_quantizer_map_type_id;
	he_quantizer_map_type_id = g_type_register_static (HE_TYPE_QUANTIZER, "HeQuantizerMap", &g_define_type_info, 0);
	HeQuantizerMap_private_offset = g_type_add_instance_private (he_quantizer_map_type_id, sizeof (HeQuantizerMapPrivate));
	return he_quantizer_map_type_id;
}

GType
he_quantizer_map_get_type (void)
{
	static volatile gsize he_quantizer_map_type_id__once = 0;
	if (g_once_init_enter (&he_quantizer_map_type_id__once)) {
		GType he_quantizer_map_type_id;
		he_quantizer_map_type_id = he_quantizer_map_get_type_once ();
		g_once_init_leave (&he_quantizer_map_type_id__once, he_quantizer_map_type_id);
	}
	return he_quantizer_map_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

