/* Math.c generated by valac 0.56.13, the Vala compiler
 * generated from Math.vala, do not modify */

#include <glib.h>
#include <float.h>
#include <math.h>
#include "libhelium-1.h"
#include <string.h>

static gdouble* _vala_array_dup3 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup4 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup5 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup6 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup7 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup8 (gdouble* self,
                           gssize length);
static gdouble* _vala_array_dup9 (gdouble* self,
                           gssize length);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const gdouble HE_MATH_UTILS_SCALED_DISCOUNT_FROM_LINRGB[3][3] = {{0.001200833568784504, 0.002389694492170889, 0.0002795742885861124}, {0.0005891086651375999, 0.0029785502573438758, 0.0003270666104008398}, {0.00010146692491640572, 0.0005364214359186694, 0.0032979401770712076}};
const gdouble HE_MATH_UTILS_LINRGB_FROM_SCALED_DISCOUNT[3][3] = {{1373.2198709594231, -1100.4251190754821, -7.278681089101213}, {-271.815969077903, 559.6580465940733, -32.46047482791194}, {1.9622899599665666, -57.173814538844006, 308.7233197812385}};
VALA_EXTERN const gdouble HE_COLOR_CRITICAL_PLANES[255];

gdouble
he_math_utils_clamp_double (gdouble min,
                            gdouble max,
                            gdouble input)
{
	gdouble result;
	if (input < min) {
		result = min;
		return result;
	} else {
		if (input > max) {
			result = max;
			return result;
		}
	}
	result = input;
	return result;
}

gint
he_math_utils_signum (gdouble x)
{
	gint result;
	result = ((gint) (x > ((gdouble) 0))) - ((gint) (x < ((gdouble) 0)));
	return result;
}

gdouble
he_math_utils_chromatic_adaptation (gdouble component)
{
	gdouble af = 0.0;
	gdouble result;
	af = pow (he_math_utils_abs (component), 0.42);
	result = ((he_math_utils_signum (component) * 400.0) * af) / (af + 27.13);
	return result;
}

gdouble
he_math_utils_inverse_chromatic_adaptation (gdouble adapted)
{
	gdouble adapted_abs = 0.0;
	gdouble b = 0.0;
	gdouble result;
	adapted_abs = he_math_utils_abs (adapted);
	b = he_math_utils_max ((gdouble) 0, (27.13 * adapted_abs) / (400.0 - adapted_abs));
	result = he_math_utils_signum (adapted) * pow (b, 1.0 / 0.42);
	return result;
}

gdouble*
he_math_utils_lerp_point (gdouble* source,
                          gint source_length1,
                          gdouble t,
                          gdouble* target,
                          gint target_length1,
                          gint* result_length1)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble* _tmp9_;
	gdouble* _tmp10_;
	gint _tmp10__length1;
	gdouble* result;
	_tmp0_ = source[0];
	_tmp1_ = target[0];
	_tmp2_ = source[0];
	_tmp3_ = source[1];
	_tmp4_ = target[1];
	_tmp5_ = source[1];
	_tmp6_ = source[2];
	_tmp7_ = target[2];
	_tmp8_ = source[2];
	_tmp9_ = g_new0 (gdouble, 3);
	_tmp9_[0] = _tmp0_ + ((_tmp1_ - _tmp2_) * t);
	_tmp9_[1] = _tmp3_ + ((_tmp4_ - _tmp5_) * t);
	_tmp9_[2] = _tmp6_ + ((_tmp7_ - _tmp8_) * t);
	_tmp10_ = _tmp9_;
	_tmp10__length1 = 3;
	if (result_length1) {
		*result_length1 = _tmp10__length1;
	}
	result = _tmp10_;
	return result;
}

gdouble
he_math_utils_lerp (gdouble a,
                    gdouble b,
                    gdouble t)
{
	gdouble result;
	result = a + ((b - a) * t);
	return result;
}

gdouble
he_math_utils_sanitize_radians (gdouble angle)
{
	gdouble result;
	result = fmod (angle + (G_PI * 8), G_PI * 2);
	return result;
}

gboolean
he_math_utils_is_bounded_rgb (gdouble x)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	if (0.0 <= x) {
		_tmp0_ = x <= 100.0;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

gdouble
he_math_utils_adapt (gdouble color_channel)
{
	gdouble result;
	if (color_channel > 0.0031308) {
		result = (1.055 * pow (color_channel, 1.0 / 2.4)) - 0.055;
		return result;
	} else {
		result = color_channel * 12.92;
		return result;
	}
}

gdouble*
he_math_utils_elem_mul (gdouble* row,
                        gint row_length1,
                        gdouble* matrix,
                        gint matrix_length1,
                        gint matrix_length2,
                        gint* result_length1)
{
	gdouble* prod = NULL;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble* _tmp18_;
	gint prod_length1;
	gint _prod_size_;
	gdouble* _tmp19_;
	gint _tmp19__length1;
	gdouble* result;
	_tmp0_ = row[0];
	_tmp1_ = matrix[(0 * matrix_length2) + 0];
	_tmp2_ = row[1];
	_tmp3_ = matrix[(0 * matrix_length2) + 1];
	_tmp4_ = row[2];
	_tmp5_ = matrix[(0 * matrix_length2) + 2];
	_tmp6_ = row[0];
	_tmp7_ = matrix[(1 * matrix_length2) + 0];
	_tmp8_ = row[1];
	_tmp9_ = matrix[(1 * matrix_length2) + 1];
	_tmp10_ = row[2];
	_tmp11_ = matrix[(1 * matrix_length2) + 2];
	_tmp12_ = row[0];
	_tmp13_ = matrix[(2 * matrix_length2) + 0];
	_tmp14_ = row[1];
	_tmp15_ = matrix[(2 * matrix_length2) + 1];
	_tmp16_ = row[2];
	_tmp17_ = matrix[(2 * matrix_length2) + 2];
	_tmp18_ = g_new0 (gdouble, 3);
	_tmp18_[0] = ((_tmp0_ * _tmp1_) + (_tmp2_ * _tmp3_)) + (_tmp4_ * _tmp5_);
	_tmp18_[1] = ((_tmp6_ * _tmp7_) + (_tmp8_ * _tmp9_)) + (_tmp10_ * _tmp11_);
	_tmp18_[2] = ((_tmp12_ * _tmp13_) + (_tmp14_ * _tmp15_)) + (_tmp16_ * _tmp17_);
	prod = _tmp18_;
	prod_length1 = 3;
	_prod_size_ = prod_length1;
	_tmp19_ = prod;
	_tmp19__length1 = prod_length1;
	if (result_length1) {
		*result_length1 = _tmp19__length1;
	}
	result = _tmp19_;
	return result;
}

gdouble
he_math_utils_lab_inverse_fovea (gdouble ft)
{
	gdouble e = 0.0;
	gdouble kappa = 0.0;
	gdouble ft3 = 0.0;
	gdouble result;
	e = 216.0 / 24389.0;
	kappa = 24389.0 / 27.0;
	ft3 = (ft * ft) * ft;
	if (ft3 > e) {
		result = ft3;
		return result;
	} else {
		result = ((116 * ft) - 16) / kappa;
		return result;
	}
}

gdouble
he_math_utils_lab_fovea (gdouble t)
{
	gdouble e = 0.0;
	gdouble kappa = 0.0;
	gdouble result;
	e = 216.0 / 24389.0;
	kappa = 24389.0 / 27.0;
	if (t > e) {
		result = pow (t, 1.0 / 3.0);
		return result;
	} else {
		result = ((kappa * t) + 16) / 116;
		return result;
	}
}

gdouble
he_math_utils_sanitize_degrees (gdouble degrees)
{
	gdouble result;
	degrees = fmod (degrees, 360.0);
	if (degrees < ((gdouble) 0)) {
		degrees = degrees + 360.0;
	}
	result = degrees;
	return result;
}

gint
he_math_utils_sanitize_degrees_int (gint degrees)
{
	gint result;
	degrees = degrees % 360;
	if (degrees < 0) {
		degrees = degrees + 360;
	}
	result = degrees;
	return result;
}

gdouble
he_math_utils_rotate_direction (gdouble from,
                                gdouble to)
{
	gdouble inc_diff = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble result;
	inc_diff = he_math_utils_sanitize_degrees (to - from);
	if (inc_diff <= 180.0) {
		_tmp0_ = 1.0;
	} else {
		_tmp0_ = -1.0;
	}
	result = _tmp0_;
	return result;
}

gdouble
he_math_utils_difference_degrees (gdouble a,
                                  gdouble b)
{
	gdouble result;
	result = 180.0 - he_math_utils_abs (he_math_utils_abs (a - b) - 180.0);
	return result;
}

gdouble
he_math_utils_abs (gdouble n)
{
	gdouble _tmp0_ = 0.0;
	gdouble result;
	if (n > ((gdouble) 0)) {
		_tmp0_ = n;
	} else {
		_tmp0_ = -n;
	}
	result = _tmp0_;
	return result;
}

gdouble
he_math_utils_max (gdouble n,
                   gdouble m)
{
	gdouble _tmp0_ = 0.0;
	gdouble result;
	if (n > m) {
		_tmp0_ = n;
	} else {
		_tmp0_ = m;
	}
	result = _tmp0_;
	return result;
}

gdouble
he_math_utils_min (gdouble n,
                   gdouble m)
{
	gdouble _tmp0_ = 0.0;
	gdouble result;
	if (n < m) {
		_tmp0_ = n;
	} else {
		_tmp0_ = m;
	}
	result = _tmp0_;
	return result;
}

gdouble
he_math_utils_linearized (gint rgb_component)
{
	gdouble normalized = 0.0;
	gdouble result;
	normalized = rgb_component / 255.0;
	if (normalized <= 0.040449936) {
		result = (normalized / 12.92) * 100.0;
		return result;
	} else {
		result = pow ((normalized + 0.055) / 1.055, 2.4) * 100.0;
		return result;
	}
}

gint
he_math_utils_delinearized (gdouble rgb_component)
{
	gdouble normalized = 0.0;
	gdouble delinearized = 0.0;
	gint result;
	normalized = rgb_component / 100.0;
	delinearized = 0.0;
	if (normalized <= 0.0031308) {
		delinearized = normalized * 12.92;
	} else {
		delinearized = (1.055 * pow (normalized, 1.0 / 2.4)) - 0.055;
	}
	result = (gint) CLAMP (round (delinearized * 255.0), (gdouble) 0, (gdouble) 255);
	return result;
}

gdouble
he_math_utils_double_delinearized (gdouble rgb_component)
{
	gdouble normalized = 0.0;
	gdouble delinearized = 0.0;
	gdouble result;
	normalized = rgb_component / 100.0;
	delinearized = 0.0;
	if (normalized <= 0.0031308) {
		delinearized = normalized * 12.92;
	} else {
		delinearized = (1.055 * pow (normalized, 1.0 / 2.4)) - 0.055;
	}
	result = delinearized * 255.0;
	return result;
}

gdouble*
he_math_utils_midpoint (gdouble* a,
                        gint a_length1,
                        gdouble* b,
                        gint b_length1,
                        gint* result_length1)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble* _tmp6_;
	gdouble* _tmp7_;
	gint _tmp7__length1;
	gdouble* result;
	_tmp0_ = a[0];
	_tmp1_ = b[0];
	_tmp2_ = a[1];
	_tmp3_ = b[1];
	_tmp4_ = a[2];
	_tmp5_ = b[2];
	_tmp6_ = g_new0 (gdouble, 3);
	_tmp6_[0] = (_tmp0_ + _tmp1_) / 2;
	_tmp6_[1] = (_tmp2_ + _tmp3_) / 2;
	_tmp6_[2] = (_tmp4_ + _tmp5_) / 2;
	_tmp7_ = _tmp6_;
	_tmp7__length1 = 3;
	if (result_length1) {
		*result_length1 = _tmp7__length1;
	}
	result = _tmp7_;
	return result;
}

gdouble
he_math_utils_intercept (gdouble source,
                         gdouble mid,
                         gdouble target)
{
	gdouble result;
	result = (mid - source) / (target - source);
	return result;
}

gdouble
he_math_utils_hue_of (gdouble* linrgb,
                      gint linrgb_length1)
{
	gdouble* scaled_discount = NULL;
	gint _tmp0_ = 0;
	gdouble* _tmp1_;
	gint scaled_discount_length1;
	gint _scaled_discount_size_;
	gdouble r_a = 0.0;
	gdouble _tmp2_;
	gdouble g_a = 0.0;
	gdouble _tmp3_;
	gdouble b_a = 0.0;
	gdouble _tmp4_;
	gdouble a = 0.0;
	gdouble b = 0.0;
	gdouble result;
	_tmp1_ = he_math_utils_elem_mul (linrgb, (gint) linrgb_length1, HE_MATH_UTILS_SCALED_DISCOUNT_FROM_LINRGB, (gint) G_N_ELEMENTS (HE_MATH_UTILS_SCALED_DISCOUNT_FROM_LINRGB), (gint) G_N_ELEMENTS (HE_MATH_UTILS_SCALED_DISCOUNT_FROM_LINRGB[0]), &_tmp0_);
	scaled_discount = _tmp1_;
	scaled_discount_length1 = _tmp0_;
	_scaled_discount_size_ = scaled_discount_length1;
	_tmp2_ = scaled_discount[0];
	r_a = he_math_utils_chromatic_adaptation (_tmp2_);
	_tmp3_ = scaled_discount[1];
	g_a = he_math_utils_chromatic_adaptation (_tmp3_);
	_tmp4_ = scaled_discount[2];
	b_a = he_math_utils_chromatic_adaptation (_tmp4_);
	a = (((11.0 * r_a) + ((-12.0) * g_a)) + b_a) / 11.0;
	b = ((r_a + g_a) - (2.0 * b_a)) / 9.0;
	result = atan2 (b, a);
	scaled_discount = (g_free (scaled_discount), NULL);
	return result;
}

gdouble*
he_math_utils_nth_vertex (gdouble y,
                          gint n,
                          gint* result_length1)
{
	gdouble k_r = 0.0;
	gdouble k_g = 0.0;
	gdouble k_b = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble coord_a = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble coord_b = 0.0;
	gdouble* result;
	k_r = 0.2126;
	k_g = 0.7152;
	k_b = 0.0722;
	if ((n % 4) <= 1) {
		_tmp0_ = 0.0;
	} else {
		_tmp0_ = 100.0;
	}
	coord_a = _tmp0_;
	if ((n % 2) == 0) {
		_tmp1_ = 0.0;
	} else {
		_tmp1_ = 100.0;
	}
	coord_b = _tmp1_;
	if (n < 4) {
		gdouble g = 0.0;
		gdouble b = 0.0;
		gdouble r = 0.0;
		g = coord_a;
		b = coord_b;
		r = ((y - (g * k_g)) - (b * k_b)) / k_r;
		if (he_math_utils_is_bounded_rgb (r)) {
			gdouble* _tmp2_;
			gdouble* _tmp3_;
			gint _tmp3__length1;
			_tmp2_ = g_new0 (gdouble, 3);
			_tmp2_[0] = r;
			_tmp2_[1] = g;
			_tmp2_[2] = b;
			_tmp3_ = _tmp2_;
			_tmp3__length1 = 3;
			if (result_length1) {
				*result_length1 = _tmp3__length1;
			}
			result = _tmp3_;
			return result;
		} else {
			gdouble* _tmp4_;
			gdouble* _tmp5_;
			gint _tmp5__length1;
			_tmp4_ = g_new0 (gdouble, 3);
			_tmp4_[0] = -1.0;
			_tmp4_[1] = -1.0;
			_tmp4_[2] = -1.0;
			_tmp5_ = _tmp4_;
			_tmp5__length1 = 3;
			if (result_length1) {
				*result_length1 = _tmp5__length1;
			}
			result = _tmp5_;
			return result;
		}
	} else {
		if (n < 8) {
			gdouble b = 0.0;
			gdouble r = 0.0;
			gdouble g = 0.0;
			b = coord_a;
			r = coord_b;
			g = ((y - (r * k_r)) - (b * k_b)) / k_g;
			if (he_math_utils_is_bounded_rgb (g)) {
				gdouble* _tmp6_;
				gdouble* _tmp7_;
				gint _tmp7__length1;
				_tmp6_ = g_new0 (gdouble, 3);
				_tmp6_[0] = r;
				_tmp6_[1] = g;
				_tmp6_[2] = b;
				_tmp7_ = _tmp6_;
				_tmp7__length1 = 3;
				if (result_length1) {
					*result_length1 = _tmp7__length1;
				}
				result = _tmp7_;
				return result;
			} else {
				gdouble* _tmp8_;
				gdouble* _tmp9_;
				gint _tmp9__length1;
				_tmp8_ = g_new0 (gdouble, 3);
				_tmp8_[0] = -1.0;
				_tmp8_[1] = -1.0;
				_tmp8_[2] = -1.0;
				_tmp9_ = _tmp8_;
				_tmp9__length1 = 3;
				if (result_length1) {
					*result_length1 = _tmp9__length1;
				}
				result = _tmp9_;
				return result;
			}
		} else {
			gdouble r = 0.0;
			gdouble g = 0.0;
			gdouble b = 0.0;
			r = coord_a;
			g = coord_b;
			b = ((y - (r * k_r)) - (g * k_g)) / k_b;
			if (he_math_utils_is_bounded_rgb (b)) {
				gdouble* _tmp10_;
				gdouble* _tmp11_;
				gint _tmp11__length1;
				_tmp10_ = g_new0 (gdouble, 3);
				_tmp10_[0] = r;
				_tmp10_[1] = g;
				_tmp10_[2] = b;
				_tmp11_ = _tmp10_;
				_tmp11__length1 = 3;
				if (result_length1) {
					*result_length1 = _tmp11__length1;
				}
				result = _tmp11_;
				return result;
			} else {
				gdouble* _tmp12_;
				gdouble* _tmp13_;
				gint _tmp13__length1;
				_tmp12_ = g_new0 (gdouble, 3);
				_tmp12_[0] = -1.0;
				_tmp12_[1] = -1.0;
				_tmp12_[2] = -1.0;
				_tmp13_ = _tmp12_;
				_tmp13__length1 = 3;
				if (result_length1) {
					*result_length1 = _tmp13__length1;
				}
				result = _tmp13_;
				return result;
			}
		}
	}
}

gboolean
he_math_utils_are_in_cyclic_order (gdouble a,
                                   gdouble b,
                                   gdouble c)
{
	gdouble delta_ab = 0.0;
	gdouble delta_ac = 0.0;
	gboolean result;
	delta_ab = he_math_utils_sanitize_radians (b - a);
	delta_ac = he_math_utils_sanitize_radians (c - a);
	result = delta_ab < delta_ac;
	return result;
}

gdouble*
he_math_utils_set_coordinate (gdouble* source,
                              gint source_length1,
                              gdouble coordinate,
                              gdouble* target,
                              gint target_length1,
                              gint axis,
                              gint* result_length1)
{
	gdouble t = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gint _tmp2_ = 0;
	gdouble* _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gdouble* result;
	_tmp0_ = source[axis];
	_tmp1_ = target[axis];
	t = he_math_utils_intercept (_tmp0_, coordinate, _tmp1_);
	_tmp3_ = he_math_utils_lerp_point (source, (gint) source_length1, t, target, (gint) target_length1, &_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp2_;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}

gdouble
he_math_utils_convert (gdouble value)
{
	gdouble epsilon = 0.0;
	gdouble kappa = 0.0;
	gdouble delta = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble result;
	epsilon = 6.0 / 29.0;
	kappa = 108.0 / 841.0;
	delta = 4.0 / 29.0;
	if (value > epsilon) {
		_tmp0_ = pow (value, (gdouble) 3);
	} else {
		_tmp0_ = (value - delta) * kappa;
	}
	result = _tmp0_;
	return result;
}

static gdouble*
_vala_array_dup3 (gdouble* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gdouble));
	}
	return NULL;
}

static gdouble*
_vala_array_dup4 (gdouble* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gdouble));
	}
	return NULL;
}

static gdouble*
_vala_array_dup5 (gdouble* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gdouble));
	}
	return NULL;
}

static gdouble*
_vala_array_dup6 (gdouble* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gdouble));
	}
	return NULL;
}

static gdouble*
_vala_array_dup7 (gdouble* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gdouble));
	}
	return NULL;
}

gdouble*
he_math_utils_bisect_to_segment (gdouble y,
                                 gdouble target_hue,
                                 gint* result_length1)
{
	gdouble* left = NULL;
	gdouble* _tmp0_;
	gint left_length1;
	gint _left_size_;
	gdouble* right = NULL;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint right_length1;
	gint _right_size_;
	gdouble left_hue = 0.0;
	gdouble right_hue = 0.0;
	gboolean initialized = FALSE;
	gboolean uncut = FALSE;
	gdouble* _tmp19_;
	gint _tmp19__length1;
	gdouble _tmp20_;
	gdouble* _tmp21_;
	gint _tmp21__length1;
	gdouble _tmp22_;
	gdouble* _tmp23_;
	gint _tmp23__length1;
	gdouble _tmp24_;
	gdouble* _tmp25_;
	gint _tmp25__length1;
	gdouble _tmp26_;
	gdouble* _tmp27_;
	gint _tmp27__length1;
	gdouble _tmp28_;
	gdouble* _tmp29_;
	gint _tmp29__length1;
	gdouble _tmp30_;
	gdouble* _tmp31_;
	gdouble* _tmp32_;
	gint _tmp32__length1;
	gdouble* result;
	_tmp0_ = g_new0 (gdouble, 3);
	_tmp0_[0] = -1.0;
	_tmp0_[1] = -1.0;
	_tmp0_[2] = -1.0;
	left = _tmp0_;
	left_length1 = 3;
	_left_size_ = left_length1;
	_tmp1_ = left;
	_tmp1__length1 = left_length1;
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup3 (_tmp1_, _tmp1__length1) : _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	right = _tmp2_;
	right_length1 = _tmp2__length1;
	_right_size_ = right_length1;
	left_hue = 0.0;
	right_hue = 0.0;
	initialized = FALSE;
	uncut = TRUE;
	{
		gint n = 0;
		n = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gdouble* mid = NULL;
				gint _tmp5_ = 0;
				gdouble* _tmp6_;
				gint mid_length1;
				gint _mid_size_;
				gdouble* _tmp7_;
				gint _tmp7__length1;
				gdouble _tmp8_;
				gdouble mid_hue = 0.0;
				gdouble* _tmp9_;
				gint _tmp9__length1;
				gboolean _tmp14_ = FALSE;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = n;
					n = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				if (!(n < 12)) {
					break;
				}
				_tmp6_ = he_math_utils_nth_vertex (y, n, &_tmp5_);
				mid = _tmp6_;
				mid_length1 = _tmp5_;
				_mid_size_ = mid_length1;
				_tmp7_ = mid;
				_tmp7__length1 = mid_length1;
				_tmp8_ = _tmp7_[0];
				if (_tmp8_ < ((gdouble) 0)) {
					mid = (g_free (mid), NULL);
					continue;
				}
				_tmp9_ = mid;
				_tmp9__length1 = mid_length1;
				mid_hue = he_math_utils_hue_of (_tmp9_, (gint) _tmp9__length1);
				if (!initialized) {
					gdouble* _tmp10_;
					gint _tmp10__length1;
					gdouble* _tmp11_;
					gint _tmp11__length1;
					gdouble* _tmp12_;
					gint _tmp12__length1;
					gdouble* _tmp13_;
					gint _tmp13__length1;
					_tmp10_ = mid;
					_tmp10__length1 = mid_length1;
					_tmp11_ = (_tmp10_ != NULL) ? _vala_array_dup4 (_tmp10_, _tmp10__length1) : _tmp10_;
					_tmp11__length1 = _tmp10__length1;
					left = (g_free (left), NULL);
					left = _tmp11_;
					left_length1 = _tmp11__length1;
					_left_size_ = left_length1;
					_tmp12_ = mid;
					_tmp12__length1 = mid_length1;
					_tmp13_ = (_tmp12_ != NULL) ? _vala_array_dup5 (_tmp12_, _tmp12__length1) : _tmp12_;
					_tmp13__length1 = _tmp12__length1;
					right = (g_free (right), NULL);
					right = _tmp13_;
					right_length1 = _tmp13__length1;
					_right_size_ = right_length1;
					left_hue = mid_hue;
					right_hue = mid_hue;
					initialized = TRUE;
					mid = (g_free (mid), NULL);
					continue;
				}
				if (uncut) {
					_tmp14_ = TRUE;
				} else {
					_tmp14_ = he_math_utils_are_in_cyclic_order (left_hue, mid_hue, right_hue);
				}
				if (_tmp14_) {
					uncut = FALSE;
					if (he_math_utils_are_in_cyclic_order (left_hue, target_hue, mid_hue)) {
						gdouble* _tmp15_;
						gint _tmp15__length1;
						gdouble* _tmp16_;
						gint _tmp16__length1;
						_tmp15_ = mid;
						_tmp15__length1 = mid_length1;
						_tmp16_ = (_tmp15_ != NULL) ? _vala_array_dup6 (_tmp15_, _tmp15__length1) : _tmp15_;
						_tmp16__length1 = _tmp15__length1;
						right = (g_free (right), NULL);
						right = _tmp16_;
						right_length1 = _tmp16__length1;
						_right_size_ = right_length1;
						right_hue = mid_hue;
					} else {
						gdouble* _tmp17_;
						gint _tmp17__length1;
						gdouble* _tmp18_;
						gint _tmp18__length1;
						_tmp17_ = mid;
						_tmp17__length1 = mid_length1;
						_tmp18_ = (_tmp17_ != NULL) ? _vala_array_dup7 (_tmp17_, _tmp17__length1) : _tmp17_;
						_tmp18__length1 = _tmp17__length1;
						left = (g_free (left), NULL);
						left = _tmp18_;
						left_length1 = _tmp18__length1;
						_left_size_ = left_length1;
						left_hue = mid_hue;
					}
				}
				mid = (g_free (mid), NULL);
			}
		}
	}
	_tmp19_ = left;
	_tmp19__length1 = left_length1;
	_tmp20_ = _tmp19_[0];
	_tmp21_ = left;
	_tmp21__length1 = left_length1;
	_tmp22_ = _tmp21_[1];
	_tmp23_ = left;
	_tmp23__length1 = left_length1;
	_tmp24_ = _tmp23_[2];
	_tmp25_ = right;
	_tmp25__length1 = right_length1;
	_tmp26_ = _tmp25_[0];
	_tmp27_ = right;
	_tmp27__length1 = right_length1;
	_tmp28_ = _tmp27_[1];
	_tmp29_ = right;
	_tmp29__length1 = right_length1;
	_tmp30_ = _tmp29_[2];
	_tmp31_ = g_new0 (gdouble, 6);
	_tmp31_[0] = _tmp20_;
	_tmp31_[1] = _tmp22_;
	_tmp31_[2] = _tmp24_;
	_tmp31_[3] = _tmp26_;
	_tmp31_[4] = _tmp28_;
	_tmp31_[5] = _tmp30_;
	_tmp32_ = _tmp31_;
	_tmp32__length1 = 6;
	if (result_length1) {
		*result_length1 = _tmp32__length1;
	}
	result = _tmp32_;
	right = (g_free (right), NULL);
	left = (g_free (left), NULL);
	return result;
}

static gdouble*
_vala_array_dup8 (gdouble* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gdouble));
	}
	return NULL;
}

static gdouble*
_vala_array_dup9 (gdouble* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gdouble));
	}
	return NULL;
}

gdouble*
he_math_utils_bisect_to_limit (gdouble y,
                               gdouble target_hue,
                               gint* result_length1)
{
	gdouble* segment = NULL;
	gint _tmp0_ = 0;
	gdouble* _tmp1_;
	gint segment_length1;
	gint _segment_size_;
	gdouble* left = NULL;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gdouble _tmp3_;
	gdouble* _tmp4_;
	gint _tmp4__length1;
	gdouble _tmp5_;
	gdouble* _tmp6_;
	gint _tmp6__length1;
	gdouble _tmp7_;
	gdouble* _tmp8_;
	gint left_length1;
	gint _left_size_;
	gdouble left_hue = 0.0;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble* right = NULL;
	gdouble* _tmp10_;
	gint _tmp10__length1;
	gdouble _tmp11_;
	gdouble* _tmp12_;
	gint _tmp12__length1;
	gdouble _tmp13_;
	gdouble* _tmp14_;
	gint _tmp14__length1;
	gdouble _tmp15_;
	gdouble* _tmp16_;
	gint right_length1;
	gint _right_size_;
	gdouble* _tmp47_;
	gint _tmp47__length1;
	gdouble* _tmp48_;
	gint _tmp48__length1;
	gint _tmp49_ = 0;
	gdouble* _tmp50_;
	gdouble* _tmp51_;
	gint _tmp51__length1;
	gdouble* result;
	_tmp1_ = he_math_utils_bisect_to_segment (y, target_hue, &_tmp0_);
	segment = _tmp1_;
	segment_length1 = _tmp0_;
	_segment_size_ = segment_length1;
	_tmp2_ = segment;
	_tmp2__length1 = segment_length1;
	_tmp3_ = _tmp2_[0];
	_tmp4_ = segment;
	_tmp4__length1 = segment_length1;
	_tmp5_ = _tmp4_[1];
	_tmp6_ = segment;
	_tmp6__length1 = segment_length1;
	_tmp7_ = _tmp6_[2];
	_tmp8_ = g_new0 (gdouble, 3);
	_tmp8_[0] = _tmp3_;
	_tmp8_[1] = _tmp5_;
	_tmp8_[2] = _tmp7_;
	left = _tmp8_;
	left_length1 = 3;
	_left_size_ = left_length1;
	_tmp9_ = left;
	_tmp9__length1 = left_length1;
	left_hue = he_math_utils_hue_of (_tmp9_, (gint) _tmp9__length1);
	_tmp10_ = segment;
	_tmp10__length1 = segment_length1;
	_tmp11_ = _tmp10_[3];
	_tmp12_ = segment;
	_tmp12__length1 = segment_length1;
	_tmp13_ = _tmp12_[4];
	_tmp14_ = segment;
	_tmp14__length1 = segment_length1;
	_tmp15_ = _tmp14_[5];
	_tmp16_ = g_new0 (gdouble, 3);
	_tmp16_[0] = _tmp11_;
	_tmp16_[1] = _tmp13_;
	_tmp16_[2] = _tmp15_;
	right = _tmp16_;
	right_length1 = 3;
	_right_size_ = right_length1;
	{
		gint axis = 0;
		axis = 0;
		{
			gboolean _tmp17_ = FALSE;
			_tmp17_ = TRUE;
			while (TRUE) {
				gdouble* _tmp19_;
				gint _tmp19__length1;
				gdouble _tmp20_;
				gdouble* _tmp21_;
				gint _tmp21__length1;
				gdouble _tmp22_;
				if (!_tmp17_) {
					gint _tmp18_;
					_tmp18_ = axis;
					axis = _tmp18_ + 1;
				}
				_tmp17_ = FALSE;
				if (!(axis < 3)) {
					break;
				}
				_tmp19_ = left;
				_tmp19__length1 = left_length1;
				_tmp20_ = _tmp19_[axis];
				_tmp21_ = right;
				_tmp21__length1 = right_length1;
				_tmp22_ = _tmp21_[axis];
				if (_tmp20_ != _tmp22_) {
					gint l_plane = 0;
					gint r_plane = 0;
					gdouble* _tmp23_;
					gint _tmp23__length1;
					gdouble _tmp24_;
					gdouble* _tmp25_;
					gint _tmp25__length1;
					gdouble _tmp26_;
					l_plane = -1;
					r_plane = 255;
					_tmp23_ = left;
					_tmp23__length1 = left_length1;
					_tmp24_ = _tmp23_[axis];
					_tmp25_ = right;
					_tmp25__length1 = right_length1;
					_tmp26_ = _tmp25_[axis];
					if (_tmp24_ < _tmp26_) {
						gdouble* _tmp27_;
						gint _tmp27__length1;
						gdouble _tmp28_;
						gdouble* _tmp29_;
						gint _tmp29__length1;
						gdouble _tmp30_;
						_tmp27_ = left;
						_tmp27__length1 = left_length1;
						_tmp28_ = _tmp27_[axis];
						l_plane = he_color_critical_plane_below (he_math_utils_double_delinearized (_tmp28_));
						_tmp29_ = right;
						_tmp29__length1 = right_length1;
						_tmp30_ = _tmp29_[axis];
						r_plane = he_color_critical_plane_above (he_math_utils_double_delinearized (_tmp30_));
					} else {
						gdouble* _tmp31_;
						gint _tmp31__length1;
						gdouble _tmp32_;
						gdouble* _tmp33_;
						gint _tmp33__length1;
						gdouble _tmp34_;
						_tmp31_ = left;
						_tmp31__length1 = left_length1;
						_tmp32_ = _tmp31_[axis];
						l_plane = he_color_critical_plane_above (he_math_utils_double_delinearized (_tmp32_));
						_tmp33_ = right;
						_tmp33__length1 = right_length1;
						_tmp34_ = _tmp33_[axis];
						r_plane = he_color_critical_plane_below (he_math_utils_double_delinearized (_tmp34_));
					}
					{
						gint i = 0;
						i = 0;
						{
							gboolean _tmp35_ = FALSE;
							_tmp35_ = TRUE;
							while (TRUE) {
								if (!_tmp35_) {
									gint _tmp36_;
									_tmp36_ = i;
									i = _tmp36_ + 1;
								}
								_tmp35_ = FALSE;
								if (!(i < 8)) {
									break;
								}
								if (he_math_utils_abs ((gdouble) (r_plane - l_plane)) <= ((gdouble) 1)) {
									break;
								} else {
									gint m_plane = 0;
									gdouble mid_plane_coord = 0.0;
									gdouble _tmp37_;
									gdouble* mid = NULL;
									gdouble* _tmp38_;
									gint _tmp38__length1;
									gdouble* _tmp39_;
									gint _tmp39__length1;
									gint _tmp40_ = 0;
									gdouble* _tmp41_;
									gint mid_length1;
									gint _mid_size_;
									gdouble mid_hue = 0.0;
									gdouble* _tmp42_;
									gint _tmp42__length1;
									m_plane = (gint) floor ((l_plane + r_plane) / 2.0);
									_tmp37_ = HE_COLOR_CRITICAL_PLANES[m_plane];
									mid_plane_coord = _tmp37_;
									_tmp38_ = left;
									_tmp38__length1 = left_length1;
									_tmp39_ = right;
									_tmp39__length1 = right_length1;
									_tmp41_ = he_math_utils_set_coordinate (_tmp38_, (gint) _tmp38__length1, mid_plane_coord, _tmp39_, (gint) _tmp39__length1, axis, &_tmp40_);
									mid = _tmp41_;
									mid_length1 = _tmp40_;
									_mid_size_ = mid_length1;
									_tmp42_ = mid;
									_tmp42__length1 = mid_length1;
									mid_hue = he_math_utils_hue_of (_tmp42_, (gint) _tmp42__length1);
									if (he_math_utils_are_in_cyclic_order (left_hue, target_hue, mid_hue)) {
										gdouble* _tmp43_;
										gint _tmp43__length1;
										gdouble* _tmp44_;
										gint _tmp44__length1;
										_tmp43_ = mid;
										_tmp43__length1 = mid_length1;
										_tmp44_ = (_tmp43_ != NULL) ? _vala_array_dup8 (_tmp43_, _tmp43__length1) : _tmp43_;
										_tmp44__length1 = _tmp43__length1;
										right = (g_free (right), NULL);
										right = _tmp44_;
										right_length1 = _tmp44__length1;
										_right_size_ = right_length1;
										r_plane = m_plane;
									} else {
										gdouble* _tmp45_;
										gint _tmp45__length1;
										gdouble* _tmp46_;
										gint _tmp46__length1;
										_tmp45_ = mid;
										_tmp45__length1 = mid_length1;
										_tmp46_ = (_tmp45_ != NULL) ? _vala_array_dup9 (_tmp45_, _tmp45__length1) : _tmp45_;
										_tmp46__length1 = _tmp45__length1;
										left = (g_free (left), NULL);
										left = _tmp46_;
										left_length1 = _tmp46__length1;
										_left_size_ = left_length1;
										left_hue = mid_hue;
										l_plane = m_plane;
									}
									mid = (g_free (mid), NULL);
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp47_ = left;
	_tmp47__length1 = left_length1;
	_tmp48_ = right;
	_tmp48__length1 = right_length1;
	_tmp50_ = he_math_utils_midpoint (_tmp47_, (gint) _tmp47__length1, _tmp48_, (gint) _tmp48__length1, &_tmp49_);
	_tmp51_ = _tmp50_;
	_tmp51__length1 = _tmp49_;
	if (result_length1) {
		*result_length1 = _tmp51__length1;
	}
	result = _tmp51_;
	right = (g_free (right), NULL);
	left = (g_free (left), NULL);
	segment = (g_free (segment), NULL);
	return result;
}

gdouble
he_math_utils_y_from_lstar (gdouble lstar)
{
	gdouble result;
	result = 100.0 * he_math_utils_lab_inverse_fovea ((lstar + 16.0) / 116.0);
	return result;
}

gint
he_math_utils_argb_from_lstar (gdouble lstar)
{
	gdouble y = 0.0;
	gint component = 0;
	gint result;
	y = he_math_utils_y_from_lstar (lstar);
	component = he_math_utils_delinearized (y);
	result = he_color_argb_from_rgb_int (component, component, component);
	return result;
}

gdouble
he_math_utils_lstar_from_argb (gint argb)
{
	gdouble y = 0.0;
	HeColorXYZColor _tmp0_ = {0};
	gdouble result;
	he_color_argb_to_xyz (argb, &_tmp0_);
	y = _tmp0_.y;
	result = (116.0 * he_math_utils_lab_fovea (y / 100.0)) - 16.0;
	return result;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

