/* AboutWindow.c generated by valac 0.56.13, the Vala compiler
 * generated from AboutWindow.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

enum  {
	HE_ABOUT_WINDOW_0_PROPERTY,
	HE_ABOUT_WINDOW_COLOR_PROPERTY,
	HE_ABOUT_WINDOW_LICENSE_PROPERTY,
	HE_ABOUT_WINDOW_VERSION_PROPERTY,
	HE_ABOUT_WINDOW_APP_NAME_PROPERTY,
	HE_ABOUT_WINDOW_ICON_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY,
	HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY,
	HE_ABOUT_WINDOW_APP_ID_PROPERTY,
	HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY,
	HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY,
	HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY,
	HE_ABOUT_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_about_window_properties[HE_ABOUT_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeAboutWindowPrivate {
	HeAppBar* app_bar;
	GtkOverlay* window_overlay;
	GtkBox* about_box;
	GtkBox* content_box;
	GtkBox* button_box;
	GtkBox* info_box;
	GtkBox* title_box;
	GtkBox* text_box;
	GtkBox* developers_box;
	GtkBox* license_box;
	GtkLabel* title_label;
	GtkLabel* developers_copyright;
	GtkLabel* developers_label;
	GtkLabel* translators_label;
	GtkLabel* license_label;
	GtkLinkButton* license_link;
	GtkImage* icon_image;
	HeTextButton* translate_app_button;
	HeTintButton* report_button;
	HeFillButton* more_info_button;
	HeModifierBadge* version_badge;
	HeColors _color;
	HeAboutWindowLicenses _license;
	gchar** translators;
	gint translators_length1;
	gint _translators_size_;
	gchar** developers;
	gint developers_length1;
	gint _developers_size_;
	gint _copyright_year;
	gchar* _translate_url;
	gchar* _issue_url;
	gchar* _more_info_url;
	gchar* _app_id;
};

static gint HeAboutWindow_private_offset;
static gpointer he_about_window_parent_class = NULL;

static gchar** _vala_array_dup13 (gchar** self,
                           gssize length);
static gchar** _vala_array_dup14 (gchar** self,
                           gssize length);
static GObject * he_about_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _he_about_window___lambda10_ (HeAboutWindow* self);
static void __he_about_window___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _he_about_window___lambda11_ (HeAboutWindow* self);
static void __he_about_window___lambda11__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _he_about_window___lambda12_ (HeAboutWindow* self);
static void __he_about_window___lambda12__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void he_about_window_finalize (GObject * obj);
static GType he_about_window_get_type_once (void);
static void _vala_he_about_window_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_he_about_window_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_about_window_get_instance_private (HeAboutWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeAboutWindow_private_offset);
}

/**
  * An enum of commonly used licenses to be used in AboutWindow.
  */
/**
    * Returns the license url for the license.
    */
gchar*
he_about_window_licenses_get_url (HeAboutWindowLicenses self)
{
	gchar* result;
	switch (self) {
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("https://choosealicense.com/licenses/gpl-3.0");
			result = _tmp0_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_MIT:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("https://choosealicense.com/licenses/mit");
			result = _tmp1_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("https://choosealicense.com/licenses/mpl-2.0");
			result = _tmp2_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("https://choosealicense.com/licenses/unlicense");
			result = _tmp3_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("https://choosealicense.com/licenses/apache-2.0");
			result = _tmp4_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("https://choosealicense.com/licenses/wtfpl");
			result = _tmp5_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("https://choosealicense.com/no-permission");
			result = _tmp6_;
			return result;
		}
		default:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("about:blank");
			result = _tmp7_;
			return result;
		}
	}
}

/**
    * Returns the license name for the license.
    */
gchar*
he_about_window_licenses_get_name (HeAboutWindowLicenses self)
{
	gchar* result;
	switch (self) {
		case HE_ABOUT_WINDOW_LICENSES_GPLV3:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("GPLv3");
			result = _tmp0_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_MIT:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("MIT");
			result = _tmp1_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_MPLV2:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("MPLv2");
			result = _tmp2_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_UNLICENSE:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("Unlicense");
			result = _tmp3_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_APACHEV2:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Apache License v2");
			result = _tmp4_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_WTFPL:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("WTFPL");
			result = _tmp5_;
			return result;
		}
		case HE_ABOUT_WINDOW_LICENSES_PROPRIETARY:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("a proprietary license");
			result = _tmp6_;
			return result;
		}
		default:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("N/A");
			result = _tmp7_;
			return result;
		}
	}
}

static GType
he_about_window_licenses_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_ABOUT_WINDOW_LICENSES_GPLV3, "HE_ABOUT_WINDOW_LICENSES_GPLV3", "gplv3"}, {HE_ABOUT_WINDOW_LICENSES_MIT, "HE_ABOUT_WINDOW_LICENSES_MIT", "mit"}, {HE_ABOUT_WINDOW_LICENSES_MPLV2, "HE_ABOUT_WINDOW_LICENSES_MPLV2", "mplv2"}, {HE_ABOUT_WINDOW_LICENSES_UNLICENSE, "HE_ABOUT_WINDOW_LICENSES_UNLICENSE", "unlicense"}, {HE_ABOUT_WINDOW_LICENSES_APACHEV2, "HE_ABOUT_WINDOW_LICENSES_APACHEV2", "apachev2"}, {HE_ABOUT_WINDOW_LICENSES_WTFPL, "HE_ABOUT_WINDOW_LICENSES_WTFPL", "wtfpl"}, {HE_ABOUT_WINDOW_LICENSES_PROPRIETARY, "HE_ABOUT_WINDOW_LICENSES_PROPRIETARY", "proprietary"}, {0, NULL, NULL}};
	GType he_about_window_licenses_type_id;
	he_about_window_licenses_type_id = g_enum_register_static ("HeAboutWindowLicenses", values);
	return he_about_window_licenses_type_id;
}

GType
he_about_window_licenses_get_type (void)
{
	static volatile gsize he_about_window_licenses_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_licenses_type_id__once)) {
		GType he_about_window_licenses_type_id;
		he_about_window_licenses_type_id = he_about_window_licenses_get_type_once ();
		g_once_init_leave (&he_about_window_licenses_type_id__once, he_about_window_licenses_type_id);
	}
	return he_about_window_licenses_type_id__once;
}

HeColors
he_about_window_get_color (HeAboutWindow* self)
{
	HeColors result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_color;
	return result;
}

void
he_about_window_set_color (HeAboutWindow* self,
                           HeColors value)
{
	HeTextButton* _tmp0_;
	HeTintButton* _tmp1_;
	HeFillButton* _tmp2_;
	HeModifierBadge* _tmp3_;
	g_return_if_fail (self != NULL);
	self->priv->_color = value;
	_tmp0_ = self->priv->translate_app_button;
	he_button_set_color ((HeButton*) _tmp0_, value);
	_tmp1_ = self->priv->report_button;
	he_button_set_color ((HeButton*) _tmp1_, value);
	_tmp2_ = self->priv->more_info_button;
	he_button_set_color ((HeButton*) _tmp2_, value);
	_tmp3_ = self->priv->version_badge;
	he_modifier_badge_set_color (_tmp3_, value);
	if (self->priv->_color != HE_COLORS_NONE) {
		GtkLinkButton* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = self->priv->license_link;
		_tmp5_ = he_colors_to_css_class (self->priv->_color);
		_tmp6_ = _tmp5_;
		gtk_widget_remove_css_class ((GtkWidget*) _tmp4_, _tmp6_);
		_g_free0 (_tmp6_);
	}
	if (value != HE_COLORS_NONE) {
		GtkLinkButton* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp7_ = self->priv->license_link;
		_tmp8_ = he_colors_to_css_class (value);
		_tmp9_ = _tmp8_;
		gtk_widget_add_css_class ((GtkWidget*) _tmp7_, _tmp9_);
		_g_free0 (_tmp9_);
	}
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY]);
}

HeAboutWindowLicenses
he_about_window_get_license (HeAboutWindow* self)
{
	HeAboutWindowLicenses result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_license;
	return result;
}

void
he_about_window_set_license (HeAboutWindow* self,
                             HeAboutWindowLicenses value)
{
	GtkLinkButton* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLinkButton* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_if_fail (self != NULL);
	self->priv->_license = value;
	_tmp0_ = self->priv->license_link;
	_tmp1_ = he_about_window_licenses_get_name (value);
	_tmp2_ = _tmp1_;
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->license_link;
	_tmp4_ = he_about_window_licenses_get_url (value);
	_tmp5_ = _tmp4_;
	gtk_link_button_set_uri (_tmp3_, _tmp5_);
	_g_free0 (_tmp5_);
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY]);
}

const gchar*
he_about_window_get_version (HeAboutWindow* self)
{
	const gchar* result;
	HeModifierBadge* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->version_badge;
	_tmp1_ = he_modifier_badge_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
he_about_window_set_version (HeAboutWindow* self,
                             const gchar* value)
{
	HeModifierBadge* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->version_badge;
	he_modifier_badge_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY]);
}

const gchar*
he_about_window_get_app_name (HeAboutWindow* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->title_label;
	_tmp1_ = gtk_label_get_text (_tmp0_);
	result = _tmp1_;
	return result;
}

void
he_about_window_set_app_name (HeAboutWindow* self,
                              const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->title_label;
	gtk_label_set_text (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY]);
}

const gchar*
he_about_window_get_icon (HeAboutWindow* self)
{
	const gchar* result;
	GtkImage* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->icon_image;
	_tmp1_ = gtk_image_get_icon_name (_tmp0_);
	result = _tmp1_;
	return result;
}

void
he_about_window_set_icon (HeAboutWindow* self,
                          const gchar* value)
{
	GtkImage* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->icon_image;
	gtk_image_set_from_icon_name (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY]);
}

gchar**
he_about_window_get_translator_names (HeAboutWindow* self,
                                      gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->translators;
	_tmp0__length1 = self->priv->translators_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup13 (gchar** self,
                   gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					_tmp7_ = i < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp8_ = FALSE;
					if (str_array_length1 == -1) {
						const gchar* _tmp9_;
						_tmp9_ = str_array[i];
						_tmp8_ = _tmp9_ != NULL;
					} else {
						_tmp8_ = FALSE;
					}
					_tmp6_ = _tmp8_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp11_ = str_array[i];
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					_tmp12_ = str_array[i];
					_tmp13_ = strlen ((const gchar*) _tmp12_);
					_tmp14_ = _tmp13_;
					_tmp10_ = _tmp14_;
				} else {
					_tmp10_ = 0;
				}
				len += (gsize) _tmp10_;
			}
		}
		if (i == 0) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			return result;
		}
		str_array_length1 = i;
		_tmp16_ = strlen ((const gchar*) separator);
		_tmp17_ = _tmp16_;
		len += (gsize) (_tmp17_ * (i - 1));
		_tmp18_ = g_malloc (len);
		res = _tmp18_;
		_tmp20_ = str_array[0];
		if (_tmp20_ != NULL) {
			const gchar* _tmp21_;
			_tmp21_ = str_array[0];
			_tmp19_ = (const gchar*) _tmp21_;
		} else {
			_tmp19_ = "";
		}
		_tmp22_ = res;
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
		ptr = _tmp23_;
		{
			gboolean _tmp24_ = FALSE;
			i = 1;
			_tmp24_ = TRUE;
			while (TRUE) {
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
				if (!_tmp24_) {
					gint _tmp25_;
					_tmp25_ = i;
					i = _tmp25_ + 1;
				}
				_tmp24_ = FALSE;
				if (!(i < str_array_length1)) {
					break;
				}
				_tmp26_ = ptr;
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
				ptr = _tmp27_;
				_tmp29_ = str_array[i];
				if (_tmp29_ != NULL) {
					const gchar* _tmp30_;
					_tmp30_ = str_array[i];
					_tmp28_ = (const gchar*) _tmp30_;
				} else {
					_tmp28_ = "";
				}
				_tmp31_ = ptr;
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
				ptr = _tmp32_;
			}
		}
		_tmp33_ = res;
		res = NULL;
		result = (gchar*) _tmp33_;
		return result;
	} else {
		gchar* _tmp34_;
		_tmp34_ = g_strdup ("");
		result = _tmp34_;
		return result;
	}
}

void
he_about_window_set_translator_names (HeAboutWindow* self,
                                      gchar** value,
                                      gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = (value != NULL) ? _vala_array_dup13 (value, value_length1) : value;
	_tmp0__length1 = value_length1;
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
	self->priv->translators = _tmp0_;
	self->priv->translators_length1 = _tmp0__length1;
	self->priv->_translators_size_ = self->priv->translators_length1;
	_tmp1_ = self->priv->translators;
	_tmp1__length1 = self->priv->translators_length1;
	if (_tmp1__length1 > 0) {
		GtkLabel* _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
		_tmp2_ = self->priv->translators_label;
		_tmp3_ = self->priv->translators;
		_tmp3__length1 = self->priv->translators_length1;
		_tmp4_ = _vala_g_strjoinv (", ", _tmp3_, (gint) _tmp3__length1);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strconcat ("Translated By: ", _tmp5_, NULL);
		_tmp7_ = _tmp6_;
		gtk_label_set_text (_tmp2_, _tmp7_);
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
		_tmp8_ = self->priv->translators_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
	} else {
		GtkLabel* _tmp9_;
		GtkLabel* _tmp10_;
		_tmp9_ = self->priv->translators_label;
		gtk_label_set_text (_tmp9_, "");
		_tmp10_ = self->priv->translators_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
	}
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY]);
}

gchar**
he_about_window_get_developer_names (HeAboutWindow* self,
                                     gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->developers;
	_tmp0__length1 = self->priv->developers_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}

static gchar**
_vala_array_dup14 (gchar** self,
                   gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

void
he_about_window_set_developer_names (HeAboutWindow* self,
                                     gchar** value,
                                     gint value_length1)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = (value != NULL) ? _vala_array_dup14 (value, value_length1) : value;
	_tmp0__length1 = value_length1;
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
	self->priv->developers = _tmp0_;
	self->priv->developers_length1 = _tmp0__length1;
	self->priv->_developers_size_ = self->priv->developers_length1;
	_tmp1_ = self->priv->developers;
	_tmp1__length1 = self->priv->developers_length1;
	if (_tmp1__length1 > 0) {
		GtkLabel* _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GtkLabel* _tmp6_;
		_tmp2_ = self->priv->developers_label;
		_tmp3_ = self->priv->developers;
		_tmp3__length1 = self->priv->developers_length1;
		_tmp4_ = _vala_g_strjoinv (", ", _tmp3_, (gint) _tmp3__length1);
		_tmp5_ = _tmp4_;
		gtk_label_set_text (_tmp2_, _tmp5_);
		_g_free0 (_tmp5_);
		_tmp6_ = self->priv->developers_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
	} else {
		GtkLabel* _tmp7_;
		GtkLabel* _tmp8_;
		_tmp7_ = self->priv->developers_label;
		gtk_label_set_text (_tmp7_, "");
		_tmp8_ = self->priv->developers_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, FALSE);
	}
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY]);
}

gint
he_about_window_get_copyright_year (HeAboutWindow* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_copyright_year;
	return result;
}

void
he_about_window_set_copyright_year (HeAboutWindow* self,
                                    gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_copyright_year = value;
	if (value > 0) {
		GtkLabel* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkLabel* _tmp7_;
		_tmp0_ = self->priv->developers_copyright;
		_tmp1_ = g_strdup_printf ("%i", value);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_strconcat ("Copyright © ", _tmp2_, NULL);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strconcat (_tmp4_, " ", NULL);
		_tmp6_ = _tmp5_;
		gtk_label_set_text (_tmp0_, _tmp6_);
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		_g_free0 (_tmp2_);
		_tmp7_ = self->priv->developers_copyright;
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, TRUE);
	} else {
		GtkLabel* _tmp8_;
		GtkLabel* _tmp9_;
		_tmp8_ = self->priv->developers_copyright;
		gtk_label_set_text (_tmp8_, "");
		_tmp9_ = self->priv->developers_copyright;
		gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
	}
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY]);
}

const gchar*
he_about_window_get_app_id (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_id;
	result = _tmp0_;
	return result;
}

void
he_about_window_set_app_id (HeAboutWindow* self,
                            const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = he_about_window_get_app_id (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_app_id);
		self->priv->_app_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY]);
	}
}

const gchar*
he_about_window_get_translate_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_translate_url;
	result = _tmp0_;
	return result;
}

void
he_about_window_set_translate_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_translate_url);
	self->priv->_translate_url = _tmp0_;
	if (value != NULL) {
		HeTextButton* _tmp1_;
		_tmp1_ = self->priv->translate_app_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
	} else {
		HeTextButton* _tmp2_;
		_tmp2_ = self->priv->translate_app_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
	}
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY]);
}

const gchar*
he_about_window_get_issue_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_issue_url;
	result = _tmp0_;
	return result;
}

void
he_about_window_set_issue_url (HeAboutWindow* self,
                               const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_issue_url);
	self->priv->_issue_url = _tmp0_;
	if (value != NULL) {
		HeTintButton* _tmp1_;
		_tmp1_ = self->priv->report_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
	} else {
		HeTintButton* _tmp2_;
		_tmp2_ = self->priv->report_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
	}
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY]);
}

const gchar*
he_about_window_get_more_info_url (HeAboutWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_more_info_url;
	result = _tmp0_;
	return result;
}

void
he_about_window_set_more_info_url (HeAboutWindow* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_more_info_url);
	self->priv->_more_info_url = _tmp0_;
	if (value != NULL) {
		HeFillButton* _tmp1_;
		_tmp1_ = self->priv->more_info_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, TRUE);
	} else {
		HeFillButton* _tmp2_;
		_tmp2_ = self->priv->more_info_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
	}
	g_object_notify_by_pspec ((GObject *) self, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY]);
}

/**
  * Creates a new AboutWindow.
  * @param parent The parent window.
  * @param app_name Your application's name.
  * @param app_id Your application's reverse-domain name.
  * @param version Your application's version.
  * @param icon Your application's icon.
  * @param translate_url A URL where contributors can help translate the application.
  * @param issue_url A URL where users can report a problem with the application.
  * @param more_info_url A URL where users can get more information about the application.
  * @param translators Your application's translators.
  * @param developers Your application's developers.
  * @param copyright_year Your application's copyright year.
  * @param license Your application's license.
  * @param color The color of the AboutWindow.
  *
  * @since 1.0
  */
HeAboutWindow*
he_about_window_construct (GType object_type,
                           GtkWindow* parent,
                           const gchar* app_name,
                           const gchar* app_id,
                           const gchar* version,
                           const gchar* icon,
                           const gchar* translate_url,
                           const gchar* issue_url,
                           const gchar* more_info_url,
                           gchar** translators,
                           gint translators_length1,
                           gchar** developers,
                           gint developers_length1,
                           gint copyright_year,
                           HeAboutWindowLicenses license,
                           HeColors color)
{
	HeAboutWindow * self = NULL;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (app_name != NULL, NULL);
	g_return_val_if_fail (app_id != NULL, NULL);
	g_return_val_if_fail (version != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	self = (HeAboutWindow*) he_window_construct (object_type);
	he_window_set_parent ((HeWindow*) self, parent);
	he_about_window_set_app_name (self, app_name);
	he_about_window_set_app_id (self, app_id);
	he_about_window_set_version (self, version);
	he_about_window_set_icon (self, icon);
	he_about_window_set_translate_url (self, translate_url);
	he_about_window_set_issue_url (self, issue_url);
	he_about_window_set_more_info_url (self, more_info_url);
	he_about_window_set_translator_names (self, translators, translators_length1);
	he_about_window_set_developer_names (self, developers, developers_length1);
	he_about_window_set_copyright_year (self, copyright_year);
	he_about_window_set_license (self, license);
	he_about_window_set_color (self, color);
	return self;
}

HeAboutWindow*
he_about_window_new (GtkWindow* parent,
                     const gchar* app_name,
                     const gchar* app_id,
                     const gchar* version,
                     const gchar* icon,
                     const gchar* translate_url,
                     const gchar* issue_url,
                     const gchar* more_info_url,
                     gchar** translators,
                     gint translators_length1,
                     gchar** developers,
                     gint developers_length1,
                     gint copyright_year,
                     HeAboutWindowLicenses license,
                     HeColors color)
{
	return he_about_window_construct (HE_TYPE_ABOUT_WINDOW, parent, app_name, app_id, version, icon, translate_url, issue_url, more_info_url, translators, translators_length1, developers, developers_length1, copyright_year, license, color);
}

static void
_he_about_window___lambda10_ (HeAboutWindow* self)
{
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	_tmp0_ = he_window_get_parent ((HeWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = he_about_window_get_translate_url (self);
	_tmp3_ = _tmp2_;
	gtk_show_uri (_tmp1_, _tmp3_, (guint32) GDK_CURRENT_TIME);
}

static void
__he_about_window___lambda10__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
	_he_about_window___lambda10_ ((HeAboutWindow*) self);
}

static void
_he_about_window___lambda11_ (HeAboutWindow* self)
{
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	_tmp0_ = he_window_get_parent ((HeWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = he_about_window_get_issue_url (self);
	_tmp3_ = _tmp2_;
	gtk_show_uri (_tmp1_, _tmp3_, (guint32) GDK_CURRENT_TIME);
}

static void
__he_about_window___lambda11__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
	_he_about_window___lambda11_ ((HeAboutWindow*) self);
}

static void
_he_about_window___lambda12_ (HeAboutWindow* self)
{
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	_tmp0_ = he_window_get_parent ((HeWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = he_about_window_get_more_info_url (self);
	_tmp3_ = _tmp2_;
	gtk_show_uri (_tmp1_, _tmp3_, (guint32) GDK_CURRENT_TIME);
}

static void
__he_about_window___lambda12__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
	_he_about_window___lambda12_ ((HeAboutWindow*) self);
}

static GObject *
he_about_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeAboutWindow * self;
	HeAppBar* _tmp0_;
	HeAppBar* _tmp1_;
	HeAppBar* _tmp2_;
	HeAppBar* _tmp3_;
	GtkOverlay* _tmp4_;
	HeAppBar* _tmp5_;
	GtkOverlay* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GtkImage* _tmp15_;
	GtkBox* _tmp16_;
	GtkImage* _tmp17_;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GtkBox* _tmp22_;
	GtkBox* _tmp23_;
	HeModifierBadge* _tmp24_;
	HeModifierBadge* _tmp25_;
	GtkLabel* _tmp26_;
	GtkBox* _tmp27_;
	GtkLabel* _tmp28_;
	GtkBox* _tmp29_;
	HeModifierBadge* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkBox* _tmp33_;
	GtkLabel* _tmp34_;
	GtkBox* _tmp35_;
	GtkLabel* _tmp36_;
	GtkBox* _tmp37_;
	GtkBox* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkBox* _tmp41_;
	GtkLabel* _tmp42_;
	GtkLinkButton* _tmp43_;
	GtkLinkButton* _tmp44_;
	GtkLinkButton* _tmp45_;
	GtkBox* _tmp46_;
	GtkLabel* _tmp47_;
	GtkBox* _tmp48_;
	GtkLinkButton* _tmp49_;
	GtkBox* _tmp50_;
	GtkBox* _tmp51_;
	GtkBox* _tmp52_;
	GtkBox* _tmp53_;
	GtkBox* _tmp54_;
	HeTextButton* _tmp55_;
	GtkBox* _tmp56_;
	HeTintButton* _tmp57_;
	GtkBox* _tmp58_;
	HeFillButton* _tmp59_;
	HeTextButton* _tmp60_;
	HeTintButton* _tmp61_;
	HeFillButton* _tmp62_;
	GtkWindowHandle* window_handle = NULL;
	GtkWindowHandle* _tmp63_;
	GtkWindowHandle* _tmp64_;
	GtkOverlay* _tmp65_;
	GtkWindowHandle* _tmp66_;
	parent_class = G_OBJECT_CLASS (he_about_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	_tmp0_ = self->priv->app_bar;
	gtk_widget_set_valign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
	_tmp1_ = self->priv->app_bar;
	he_app_bar_set_show_back (_tmp1_, FALSE);
	_tmp2_ = self->priv->app_bar;
	he_app_bar_set_show_left_title_buttons (_tmp2_, TRUE);
	_tmp3_ = self->priv->app_bar;
	he_app_bar_set_show_right_title_buttons (_tmp3_, FALSE);
	_tmp4_ = self->priv->window_overlay;
	_tmp5_ = self->priv->app_bar;
	gtk_overlay_add_overlay (_tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = self->priv->window_overlay;
	_tmp7_ = self->priv->about_box;
	gtk_overlay_set_child (_tmp6_, (GtkWidget*) _tmp7_);
	_tmp8_ = self->priv->about_box;
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "dialog-content");
	_tmp9_ = self->priv->about_box;
	_tmp10_ = self->priv->content_box;
	gtk_box_append (_tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->about_box;
	_tmp12_ = self->priv->button_box;
	gtk_box_append (_tmp11_, (GtkWidget*) _tmp12_);
	_tmp13_ = self->priv->icon_image;
	gtk_widget_set_valign ((GtkWidget*) _tmp13_, GTK_ALIGN_START);
	_tmp14_ = self->priv->icon_image;
	gtk_image_set_pixel_size (_tmp14_, 128);
	_tmp15_ = self->priv->icon_image;
	gtk_widget_add_css_class ((GtkWidget*) _tmp15_, "icon-dropshadow");
	_tmp16_ = self->priv->content_box;
	_tmp17_ = self->priv->icon_image;
	gtk_box_append (_tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = self->priv->content_box;
	_tmp19_ = self->priv->info_box;
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->info_box;
	_tmp21_ = self->priv->title_box;
	gtk_box_append (_tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = self->priv->info_box;
	_tmp23_ = self->priv->text_box;
	gtk_box_append (_tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = self->priv->version_badge;
	he_modifier_badge_set_tinted (_tmp24_, TRUE);
	_tmp25_ = self->priv->version_badge;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp25_, 18);
	_tmp26_ = self->priv->title_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp26_, "display");
	_tmp27_ = self->priv->title_box;
	_tmp28_ = self->priv->title_label;
	gtk_box_append (_tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = self->priv->title_box;
	_tmp30_ = self->priv->version_badge;
	gtk_box_append (_tmp29_, (GtkWidget*) _tmp30_);
	_tmp31_ = self->priv->developers_copyright;
	gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
	_tmp32_ = self->priv->developers_label;
	gtk_widget_set_visible ((GtkWidget*) _tmp32_, FALSE);
	_tmp33_ = self->priv->developers_box;
	_tmp34_ = self->priv->developers_copyright;
	gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
	_tmp35_ = self->priv->developers_box;
	_tmp36_ = self->priv->developers_label;
	gtk_box_append (_tmp35_, (GtkWidget*) _tmp36_);
	_tmp37_ = self->priv->text_box;
	_tmp38_ = self->priv->developers_box;
	gtk_box_append (_tmp37_, (GtkWidget*) _tmp38_);
	_tmp39_ = self->priv->translators_label;
	gtk_label_set_xalign (_tmp39_, (gfloat) 0);
	_tmp40_ = self->priv->translators_label;
	gtk_widget_set_visible ((GtkWidget*) _tmp40_, FALSE);
	_tmp41_ = self->priv->text_box;
	_tmp42_ = self->priv->translators_label;
	gtk_box_append (_tmp41_, (GtkWidget*) _tmp42_);
	_tmp43_ = self->priv->license_link;
	gtk_widget_remove_css_class ((GtkWidget*) _tmp43_, "text-button");
	_tmp44_ = self->priv->license_link;
	gtk_widget_remove_css_class ((GtkWidget*) _tmp44_, "link");
	_tmp45_ = self->priv->license_link;
	gtk_widget_add_css_class ((GtkWidget*) _tmp45_, "link-button");
	_tmp46_ = self->priv->license_box;
	_tmp47_ = self->priv->license_label;
	gtk_box_append (_tmp46_, (GtkWidget*) _tmp47_);
	_tmp48_ = self->priv->license_box;
	_tmp49_ = self->priv->license_link;
	gtk_box_append (_tmp48_, (GtkWidget*) _tmp49_);
	_tmp50_ = self->priv->text_box;
	_tmp51_ = self->priv->license_box;
	gtk_box_append (_tmp50_, (GtkWidget*) _tmp51_);
	_tmp52_ = self->priv->button_box;
	gtk_widget_set_valign ((GtkWidget*) _tmp52_, GTK_ALIGN_CENTER);
	_tmp53_ = self->priv->button_box;
	gtk_box_set_homogeneous (_tmp53_, TRUE);
	_tmp54_ = self->priv->button_box;
	_tmp55_ = self->priv->translate_app_button;
	gtk_box_append (_tmp54_, (GtkWidget*) _tmp55_);
	_tmp56_ = self->priv->button_box;
	_tmp57_ = self->priv->report_button;
	gtk_box_append (_tmp56_, (GtkWidget*) _tmp57_);
	_tmp58_ = self->priv->button_box;
	_tmp59_ = self->priv->more_info_button;
	gtk_box_append (_tmp58_, (GtkWidget*) _tmp59_);
	_tmp60_ = self->priv->translate_app_button;
	g_signal_connect_object ((GtkButton*) _tmp60_, "clicked", (GCallback) __he_about_window___lambda10__gtk_button_clicked, self, 0);
	_tmp61_ = self->priv->report_button;
	g_signal_connect_object ((GtkButton*) _tmp61_, "clicked", (GCallback) __he_about_window___lambda11__gtk_button_clicked, self, 0);
	_tmp62_ = self->priv->more_info_button;
	g_signal_connect_object ((GtkButton*) _tmp62_, "clicked", (GCallback) __he_about_window___lambda12__gtk_button_clicked, self, 0);
	_tmp63_ = (GtkWindowHandle*) gtk_window_handle_new ();
	g_object_ref_sink (_tmp63_);
	window_handle = _tmp63_;
	_tmp64_ = window_handle;
	_tmp65_ = self->priv->window_overlay;
	gtk_window_handle_set_child (_tmp64_, (GtkWidget*) _tmp65_);
	_tmp66_ = window_handle;
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp66_);
	gtk_widget_add_css_class ((GtkWidget*) self, "dialog-content");
	_g_object_unref0 (window_handle);
	return obj;
}

static void
he_about_window_class_init (HeAboutWindowClass * klass,
                            gpointer klass_data)
{
	he_about_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeAboutWindow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_about_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_about_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_about_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_about_window_finalize;
	/**
	  * The theme color of the AboutWindow.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COLOR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * The license shown in the AboutWindow.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_LICENSE_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_LICENSE_PROPERTY] = g_param_spec_enum ("license", "license", "license", HE_ABOUT_WINDOW_TYPE_LICENSES, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * The version shown in the AboutWindow.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_VERSION_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * The name of the application shown in the AboutWindow.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_NAME_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  *  The icon shown in the AboutWindow.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ICON_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * The translators shown in the AboutWindow.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY] = g_param_spec_boxed ("translator-names", "translator-names", "translator-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * The developers shown in the AboutWindow.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY] = g_param_spec_boxed ("developer-names", "developer-names", "developer-names", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * The copyright year shown in the AboutWindow.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY] = g_param_spec_int ("copyright-year", "copyright-year", "copyright-year", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * Your application's reverse-domain name.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_APP_ID_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * A URL where contributors can help translate the application.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY] = g_param_spec_string ("translate-url", "translate-url", "translate-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * A URL where users can report a problem with the application.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY] = g_param_spec_string ("issue-url", "issue-url", "issue-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	  * A URL where users can get more information about the application.
	  */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY, he_about_window_properties[HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY] = g_param_spec_string ("more-info-url", "more-info-url", "more-info-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_about_window_instance_init (HeAboutWindow * self,
                               gpointer klass)
{
	HeAppBar* _tmp0_;
	GtkOverlay* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLinkButton* _tmp15_;
	GtkImage* _tmp16_;
	HeTextButton* _tmp17_;
	HeTintButton* _tmp18_;
	HeFillButton* _tmp19_;
	HeModifierBadge* _tmp20_;
	gchar** _tmp21_;
	gchar** _tmp22_;
	gchar* _tmp23_;
	self->priv = he_about_window_get_instance_private (self);
	_tmp0_ = he_app_bar_new ();
	g_object_ref_sink (_tmp0_);
	self->priv->app_bar = _tmp0_;
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp1_);
	self->priv->window_overlay = _tmp1_;
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 30);
	g_object_ref_sink (_tmp2_);
	self->priv->about_box = _tmp2_;
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
	g_object_ref_sink (_tmp3_);
	self->priv->content_box = _tmp3_;
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 18);
	g_object_ref_sink (_tmp4_);
	self->priv->button_box = _tmp4_;
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
	g_object_ref_sink (_tmp5_);
	self->priv->info_box = _tmp5_;
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
	g_object_ref_sink (_tmp6_);
	self->priv->title_box = _tmp6_;
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	g_object_ref_sink (_tmp7_);
	self->priv->text_box = _tmp7_;
	_tmp8_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp8_);
	self->priv->developers_box = _tmp8_;
	_tmp9_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp9_);
	self->priv->license_box = _tmp9_;
	_tmp10_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp10_);
	self->priv->title_label = _tmp10_;
	_tmp11_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp11_);
	self->priv->developers_copyright = _tmp11_;
	_tmp12_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp12_);
	self->priv->developers_label = _tmp12_;
	_tmp13_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp13_);
	self->priv->translators_label = _tmp13_;
	_tmp14_ = (GtkLabel*) gtk_label_new ("This program is licensed under ");
	g_object_ref_sink (_tmp14_);
	self->priv->license_label = _tmp14_;
	_tmp15_ = (GtkLinkButton*) gtk_link_button_new ("about:blank");
	g_object_ref_sink (_tmp15_);
	self->priv->license_link = _tmp15_;
	_tmp16_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp16_);
	self->priv->icon_image = _tmp16_;
	_tmp17_ = he_text_button_new ("Translate App");
	g_object_ref_sink (_tmp17_);
	self->priv->translate_app_button = _tmp17_;
	_tmp18_ = he_tint_button_new ("Report a Problem");
	g_object_ref_sink (_tmp18_);
	self->priv->report_button = _tmp18_;
	_tmp19_ = he_fill_button_new ("More Info…");
	g_object_ref_sink (_tmp19_);
	self->priv->more_info_button = _tmp19_;
	_tmp20_ = he_modifier_badge_new ("");
	g_object_ref_sink (_tmp20_);
	self->priv->version_badge = _tmp20_;
	self->priv->_color = HE_COLORS_PURPLE;
	self->priv->_license = HE_ABOUT_WINDOW_LICENSES_GPLV3;
	_tmp21_ = g_new0 (gchar*, 0 + 1);
	self->priv->translators = _tmp21_;
	self->priv->translators_length1 = 0;
	self->priv->_translators_size_ = self->priv->translators_length1;
	_tmp22_ = g_new0 (gchar*, 0 + 1);
	self->priv->developers = _tmp22_;
	self->priv->developers_length1 = 0;
	self->priv->_developers_size_ = self->priv->developers_length1;
	_tmp23_ = g_strdup ("");
	self->priv->_app_id = _tmp23_;
}

static void
he_about_window_finalize (GObject * obj)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
	_g_object_unref0 (self->priv->app_bar);
	_g_object_unref0 (self->priv->window_overlay);
	_g_object_unref0 (self->priv->about_box);
	_g_object_unref0 (self->priv->content_box);
	_g_object_unref0 (self->priv->button_box);
	_g_object_unref0 (self->priv->info_box);
	_g_object_unref0 (self->priv->title_box);
	_g_object_unref0 (self->priv->text_box);
	_g_object_unref0 (self->priv->developers_box);
	_g_object_unref0 (self->priv->license_box);
	_g_object_unref0 (self->priv->title_label);
	_g_object_unref0 (self->priv->developers_copyright);
	_g_object_unref0 (self->priv->developers_label);
	_g_object_unref0 (self->priv->translators_label);
	_g_object_unref0 (self->priv->license_label);
	_g_object_unref0 (self->priv->license_link);
	_g_object_unref0 (self->priv->icon_image);
	_g_object_unref0 (self->priv->translate_app_button);
	_g_object_unref0 (self->priv->report_button);
	_g_object_unref0 (self->priv->more_info_button);
	_g_object_unref0 (self->priv->version_badge);
	self->priv->translators = (_vala_array_free (self->priv->translators, self->priv->translators_length1, (GDestroyNotify) g_free), NULL);
	self->priv->developers = (_vala_array_free (self->priv->developers, self->priv->developers_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->_translate_url);
	_g_free0 (self->priv->_issue_url);
	_g_free0 (self->priv->_more_info_url);
	_g_free0 (self->priv->_app_id);
	G_OBJECT_CLASS (he_about_window_parent_class)->finalize (obj);
}

/**
* An AboutWindow is a window that displays information about the application.
*/
static GType
he_about_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeAboutWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_about_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeAboutWindow), 0, (GInstanceInitFunc) he_about_window_instance_init, NULL };
	GType he_about_window_type_id;
	he_about_window_type_id = g_type_register_static (HE_TYPE_WINDOW, "HeAboutWindow", &g_define_type_info, 0);
	HeAboutWindow_private_offset = g_type_add_instance_private (he_about_window_type_id, sizeof (HeAboutWindowPrivate));
	return he_about_window_type_id;
}

GType
he_about_window_get_type (void)
{
	static volatile gsize he_about_window_type_id__once = 0;
	if (g_once_init_enter (&he_about_window_type_id__once)) {
		GType he_about_window_type_id;
		he_about_window_type_id = he_about_window_get_type_once ();
		g_once_init_leave (&he_about_window_type_id__once, he_about_window_type_id);
	}
	return he_about_window_type_id__once;
}

static void
_vala_he_about_window_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
	switch (property_id) {
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
		g_value_set_enum (value, he_about_window_get_color (self));
		break;
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
		g_value_set_enum (value, he_about_window_get_license (self));
		break;
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
		g_value_set_string (value, he_about_window_get_version (self));
		break;
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
		g_value_set_string (value, he_about_window_get_app_name (self));
		break;
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
		g_value_set_string (value, he_about_window_get_icon (self));
		break;
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, he_about_window_get_translator_names (self, &length));
		}
		break;
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
		{
			int length;
			g_value_set_boxed (value, he_about_window_get_developer_names (self, &length));
		}
		break;
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
		g_value_set_int (value, he_about_window_get_copyright_year (self));
		break;
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
		g_value_set_string (value, he_about_window_get_app_id (self));
		break;
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
		g_value_set_string (value, he_about_window_get_translate_url (self));
		break;
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
		g_value_set_string (value, he_about_window_get_issue_url (self));
		break;
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
		g_value_set_string (value, he_about_window_get_more_info_url (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_about_window_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	HeAboutWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ABOUT_WINDOW, HeAboutWindow);
	switch (property_id) {
		case HE_ABOUT_WINDOW_COLOR_PROPERTY:
		he_about_window_set_color (self, g_value_get_enum (value));
		break;
		case HE_ABOUT_WINDOW_LICENSE_PROPERTY:
		he_about_window_set_license (self, g_value_get_enum (value));
		break;
		case HE_ABOUT_WINDOW_VERSION_PROPERTY:
		he_about_window_set_version (self, g_value_get_string (value));
		break;
		case HE_ABOUT_WINDOW_APP_NAME_PROPERTY:
		he_about_window_set_app_name (self, g_value_get_string (value));
		break;
		case HE_ABOUT_WINDOW_ICON_PROPERTY:
		he_about_window_set_icon (self, g_value_get_string (value));
		break;
		case HE_ABOUT_WINDOW_TRANSLATOR_NAMES_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			he_about_window_set_translator_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case HE_ABOUT_WINDOW_DEVELOPER_NAMES_PROPERTY:
		{
			gpointer boxed;
			boxed = g_value_get_boxed (value);
			he_about_window_set_developer_names (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
		}
		break;
		case HE_ABOUT_WINDOW_COPYRIGHT_YEAR_PROPERTY:
		he_about_window_set_copyright_year (self, g_value_get_int (value));
		break;
		case HE_ABOUT_WINDOW_APP_ID_PROPERTY:
		he_about_window_set_app_id (self, g_value_get_string (value));
		break;
		case HE_ABOUT_WINDOW_TRANSLATE_URL_PROPERTY:
		he_about_window_set_translate_url (self, g_value_get_string (value));
		break;
		case HE_ABOUT_WINDOW_ISSUE_URL_PROPERTY:
		he_about_window_set_issue_url (self, g_value_get_string (value));
		break;
		case HE_ABOUT_WINDOW_MORE_INFO_URL_PROPERTY:
		he_about_window_set_more_info_url (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

