/* ApplicationWindow.c generated by valac 0.56.13, the Vala compiler
 * generated from ApplicationWindow.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>

enum  {
	HE_APPLICATION_WINDOW_0_PROPERTY,
	HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY,
	HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY,
	HE_APPLICATION_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_application_window_properties[HE_APPLICATION_WINDOW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeApplicationWindowPrivate {
	HeAppBar* title;
	gboolean _has_title;
	gboolean _has_back_button;
};

static gint HeApplicationWindow_private_offset;
static gpointer he_application_window_parent_class = NULL;

static GObject * he_application_window_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void he_application_window_finalize (GObject * obj);
static GType he_application_window_get_type_once (void);
static void _vala_he_application_window_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_he_application_window_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_application_window_get_instance_private (HeApplicationWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeApplicationWindow_private_offset);
}

/**
    * Creates a new ApplicationWindow.
    * @param app The application associated with this window.
    *
    * @since 1.0
    */
HeApplicationWindow*
he_application_window_construct (GType object_type,
                                 HeApplication* app)
{
	HeApplicationWindow * self = NULL;
	gchar* base_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* base_uri = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* base_file = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	gboolean _tmp10_;
	g_return_val_if_fail (app != NULL, NULL);
	self = (HeApplicationWindow*) g_object_new (object_type, "application", app, NULL);
	_tmp0_ = g_application_get_resource_base_path ((GApplication*) app);
	_tmp1_ = g_strdup (_tmp0_);
	base_path = _tmp1_;
	_tmp2_ = base_path;
	if (_tmp2_ == NULL) {
		_g_free0 (base_path);
		return self;
	}
	_tmp3_ = base_path;
	_tmp4_ = g_strconcat ("resource://", _tmp3_, NULL);
	base_uri = _tmp4_;
	_tmp5_ = base_uri;
	_tmp6_ = g_file_new_for_uri (_tmp5_);
	base_file = _tmp6_;
	_tmp7_ = base_file;
	_tmp8_ = g_file_get_child (_tmp7_, "gtk/help-overlay.ui");
	_tmp9_ = _tmp8_;
	_tmp10_ = g_file_query_exists (_tmp9_, NULL);
	_g_object_unref0 (_tmp9_);
	if (_tmp10_) {
		GtkBuilder* builder = NULL;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		GtkBuilder* _tmp14_;
		GtkBuilder* _tmp15_;
		GtkBuilder* _tmp16_;
		GObject* _tmp17_;
		_tmp11_ = base_path;
		_tmp12_ = g_strconcat (_tmp11_, "/gtk/help-overlay.ui", NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = gtk_builder_new_from_file (_tmp13_);
		_tmp15_ = _tmp14_;
		_g_free0 (_tmp13_);
		builder = _tmp15_;
		_tmp16_ = builder;
		_tmp17_ = gtk_builder_get_object (_tmp16_, "help_overlay");
		gtk_application_window_set_help_overlay ((GtkApplicationWindow*) self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, gtk_shortcuts_window_get_type ()) ? ((GtkShortcutsWindow*) _tmp17_) : NULL);
		_g_object_unref0 (builder);
	}
	_g_object_unref0 (base_file);
	_g_free0 (base_uri);
	_g_free0 (base_path);
	return self;
}

HeApplicationWindow*
he_application_window_new (HeApplication* app)
{
	return he_application_window_construct (HE_TYPE_APPLICATION_WINDOW, app);
}

gboolean
he_application_window_get_has_title (HeApplicationWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_title;
	return result;
}

void
he_application_window_set_has_title (HeApplicationWindow* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_has_title = value;
	if (!value) {
		GtkBox* box = NULL;
		GtkBox* _tmp0_;
		GtkBox* _tmp1_;
		_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
		g_object_ref_sink (_tmp0_);
		box = _tmp0_;
		_tmp1_ = box;
		gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp1_);
		_g_object_unref0 (box);
	} else {
		HeAppBar* _tmp2_;
		HeAppBar* _tmp3_;
		_tmp2_ = self->priv->title;
		gtk_widget_add_css_class ((GtkWidget*) _tmp2_, "flat");
		_tmp3_ = self->priv->title;
		gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp3_);
	}
	g_object_notify_by_pspec ((GObject *) self, he_application_window_properties[HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY]);
}

gboolean
he_application_window_get_has_back_button (HeApplicationWindow* self)
{
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = he_application_window_get_has_back_button (self);
	_tmp1_ = _tmp0_;
	result = _tmp1_;
	return result;
}

void
he_application_window_set_has_back_button (HeApplicationWindow* self,
                                           gboolean value)
{
	HeAppBar* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_has_back_button = value;
	_tmp0_ = self->priv->title;
	he_app_bar_set_show_back (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_application_window_properties[HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY]);
}

static GObject *
he_application_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeApplicationWindow * self;
	parent_class = G_OBJECT_CLASS (he_application_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_APPLICATION_WINDOW, HeApplicationWindow);
	he_application_window_set_has_title (self, FALSE);
	he_application_window_set_has_back_button (self, FALSE);
	return obj;
}

static void
he_application_window_class_init (HeApplicationWindowClass * klass,
                                  gpointer klass_data)
{
	he_application_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeApplicationWindow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_application_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_application_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_application_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_application_window_finalize;
	/**
	    * Whether this window should display a title.
	    */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY, he_application_window_properties[HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY] = g_param_spec_boolean ("has-title", "has-title", "has-title", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	    * Whether this window should display a back button.
	    */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY, he_application_window_properties[HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY] = g_param_spec_boolean ("has-back-button", "has-back-button", "has-back-button", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_application_window_instance_init (HeApplicationWindow * self,
                                     gpointer klass)
{
	HeAppBar* _tmp0_;
	self->priv = he_application_window_get_instance_private (self);
	_tmp0_ = he_app_bar_new ();
	g_object_ref_sink (_tmp0_);
	self->priv->title = _tmp0_;
}

static void
he_application_window_finalize (GObject * obj)
{
	HeApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_APPLICATION_WINDOW, HeApplicationWindow);
	_g_object_unref0 (self->priv->title);
	G_OBJECT_CLASS (he_application_window_parent_class)->finalize (obj);
}

/**
* An ApplicationWindow is a Window for holding the main content of an application.
*/
static GType
he_application_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeApplicationWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_application_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeApplicationWindow), 0, (GInstanceInitFunc) he_application_window_instance_init, NULL };
	GType he_application_window_type_id;
	he_application_window_type_id = g_type_register_static (gtk_application_window_get_type (), "HeApplicationWindow", &g_define_type_info, 0);
	HeApplicationWindow_private_offset = g_type_add_instance_private (he_application_window_type_id, sizeof (HeApplicationWindowPrivate));
	return he_application_window_type_id;
}

GType
he_application_window_get_type (void)
{
	static volatile gsize he_application_window_type_id__once = 0;
	if (g_once_init_enter (&he_application_window_type_id__once)) {
		GType he_application_window_type_id;
		he_application_window_type_id = he_application_window_get_type_once ();
		g_once_init_leave (&he_application_window_type_id__once, he_application_window_type_id);
	}
	return he_application_window_type_id__once;
}

static void
_vala_he_application_window_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	HeApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION_WINDOW, HeApplicationWindow);
	switch (property_id) {
		case HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY:
		g_value_set_boolean (value, he_application_window_get_has_title (self));
		break;
		case HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY:
		g_value_set_boolean (value, he_application_window_get_has_back_button (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_application_window_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	HeApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_APPLICATION_WINDOW, HeApplicationWindow);
	switch (property_id) {
		case HE_APPLICATION_WINDOW_HAS_TITLE_PROPERTY:
		he_application_window_set_has_title (self, g_value_get_boolean (value));
		break;
		case HE_APPLICATION_WINDOW_HAS_BACK_BUTTON_PROPERTY:
		he_application_window_set_has_back_button (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

