/* Banner.c generated by valac 0.56.13, the Vala compiler
 * generated from Banner.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>

enum  {
	HE_BANNER_0_PROPERTY,
	HE_BANNER_TITLE_PROPERTY,
	HE_BANNER_DESCRIPTION_PROPERTY,
	HE_BANNER_STYLE_PROPERTY,
	HE_BANNER_NUM_PROPERTIES
};
static GParamSpec* he_banner_properties[HE_BANNER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeBannerPrivate {
	GtkBox* main_box;
	GtkBox* text_box;
	GtkBox* button_box;
	GtkLabel* title_label;
	GtkLabel* description_label;
	HeBannerStyle _style;
};

static gint HeBanner_private_offset;
static gpointer he_banner_parent_class = NULL;
static GtkBuildableIface * he_banner_gtk_buildable_parent_iface = NULL;

static void he_banner_real_add_child (GtkBuildable* base,
                               GtkBuilder* builder,
                               GObject* child,
                               const gchar* type);
static GObject * he_banner_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void he_banner_finalize (GObject * obj);
static GType he_banner_get_type_once (void);
static void _vala_he_banner_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_he_banner_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_banner_get_instance_private (HeBanner* self)
{
	return G_STRUCT_MEMBER_P (self, HeBanner_private_offset);
}

/**
     * An enum representing the style of the banner.
     */
static GType
he_banner_style_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_BANNER_STYLE_INFO, "HE_BANNER_STYLE_INFO", "info"}, {HE_BANNER_STYLE_WARNING, "HE_BANNER_STYLE_WARNING", "warning"}, {HE_BANNER_STYLE_ERROR, "HE_BANNER_STYLE_ERROR", "error"}, {0, NULL, NULL}};
	GType he_banner_style_type_id;
	he_banner_style_type_id = g_enum_register_static ("HeBannerStyle", values);
	return he_banner_style_type_id;
}

GType
he_banner_style_get_type (void)
{
	static volatile gsize he_banner_style_type_id__once = 0;
	if (g_once_init_enter (&he_banner_style_type_id__once)) {
		GType he_banner_style_type_id;
		he_banner_style_type_id = he_banner_style_get_type_once ();
		g_once_init_leave (&he_banner_style_type_id__once, he_banner_style_type_id);
	}
	return he_banner_style_type_id__once;
}

const gchar*
he_banner_get_title (HeBanner* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->title_label;
	_tmp1_ = gtk_label_get_text (_tmp0_);
	result = _tmp1_;
	return result;
}

void
he_banner_set_title (HeBanner* self,
                     const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->title_label;
	gtk_label_set_text (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_banner_properties[HE_BANNER_TITLE_PROPERTY]);
}

const gchar*
he_banner_get_description (HeBanner* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->description_label;
	_tmp1_ = gtk_label_get_text (_tmp0_);
	result = _tmp1_;
	return result;
}

void
he_banner_set_description (HeBanner* self,
                           const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->description_label;
	gtk_label_set_text (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_banner_properties[HE_BANNER_DESCRIPTION_PROPERTY]);
}

HeBannerStyle
he_banner_get_style (HeBanner* self)
{
	HeBannerStyle result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_style;
	return result;
}

void
he_banner_set_style (HeBanner* self,
                     HeBannerStyle value)
{
	g_return_if_fail (self != NULL);
	he_banner_set_banner_style (self, value);
	g_object_notify_by_pspec ((GObject *) self, he_banner_properties[HE_BANNER_STYLE_PROPERTY]);
}

/**
     * Add a child to the banner, should only be used in the context of a UI or Blueprint file. There should be no need to use this method in code.
     */
static void
he_banner_real_add_child (GtkBuildable* base,
                          GtkBuilder* builder,
                          GObject* child,
                          const gchar* type)
{
	HeBanner * self;
	GCompareFunc _tmp0_;
	self = (HeBanner*) base;
	g_return_if_fail (builder != NULL);
	g_return_if_fail (child != NULL);
	_tmp0_ = ((GCompareFunc) g_strcmp0);
	if (_tmp0_ (type, "action") == 0) {
		he_banner_add_action_button (self, G_TYPE_CHECK_INSTANCE_CAST (child, gtk_widget_get_type (), GtkWidget));
	} else {
		GtkBox* _tmp1_;
		_tmp1_ = self->priv->main_box;
		gtk_box_append (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (child, gtk_widget_get_type (), GtkWidget));
	}
}

/**
     * Add a button to the banner.
     * @param widget The button to add to the banner.
     */
void
he_banner_add_action_button (HeBanner* self,
                             GtkWidget* widget)
{
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	GtkBox* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = self->priv->button_box;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	if (_tmp1_ == NULL) {
		GtkBox* _tmp2_;
		_tmp2_ = self->priv->button_box;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	}
	_tmp3_ = self->priv->button_box;
	gtk_box_append (_tmp3_, widget);
}

/**
     * Remove a button from the banner.
     * @param widget The button to remove.
     */
void
he_banner_remove_action (HeBanner* self,
                         GtkWidget* widget)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkWidget* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = self->priv->button_box;
	gtk_box_remove (_tmp0_, widget);
	_tmp1_ = self->priv->button_box;
	_tmp2_ = gtk_widget_get_first_child ((GtkWidget*) _tmp1_);
	if (_tmp2_ == NULL) {
		GtkBox* _tmp3_;
		_tmp3_ = self->priv->button_box;
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
	}
}

/**
     * Set the banner style.
     * @param style The style to set the banner to.
     */
void
he_banner_set_banner_style (HeBanner* self,
                            HeBannerStyle style)
{
	g_return_if_fail (self != NULL);
	gtk_widget_remove_css_class ((GtkWidget*) self, "info");
	gtk_widget_remove_css_class ((GtkWidget*) self, "warning");
	gtk_widget_remove_css_class ((GtkWidget*) self, "error");
	if (style == HE_BANNER_STYLE_INFO) {
		gtk_widget_add_css_class ((GtkWidget*) self, "info");
	} else {
		if (style == HE_BANNER_STYLE_WARNING) {
			gtk_widget_add_css_class ((GtkWidget*) self, "warning");
		} else {
			if (style == HE_BANNER_STYLE_ERROR) {
				gtk_widget_add_css_class ((GtkWidget*) self, "error");
			}
		}
	}
	self->priv->_style = style;
}

/**
     * Construct a new banner.
     * @param title The title of the banner.
     * @param description The description of the banner.
     *
     * @since 1.0
     */
HeBanner*
he_banner_construct (GType object_type,
                     const gchar* title,
                     const gchar* description)
{
	HeBanner * self = NULL;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (description != NULL, NULL);
	self = (HeBanner*) he_bin_construct (object_type);
	he_banner_set_title (self, title);
	he_banner_set_description (self, description);
	return self;
}

HeBanner*
he_banner_new (const gchar* title,
               const gchar* description)
{
	return he_banner_construct (HE_TYPE_BANNER, title, description);
}

static GObject *
he_banner_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeBanner * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkBox* _tmp4_;
	GtkLabel* _tmp5_;
	GtkBox* _tmp6_;
	GtkLabel* _tmp7_;
	GtkBox* _tmp8_;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkBox* _tmp16_;
	GtkBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	parent_class = G_OBJECT_CLASS (he_banner_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BANNER, HeBanner);
	_tmp0_ = self->priv->title_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "header");
	_tmp1_ = self->priv->title_label;
	gtk_label_set_xalign (_tmp1_, (gfloat) 0);
	_tmp2_ = self->priv->description_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp2_, "body");
	_tmp3_ = self->priv->description_label;
	gtk_label_set_xalign (_tmp3_, (gfloat) 0);
	gtk_widget_add_css_class ((GtkWidget*) self, "banner");
	_tmp4_ = self->priv->text_box;
	_tmp5_ = self->priv->title_label;
	gtk_box_append (_tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = self->priv->text_box;
	_tmp7_ = self->priv->description_label;
	gtk_box_append (_tmp6_, (GtkWidget*) _tmp7_);
	_tmp8_ = self->priv->text_box;
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_START);
	_tmp9_ = self->priv->text_box;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp9_, 5);
	_tmp10_ = self->priv->text_box;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp10_, 5);
	_tmp11_ = self->priv->button_box;
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_END);
	_tmp12_ = self->priv->button_box;
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_END);
	_tmp13_ = self->priv->button_box;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp13_, TRUE);
	_tmp14_ = self->priv->button_box;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp14_, TRUE);
	_tmp15_ = self->priv->button_box;
	gtk_widget_set_visible ((GtkWidget*) _tmp15_, FALSE);
	_tmp16_ = self->priv->main_box;
	_tmp17_ = self->priv->text_box;
	gtk_box_append (_tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = self->priv->main_box;
	_tmp19_ = self->priv->button_box;
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->main_box;
	gtk_box_set_homogeneous (_tmp20_, TRUE);
	_tmp21_ = self->priv->main_box;
	gtk_widget_set_parent ((GtkWidget*) _tmp21_, (GtkWidget*) self);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_START);
	gtk_widget_set_vexpand ((GtkWidget*) self, FALSE);
	return obj;
}

static void
he_banner_class_init (HeBannerClass * klass,
                      gpointer klass_data)
{
	he_banner_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeBanner_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_banner_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_banner_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_banner_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_banner_finalize;
	/**
	     * The title of the banner
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BANNER_TITLE_PROPERTY, he_banner_properties[HE_BANNER_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The description of the banner
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BANNER_DESCRIPTION_PROPERTY, he_banner_properties[HE_BANNER_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The style of the banner
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BANNER_STYLE_PROPERTY, he_banner_properties[HE_BANNER_STYLE_PROPERTY] = g_param_spec_enum ("style", "style", "style", HE_BANNER_TYPE_STYLE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
}

static void
he_banner_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                        gpointer iface_data)
{
	he_banner_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) he_banner_real_add_child;
}

static void
he_banner_instance_init (HeBanner * self,
                         gpointer klass)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	self->priv = he_banner_get_instance_private (self);
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp0_);
	self->priv->main_box = _tmp0_;
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
	g_object_ref_sink (_tmp1_);
	self->priv->text_box = _tmp1_;
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
	g_object_ref_sink (_tmp2_);
	self->priv->button_box = _tmp2_;
	_tmp3_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp3_);
	self->priv->title_label = _tmp3_;
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp4_);
	self->priv->description_label = _tmp4_;
	self->priv->_style = HE_BANNER_STYLE_INFO;
}

static void
he_banner_finalize (GObject * obj)
{
	HeBanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BANNER, HeBanner);
	_g_object_unref0 (self->priv->main_box);
	_g_object_unref0 (self->priv->text_box);
	_g_object_unref0 (self->priv->button_box);
	_g_object_unref0 (self->priv->title_label);
	_g_object_unref0 (self->priv->description_label);
	G_OBJECT_CLASS (he_banner_parent_class)->finalize (obj);
}

/**
 * A Banner is a widget that displays a message to the user and provides a way for the user to act on the message.
 */
static GType
he_banner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeBannerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_banner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeBanner), 0, (GInstanceInitFunc) he_banner_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_banner_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_banner_type_id;
	he_banner_type_id = g_type_register_static (HE_TYPE_BIN, "HeBanner", &g_define_type_info, 0);
	g_type_add_interface_static (he_banner_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeBanner_private_offset = g_type_add_instance_private (he_banner_type_id, sizeof (HeBannerPrivate));
	return he_banner_type_id;
}

GType
he_banner_get_type (void)
{
	static volatile gsize he_banner_type_id__once = 0;
	if (g_once_init_enter (&he_banner_type_id__once)) {
		GType he_banner_type_id;
		he_banner_type_id = he_banner_get_type_once ();
		g_once_init_leave (&he_banner_type_id__once, he_banner_type_id);
	}
	return he_banner_type_id__once;
}

static void
_vala_he_banner_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	HeBanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BANNER, HeBanner);
	switch (property_id) {
		case HE_BANNER_TITLE_PROPERTY:
		g_value_set_string (value, he_banner_get_title (self));
		break;
		case HE_BANNER_DESCRIPTION_PROPERTY:
		g_value_set_string (value, he_banner_get_description (self));
		break;
		case HE_BANNER_STYLE_PROPERTY:
		g_value_set_enum (value, he_banner_get_style (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_banner_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	HeBanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BANNER, HeBanner);
	switch (property_id) {
		case HE_BANNER_TITLE_PROPERTY:
		he_banner_set_title (self, g_value_get_string (value));
		break;
		case HE_BANNER_DESCRIPTION_PROPERTY:
		he_banner_set_description (self, g_value_get_string (value));
		break;
		case HE_BANNER_STYLE_PROPERTY:
		he_banner_set_style (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

