/* BottomBar.c generated by valac 0.56.13, the Vala compiler
 * generated from BottomBar.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	HE_BOTTOM_BAR_0_PROPERTY,
	HE_BOTTOM_BAR_TITLE_PROPERTY,
	HE_BOTTOM_BAR_DESCRIPTION_PROPERTY,
	HE_BOTTOM_BAR_MENU_MODEL_PROPERTY,
	HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY,
	HE_BOTTOM_BAR_NUM_PROPERTIES
};
static GParamSpec* he_bottom_bar_properties[HE_BOTTOM_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeBottomBarPrivate {
	GtkBox* box;
	GtkBox* left_fmenu_box;
	GtkBox* right_fmenu_box;
	GtkBox* left_box;
	GtkBox* center_box;
	GtkBox* right_box;
	GtkLabel* title_label;
	GtkLabel* description_label;
	GtkMenuButton* menu;
	GtkMenuButton* fold_menu;
	GtkPopover* fmenu;
	GtkBox* fmenu_box;
	GtkBox* fmenu_box_l;
	GtkBox* fmenu_box_r;
	GtkSeparator* fmenu_separator;
	GtkImage* fmenu_image;
	GeeHashMap* button_to_mbutton;
	gboolean _collapse_actions;
};

static gint HeBottomBar_private_offset;
static gpointer he_bottom_bar_parent_class = NULL;
static GtkBuildableIface * he_bottom_bar_gtk_buildable_parent_iface = NULL;

static GtkWidget* he_bottom_bar_create_menu_button (HeBottomBar* self,
                                             GtkWidget* child);
static void he_bottom_bar_real_add_child (GtkBuildable* base,
                                   GtkBuilder* builder,
                                   GObject* child,
                                   const gchar* type);
static GObject * he_bottom_bar_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void he_bottom_bar_finalize (GObject * obj);
static GType he_bottom_bar_get_type_once (void);
static void _vala_he_bottom_bar_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_he_bottom_bar_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_bottom_bar_get_instance_private (HeBottomBar* self)
{
	return G_STRUCT_MEMBER_P (self, HeBottomBar_private_offset);
}

/**
   * An enum to define the position of the bottom bar actions.
   */
static GType
he_bottom_bar_position_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_BOTTOM_BAR_POSITION_LEFT, "HE_BOTTOM_BAR_POSITION_LEFT", "left"}, {HE_BOTTOM_BAR_POSITION_RIGHT, "HE_BOTTOM_BAR_POSITION_RIGHT", "right"}, {0, NULL, NULL}};
	GType he_bottom_bar_position_type_id;
	he_bottom_bar_position_type_id = g_enum_register_static ("HeBottomBarPosition", values);
	return he_bottom_bar_position_type_id;
}

GType
he_bottom_bar_position_get_type (void)
{
	static volatile gsize he_bottom_bar_position_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_position_type_id__once)) {
		GType he_bottom_bar_position_type_id;
		he_bottom_bar_position_type_id = he_bottom_bar_position_get_type_once ();
		g_once_init_leave (&he_bottom_bar_position_type_id__once, he_bottom_bar_position_type_id);
	}
	return he_bottom_bar_position_type_id__once;
}

const gchar*
he_bottom_bar_get_title (HeBottomBar* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->title_label;
	_tmp1_ = gtk_label_get_text (_tmp0_);
	result = _tmp1_;
	return result;
}

void
he_bottom_bar_set_title (HeBottomBar* self,
                         const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->title_label;
	gtk_label_set_text (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_TITLE_PROPERTY]);
}

const gchar*
he_bottom_bar_get_description (HeBottomBar* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->description_label;
	_tmp1_ = gtk_label_get_text (_tmp0_);
	result = _tmp1_;
	return result;
}

void
he_bottom_bar_set_description (HeBottomBar* self,
                               const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->description_label;
	gtk_label_set_text (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_DESCRIPTION_PROPERTY]);
}

GMenuModel*
he_bottom_bar_get_menu_model (HeBottomBar* self)
{
	GMenuModel* result;
	GtkMenuButton* _tmp0_;
	GMenuModel* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->menu;
	_tmp1_ = gtk_menu_button_get_menu_model (_tmp0_);
	result = _tmp1_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
he_bottom_bar_set_menu_model (HeBottomBar* self,
                              GMenuModel* value)
{
	GtkMenuButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->menu;
	gtk_menu_button_set_menu_model (_tmp0_, value);
	if (value != NULL) {
		GtkBox* _tmp1_;
		GtkBox* _tmp10_;
		GtkMenuButton* _tmp11_;
		GtkBox* menu_box = NULL;
		GtkBox* _tmp12_;
		GtkBox* _tmp13_;
		GtkLabel* _tmp14_;
		GtkBox* _tmp15_;
		GtkLabel* _tmp16_;
		GtkImage* menu_image = NULL;
		GtkImage* _tmp17_;
		GtkImage* _tmp18_;
		GtkImage* _tmp19_;
		GtkBox* menu_arrow_box = NULL;
		GtkBox* _tmp20_;
		GtkBox* _tmp21_;
		GtkBox* _tmp22_;
		GtkBox* _tmp23_;
		GtkImage* _tmp24_;
		GtkMenuButton* _tmp25_;
		GtkBox* _tmp26_;
		GtkMenuButton* _tmp27_;
		GtkMenuButton* _tmp28_;
		GtkMenuButton* _tmp29_;
		GtkMenuButton* _tmp30_;
		_tmp1_ = self->priv->center_box;
		if (_tmp1_ != NULL) {
			GtkWidget* childs = NULL;
			GtkBox* _tmp2_;
			GtkWidget* _tmp3_;
			GtkWidget* _tmp4_;
			_tmp2_ = self->priv->center_box;
			_tmp3_ = gtk_widget_get_first_child ((GtkWidget*) _tmp2_);
			_tmp4_ = _g_object_ref0 (_tmp3_);
			childs = _tmp4_;
			while (TRUE) {
				GtkWidget* _tmp5_;
				GtkWidget* _tmp6_;
				GtkBox* _tmp7_;
				GtkWidget* _tmp8_;
				GtkWidget* _tmp9_;
				_tmp5_ = childs;
				if (!(_tmp5_ != NULL)) {
					break;
				}
				_tmp6_ = childs;
				gtk_widget_unparent (_tmp6_);
				_tmp7_ = self->priv->center_box;
				_tmp8_ = gtk_widget_get_first_child ((GtkWidget*) _tmp7_);
				_tmp9_ = _g_object_ref0 (_tmp8_);
				_g_object_unref0 (childs);
				childs = _tmp9_;
			}
			_g_object_unref0 (childs);
		}
		_tmp10_ = self->priv->center_box;
		_tmp11_ = self->priv->menu;
		gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
		_tmp12_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
		g_object_ref_sink (_tmp12_);
		menu_box = _tmp12_;
		_tmp13_ = menu_box;
		_tmp14_ = self->priv->title_label;
		gtk_box_append (_tmp13_, (GtkWidget*) _tmp14_);
		_tmp15_ = menu_box;
		_tmp16_ = self->priv->description_label;
		gtk_box_append (_tmp15_, (GtkWidget*) _tmp16_);
		_tmp17_ = (GtkImage*) gtk_image_new ();
		g_object_ref_sink (_tmp17_);
		menu_image = _tmp17_;
		_tmp18_ = menu_image;
		gtk_image_set_from_icon_name (_tmp18_, "pan-up-symbolic");
		_tmp19_ = menu_image;
		gtk_image_set_pixel_size (_tmp19_, 10);
		_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
		g_object_ref_sink (_tmp20_);
		menu_arrow_box = _tmp20_;
		_tmp21_ = menu_arrow_box;
		_tmp22_ = menu_box;
		gtk_box_append (_tmp21_, (GtkWidget*) _tmp22_);
		_tmp23_ = menu_arrow_box;
		_tmp24_ = menu_image;
		gtk_box_append (_tmp23_, (GtkWidget*) _tmp24_);
		_tmp25_ = self->priv->menu;
		_tmp26_ = menu_arrow_box;
		gtk_menu_button_set_child (_tmp25_, (GtkWidget*) _tmp26_);
		_tmp27_ = self->priv->menu;
		gtk_menu_button_set_direction (_tmp27_, GTK_ARROW_UP);
		_tmp28_ = self->priv->menu;
		gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_CENTER);
		_tmp29_ = self->priv->menu;
		gtk_widget_set_valign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
		_tmp30_ = self->priv->menu;
		gtk_widget_add_css_class ((GtkWidget*) _tmp30_, "flat");
		_g_object_unref0 (menu_arrow_box);
		_g_object_unref0 (menu_image);
		_g_object_unref0 (menu_box);
	} else {
		GtkBox* _tmp31_;
		GtkMenuButton* _tmp32_;
		GtkBox* _tmp33_;
		GtkLabel* _tmp34_;
		GtkBox* _tmp35_;
		GtkLabel* _tmp36_;
		_tmp31_ = self->priv->center_box;
		_tmp32_ = self->priv->menu;
		gtk_box_remove (_tmp31_, (GtkWidget*) _tmp32_);
		_tmp33_ = self->priv->center_box;
		_tmp34_ = self->priv->title_label;
		gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
		_tmp35_ = self->priv->center_box;
		_tmp36_ = self->priv->description_label;
		gtk_box_append (_tmp35_, (GtkWidget*) _tmp36_);
	}
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_MENU_MODEL_PROPERTY]);
}

static GtkWidget*
he_bottom_bar_create_menu_button (HeBottomBar* self,
                                  GtkWidget* child)
{
	GtkBox* child_box = NULL;
	GtkBox* _tmp0_;
	GtkImage* child_image = NULL;
	GtkImage* _tmp1_;
	const gchar* _tmp2_;
	GtkLabel* child_label = NULL;
	const gchar* _tmp3_;
	GtkLabel* _tmp4_;
	GtkButton* child_button = NULL;
	GtkButton* _tmp5_;
	GtkWidget* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (child != NULL, NULL);
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
	g_object_ref_sink (_tmp0_);
	child_box = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp1_);
	child_image = _tmp1_;
	_tmp2_ = gtk_button_get_icon_name (G_TYPE_CHECK_INSTANCE_CAST (child, gtk_button_get_type (), GtkButton));
	gtk_image_set_from_icon_name (child_image, _tmp2_);
	_tmp3_ = gtk_widget_get_tooltip_text (child);
	_tmp4_ = (GtkLabel*) gtk_label_new (_tmp3_);
	g_object_ref_sink (_tmp4_);
	child_label = _tmp4_;
	gtk_box_append (child_box, (GtkWidget*) child_image);
	gtk_box_append (child_box, (GtkWidget*) child_label);
	_tmp5_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp5_);
	child_button = _tmp5_;
	gtk_widget_add_css_class ((GtkWidget*) child_button, "flat");
	gtk_button_set_child (child_button, (GtkWidget*) child_box);
	result = (GtkWidget*) child_button;
	_g_object_unref0 (child_label);
	_g_object_unref0 (child_image);
	_g_object_unref0 (child_box);
	return result;
}

gboolean
he_bottom_bar_get_collapse_actions (HeBottomBar* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_collapse_actions;
	return result;
}

void
he_bottom_bar_set_collapse_actions (HeBottomBar* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_collapse_actions = value;
	if (self->priv->_collapse_actions) {
		GtkBox* _tmp0_;
		GtkBox* _tmp1_;
		GtkBox* _tmp2_;
		GtkBox* _tmp3_;
		GtkBox* _tmp4_;
		GtkBox* _tmp5_;
		GtkBox* _tmp6_;
		GtkBox* _tmp7_;
		_tmp0_ = self->priv->box;
		_tmp1_ = self->priv->left_box;
		gtk_box_remove (_tmp0_, (GtkWidget*) _tmp1_);
		_tmp2_ = self->priv->box;
		_tmp3_ = self->priv->left_fmenu_box;
		gtk_box_prepend (_tmp2_, (GtkWidget*) _tmp3_);
		_tmp4_ = self->priv->box;
		_tmp5_ = self->priv->right_box;
		gtk_box_remove (_tmp4_, (GtkWidget*) _tmp5_);
		_tmp6_ = self->priv->box;
		_tmp7_ = self->priv->right_fmenu_box;
		gtk_box_append (_tmp6_, (GtkWidget*) _tmp7_);
	} else {
		GtkBox* _tmp8_;
		GtkBox* _tmp9_;
		GtkBox* _tmp10_;
		GtkBox* _tmp11_;
		GtkBox* _tmp12_;
		GtkBox* _tmp13_;
		GtkBox* _tmp14_;
		GtkBox* _tmp15_;
		_tmp8_ = self->priv->box;
		_tmp9_ = self->priv->left_fmenu_box;
		gtk_box_remove (_tmp8_, (GtkWidget*) _tmp9_);
		_tmp10_ = self->priv->box;
		_tmp11_ = self->priv->left_box;
		gtk_box_prepend (_tmp10_, (GtkWidget*) _tmp11_);
		_tmp12_ = self->priv->box;
		_tmp13_ = self->priv->right_fmenu_box;
		gtk_box_remove (_tmp12_, (GtkWidget*) _tmp13_);
		_tmp14_ = self->priv->box;
		_tmp15_ = self->priv->right_box;
		gtk_box_append (_tmp14_, (GtkWidget*) _tmp15_);
	}
	g_object_notify_by_pspec ((GObject *) self, he_bottom_bar_properties[HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY]);
}

/**
   * Add a child to the bottombar, should only be used in the context of a UI or Blueprint file. There should be no need to use this method in code.
   */
static void
he_bottom_bar_real_add_child (GtkBuildable* base,
                              GtkBuilder* builder,
                              GObject* child,
                              const gchar* type)
{
	HeBottomBar * self;
	self = (HeBottomBar*) base;
	g_return_if_fail (builder != NULL);
	g_return_if_fail (child != NULL);
	if (g_strcmp0 (type, "left") == 0) {
		he_bottom_bar_append_button (self, G_TYPE_CHECK_INSTANCE_CAST (child, HE_TYPE_ICONIC_BUTTON, HeIconicButton), HE_BOTTOM_BAR_POSITION_LEFT);
	} else {
		if (g_strcmp0 (type, "right") == 0) {
			he_bottom_bar_append_button (self, G_TYPE_CHECK_INSTANCE_CAST (child, HE_TYPE_ICONIC_BUTTON, HeIconicButton), HE_BOTTOM_BAR_POSITION_RIGHT);
		} else {
			he_bottom_bar_append_button (self, G_TYPE_CHECK_INSTANCE_CAST (child, HE_TYPE_ICONIC_BUTTON, HeIconicButton), HE_BOTTOM_BAR_POSITION_LEFT);
		}
	}
}

/**
   * Create a new bottom bar.
   * @param title The title of the bottom bar.
   * @param description The description of the bottom bar.
   */
HeBottomBar*
he_bottom_bar_construct_with_details (GType object_type,
                                      const gchar* title,
                                      const gchar* description)
{
	HeBottomBar * self = NULL;
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (description != NULL, NULL);
	self = (HeBottomBar*) he_bin_construct (object_type);
	he_bottom_bar_set_title (self, title);
	he_bottom_bar_set_description (self, description);
	return self;
}

HeBottomBar*
he_bottom_bar_new_with_details (const gchar* title,
                                const gchar* description)
{
	return he_bottom_bar_construct_with_details (HE_TYPE_BOTTOM_BAR, title, description);
}

/**
   * Create a new bottom bar.
   */
HeBottomBar*
he_bottom_bar_construct (GType object_type)
{
	HeBottomBar * self = NULL;
	self = (HeBottomBar*) he_bin_construct (object_type);
	return self;
}

HeBottomBar*
he_bottom_bar_new (void)
{
	return he_bottom_bar_construct (HE_TYPE_BOTTOM_BAR);
}

/**
   * Add an action to the bottom bar on the end of the bar.
   * @param icon The iconicbutton of the action.
   * @param position The position of the action.
   */
void
he_bottom_bar_append_button (HeBottomBar* self,
                             HeIconicButton* icon,
                             HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkWidget* menu_button = NULL;
	GtkWidget* _tmp8_;
	GtkBox* _tmp9_;
	GeeHashMap* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (icon != NULL);
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp1_;
		_tmp1_ = self->priv->left_box;
		_tmp0_ = _tmp1_;
	} else {
		GtkBox* _tmp2_;
		_tmp2_ = self->priv->right_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	box = _tmp3_;
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp5_;
		_tmp5_ = self->priv->fmenu_box_l;
		_tmp4_ = _tmp5_;
	} else {
		GtkBox* _tmp6_;
		_tmp6_ = self->priv->fmenu_box_r;
		_tmp4_ = _tmp6_;
	}
	_tmp7_ = _g_object_ref0 (_tmp4_);
	fmenu_box = _tmp7_;
	_tmp8_ = he_bottom_bar_create_menu_button (self, (GtkWidget*) icon);
	menu_button = _tmp8_;
	_tmp9_ = box;
	gtk_box_append (_tmp9_, (GtkWidget*) icon);
	gtk_box_append (fmenu_box, menu_button);
	_tmp10_ = self->priv->button_to_mbutton;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, (GtkWidget*) icon, menu_button);
	_g_object_unref0 (menu_button);
	_g_object_unref0 (fmenu_box);
	_g_object_unref0 (box);
}

/**
   * Add an action to the bottom bar on the start of the bar.
   * @param icon The iconicbutton of the action.
   * @param position The position of the action.
   */
void
he_bottom_bar_prepend_button (HeBottomBar* self,
                              HeIconicButton* icon,
                              HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkWidget* menu_button = NULL;
	GtkWidget* _tmp8_;
	GtkBox* _tmp9_;
	GeeHashMap* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (icon != NULL);
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp1_;
		_tmp1_ = self->priv->left_box;
		_tmp0_ = _tmp1_;
	} else {
		GtkBox* _tmp2_;
		_tmp2_ = self->priv->right_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	box = _tmp3_;
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp5_;
		_tmp5_ = self->priv->fmenu_box_l;
		_tmp4_ = _tmp5_;
	} else {
		GtkBox* _tmp6_;
		_tmp6_ = self->priv->fmenu_box_r;
		_tmp4_ = _tmp6_;
	}
	_tmp7_ = _g_object_ref0 (_tmp4_);
	fmenu_box = _tmp7_;
	_tmp8_ = he_bottom_bar_create_menu_button (self, (GtkWidget*) icon);
	menu_button = _tmp8_;
	_tmp9_ = box;
	gtk_box_prepend (_tmp9_, (GtkWidget*) icon);
	gtk_box_prepend (fmenu_box, menu_button);
	_tmp10_ = self->priv->button_to_mbutton;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, (GtkWidget*) icon, menu_button);
	_g_object_unref0 (menu_button);
	_g_object_unref0 (fmenu_box);
	_g_object_unref0 (box);
}

/**
   * Remove an action of the bottom bar.
   * @param icon The iconicbutton of the action.
   * @param position The position of the action.
   */
void
he_bottom_bar_remove_button (HeBottomBar* self,
                             HeIconicButton* icon,
                             HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	GeeHashMap* _tmp9_;
	gpointer _tmp10_;
	GtkWidget* _tmp11_;
	GeeHashMap* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (icon != NULL);
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp1_;
		_tmp1_ = self->priv->left_box;
		_tmp0_ = _tmp1_;
	} else {
		GtkBox* _tmp2_;
		_tmp2_ = self->priv->right_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	box = _tmp3_;
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp5_;
		_tmp5_ = self->priv->fmenu_box_l;
		_tmp4_ = _tmp5_;
	} else {
		GtkBox* _tmp6_;
		_tmp6_ = self->priv->fmenu_box_r;
		_tmp4_ = _tmp6_;
	}
	_tmp7_ = _g_object_ref0 (_tmp4_);
	fmenu_box = _tmp7_;
	_tmp8_ = box;
	gtk_box_remove (_tmp8_, (GtkWidget*) icon);
	_tmp9_ = self->priv->button_to_mbutton;
	_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, (GtkWidget*) icon);
	_tmp11_ = (GtkWidget*) _tmp10_;
	gtk_box_remove (fmenu_box, _tmp11_);
	_g_object_unref0 (_tmp11_);
	_tmp12_ = self->priv->button_to_mbutton;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp12_, (GtkWidget*) icon, NULL);
	_g_object_unref0 (fmenu_box);
	_g_object_unref0 (box);
}

/**
   * Insert an action after another action.
   * @param icon The iconicbutton of the action.
   * @param after The iconicbutton of the action after which the action is.
   * @param position The position of the action.
   */
void
he_bottom_bar_insert_button_after (HeBottomBar* self,
                                   HeIconicButton* icon,
                                   HeIconicButton* after,
                                   HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkWidget* menu_button = NULL;
	GtkWidget* _tmp8_;
	GtkBox* _tmp9_;
	GeeHashMap* _tmp10_;
	gpointer _tmp11_;
	GtkWidget* _tmp12_;
	GeeHashMap* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (icon != NULL);
	g_return_if_fail (after != NULL);
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp1_;
		_tmp1_ = self->priv->left_box;
		_tmp0_ = _tmp1_;
	} else {
		GtkBox* _tmp2_;
		_tmp2_ = self->priv->right_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	box = _tmp3_;
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp5_;
		_tmp5_ = self->priv->fmenu_box_l;
		_tmp4_ = _tmp5_;
	} else {
		GtkBox* _tmp6_;
		_tmp6_ = self->priv->fmenu_box_r;
		_tmp4_ = _tmp6_;
	}
	_tmp7_ = _g_object_ref0 (_tmp4_);
	fmenu_box = _tmp7_;
	_tmp8_ = he_bottom_bar_create_menu_button (self, (GtkWidget*) icon);
	menu_button = _tmp8_;
	_tmp9_ = box;
	gtk_box_insert_child_after (_tmp9_, (GtkWidget*) icon, (GtkWidget*) after);
	_tmp10_ = self->priv->button_to_mbutton;
	_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (GtkWidget*) after);
	_tmp12_ = (GtkWidget*) _tmp11_;
	gtk_box_insert_child_after (fmenu_box, menu_button, _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = self->priv->button_to_mbutton;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, (GtkWidget*) icon, menu_button);
	_g_object_unref0 (menu_button);
	_g_object_unref0 (fmenu_box);
	_g_object_unref0 (box);
}

/**
   * Reorder an action based on another action.
   * @param icon The iconicbutton of the action.
   * @param sibling The iconicbutton of the action after which the action is.
   * @param position The position of the action.
   *
     * @since 1.0
     */
void
he_bottom_bar_reorder_button_after (HeBottomBar* self,
                                    HeIconicButton* icon,
                                    HeIconicButton* sibling,
                                    HeBottomBarPosition position)
{
	GtkBox* _tmp0_ = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_ = NULL;
	GtkBox* fmenu_box = NULL;
	GtkBox* _tmp7_;
	GtkWidget* _tmp8_;
	GtkWidget* _tmp9_;
	GtkBox* _tmp10_;
	GeeHashMap* _tmp11_;
	gpointer _tmp12_;
	GtkWidget* _tmp13_;
	GeeHashMap* _tmp14_;
	gpointer _tmp15_;
	GtkWidget* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (icon != NULL);
	g_return_if_fail (sibling != NULL);
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp1_;
		_tmp1_ = self->priv->left_box;
		_tmp0_ = _tmp1_;
	} else {
		GtkBox* _tmp2_;
		_tmp2_ = self->priv->right_box;
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = _g_object_ref0 (_tmp0_);
	box = _tmp3_;
	if (position == HE_BOTTOM_BAR_POSITION_LEFT) {
		GtkBox* _tmp5_;
		_tmp5_ = self->priv->fmenu_box_l;
		_tmp4_ = _tmp5_;
	} else {
		GtkBox* _tmp6_;
		_tmp6_ = self->priv->fmenu_box_r;
		_tmp4_ = _tmp6_;
	}
	_tmp7_ = _g_object_ref0 (_tmp4_);
	fmenu_box = _tmp7_;
	_tmp8_ = he_bottom_bar_create_menu_button (self, (GtkWidget*) icon);
	_tmp9_ = _tmp8_;
	_g_object_unref0 (_tmp9_);
	_tmp10_ = box;
	gtk_box_reorder_child_after (_tmp10_, (GtkWidget*) icon, (GtkWidget*) sibling);
	_tmp11_ = self->priv->button_to_mbutton;
	_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, (GtkWidget*) icon);
	_tmp13_ = (GtkWidget*) _tmp12_;
	_tmp14_ = self->priv->button_to_mbutton;
	_tmp15_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, (GtkWidget*) sibling);
	_tmp16_ = (GtkWidget*) _tmp15_;
	gtk_box_reorder_child_after (fmenu_box, _tmp13_, _tmp16_);
	_g_object_unref0 (_tmp16_);
	_g_object_unref0 (_tmp13_);
	_g_object_unref0 (fmenu_box);
	_g_object_unref0 (box);
}

static GObject *
he_bottom_bar_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeBottomBar * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkLabel* _tmp7_;
	GtkBox* _tmp8_;
	GtkLabel* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkMenuButton* _tmp16_;
	GtkMenuButton* _tmp17_;
	GtkMenuButton* _tmp18_;
	GtkMenuButton* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkMenuButton* _tmp22_;
	GtkImage* _tmp23_;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GtkBox* _tmp26_;
	GtkSeparator* _tmp27_;
	GtkBox* _tmp28_;
	GtkBox* _tmp29_;
	GtkPopover* _tmp30_;
	GtkBox* _tmp31_;
	GtkMenuButton* _tmp32_;
	GtkPopover* _tmp33_;
	GtkBox* _tmp34_;
	GtkMenuButton* _tmp35_;
	GtkBox* _tmp36_;
	parent_class = G_OBJECT_CLASS (he_bottom_bar_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_BAR, HeBottomBar);
	_tmp0_ = self->priv->title_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, "title");
	_tmp1_ = self->priv->description_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "dim-label");
	gtk_widget_add_css_class ((GtkWidget*) self, "bottom-bar");
	_tmp2_ = self->priv->center_box;
	gtk_box_set_homogeneous (_tmp2_, TRUE);
	_tmp3_ = self->priv->center_box;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
	_tmp4_ = self->priv->center_box;
	_tmp5_ = self->priv->center_box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp5_, 18);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 18);
	_tmp6_ = self->priv->center_box;
	_tmp7_ = self->priv->title_label;
	gtk_box_append (_tmp6_, (GtkWidget*) _tmp7_);
	_tmp8_ = self->priv->center_box;
	_tmp9_ = self->priv->description_label;
	gtk_box_append (_tmp8_, (GtkWidget*) _tmp9_);
	_tmp10_ = self->priv->box;
	_tmp11_ = self->priv->left_box;
	gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = self->priv->box;
	_tmp13_ = self->priv->center_box;
	gtk_box_append (_tmp12_, (GtkWidget*) _tmp13_);
	_tmp14_ = self->priv->box;
	_tmp15_ = self->priv->right_box;
	gtk_box_append (_tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = self->priv->fold_menu;
	gtk_menu_button_set_direction (_tmp16_, GTK_ARROW_UP);
	_tmp17_ = self->priv->fold_menu;
	gtk_widget_set_halign ((GtkWidget*) _tmp17_, GTK_ALIGN_CENTER);
	_tmp18_ = self->priv->fold_menu;
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
	_tmp19_ = self->priv->fold_menu;
	gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "flat");
	_tmp20_ = self->priv->fmenu_image;
	gtk_image_set_from_icon_name (_tmp20_, "view-more-symbolic");
	_tmp21_ = self->priv->fmenu_image;
	gtk_image_set_pixel_size (_tmp21_, 16);
	_tmp22_ = self->priv->fold_menu;
	_tmp23_ = self->priv->fmenu_image;
	gtk_menu_button_set_child (_tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = self->priv->fmenu_box;
	_tmp25_ = self->priv->fmenu_box_l;
	gtk_box_append (_tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = self->priv->fmenu_box;
	_tmp27_ = self->priv->fmenu_separator;
	gtk_box_append (_tmp26_, (GtkWidget*) _tmp27_);
	_tmp28_ = self->priv->fmenu_box;
	_tmp29_ = self->priv->fmenu_box_r;
	gtk_box_append (_tmp28_, (GtkWidget*) _tmp29_);
	_tmp30_ = self->priv->fmenu;
	_tmp31_ = self->priv->fmenu_box;
	gtk_popover_set_child (_tmp30_, (GtkWidget*) _tmp31_);
	_tmp32_ = self->priv->fold_menu;
	_tmp33_ = self->priv->fmenu;
	gtk_menu_button_set_popover (_tmp32_, (GtkWidget*) _tmp33_);
	_tmp34_ = self->priv->left_fmenu_box;
	_tmp35_ = self->priv->fold_menu;
	gtk_box_append (_tmp34_, (GtkWidget*) _tmp35_);
	_tmp36_ = self->priv->box;
	gtk_widget_set_parent ((GtkWidget*) _tmp36_, (GtkWidget*) self);
	return obj;
}

static void
he_bottom_bar_class_init (HeBottomBarClass * klass,
                          gpointer klass_data)
{
	he_bottom_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeBottomBar_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_bottom_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_bottom_bar_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_bottom_bar_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_bottom_bar_finalize;
	/**
	   * The title of the bottom bar.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_TITLE_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * The description of the bottom bar.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_DESCRIPTION_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * The menu_model of the bottom bar.
	   * If a menu_model is set, show it on the center widget of the bottom bar.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_MENU_MODEL_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_MENU_MODEL_PROPERTY] = g_param_spec_object ("menu-model", "menu-model", "menu-model", g_menu_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * Whether to collapse actions into a menu.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY, he_bottom_bar_properties[HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY] = g_param_spec_boolean ("collapse-actions", "collapse-actions", "collapse-actions", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
}

static void
he_bottom_bar_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                            gpointer iface_data)
{
	he_bottom_bar_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) he_bottom_bar_real_add_child;
}

static void
he_bottom_bar_instance_init (HeBottomBar * self,
                             gpointer klass)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkMenuButton* _tmp8_;
	GtkMenuButton* _tmp9_;
	GtkPopover* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	GtkBox* _tmp13_;
	GtkSeparator* _tmp14_;
	GtkImage* _tmp15_;
	GeeHashMap* _tmp16_;
	self->priv = he_bottom_bar_get_instance_private (self);
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp0_);
	self->priv->box = _tmp0_;
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
	g_object_ref_sink (_tmp1_);
	self->priv->left_fmenu_box = _tmp1_;
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
	g_object_ref_sink (_tmp2_);
	self->priv->right_fmenu_box = _tmp2_;
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
	g_object_ref_sink (_tmp3_);
	self->priv->left_box = _tmp3_;
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp4_);
	self->priv->center_box = _tmp4_;
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 18);
	g_object_ref_sink (_tmp5_);
	self->priv->right_box = _tmp5_;
	_tmp6_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp6_);
	self->priv->title_label = _tmp6_;
	_tmp7_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp7_);
	self->priv->description_label = _tmp7_;
	_tmp8_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp8_);
	self->priv->menu = _tmp8_;
	_tmp9_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp9_);
	self->priv->fold_menu = _tmp9_;
	_tmp10_ = (GtkPopover*) gtk_popover_new ();
	g_object_ref_sink (_tmp10_);
	self->priv->fmenu = _tmp10_;
	_tmp11_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	g_object_ref_sink (_tmp11_);
	self->priv->fmenu_box = _tmp11_;
	_tmp12_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	g_object_ref_sink (_tmp12_);
	self->priv->fmenu_box_l = _tmp12_;
	_tmp13_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	g_object_ref_sink (_tmp13_);
	self->priv->fmenu_box_r = _tmp13_;
	_tmp14_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp14_);
	self->priv->fmenu_separator = _tmp14_;
	_tmp15_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp15_);
	self->priv->fmenu_image = _tmp15_;
	_tmp16_ = gee_hash_map_new (gtk_widget_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, gtk_widget_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->button_to_mbutton = _tmp16_;
}

static void
he_bottom_bar_finalize (GObject * obj)
{
	HeBottomBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_BOTTOM_BAR, HeBottomBar);
	_g_object_unref0 (self->priv->box);
	_g_object_unref0 (self->priv->left_fmenu_box);
	_g_object_unref0 (self->priv->right_fmenu_box);
	_g_object_unref0 (self->priv->left_box);
	_g_object_unref0 (self->priv->center_box);
	_g_object_unref0 (self->priv->right_box);
	_g_object_unref0 (self->priv->title_label);
	_g_object_unref0 (self->priv->description_label);
	_g_object_unref0 (self->priv->menu);
	_g_object_unref0 (self->priv->fold_menu);
	_g_object_unref0 (self->priv->fmenu);
	_g_object_unref0 (self->priv->fmenu_box);
	_g_object_unref0 (self->priv->fmenu_box_l);
	_g_object_unref0 (self->priv->fmenu_box_r);
	_g_object_unref0 (self->priv->fmenu_separator);
	_g_object_unref0 (self->priv->fmenu_image);
	_g_object_unref0 (self->priv->button_to_mbutton);
	G_OBJECT_CLASS (he_bottom_bar_parent_class)->finalize (obj);
}

/**
 * A BottomBar is a toolbar made to make actions on content more visible.
 * It may have up to 5 actions on each side.
 * It has title and description labels, which can be part of a menu's label.
 */
static GType
he_bottom_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeBottomBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_bottom_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeBottomBar), 0, (GInstanceInitFunc) he_bottom_bar_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_bottom_bar_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_bottom_bar_type_id;
	he_bottom_bar_type_id = g_type_register_static (HE_TYPE_BIN, "HeBottomBar", &g_define_type_info, 0);
	g_type_add_interface_static (he_bottom_bar_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeBottomBar_private_offset = g_type_add_instance_private (he_bottom_bar_type_id, sizeof (HeBottomBarPrivate));
	return he_bottom_bar_type_id;
}

GType
he_bottom_bar_get_type (void)
{
	static volatile gsize he_bottom_bar_type_id__once = 0;
	if (g_once_init_enter (&he_bottom_bar_type_id__once)) {
		GType he_bottom_bar_type_id;
		he_bottom_bar_type_id = he_bottom_bar_get_type_once ();
		g_once_init_leave (&he_bottom_bar_type_id__once, he_bottom_bar_type_id);
	}
	return he_bottom_bar_type_id__once;
}

static void
_vala_he_bottom_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	HeBottomBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_BAR, HeBottomBar);
	switch (property_id) {
		case HE_BOTTOM_BAR_TITLE_PROPERTY:
		g_value_set_string (value, he_bottom_bar_get_title (self));
		break;
		case HE_BOTTOM_BAR_DESCRIPTION_PROPERTY:
		g_value_set_string (value, he_bottom_bar_get_description (self));
		break;
		case HE_BOTTOM_BAR_MENU_MODEL_PROPERTY:
		g_value_set_object (value, he_bottom_bar_get_menu_model (self));
		break;
		case HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY:
		g_value_set_boolean (value, he_bottom_bar_get_collapse_actions (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_bottom_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	HeBottomBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_BOTTOM_BAR, HeBottomBar);
	switch (property_id) {
		case HE_BOTTOM_BAR_TITLE_PROPERTY:
		he_bottom_bar_set_title (self, g_value_get_string (value));
		break;
		case HE_BOTTOM_BAR_DESCRIPTION_PROPERTY:
		he_bottom_bar_set_description (self, g_value_get_string (value));
		break;
		case HE_BOTTOM_BAR_MENU_MODEL_PROPERTY:
		he_bottom_bar_set_menu_model (self, g_value_get_object (value));
		break;
		case HE_BOTTOM_BAR_COLLAPSE_ACTIONS_PROPERTY:
		he_bottom_bar_set_collapse_actions (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

