/* DatePicker.c generated by valac 0.56.13, the Vala compiler
 * generated from DatePicker.vala, do not modify */

/*
 * Copyright (c) 2022-2023 Fyra Labs
 * Copyright (c) 2014–2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libhelium-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

enum  {
	HE_DATE_PICKER_0_PROPERTY,
	HE_DATE_PICKER_FORMAT_PROPERTY,
	HE_DATE_PICKER_DATE_PROPERTY,
	HE_DATE_PICKER_NUM_PROPERTIES
};
static GParamSpec* he_date_picker_properties[HE_DATE_PICKER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _HeDatePickerPrivate {
	gchar* _format;
	GDateTime* _date;
};

struct _Block4Data {
	int _ref_count_;
	HeDatePicker* self;
	GtkCalendar* calendar;
	GtkPopover* popover;
};

static gint HeDatePicker_private_offset;
static gpointer he_date_picker_parent_class = NULL;

static GObject * he_date_picker_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _he_date_picker___lambda16_ (Block4Data* _data4_);
static void __he_date_picker___lambda16__gtk_entry_icon_release (GtkEntry* _sender,
                                                          GtkEntryIconPosition icon_pos,
                                                          gpointer self);
static void _he_date_picker___lambda17_ (Block4Data* _data4_);
static void __he_date_picker___lambda17__gtk_calendar_day_selected (GtkCalendar* _sender,
                                                             gpointer self);
static void _he_date_picker___lambda18_ (Block4Data* _data4_);
static void __he_date_picker___lambda18__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void he_date_picker_finalize (GObject * obj);
static GType he_date_picker_get_type_once (void);
static void _vala_he_date_picker_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_he_date_picker_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_date_picker_get_instance_private (HeDatePicker* self)
{
	return G_STRUCT_MEMBER_P (self, HeDatePicker_private_offset);
}

const gchar*
he_date_picker_get_format (HeDatePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_format;
	result = _tmp0_;
	return result;
}

static void
he_date_picker_set_format (HeDatePicker* self,
                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = he_date_picker_get_format (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_format);
		self->priv->_format = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, he_date_picker_properties[HE_DATE_PICKER_FORMAT_PROPERTY]);
	}
}

GDateTime*
he_date_picker_get_date (HeDatePicker* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_date;
	result = _tmp0_;
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

void
he_date_picker_set_date (HeDatePicker* self,
                         GDateTime* value)
{
	GDateTime* old_value;
	g_return_if_fail (self != NULL);
	old_value = he_date_picker_get_date (self);
	if (old_value != value) {
		GDateTime* _tmp0_;
		_tmp0_ = _g_date_time_ref0 (value);
		_g_date_time_unref0 (self->priv->_date);
		self->priv->_date = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, he_date_picker_properties[HE_DATE_PICKER_DATE_PROPERTY]);
	}
}

/**
     *  Creates this widget with a predetermined date format.
     */
HeDatePicker*
he_date_picker_construct_with_format (GType object_type,
                                      const gchar* format)
{
	HeDatePicker * self = NULL;
	g_return_val_if_fail (format != NULL, NULL);
	self = (HeDatePicker*) g_object_new (object_type, "format", format, NULL);
	return self;
}

HeDatePicker*
he_date_picker_new_with_format (const gchar* format)
{
	return he_date_picker_construct_with_format (HE_TYPE_DATE_PICKER, format);
}

HeDatePicker*
he_date_picker_construct (GType object_type)
{
	HeDatePicker * self = NULL;
	self = (HeDatePicker*) g_object_new (object_type, NULL);
	return self;
}

HeDatePicker*
he_date_picker_new (void)
{
	return he_date_picker_construct (HE_TYPE_DATE_PICKER);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		HeDatePicker* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->popover);
		_g_object_unref0 (_data4_->calendar);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_he_date_picker___lambda16_ (Block4Data* _data4_)
{
	HeDatePicker* self;
	GtkPopover* _tmp0_;
	self = _data4_->self;
	_tmp0_ = _data4_->popover;
	gtk_popover_popup (_tmp0_);
}

static void
__he_date_picker___lambda16__gtk_entry_icon_release (GtkEntry* _sender,
                                                     GtkEntryIconPosition icon_pos,
                                                     gpointer self)
{
	_he_date_picker___lambda16_ (self);
}

static void
_he_date_picker___lambda17_ (Block4Data* _data4_)
{
	HeDatePicker* self;
	GtkCalendar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkCalendar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GtkCalendar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GDateTime* _tmp9_;
	GDateTime* _tmp10_;
	self = _data4_->self;
	_tmp0_ = _data4_->calendar;
	g_object_get (_tmp0_, "year", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = _data4_->calendar;
	g_object_get (_tmp3_, "month", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = _data4_->calendar;
	g_object_get (_tmp6_, "day", &_tmp7_, NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_date_time_new_local (_tmp2_, _tmp5_ + 1, _tmp8_, 0, 0, (gdouble) 0);
	_tmp10_ = _tmp9_;
	he_date_picker_set_date (self, _tmp10_);
	_g_date_time_unref0 (_tmp10_);
}

static void
__he_date_picker___lambda17__gtk_calendar_day_selected (GtkCalendar* _sender,
                                                        gpointer self)
{
	_he_date_picker___lambda17_ (self);
}

static void
_he_date_picker___lambda18_ (Block4Data* _data4_)
{
	HeDatePicker* self;
	GDateTime* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkCalendar* _tmp4_;
	GDateTime* _tmp5_;
	self = _data4_->self;
	_tmp0_ = self->priv->_date;
	_tmp1_ = self->priv->_format;
	_tmp2_ = g_date_time_format (_tmp0_, _tmp1_);
	_tmp3_ = _tmp2_;
	gtk_editable_set_text ((GtkEditable*) self, _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = _data4_->calendar;
	_tmp5_ = self->priv->_date;
	gtk_calendar_select_day (_tmp4_, _tmp5_);
}

static void
__he_date_picker___lambda18__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
	_he_date_picker___lambda18_ (self);
}

static GObject *
he_date_picker_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeDatePicker * self;
	Block4Data* _data4_;
	const gchar* _tmp0_;
	GtkCalendar* _tmp1_;
	GtkCalendar* _tmp2_;
	GtkWidget* _tmp3_;
	GtkPopover* _tmp4_ = NULL;
	GtkPopover* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GThemedIcon* _tmp8_;
	GThemedIcon* _tmp9_;
	GThemedIcon* _tmp10_;
	GThemedIcon* _tmp11_;
	GtkCalendar* _tmp12_;
	parent_class = G_OBJECT_CLASS (he_date_picker_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DATE_PICKER, HeDatePicker);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = self->priv->_format;
	if (_tmp0_ == NULL) {
		he_date_picker_set_format (self, "%x");
	}
	_tmp1_ = (GtkCalendar*) gtk_calendar_new ();
	g_object_ref_sink (_tmp1_);
	_data4_->calendar = _tmp1_;
	_tmp2_ = _data4_->calendar;
	_tmp3_ = _g_object_ref0 ((GtkWidget*) _tmp2_);
	_tmp4_ = (GtkPopover*) gtk_popover_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_END);
	gtk_popover_set_autohide (_tmp4_, TRUE);
	gtk_popover_set_child (_tmp4_, _tmp3_);
	_g_object_unref0 (_tmp3_);
	gtk_popover_set_has_arrow (_tmp4_, FALSE);
	gtk_popover_set_position (_tmp4_, GTK_POS_BOTTOM);
	g_object_ref_sink (_tmp4_);
	_data4_->popover = _tmp4_;
	_tmp5_ = _data4_->popover;
	gtk_widget_set_parent ((GtkWidget*) _tmp5_, (GtkWidget*) self);
	_tmp6_ = g_date_time_new_now_local ();
	_tmp7_ = _tmp6_;
	he_date_picker_set_date (self, _tmp7_);
	_g_date_time_unref0 (_tmp7_);
	gtk_editable_set_editable ((GtkEditable*) self, FALSE);
	_tmp8_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("office-calendar-symbolic");
	_tmp9_ = _tmp8_;
	g_object_set ((GtkEntry*) self, "primary-icon-gicon", (GIcon*) _tmp9_, NULL);
	_g_object_unref0 (_tmp9_);
	_tmp10_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("pan-down-symbolic");
	_tmp11_ = _tmp10_;
	g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp11_, NULL);
	_g_object_unref0 (_tmp11_);
	g_signal_connect_data ((GtkEntry*) self, "icon-release", (GCallback) __he_date_picker___lambda16__gtk_entry_icon_release, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp12_ = _data4_->calendar;
	g_signal_connect_data (_tmp12_, "day-selected", (GCallback) __he_date_picker___lambda17__gtk_calendar_day_selected, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	g_signal_connect_data ((GObject*) self, "notify::date", (GCallback) __he_date_picker___lambda18__g_object_notify, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	gtk_widget_add_css_class ((GtkWidget*) self, "text-field");
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return obj;
}

static void
he_date_picker_class_init (HeDatePickerClass * klass,
                           gpointer klass_data)
{
	he_date_picker_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeDatePicker_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_date_picker_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_date_picker_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_date_picker_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_date_picker_finalize;
	/**
	     *  The string format of how to display the date.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DATE_PICKER_FORMAT_PROPERTY, he_date_picker_properties[HE_DATE_PICKER_FORMAT_PROPERTY] = g_param_spec_string ("format", "format", "format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	     *  The date to be used.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DATE_PICKER_DATE_PROPERTY, he_date_picker_properties[HE_DATE_PICKER_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_date_picker_instance_init (HeDatePicker * self,
                              gpointer klass)
{
	self->priv = he_date_picker_get_instance_private (self);
}

static void
he_date_picker_finalize (GObject * obj)
{
	HeDatePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DATE_PICKER, HeDatePicker);
	_g_free0 (self->priv->_format);
	_g_date_time_unref0 (self->priv->_date);
	G_OBJECT_CLASS (he_date_picker_parent_class)->finalize (obj);
}

static GType
he_date_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeDatePickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_date_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeDatePicker), 0, (GInstanceInitFunc) he_date_picker_instance_init, NULL };
	GType he_date_picker_type_id;
	he_date_picker_type_id = g_type_register_static (gtk_entry_get_type (), "HeDatePicker", &g_define_type_info, 0);
	HeDatePicker_private_offset = g_type_add_instance_private (he_date_picker_type_id, sizeof (HeDatePickerPrivate));
	return he_date_picker_type_id;
}

GType
he_date_picker_get_type (void)
{
	static volatile gsize he_date_picker_type_id__once = 0;
	if (g_once_init_enter (&he_date_picker_type_id__once)) {
		GType he_date_picker_type_id;
		he_date_picker_type_id = he_date_picker_get_type_once ();
		g_once_init_leave (&he_date_picker_type_id__once, he_date_picker_type_id);
	}
	return he_date_picker_type_id__once;
}

static void
_vala_he_date_picker_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HeDatePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DATE_PICKER, HeDatePicker);
	switch (property_id) {
		case HE_DATE_PICKER_FORMAT_PROPERTY:
		g_value_set_string (value, he_date_picker_get_format (self));
		break;
		case HE_DATE_PICKER_DATE_PROPERTY:
		g_value_set_boxed (value, he_date_picker_get_date (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_date_picker_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HeDatePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DATE_PICKER, HeDatePicker);
	switch (property_id) {
		case HE_DATE_PICKER_FORMAT_PROPERTY:
		he_date_picker_set_format (self, g_value_get_string (value));
		break;
		case HE_DATE_PICKER_DATE_PROPERTY:
		he_date_picker_set_date (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

