/* DisclosureButton.c generated by valac 0.56.13, the Vala compiler
 * generated from DisclosureButton.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

enum  {
	HE_DISCLOSURE_BUTTON_0_PROPERTY,
	HE_DISCLOSURE_BUTTON_COLOR_PROPERTY,
	HE_DISCLOSURE_BUTTON_ICON_PROPERTY,
	HE_DISCLOSURE_BUTTON_NUM_PROPERTIES
};
static GParamSpec* he_disclosure_button_properties[HE_DISCLOSURE_BUTTON_NUM_PROPERTIES];

struct _HeDisclosureButtonPrivate {
	HeColors _color;
};

static gint HeDisclosureButton_private_offset;
static gpointer he_disclosure_button_parent_class = NULL;

static GObject * he_disclosure_button_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void he_disclosure_button_finalize (GObject * obj);
static GType he_disclosure_button_get_type_once (void);
static void _vala_he_disclosure_button_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_he_disclosure_button_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_disclosure_button_get_instance_private (HeDisclosureButton* self)
{
	return G_STRUCT_MEMBER_P (self, HeDisclosureButton_private_offset);
}

static HeColors
he_disclosure_button_real_get_color (HeButton* base)
{
	HeColors result;
	HeDisclosureButton* self;
	self = (HeDisclosureButton*) base;
	result = self->priv->_color;
	return result;
}

static void
he_disclosure_button_real_set_color (HeButton* base,
                                     HeColors value)
{
	HeDisclosureButton* self;
	self = (HeDisclosureButton*) base;
	self->priv->_color = HE_COLORS_NONE;
	g_object_notify_by_pspec ((GObject *) self, he_disclosure_button_properties[HE_DISCLOSURE_BUTTON_COLOR_PROPERTY]);
}

const gchar*
he_disclosure_button_get_icon (HeDisclosureButton* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_button_get_icon_name ((GtkButton*) self);
	result = _tmp0_;
	return result;
}

void
he_disclosure_button_set_icon (HeDisclosureButton* self,
                               const gchar* value)
{
	g_return_if_fail (self != NULL);
	gtk_button_set_icon_name ((GtkButton*) self, value);
	g_object_notify_by_pspec ((GObject *) self, he_disclosure_button_properties[HE_DISCLOSURE_BUTTON_ICON_PROPERTY]);
}

/** 
   * Creates a new DisclosureButton.
   * @param icon The name of the icon to use.
   */
HeDisclosureButton*
he_disclosure_button_construct (GType object_type,
                                const gchar* icon)
{
	HeDisclosureButton * self = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	self = (HeDisclosureButton*) he_button_construct (object_type);
	he_disclosure_button_set_icon (self, icon);
	return self;
}

HeDisclosureButton*
he_disclosure_button_new (const gchar* icon)
{
	return he_disclosure_button_construct (HE_TYPE_DISCLOSURE_BUTTON, icon);
}

/**
   * Create a new DisclosureButton from an icon.
   * @param icon The icon to display on the button.
   *
     * @since 1.0
     */
HeDisclosureButton*
he_disclosure_button_construct_from_icon (GType object_type,
                                          const gchar* icon)
{
	HeDisclosureButton * self = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	self = (HeDisclosureButton*) he_button_construct (object_type);
	he_disclosure_button_set_icon (self, icon);
	return self;
}

HeDisclosureButton*
he_disclosure_button_new_from_icon (const gchar* icon)
{
	return he_disclosure_button_construct_from_icon (HE_TYPE_DISCLOSURE_BUTTON, icon);
}

static GObject *
he_disclosure_button_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeDisclosureButton * self;
	parent_class = G_OBJECT_CLASS (he_disclosure_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DISCLOSURE_BUTTON, HeDisclosureButton);
	gtk_widget_add_css_class ((GtkWidget*) self, "image-button");
	gtk_widget_add_css_class ((GtkWidget*) self, "disclosure-button");
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	return obj;
}

static void
he_disclosure_button_class_init (HeDisclosureButtonClass * klass,
                                 gpointer klass_data)
{
	he_disclosure_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeDisclosureButton_private_offset);
	HE_BUTTON_CLASS (klass)->get_color = (HeColors (*) (HeButton*)) he_disclosure_button_real_get_color;
	HE_BUTTON_CLASS (klass)->set_color = (void (*) (HeButton*, HeColors)) he_disclosure_button_real_set_color;
	G_OBJECT_CLASS (klass)->get_property = _vala_he_disclosure_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_disclosure_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_disclosure_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_disclosure_button_finalize;
	/**
	   * The color of the button.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DISCLOSURE_BUTTON_COLOR_PROPERTY, he_disclosure_button_properties[HE_DISCLOSURE_BUTTON_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * Sets the icon of the button.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_DISCLOSURE_BUTTON_ICON_PROPERTY, he_disclosure_button_properties[HE_DISCLOSURE_BUTTON_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_disclosure_button_instance_init (HeDisclosureButton * self,
                                    gpointer klass)
{
	self->priv = he_disclosure_button_get_instance_private (self);
}

static void
he_disclosure_button_finalize (GObject * obj)
{
	HeDisclosureButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_DISCLOSURE_BUTTON, HeDisclosureButton);
	G_OBJECT_CLASS (he_disclosure_button_parent_class)->finalize (obj);
}

/**
 * A Disclosure Button is a view-based button that acts on said view.
 */
static GType
he_disclosure_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeDisclosureButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_disclosure_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeDisclosureButton), 0, (GInstanceInitFunc) he_disclosure_button_instance_init, NULL };
	GType he_disclosure_button_type_id;
	he_disclosure_button_type_id = g_type_register_static (HE_TYPE_BUTTON, "HeDisclosureButton", &g_define_type_info, 0);
	HeDisclosureButton_private_offset = g_type_add_instance_private (he_disclosure_button_type_id, sizeof (HeDisclosureButtonPrivate));
	return he_disclosure_button_type_id;
}

GType
he_disclosure_button_get_type (void)
{
	static volatile gsize he_disclosure_button_type_id__once = 0;
	if (g_once_init_enter (&he_disclosure_button_type_id__once)) {
		GType he_disclosure_button_type_id;
		he_disclosure_button_type_id = he_disclosure_button_get_type_once ();
		g_once_init_leave (&he_disclosure_button_type_id__once, he_disclosure_button_type_id);
	}
	return he_disclosure_button_type_id__once;
}

static void
_vala_he_disclosure_button_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	HeDisclosureButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DISCLOSURE_BUTTON, HeDisclosureButton);
	switch (property_id) {
		case HE_DISCLOSURE_BUTTON_COLOR_PROPERTY:
		g_value_set_enum (value, he_button_get_color ((HeButton*) self));
		break;
		case HE_DISCLOSURE_BUTTON_ICON_PROPERTY:
		g_value_set_string (value, he_disclosure_button_get_icon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_disclosure_button_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	HeDisclosureButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_DISCLOSURE_BUTTON, HeDisclosureButton);
	switch (property_id) {
		case HE_DISCLOSURE_BUTTON_COLOR_PROPERTY:
		he_button_set_color ((HeButton*) self, g_value_get_enum (value));
		break;
		case HE_DISCLOSURE_BUTTON_ICON_PROPERTY:
		he_disclosure_button_set_icon (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

