/* IconicButton.c generated by valac 0.56.13, the Vala compiler
 * generated from IconicButton.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>

enum  {
	HE_ICONIC_BUTTON_0_PROPERTY,
	HE_ICONIC_BUTTON_ICON_PROPERTY,
	HE_ICONIC_BUTTON_TOOLTIP_PROPERTY,
	HE_ICONIC_BUTTON_COLOR_PROPERTY,
	HE_ICONIC_BUTTON_NUM_PROPERTIES
};
static GParamSpec* he_iconic_button_properties[HE_ICONIC_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeIconicButtonPrivate {
	gchar* _tooltip;
	HeColors _color;
};

static gint HeIconicButton_private_offset;
static gpointer he_iconic_button_parent_class = NULL;

static GObject * he_iconic_button_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void he_iconic_button_finalize (GObject * obj);
static GType he_iconic_button_get_type_once (void);
static void _vala_he_iconic_button_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_he_iconic_button_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_iconic_button_get_instance_private (HeIconicButton* self)
{
	return G_STRUCT_MEMBER_P (self, HeIconicButton_private_offset);
}

const gchar*
he_iconic_button_get_icon (HeIconicButton* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_button_get_icon_name ((GtkButton*) self);
	result = _tmp0_;
	return result;
}

void
he_iconic_button_set_icon (HeIconicButton* self,
                           const gchar* value)
{
	g_return_if_fail (self != NULL);
	gtk_button_set_icon_name ((GtkButton*) self, value);
	g_object_notify_by_pspec ((GObject *) self, he_iconic_button_properties[HE_ICONIC_BUTTON_ICON_PROPERTY]);
}

const gchar*
he_iconic_button_get_tooltip (HeIconicButton* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_widget_get_tooltip_text ((GtkWidget*) self);
	result = _tmp0_;
	return result;
}

void
he_iconic_button_set_tooltip (HeIconicButton* self,
                              const gchar* value)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_tooltip);
	self->priv->_tooltip = _tmp0_;
	_tmp1_ = self->priv->_tooltip;
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp1_);
	g_object_notify_by_pspec ((GObject *) self, he_iconic_button_properties[HE_ICONIC_BUTTON_TOOLTIP_PROPERTY]);
}

static HeColors
he_iconic_button_real_get_color (HeButton* base)
{
	HeColors result;
	HeIconicButton* self;
	self = (HeIconicButton*) base;
	result = self->priv->_color;
	return result;
}

static void
he_iconic_button_real_set_color (HeButton* base,
                                 HeColors value)
{
	HeIconicButton* self;
	self = (HeIconicButton*) base;
	self->priv->_color = HE_COLORS_NONE;
	g_object_notify_by_pspec ((GObject *) self, he_iconic_button_properties[HE_ICONIC_BUTTON_COLOR_PROPERTY]);
}

/**
   * Constructs a new IconicButton.
   * @param icon The icon name to display.
   *
     * @since 1.0
     */
HeIconicButton*
he_iconic_button_construct (GType object_type,
                            const gchar* icon)
{
	HeIconicButton * self = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	self = (HeIconicButton*) he_button_construct (object_type);
	he_iconic_button_set_icon (self, icon);
	return self;
}

HeIconicButton*
he_iconic_button_new (const gchar* icon)
{
	return he_iconic_button_construct (HE_TYPE_ICONIC_BUTTON, icon);
}

static GObject *
he_iconic_button_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeIconicButton * self;
	parent_class = G_OBJECT_CLASS (he_iconic_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ICONIC_BUTTON, HeIconicButton);
	gtk_widget_add_css_class ((GtkWidget*) self, "flat");
	gtk_widget_add_css_class ((GtkWidget*) self, "image-button");
	gtk_widget_add_css_class ((GtkWidget*) self, "iconic-button");
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	he_button_set_color ((HeButton*) self, HE_COLORS_NONE);
	return obj;
}

static void
he_iconic_button_class_init (HeIconicButtonClass * klass,
                             gpointer klass_data)
{
	he_iconic_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeIconicButton_private_offset);
	HE_BUTTON_CLASS (klass)->get_color = (HeColors (*) (HeButton*)) he_iconic_button_real_get_color;
	HE_BUTTON_CLASS (klass)->set_color = (void (*) (HeButton*, HeColors)) he_iconic_button_real_set_color;
	G_OBJECT_CLASS (klass)->get_property = _vala_he_iconic_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_iconic_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_iconic_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_iconic_button_finalize;
	/**
	   * The icon name to display.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ICONIC_BUTTON_ICON_PROPERTY, he_iconic_button_properties[HE_ICONIC_BUTTON_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ICONIC_BUTTON_TOOLTIP_PROPERTY, he_iconic_button_properties[HE_ICONIC_BUTTON_TOOLTIP_PROPERTY] = g_param_spec_string ("tooltip", "tooltip", "tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	   * The color of the button.
	   */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_ICONIC_BUTTON_COLOR_PROPERTY, he_iconic_button_properties[HE_ICONIC_BUTTON_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_iconic_button_instance_init (HeIconicButton * self,
                                gpointer klass)
{
	self->priv = he_iconic_button_get_instance_private (self);
}

static void
he_iconic_button_finalize (GObject * obj)
{
	HeIconicButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_ICONIC_BUTTON, HeIconicButton);
	_g_free0 (self->priv->_tooltip);
	G_OBJECT_CLASS (he_iconic_button_parent_class)->finalize (obj);
}

/**
 * An Iconic Button is used in a {@link BottomBar} to display an action.
 */
static GType
he_iconic_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeIconicButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_iconic_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeIconicButton), 0, (GInstanceInitFunc) he_iconic_button_instance_init, NULL };
	GType he_iconic_button_type_id;
	he_iconic_button_type_id = g_type_register_static (HE_TYPE_BUTTON, "HeIconicButton", &g_define_type_info, 0);
	HeIconicButton_private_offset = g_type_add_instance_private (he_iconic_button_type_id, sizeof (HeIconicButtonPrivate));
	return he_iconic_button_type_id;
}

GType
he_iconic_button_get_type (void)
{
	static volatile gsize he_iconic_button_type_id__once = 0;
	if (g_once_init_enter (&he_iconic_button_type_id__once)) {
		GType he_iconic_button_type_id;
		he_iconic_button_type_id = he_iconic_button_get_type_once ();
		g_once_init_leave (&he_iconic_button_type_id__once, he_iconic_button_type_id);
	}
	return he_iconic_button_type_id__once;
}

static void
_vala_he_iconic_button_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	HeIconicButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ICONIC_BUTTON, HeIconicButton);
	switch (property_id) {
		case HE_ICONIC_BUTTON_ICON_PROPERTY:
		g_value_set_string (value, he_iconic_button_get_icon (self));
		break;
		case HE_ICONIC_BUTTON_TOOLTIP_PROPERTY:
		g_value_set_string (value, he_iconic_button_get_tooltip (self));
		break;
		case HE_ICONIC_BUTTON_COLOR_PROPERTY:
		g_value_set_enum (value, he_button_get_color ((HeButton*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_iconic_button_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	HeIconicButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_ICONIC_BUTTON, HeIconicButton);
	switch (property_id) {
		case HE_ICONIC_BUTTON_ICON_PROPERTY:
		he_iconic_button_set_icon (self, g_value_get_string (value));
		break;
		case HE_ICONIC_BUTTON_TOOLTIP_PROPERTY:
		he_iconic_button_set_tooltip (self, g_value_get_string (value));
		break;
		case HE_ICONIC_BUTTON_COLOR_PROPERTY:
		he_button_set_color ((HeButton*) self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

