/* OutlineButton.c generated by valac 0.56.13, the Vala compiler
 * generated from OutlineButton.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	HE_OUTLINE_BUTTON_0_PROPERTY,
	HE_OUTLINE_BUTTON_COLOR_PROPERTY,
	HE_OUTLINE_BUTTON_NUM_PROPERTIES
};
static GParamSpec* he_outline_button_properties[HE_OUTLINE_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeOutlineButtonPrivate {
	HeColors _color;
};

static gint HeOutlineButton_private_offset;
static gpointer he_outline_button_parent_class = NULL;

static GObject * he_outline_button_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void he_outline_button_finalize (GObject * obj);
static GType he_outline_button_get_type_once (void);
static void _vala_he_outline_button_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_he_outline_button_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_outline_button_get_instance_private (HeOutlineButton* self)
{
	return G_STRUCT_MEMBER_P (self, HeOutlineButton_private_offset);
}

static HeColors
he_outline_button_real_get_color (HeButton* base)
{
	HeColors result;
	HeOutlineButton* self;
	self = (HeOutlineButton*) base;
	result = self->priv->_color;
	return result;
}

static void
he_outline_button_real_set_color (HeButton* base,
                                  HeColors value)
{
	HeOutlineButton* self;
	self = (HeOutlineButton*) base;
	if (self->priv->_color != HE_COLORS_NONE) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = he_colors_to_css_class (self->priv->_color);
		_tmp1_ = _tmp0_;
		gtk_widget_remove_css_class ((GtkWidget*) self, _tmp1_);
		_g_free0 (_tmp1_);
	}
	if (value != HE_COLORS_NONE) {
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = he_colors_to_css_class (value);
		_tmp3_ = _tmp2_;
		gtk_widget_add_css_class ((GtkWidget*) self, _tmp3_);
		_g_free0 (_tmp3_);
	}
	self->priv->_color = value;
	g_object_notify_by_pspec ((GObject *) self, he_outline_button_properties[HE_OUTLINE_BUTTON_COLOR_PROPERTY]);
}

/**
    * Creates a new OutlineButton.
    * @param label The label of the button.
    *
     * @since 1.0
     */
HeOutlineButton*
he_outline_button_construct (GType object_type,
                             const gchar* label)
{
	HeOutlineButton * self = NULL;
	g_return_val_if_fail (label != NULL, NULL);
	self = (HeOutlineButton*) he_button_construct (object_type);
	gtk_button_set_label ((GtkButton*) self, label);
	return self;
}

HeOutlineButton*
he_outline_button_new (const gchar* label)
{
	return he_outline_button_construct (HE_TYPE_OUTLINE_BUTTON, label);
}

static GObject *
he_outline_button_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeOutlineButton * self;
	parent_class = G_OBJECT_CLASS (he_outline_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_OUTLINE_BUTTON, HeOutlineButton);
	gtk_widget_add_css_class ((GtkWidget*) self, "outline-button");
	return obj;
}

static void
he_outline_button_class_init (HeOutlineButtonClass * klass,
                              gpointer klass_data)
{
	he_outline_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeOutlineButton_private_offset);
	HE_BUTTON_CLASS (klass)->get_color = (HeColors (*) (HeButton*)) he_outline_button_real_get_color;
	HE_BUTTON_CLASS (klass)->set_color = (void (*) (HeButton*, HeColors)) he_outline_button_real_set_color;
	G_OBJECT_CLASS (klass)->get_property = _vala_he_outline_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_outline_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_outline_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_outline_button_finalize;
	/**
	     * The color of the outline button.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_OUTLINE_BUTTON_COLOR_PROPERTY, he_outline_button_properties[HE_OUTLINE_BUTTON_COLOR_PROPERTY] = g_param_spec_enum ("color", "color", "color", HE_TYPE_COLORS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
he_outline_button_instance_init (HeOutlineButton * self,
                                 gpointer klass)
{
	self->priv = he_outline_button_get_instance_private (self);
}

static void
he_outline_button_finalize (GObject * obj)
{
	HeOutlineButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_OUTLINE_BUTTON, HeOutlineButton);
	G_OBJECT_CLASS (he_outline_button_parent_class)->finalize (obj);
}

/**
* An Outline button is a transparent FillButton with a border.
*/
static GType
he_outline_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeOutlineButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_outline_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeOutlineButton), 0, (GInstanceInitFunc) he_outline_button_instance_init, NULL };
	GType he_outline_button_type_id;
	he_outline_button_type_id = g_type_register_static (HE_TYPE_BUTTON, "HeOutlineButton", &g_define_type_info, 0);
	HeOutlineButton_private_offset = g_type_add_instance_private (he_outline_button_type_id, sizeof (HeOutlineButtonPrivate));
	return he_outline_button_type_id;
}

GType
he_outline_button_get_type (void)
{
	static volatile gsize he_outline_button_type_id__once = 0;
	if (g_once_init_enter (&he_outline_button_type_id__once)) {
		GType he_outline_button_type_id;
		he_outline_button_type_id = he_outline_button_get_type_once ();
		g_once_init_leave (&he_outline_button_type_id__once, he_outline_button_type_id);
	}
	return he_outline_button_type_id__once;
}

static void
_vala_he_outline_button_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	HeOutlineButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_OUTLINE_BUTTON, HeOutlineButton);
	switch (property_id) {
		case HE_OUTLINE_BUTTON_COLOR_PROPERTY:
		g_value_set_enum (value, he_button_get_color ((HeButton*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_outline_button_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	HeOutlineButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_OUTLINE_BUTTON, HeOutlineButton);
	switch (property_id) {
		case HE_OUTLINE_BUTTON_COLOR_PROPERTY:
		he_button_set_color ((HeButton*) self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

