/* SettingsWindow.c generated by valac 0.56.13, the Vala compiler
 * generated from SettingsWindow.vala, do not modify */

/*
* Copyright (c) 2022-2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

enum  {
	HE_SETTINGS_WINDOW_0_PROPERTY,
	HE_SETTINGS_WINDOW_NUM_PROPERTIES
};
static GParamSpec* he_settings_window_properties[HE_SETTINGS_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _HeSettingsWindowPrivate {
	GtkBox* box;
	GtkStack* stack;
	HeAppBar* appbar;
	HeViewSwitcher* switcher;
	GtkLabel* viewtitle;
};

static gint HeSettingsWindow_private_offset;
static gpointer he_settings_window_parent_class = NULL;
static GtkBuildableIface * he_settings_window_gtk_buildable_parent_iface = NULL;

static void he_settings_window_real_add_child (GtkBuildable* base,
                                        GtkBuilder* builder,
                                        GObject* child,
                                        const gchar* type);
static void he_settings_window_on_pages_changed (HeSettingsWindow* self,
                                          guint position,
                                          guint removed,
                                          guint added);
static GObject * he_settings_window_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _he_settings_window_on_pages_changed_g_list_model_items_changed (GListModel* _sender,
                                                                      guint position,
                                                                      guint removed,
                                                                      guint added,
                                                                      gpointer self);
static void he_settings_window_finalize (GObject * obj);
static GType he_settings_window_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_settings_window_get_instance_private (HeSettingsWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HeSettingsWindow_private_offset);
}

/**
     * Add SettingsList or SettingsPage children to this window
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
he_settings_window_real_add_child (GtkBuildable* base,
                                   GtkBuilder* builder,
                                   GObject* child,
                                   const gchar* type)
{
	HeSettingsWindow * self;
	self = (HeSettingsWindow*) base;
	g_return_if_fail (builder != NULL);
	g_return_if_fail (child != NULL);
	if (G_TYPE_FROM_INSTANCE (child) == HE_TYPE_SETTINGS_LIST) {
		he_settings_window_add_list (self, HE_IS_SETTINGS_LIST (child) ? ((HeSettingsList*) child) : NULL);
	} else {
		if (G_TYPE_FROM_INSTANCE (child) == HE_TYPE_SETTINGS_PAGE) {
			he_settings_window_add_page (self, HE_IS_SETTINGS_PAGE (child) ? ((HeSettingsPage*) child) : NULL);
		} else {
			gchar* _tmp0_;
			gchar* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			_tmp0_ = g_strdup_printf ("%lu", (gulong) G_TYPE_FROM_INSTANCE (child));
			_tmp1_ = _tmp0_;
			_tmp2_ = string_to_string (_tmp1_);
			_tmp3_ = g_strconcat ("Child of type ", _tmp2_, " is not supported.", NULL);
			_tmp4_ = _tmp3_;
			g_warning ("SettingsWindow.vala:39: %s", _tmp4_);
			_g_free0 (_tmp4_);
			_g_free0 (_tmp1_);
			he_settings_window_gtk_buildable_parent_iface->add_child ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, HE_TYPE_WINDOW, HeWindow), builder, child, type);
		}
	}
}

/**
     * Add a Settings Page to this window
     */
void
he_settings_window_add_page (HeSettingsWindow* self,
                             HeSettingsPage* page)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkStack* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = he_settings_page_get_title (page);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NULL) {
		GtkStack* _tmp2_;
		GtkSelectionModel* _tmp3_;
		GtkSelectionModel* _tmp4_;
		GtkSelectionModel* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp2_ = self->priv->stack;
		_tmp3_ = gtk_stack_get_pages (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = _tmp4_;
		_tmp6_ = g_strdup_printf ("%u", g_list_model_get_n_items ((GListModel*) _tmp5_) + 1);
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strconcat ("Page ", _tmp7_, NULL);
		_tmp9_ = _tmp8_;
		he_settings_page_set_title (page, _tmp9_);
		_g_free0 (_tmp9_);
		_g_free0 (_tmp7_);
		_g_object_unref0 (_tmp5_);
	}
	_tmp10_ = self->priv->stack;
	_tmp11_ = he_settings_page_get_title (page);
	_tmp12_ = _tmp11_;
	_tmp13_ = he_settings_page_get_title (page);
	_tmp14_ = _tmp13_;
	gtk_stack_add_titled (_tmp10_, G_TYPE_CHECK_INSTANCE_TYPE (page, gtk_widget_get_type ()) ? ((GtkWidget*) page) : NULL, _tmp12_, _tmp14_);
}

/**
     * Add a Settings List to this window
     */
void
he_settings_window_add_list (HeSettingsWindow* self,
                             HeSettingsList* list)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	HeSettingsPage* page = NULL;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	HeSettingsPage* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (list != NULL);
	_tmp1_ = he_settings_list_get_title (list);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = he_settings_list_get_title (list);
		_tmp4_ = _tmp3_;
		_tmp0_ = g_strcmp0 (_tmp4_, "") == 0;
	}
	if (_tmp0_) {
		GtkStack* _tmp5_;
		GtkSelectionModel* _tmp6_;
		GtkSelectionModel* _tmp7_;
		GtkSelectionModel* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp5_ = self->priv->stack;
		_tmp6_ = gtk_stack_get_pages (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strdup_printf ("%u", g_list_model_get_n_items ((GListModel*) _tmp8_) + 1);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strconcat ("Page ", _tmp10_, NULL);
		_tmp12_ = _tmp11_;
		he_settings_list_set_title (list, _tmp12_);
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
		_g_object_unref0 (_tmp8_);
	}
	_tmp13_ = he_settings_list_get_title (list);
	_tmp14_ = _tmp13_;
	_tmp15_ = he_settings_page_new (_tmp14_);
	g_object_ref_sink (_tmp15_);
	page = _tmp15_;
	he_settings_page_add_list (page, list);
	he_settings_window_add_page (self, page);
	_g_object_unref0 (page);
}

/**
     * Create a new Settings Window.
     *
     * @since 1.0
     */
HeSettingsWindow*
he_settings_window_construct (GType object_type,
                              GtkWindow* parent)
{
	HeSettingsWindow * self = NULL;
	self = (HeSettingsWindow*) he_window_construct (object_type);
	he_window_set_parent ((HeWindow*) self, parent);
	return self;
}

HeSettingsWindow*
he_settings_window_new (GtkWindow* parent)
{
	return he_settings_window_construct (HE_TYPE_SETTINGS_WINDOW, parent);
}

static void
he_settings_window_on_pages_changed (HeSettingsWindow* self,
                                     guint position,
                                     guint removed,
                                     guint added)
{
	GtkStack* _tmp0_;
	GtkSelectionModel* _tmp1_;
	GtkSelectionModel* _tmp2_;
	GtkSelectionModel* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_stack_get_pages (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = g_list_model_get_n_items ((GListModel*) _tmp3_) <= ((guint) 1);
	_g_object_unref0 (_tmp3_);
	if (_tmp4_) {
		gboolean _tmp5_ = FALSE;
		HeViewSwitcher* _tmp6_;
		GtkWidget* _tmp7_;
		_tmp6_ = self->priv->switcher;
		_tmp7_ = gtk_widget_get_parent ((GtkWidget*) _tmp6_);
		if (_tmp7_ != NULL) {
			HeViewSwitcher* _tmp8_;
			GtkWidget* _tmp9_;
			GtkBox* _tmp10_;
			_tmp8_ = self->priv->switcher;
			_tmp9_ = gtk_widget_get_parent ((GtkWidget*) _tmp8_);
			_tmp10_ = self->priv->box;
			_tmp5_ = _tmp9_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget);
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			GtkBox* _tmp11_;
			HeViewSwitcher* _tmp12_;
			GtkBox* _tmp13_;
			GtkLabel* _tmp14_;
			HeAppBar* _tmp15_;
			_tmp11_ = self->priv->box;
			_tmp12_ = self->priv->switcher;
			gtk_box_remove (_tmp11_, (GtkWidget*) _tmp12_);
			_tmp13_ = self->priv->box;
			_tmp14_ = self->priv->viewtitle;
			_tmp15_ = self->priv->appbar;
			gtk_box_insert_child_after (_tmp13_, (GtkWidget*) _tmp14_, (GtkWidget*) _tmp15_);
		} else {
			GtkLabel* _tmp16_;
			GtkWidget* _tmp17_;
			_tmp16_ = self->priv->viewtitle;
			_tmp17_ = gtk_widget_get_parent ((GtkWidget*) _tmp16_);
			if (_tmp17_ == NULL) {
				GtkBox* _tmp18_;
				GtkLabel* _tmp19_;
				HeAppBar* _tmp20_;
				_tmp18_ = self->priv->box;
				_tmp19_ = self->priv->viewtitle;
				_tmp20_ = self->priv->appbar;
				gtk_box_insert_child_after (_tmp18_, (GtkWidget*) _tmp19_, (GtkWidget*) _tmp20_);
			} else {
				return;
			}
		}
	} else {
		gboolean _tmp21_ = FALSE;
		GtkLabel* _tmp22_;
		GtkWidget* _tmp23_;
		_tmp22_ = self->priv->viewtitle;
		_tmp23_ = gtk_widget_get_parent ((GtkWidget*) _tmp22_);
		if (_tmp23_ != NULL) {
			GtkLabel* _tmp24_;
			GtkWidget* _tmp25_;
			GtkBox* _tmp26_;
			_tmp24_ = self->priv->viewtitle;
			_tmp25_ = gtk_widget_get_parent ((GtkWidget*) _tmp24_);
			_tmp26_ = self->priv->box;
			_tmp21_ = _tmp25_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, gtk_widget_get_type (), GtkWidget);
		} else {
			_tmp21_ = FALSE;
		}
		if (_tmp21_) {
			GtkBox* _tmp27_;
			GtkLabel* _tmp28_;
			GtkBox* _tmp29_;
			HeViewSwitcher* _tmp30_;
			HeAppBar* _tmp31_;
			_tmp27_ = self->priv->box;
			_tmp28_ = self->priv->viewtitle;
			gtk_box_remove (_tmp27_, (GtkWidget*) _tmp28_);
			_tmp29_ = self->priv->box;
			_tmp30_ = self->priv->switcher;
			_tmp31_ = self->priv->appbar;
			gtk_box_insert_child_after (_tmp29_, (GtkWidget*) _tmp30_, (GtkWidget*) _tmp31_);
		} else {
			HeViewSwitcher* _tmp32_;
			GtkWidget* _tmp33_;
			_tmp32_ = self->priv->switcher;
			_tmp33_ = gtk_widget_get_parent ((GtkWidget*) _tmp32_);
			if (_tmp33_ == NULL) {
				GtkBox* _tmp34_;
				HeViewSwitcher* _tmp35_;
				HeAppBar* _tmp36_;
				_tmp34_ = self->priv->box;
				_tmp35_ = self->priv->switcher;
				_tmp36_ = self->priv->appbar;
				gtk_box_insert_child_after (_tmp34_, (GtkWidget*) _tmp35_, (GtkWidget*) _tmp36_);
			} else {
				return;
			}
		}
	}
}

static void
_he_settings_window_on_pages_changed_g_list_model_items_changed (GListModel* _sender,
                                                                 guint position,
                                                                 guint removed,
                                                                 guint added,
                                                                 gpointer self)
{
	he_settings_window_on_pages_changed ((HeSettingsWindow*) self, position, removed, added);
}

static GObject *
he_settings_window_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeSettingsWindow * self;
	GtkStack* _tmp0_;
	GtkSelectionModel* _tmp1_;
	GtkSelectionModel* _tmp2_;
	GtkSelectionModel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	HeAppBar* _tmp12_;
	HeAppBar* _tmp13_;
	HeAppBar* _tmp14_;
	HeAppBar* _tmp15_;
	HeViewSwitcher* _tmp16_;
	GtkStack* _tmp17_;
	HeViewSwitcher* _tmp18_;
	HeViewSwitcher* _tmp19_;
	GtkStack* _tmp20_;
	GtkStack* _tmp21_;
	GtkBox* _tmp22_;
	HeAppBar* _tmp23_;
	GtkBox* _tmp24_;
	HeViewSwitcher* _tmp25_;
	GtkBox* _tmp26_;
	GtkStack* _tmp27_;
	GtkBox* _tmp28_;
	GtkStack* _tmp29_;
	GtkSelectionModel* _tmp30_;
	GtkSelectionModel* _tmp31_;
	GtkSelectionModel* _tmp32_;
	parent_class = G_OBJECT_CLASS (he_settings_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SETTINGS_WINDOW, HeSettingsWindow);
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_stack_get_pages (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	g_signal_connect_object ((GListModel*) _tmp3_, "items-changed", (GCallback) _he_settings_window_on_pages_changed_g_list_model_items_changed, self, 0);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = self->priv->viewtitle;
	gtk_label_set_label (_tmp4_, "Settings");
	_tmp5_ = self->priv->viewtitle;
	gtk_widget_add_css_class ((GtkWidget*) _tmp5_, "view-title");
	_tmp6_ = self->priv->viewtitle;
	gtk_label_set_xalign (_tmp6_, (gfloat) 0);
	_tmp7_ = self->priv->viewtitle;
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
	_tmp8_ = self->priv->viewtitle;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp8_, 6);
	_tmp9_ = self->priv->viewtitle;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp9_, 18);
	_tmp10_ = self->priv->viewtitle;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp10_, 12);
	_tmp11_ = self->priv->viewtitle;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp11_, 6);
	_tmp12_ = self->priv->appbar;
	he_app_bar_set_show_left_title_buttons (_tmp12_, TRUE);
	_tmp13_ = self->priv->appbar;
	he_app_bar_set_show_right_title_buttons (_tmp13_, FALSE);
	_tmp14_ = self->priv->appbar;
	he_app_bar_set_show_back (_tmp14_, FALSE);
	_tmp15_ = self->priv->appbar;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp15_, TRUE);
	_tmp16_ = self->priv->switcher;
	_tmp17_ = self->priv->stack;
	he_view_switcher_set_stack (_tmp16_, _tmp17_);
	_tmp18_ = self->priv->switcher;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp18_, 18);
	_tmp19_ = self->priv->switcher;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp19_, 18);
	_tmp20_ = self->priv->stack;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp20_, 18);
	_tmp21_ = self->priv->stack;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp21_, 18);
	_tmp22_ = self->priv->box;
	_tmp23_ = self->priv->appbar;
	gtk_box_append (_tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = self->priv->box;
	_tmp25_ = self->priv->switcher;
	gtk_box_append (_tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = self->priv->box;
	_tmp27_ = self->priv->stack;
	gtk_box_append (_tmp26_, (GtkWidget*) _tmp27_);
	_tmp28_ = self->priv->box;
	gtk_window_set_child ((GtkWindow*) self, (GtkWidget*) _tmp28_);
	gtk_widget_set_size_request ((GtkWidget*) self, 360, 400);
	gtk_window_set_default_size ((GtkWindow*) self, 360, 400);
	he_window_set_has_title ((HeWindow*) self, FALSE);
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	_tmp29_ = self->priv->stack;
	_tmp30_ = gtk_stack_get_pages (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = _tmp31_;
	he_settings_window_on_pages_changed (self, (guint) 0, (guint) 0, g_list_model_get_n_items ((GListModel*) _tmp32_));
	_g_object_unref0 (_tmp32_);
	return obj;
}

static void
he_settings_window_class_init (HeSettingsWindowClass * klass,
                               gpointer klass_data)
{
	he_settings_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeSettingsWindow_private_offset);
	G_OBJECT_CLASS (klass)->constructor = he_settings_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_settings_window_finalize;
}

static void
he_settings_window_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                 gpointer iface_data)
{
	he_settings_window_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) he_settings_window_real_add_child;
}

static void
he_settings_window_instance_init (HeSettingsWindow * self,
                                  gpointer klass)
{
	GtkBox* _tmp0_;
	GtkStack* _tmp1_;
	HeAppBar* _tmp2_;
	HeViewSwitcher* _tmp3_;
	GtkLabel* _tmp4_;
	self->priv = he_settings_window_get_instance_private (self);
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp0_);
	self->priv->box = _tmp0_;
	_tmp1_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp1_);
	self->priv->stack = _tmp1_;
	_tmp2_ = he_app_bar_new ();
	g_object_ref_sink (_tmp2_);
	self->priv->appbar = _tmp2_;
	_tmp3_ = he_view_switcher_new ();
	g_object_ref_sink (_tmp3_);
	self->priv->switcher = _tmp3_;
	_tmp4_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp4_);
	self->priv->viewtitle = _tmp4_;
}

static void
he_settings_window_finalize (GObject * obj)
{
	HeSettingsWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_SETTINGS_WINDOW, HeSettingsWindow);
	_g_object_unref0 (self->priv->box);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->appbar);
	_g_object_unref0 (self->priv->switcher);
	_g_object_unref0 (self->priv->viewtitle);
	G_OBJECT_CLASS (he_settings_window_parent_class)->finalize (obj);
}

/**
 * A modal window that accepts SettingsLists or SettingsPages
 */
static GType
he_settings_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeSettingsWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_settings_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeSettingsWindow), 0, (GInstanceInitFunc) he_settings_window_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_settings_window_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_settings_window_type_id;
	he_settings_window_type_id = g_type_register_static (HE_TYPE_WINDOW, "HeSettingsWindow", &g_define_type_info, 0);
	g_type_add_interface_static (he_settings_window_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeSettingsWindow_private_offset = g_type_add_instance_private (he_settings_window_type_id, sizeof (HeSettingsWindowPrivate));
	return he_settings_window_type_id;
}

GType
he_settings_window_get_type (void)
{
	static volatile gsize he_settings_window_type_id__once = 0;
	if (g_once_init_enter (&he_settings_window_type_id__once)) {
		GType he_settings_window_type_id;
		he_settings_window_type_id = he_settings_window_get_type_once ();
		g_once_init_leave (&he_settings_window_type_id__once, he_settings_window_type_id);
	}
	return he_settings_window_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

