/* Tab.c generated by valac 0.56.13, the Vala compiler
 * generated from Tab.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pango/pango.h>

#define HE_TAB_ACTION_CLOSE "action-close"
#define HE_TAB_ACTION_CLOSE_OTHER "action-close-other"
#define HE_TAB_ACTION_CLOSE_RIGHT "action-close-right"
#define HE_TAB_ACTION_DUPLICATE "action-duplicate"
#define HE_TAB_ACTION_PIN "action-pin"
#define HE_TAB_ACTION_NEW_WINDOW "action-new-window"

enum  {
	HE_TAB_0_PROPERTY,
	HE_TAB_LABEL_PROPERTY,
	HE_TAB_TOOLTIP_PROPERTY,
	HE_TAB_IS_CURRENT_TAB_PROPERTY,
	HE_TAB_PINNED_PROPERTY,
	HE_TAB_CAN_PIN_PROPERTY,
	HE_TAB_CAN_CLOSE_PROPERTY,
	HE_TAB_PAGE_PROPERTY,
	HE_TAB_MENU_PROPERTY,
	HE_TAB_ACTIONS_PROPERTY,
	HE_TAB_NUM_PROPERTIES
};
static GParamSpec* he_tab_properties[HE_TAB_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	HE_TAB_CLOSED_SIGNAL,
	HE_TAB_CLOSE_OTHERS_SIGNAL,
	HE_TAB_CLOSE_OTHERS_RIGHT_SIGNAL,
	HE_TAB_DUPLICATE_SIGNAL,
	HE_TAB_PIN_SIGNAL,
	HE_TAB_NEW_WINDOW_SIGNAL,
	HE_TAB_NUM_SIGNALS
};
static guint he_tab_signals[HE_TAB_NUM_SIGNALS] = {0};

struct _HeTabPrivate {
	GtkLabel* _label;
	gboolean _is_current_tab;
	gboolean _pinned;
	gboolean _pinnable;
	gboolean _closable;
	GMenu* _menu;
	GMenuItem* pin_menuitem;
	GtkButton* close_button;
	GtkCenterBox* tab_layout;
	GtkPopoverMenu* _popover;
	GSimpleActionGroup* _actions;
};

struct _Block7Data {
	int _ref_count_;
	HeTab* self;
	GtkGestureClick* click;
};

static gint HeTab_private_offset;
static gpointer he_tab_parent_class = NULL;

static void he_tab_action_close (HeTab* self);
static void _he_tab_action_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self);
static void he_tab_action_close_other (HeTab* self);
static void _he_tab_action_close_other_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void he_tab_action_close_right (HeTab* self);
static void _he_tab_action_close_right_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void he_tab_action_duplicate (HeTab* self);
static void _he_tab_action_duplicate_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void he_tab_action_pin (HeTab* self);
static void _he_tab_action_pin_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self);
static void he_tab_action_new_window (HeTab* self);
static void _he_tab_action_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self);
VALA_EXTERN void he_tab_set_is_current_tab (HeTab* self,
                                gboolean value);
static void he_tab_update_close_btn_visibility (HeTab* self);
static HeTabSwitcher* he_tab_get_tab_switcher (HeTab* self);
static void he_tab_set_menu (HeTab* self,
                      GMenu* value);
static GtkPopoverMenu* he_tab_get_popover (HeTab* self);
static void he_tab_set_popover (HeTab* self,
                         GtkPopoverMenu* value);
static void he_tab_handle_events (HeTab* self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda38_ (Block7Data* _data7_,
                  gint n_press,
                  gdouble x,
                  gdouble y);
static void ___lambda38__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static GObject * he_tab_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties);
static void _he_tab___lambda39_ (HeTab* self);
static void __he_tab___lambda39__gtk_button_clicked (GtkButton* _sender,
                                              gpointer self);
static void he_tab_finalize (GObject * obj);
static GType he_tab_get_type_once (void);
static void _vala_he_tab_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_he_tab_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry HE_TAB_ENTRIES[6] = {{HE_TAB_ACTION_CLOSE, _he_tab_action_close_gsimple_action_activate_callback}, {HE_TAB_ACTION_CLOSE_OTHER, _he_tab_action_close_other_gsimple_action_activate_callback}, {HE_TAB_ACTION_CLOSE_RIGHT, _he_tab_action_close_right_gsimple_action_activate_callback}, {HE_TAB_ACTION_DUPLICATE, _he_tab_action_duplicate_gsimple_action_activate_callback}, {HE_TAB_ACTION_PIN, _he_tab_action_pin_gsimple_action_activate_callback}, {HE_TAB_ACTION_NEW_WINDOW, _he_tab_action_new_window_gsimple_action_activate_callback}};

static inline gpointer
he_tab_get_instance_private (HeTab* self)
{
	return G_STRUCT_MEMBER_P (self, HeTab_private_offset);
}

static void
_he_tab_action_close_gsimple_action_activate_callback (GSimpleAction* action,
                                                       GVariant* parameter,
                                                       gpointer self)
{
	he_tab_action_close ((HeTab*) self);
}

static void
_he_tab_action_close_other_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
	he_tab_action_close_other ((HeTab*) self);
}

static void
_he_tab_action_close_right_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
	he_tab_action_close_right ((HeTab*) self);
}

static void
_he_tab_action_duplicate_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
	he_tab_action_duplicate ((HeTab*) self);
}

static void
_he_tab_action_pin_gsimple_action_activate_callback (GSimpleAction* action,
                                                     GVariant* parameter,
                                                     gpointer self)
{
	he_tab_action_pin ((HeTab*) self);
}

static void
_he_tab_action_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                            GVariant* parameter,
                                                            gpointer self)
{
	he_tab_action_new_window ((HeTab*) self);
}

const gchar*
he_tab_get_label (HeTab* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label;
	_tmp1_ = gtk_label_get_label (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
he_tab_set_label (HeTab* self,
                  const gchar* value)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_label;
	gtk_label_set_label (_tmp0_, value);
	_tmp1_ = self->priv->_label;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp1_, value);
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_LABEL_PROPERTY]);
}

void
he_tab_set_tooltip (HeTab* self,
                    const gchar* value)
{
	GtkLabel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_label;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_TOOLTIP_PROPERTY]);
}

void
he_tab_set_is_current_tab (HeTab* self,
                           gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_is_current_tab = value;
	he_tab_update_close_btn_visibility (self);
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_IS_CURRENT_TAB_PROPERTY]);
}

gboolean
he_tab_get_pinned (HeTab* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_pinned;
	return result;
}

void
he_tab_set_pinned (HeTab* self,
                   gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = he_tab_get_can_pin (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		if (value != self->priv->_pinned) {
			if (value) {
				GtkLabel* _tmp2_;
				GMenu* _tmp3_;
				GMenuItem* _tmp4_;
				GMenu* _tmp5_;
				GMenuItem* _tmp6_;
				_tmp2_ = self->priv->_label;
				gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
				_tmp3_ = self->priv->_menu;
				g_menu_remove (_tmp3_, 5);
				_tmp4_ = self->priv->pin_menuitem;
				g_menu_item_set_label (_tmp4_, "Unpin");
				_tmp5_ = self->priv->_menu;
				_tmp6_ = self->priv->pin_menuitem;
				g_menu_insert_item (_tmp5_, 5, _tmp6_);
			} else {
				GtkLabel* _tmp7_;
				GMenu* _tmp8_;
				GMenuItem* _tmp9_;
				GMenu* _tmp10_;
				GMenuItem* _tmp11_;
				_tmp7_ = self->priv->_label;
				gtk_widget_set_visible ((GtkWidget*) _tmp7_, TRUE);
				_tmp8_ = self->priv->_menu;
				g_menu_remove (_tmp8_, 5);
				_tmp9_ = self->priv->pin_menuitem;
				g_menu_item_set_label (_tmp9_, "Pin");
				_tmp10_ = self->priv->_menu;
				_tmp11_ = self->priv->pin_menuitem;
				g_menu_insert_item (_tmp10_, 5, _tmp11_);
			}
			self->priv->_pinned = value;
			he_tab_update_close_btn_visibility (self);
			g_signal_emit (self, he_tab_signals[HE_TAB_PIN_SIGNAL], 0);
		}
	}
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_PINNED_PROPERTY]);
}

gboolean
he_tab_get_can_pin (HeTab* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_pinnable;
	return result;
}

void
he_tab_set_can_pin (HeTab* self,
                    gboolean value)
{
	g_return_if_fail (self != NULL);
	if (!value) {
		he_tab_set_pinned (self, FALSE);
	}
	self->priv->_pinnable = value;
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_CAN_PIN_PROPERTY]);
}

gboolean
he_tab_get_can_close (HeTab* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_closable;
	return result;
}

void
he_tab_set_can_close (HeTab* self,
                      gboolean value)
{
	g_return_if_fail (self != NULL);
	if (value == self->priv->_closable) {
		return;
	}
	self->priv->_closable = value;
	he_tab_update_close_btn_visibility (self);
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_CAN_CLOSE_PROPERTY]);
}

GtkWidget*
he_tab_get_page (HeTab* self)
{
	GtkWidget* result;
	HeTabPage* _tmp0_;
	GtkWidget* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->page_container;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	result = _tmp1_;
	return result;
}

void
he_tab_set_page (HeTab* self,
                 GtkWidget* value)
{
	GtkWidget* container_child = NULL;
	HeTabPage* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	HeTabPage* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->page_container;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	container_child = _tmp1_;
	_tmp2_ = container_child;
	if (_tmp2_ != NULL) {
		GtkWidget* _tmp3_;
		_tmp3_ = container_child;
		gtk_widget_unparent (_tmp3_);
	}
	_tmp4_ = self->page_container;
	gtk_widget_set_parent (value, (GtkWidget*) _tmp4_);
	g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_PAGE_PROPERTY]);
}

static HeTabSwitcher*
he_tab_get_tab_switcher (HeTab* self)
{
	HeTabSwitcher* result;
	GtkNotebook* _tmp0_ = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = gtk_widget_get_parent ((GtkWidget*) self);
	_tmp0_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_notebook_get_type ()) ? ((GtkNotebook*) _tmp1_) : NULL;
	_tmp2_ = NULL;
	if (_tmp0_ != NULL) {
		GtkWidget* _tmp3_;
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) _tmp0_);
		_tmp2_ = _tmp3_;
	}
	result = HE_IS_TAB_SWITCHER (_tmp2_) ? ((HeTabSwitcher*) _tmp2_) : NULL;
	return result;
}

GMenu*
he_tab_get_menu (HeTab* self)
{
	GMenu* result;
	GMenu* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_menu;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
he_tab_set_menu (HeTab* self,
                 GMenu* value)
{
	GMenu* old_value;
	g_return_if_fail (self != NULL);
	old_value = he_tab_get_menu (self);
	if (old_value != value) {
		GMenu* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_menu);
		self->priv->_menu = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_MENU_PROPERTY]);
	}
}

static GtkPopoverMenu*
he_tab_get_popover (HeTab* self)
{
	GtkPopoverMenu* result;
	GtkPopoverMenu* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_popover;
	result = _tmp0_;
	return result;
}

static void
he_tab_set_popover (HeTab* self,
                    GtkPopoverMenu* value)
{
	GtkPopoverMenu* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_popover);
	self->priv->_popover = _tmp0_;
}

GSimpleActionGroup*
he_tab_get_actions (HeTab* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_actions;
	result = _tmp0_;
	return result;
}

static void
he_tab_set_actions (HeTab* self,
                    GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
	g_return_if_fail (self != NULL);
	old_value = he_tab_get_actions (self);
	if (old_value != value) {
		GSimpleActionGroup* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_actions);
		self->priv->_actions = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, he_tab_properties[HE_TAB_ACTIONS_PROPERTY]);
	}
}

static void
he_tab_action_close (HeTab* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, he_tab_signals[HE_TAB_CLOSED_SIGNAL], 0);
}

static void
he_tab_action_close_other (HeTab* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, he_tab_signals[HE_TAB_CLOSE_OTHERS_SIGNAL], 0);
}

static void
he_tab_action_close_right (HeTab* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, he_tab_signals[HE_TAB_CLOSE_OTHERS_RIGHT_SIGNAL], 0);
}

static void
he_tab_action_duplicate (HeTab* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, he_tab_signals[HE_TAB_DUPLICATE_SIGNAL], 0);
}

static void
he_tab_action_pin (HeTab* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = he_tab_get_pinned (self);
	_tmp1_ = _tmp0_;
	he_tab_set_pinned (self, !_tmp1_);
}

static void
he_tab_action_new_window (HeTab* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, he_tab_signals[HE_TAB_NEW_WINDOW_SIGNAL], 0);
}

/**
     * Create a new Tab
     *
     * @since 1.0
     */
HeTab*
he_tab_construct (GType object_type,
                  const gchar* label,
                  GtkWidget* page)
{
	HeTab * self = NULL;
	self = (HeTab*) g_object_new (object_type, "label", label, NULL);
	if (page != NULL) {
		he_tab_set_page (self, page);
	}
	he_tab_handle_events (self);
	return self;
}

HeTab*
he_tab_new (const gchar* label,
            GtkWidget* page)
{
	return he_tab_construct (HE_TYPE_TAB, label, page);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		HeTab* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->click);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
__lambda38_ (Block7Data* _data7_,
             gint n_press,
             gdouble x,
             gdouble y)
{
	HeTab* self;
	self = _data7_->self;
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) _data7_->click) == ((guint) GDK_BUTTON_SECONDARY)) {
		GdkRectangle rect = {0};
		GdkRectangle _tmp0_ = {0};
		GtkPopoverMenu* _tmp1_;
		GdkRectangle _tmp2_;
		GtkPopoverMenu* _tmp3_;
		_tmp0_.x = (gint) x;
		_tmp0_.y = (gint) y;
		_tmp0_.width = 0;
		_tmp0_.height = 0;
		rect = _tmp0_;
		_tmp1_ = self->priv->_popover;
		_tmp2_ = rect;
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp1_, &_tmp2_);
		_tmp3_ = self->priv->_popover;
		gtk_popover_popup ((GtkPopover*) _tmp3_);
	}
}

static void
___lambda38__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
	__lambda38_ (self, n_press, x, y);
}

static void
he_tab_handle_events (HeTab* self)
{
	Block7Data* _data7_;
	GtkGestureClick* _tmp0_ = NULL;
	GtkEventController* _tmp1_;
	GtkPopoverMenu* _tmp2_;
	g_return_if_fail (self != NULL);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp0_, (guint) 0);
	_data7_->click = _tmp0_;
	_tmp1_ = _g_object_ref0 ((GtkEventController*) _data7_->click);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp1_);
	_tmp2_ = self->priv->_popover;
	gtk_widget_set_parent ((GtkWidget*) _tmp2_, (GtkWidget*) self);
	g_signal_connect_data (_data7_->click, "pressed", (GCallback) ___lambda38__gtk_gesture_click_pressed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	block7_data_unref (_data7_);
	_data7_ = NULL;
}

static void
he_tab_update_close_btn_visibility (HeTab* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp1_ = he_tab_get_pinned (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp3_ = he_tab_get_can_close (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = !_tmp4_;
	}
	if (_tmp0_) {
		GtkButton* _tmp5_;
		_tmp5_ = self->priv->close_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
	} else {
		GtkButton* _tmp6_;
		_tmp6_ = self->priv->close_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
	}
}

static void
_he_tab___lambda39_ (HeTab* self)
{
	g_signal_emit (self, he_tab_signals[HE_TAB_CLOSED_SIGNAL], 0);
}

static void
__he_tab___lambda39__gtk_button_clicked (GtkButton* _sender,
                                         gpointer self)
{
	_he_tab___lambda39_ ((HeTab*) self);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static GObject *
he_tab_constructor (GType type,
                    guint n_construct_properties,
                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTab * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkCenterBox* _tmp7_;
	GtkCenterBox* _tmp8_;
	GtkCenterBox* _tmp9_;
	GtkButton* _tmp10_;
	GtkCenterBox* _tmp11_;
	GtkLabel* _tmp12_;
	GtkCenterBox* _tmp13_;
	GMenu* _tmp14_;
	GMenu* _tmp15_;
	GMenu* _tmp16_;
	GtkPopoverMenu* _tmp17_;
	GtkPopoverMenu* _tmp18_;
	GSimpleActionGroup* _tmp19_;
	GSimpleActionGroup* _tmp20_;
	GSimpleActionGroup* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	GSimpleActionGroup* _tmp24_;
	GMenu* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GMenu* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	GMenu* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	GMenu* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	GMenu* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp56_;
	GtkPopoverMenu* _tmp65_;
	GMenu* _tmp66_;
	HeTabPage* _tmp67_;
	parent_class = G_OBJECT_CLASS (he_tab_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TAB, HeTab);
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->_label);
	self->priv->_label = _tmp0_;
	_tmp1_ = self->priv->_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = self->priv->_label;
	gtk_label_set_ellipsize (_tmp2_, PANGO_ELLIPSIZE_END);
	_tmp3_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close");
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->close_button);
	self->priv->close_button = _tmp3_;
	_tmp4_ = self->priv->close_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
	_tmp5_ = self->priv->close_button;
	gtk_widget_add_css_class ((GtkWidget*) _tmp5_, "tab-button");
	_tmp6_ = self->priv->close_button;
	g_signal_connect_object (_tmp6_, "clicked", (GCallback) __he_tab___lambda39__gtk_button_clicked, self, 0);
	_tmp7_ = (GtkCenterBox*) gtk_center_box_new ();
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->tab_layout);
	self->priv->tab_layout = _tmp7_;
	_tmp8_ = self->priv->tab_layout;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp8_, TRUE);
	_tmp9_ = self->priv->tab_layout;
	_tmp10_ = self->priv->close_button;
	gtk_center_box_set_end_widget (_tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = self->priv->tab_layout;
	_tmp12_ = self->priv->_label;
	gtk_center_box_set_center_widget (_tmp11_, (GtkWidget*) _tmp12_);
	_tmp13_ = self->priv->tab_layout;
	gtk_widget_set_parent ((GtkWidget*) _tmp13_, (GtkWidget*) self);
	_tmp14_ = g_menu_new ();
	_tmp15_ = _tmp14_;
	he_tab_set_menu (self, _tmp15_);
	_g_object_unref0 (_tmp15_);
	_tmp16_ = self->priv->_menu;
	_tmp17_ = (GtkPopoverMenu*) gtk_popover_menu_new_from_model ((GMenuModel*) _tmp16_);
	g_object_ref_sink (_tmp17_);
	_tmp18_ = _tmp17_;
	he_tab_set_popover (self, _tmp18_);
	_g_object_unref0 (_tmp18_);
	_tmp19_ = g_simple_action_group_new ();
	_tmp20_ = _tmp19_;
	he_tab_set_actions (self, _tmp20_);
	_g_object_unref0 (_tmp20_);
	_tmp21_ = self->priv->_actions;
	g_action_map_add_action_entries ((GActionMap*) _tmp21_, HE_TAB_ENTRIES, (gint) G_N_ELEMENTS (HE_TAB_ENTRIES), self);
	_tmp22_ = he_tab_get_label (self);
	_tmp23_ = _tmp22_;
	_tmp24_ = self->priv->_actions;
	gtk_widget_insert_action_group ((GtkWidget*) self, _tmp23_, (GActionGroup*) _tmp24_);
	_tmp25_ = self->priv->_menu;
	_tmp26_ = he_tab_get_label (self);
	_tmp27_ = _tmp26_;
	_tmp28_ = string_to_string (_tmp27_);
	_tmp29_ = g_strconcat (_tmp28_, ".action-new-window", NULL);
	_tmp30_ = _tmp29_;
	g_menu_append (_tmp25_, "Open in New Window", _tmp30_);
	_g_free0 (_tmp30_);
	_tmp31_ = self->priv->_menu;
	_tmp32_ = he_tab_get_label (self);
	_tmp33_ = _tmp32_;
	_tmp34_ = string_to_string (_tmp33_);
	_tmp35_ = g_strconcat (_tmp34_, ".action-close", NULL);
	_tmp36_ = _tmp35_;
	g_menu_append (_tmp31_, "Close", _tmp36_);
	_g_free0 (_tmp36_);
	_tmp37_ = self->priv->_menu;
	_tmp38_ = he_tab_get_label (self);
	_tmp39_ = _tmp38_;
	_tmp40_ = string_to_string (_tmp39_);
	_tmp41_ = g_strconcat (_tmp40_, ".action-close-other", NULL);
	_tmp42_ = _tmp41_;
	g_menu_append (_tmp37_, "Close Others", _tmp42_);
	_g_free0 (_tmp42_);
	_tmp43_ = self->priv->_menu;
	_tmp44_ = he_tab_get_label (self);
	_tmp45_ = _tmp44_;
	_tmp46_ = string_to_string (_tmp45_);
	_tmp47_ = g_strconcat (_tmp46_, ".action-close-right", NULL);
	_tmp48_ = _tmp47_;
	g_menu_append (_tmp43_, "Close Tab to the Right", _tmp48_);
	_g_free0 (_tmp48_);
	_tmp49_ = self->priv->_menu;
	_tmp50_ = he_tab_get_label (self);
	_tmp51_ = _tmp50_;
	_tmp52_ = string_to_string (_tmp51_);
	_tmp53_ = g_strconcat (_tmp52_, ".action-duplicate", NULL);
	_tmp54_ = _tmp53_;
	g_menu_append (_tmp49_, "Duplicate", _tmp54_);
	_g_free0 (_tmp54_);
	_tmp55_ = he_tab_get_can_pin (self);
	_tmp56_ = _tmp55_;
	if (_tmp56_) {
		const gchar* _tmp57_;
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		GMenuItem* _tmp62_;
		GMenu* _tmp63_;
		GMenuItem* _tmp64_;
		_tmp57_ = he_tab_get_label (self);
		_tmp58_ = _tmp57_;
		_tmp59_ = string_to_string (_tmp58_);
		_tmp60_ = g_strconcat (_tmp59_, ".pin", NULL);
		_tmp61_ = _tmp60_;
		_tmp62_ = g_menu_item_new ("Pin", _tmp61_);
		_g_object_unref0 (self->priv->pin_menuitem);
		self->priv->pin_menuitem = _tmp62_;
		_g_free0 (_tmp61_);
		_tmp63_ = self->priv->_menu;
		_tmp64_ = self->priv->pin_menuitem;
		g_menu_insert_item (_tmp63_, 5, _tmp64_);
	}
	_tmp65_ = self->priv->_popover;
	_tmp66_ = self->priv->_menu;
	gtk_popover_menu_set_menu_model (_tmp65_, (GMenuModel*) _tmp66_);
	_tmp67_ = he_tab_page_new (self);
	g_object_ref_sink (_tmp67_);
	_g_object_unref0 (self->page_container);
	self->page_container = _tmp67_;
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	gtk_widget_add_css_class ((GtkWidget*) self, "tab-child");
	return obj;
}

static void
he_tab_class_init (HeTabClass * klass,
                   gpointer klass_data)
{
	he_tab_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeTab_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_tab_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_tab_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_tab_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_tab_finalize;
	/**
	     * The label/title of the tab
	     **/
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_LABEL_PROPERTY, he_tab_properties[HE_TAB_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The Pango marked up text that will be shown in a tooltip when the tab is hovered.
	     **/
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_TOOLTIP_PROPERTY, he_tab_properties[HE_TAB_TOOLTIP_PROPERTY] = g_param_spec_string ("tooltip", "tooltip", "tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_IS_CURRENT_TAB_PROPERTY, he_tab_properties[HE_TAB_IS_CURRENT_TAB_PROPERTY] = g_param_spec_boolean ("is-current-tab", "is-current-tab", "is-current-tab", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_PINNED_PROPERTY, he_tab_properties[HE_TAB_PINNED_PROPERTY] = g_param_spec_boolean ("pinned", "pinned", "pinned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Whether a Tab can be pinned or not
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_CAN_PIN_PROPERTY, he_tab_properties[HE_TAB_CAN_PIN_PROPERTY] = g_param_spec_boolean ("can-pin", "can-pin", "can-pin", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Whether a Tab can be closed or not
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_CAN_CLOSE_PROPERTY, he_tab_properties[HE_TAB_CAN_CLOSE_PROPERTY] = g_param_spec_boolean ("can-close", "can-close", "can-close", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The TabPage to hold children, to appear when this tab is active
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_PAGE_PROPERTY, he_tab_properties[HE_TAB_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The menu appearing when the tab is clicked
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_MENU_PROPERTY, he_tab_properties[HE_TAB_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", g_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_ACTIONS_PROPERTY, he_tab_properties[HE_TAB_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	he_tab_signals[HE_TAB_CLOSED_SIGNAL] = g_signal_new ("closed", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	he_tab_signals[HE_TAB_CLOSE_OTHERS_SIGNAL] = g_signal_new ("close-others", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	he_tab_signals[HE_TAB_CLOSE_OTHERS_RIGHT_SIGNAL] = g_signal_new ("close-others-right", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	he_tab_signals[HE_TAB_DUPLICATE_SIGNAL] = g_signal_new ("duplicate", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	he_tab_signals[HE_TAB_PIN_SIGNAL] = g_signal_new ("pin", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	he_tab_signals[HE_TAB_NEW_WINDOW_SIGNAL] = g_signal_new ("new-window", HE_TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
}

static void
he_tab_instance_init (HeTab * self,
                      gpointer klass)
{
	self->priv = he_tab_get_instance_private (self);
	self->priv->_is_current_tab = FALSE;
	self->priv->_pinned = FALSE;
	self->priv->_pinnable = TRUE;
	self->priv->_closable = TRUE;
}

static void
he_tab_finalize (GObject * obj)
{
	HeTab * self;
	GtkCenterBox* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TAB, HeTab);
	_tmp0_ = self->priv->tab_layout;
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
	_g_object_unref0 (self->priv->_label);
	_g_object_unref0 (self->page_container);
	_g_object_unref0 (self->priv->_menu);
	_g_object_unref0 (self->priv->pin_menuitem);
	_g_object_unref0 (self->priv->close_button);
	_g_object_unref0 (self->priv->tab_layout);
	_g_object_unref0 (self->priv->_popover);
	_g_object_unref0 (self->priv->_actions);
	G_OBJECT_CLASS (he_tab_parent_class)->finalize (obj);
}

/**
 * Standard tab designed for TabSwitcher, used to form a tabbed UI
 */
static GType
he_tab_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTabClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_tab_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTab), 0, (GInstanceInitFunc) he_tab_instance_init, NULL };
	GType he_tab_type_id;
	he_tab_type_id = g_type_register_static (HE_TYPE_BIN, "HeTab", &g_define_type_info, 0);
	HeTab_private_offset = g_type_add_instance_private (he_tab_type_id, sizeof (HeTabPrivate));
	return he_tab_type_id;
}

GType
he_tab_get_type (void)
{
	static volatile gsize he_tab_type_id__once = 0;
	if (g_once_init_enter (&he_tab_type_id__once)) {
		GType he_tab_type_id;
		he_tab_type_id = he_tab_get_type_once ();
		g_once_init_leave (&he_tab_type_id__once, he_tab_type_id);
	}
	return he_tab_type_id__once;
}

static void
_vala_he_tab_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	HeTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB, HeTab);
	switch (property_id) {
		case HE_TAB_LABEL_PROPERTY:
		g_value_set_string (value, he_tab_get_label (self));
		break;
		case HE_TAB_PINNED_PROPERTY:
		g_value_set_boolean (value, he_tab_get_pinned (self));
		break;
		case HE_TAB_CAN_PIN_PROPERTY:
		g_value_set_boolean (value, he_tab_get_can_pin (self));
		break;
		case HE_TAB_CAN_CLOSE_PROPERTY:
		g_value_set_boolean (value, he_tab_get_can_close (self));
		break;
		case HE_TAB_PAGE_PROPERTY:
		g_value_set_object (value, he_tab_get_page (self));
		break;
		case HE_TAB_MENU_PROPERTY:
		g_value_set_object (value, he_tab_get_menu (self));
		break;
		case HE_TAB_ACTIONS_PROPERTY:
		g_value_set_object (value, he_tab_get_actions (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_tab_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	HeTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB, HeTab);
	switch (property_id) {
		case HE_TAB_LABEL_PROPERTY:
		he_tab_set_label (self, g_value_get_string (value));
		break;
		case HE_TAB_TOOLTIP_PROPERTY:
		he_tab_set_tooltip (self, g_value_get_string (value));
		break;
		case HE_TAB_IS_CURRENT_TAB_PROPERTY:
		he_tab_set_is_current_tab (self, g_value_get_boolean (value));
		break;
		case HE_TAB_PINNED_PROPERTY:
		he_tab_set_pinned (self, g_value_get_boolean (value));
		break;
		case HE_TAB_CAN_PIN_PROPERTY:
		he_tab_set_can_pin (self, g_value_get_boolean (value));
		break;
		case HE_TAB_CAN_CLOSE_PROPERTY:
		he_tab_set_can_close (self, g_value_get_boolean (value));
		break;
		case HE_TAB_PAGE_PROPERTY:
		he_tab_set_page (self, g_value_get_object (value));
		break;
		case HE_TAB_MENU_PROPERTY:
		he_tab_set_menu (self, g_value_get_object (value));
		break;
		case HE_TAB_ACTIONS_PROPERTY:
		he_tab_set_actions (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

