/* TabPage.c generated by valac 0.56.13, the Vala compiler
 * generated from TabPage.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <string.h>

enum  {
	HE_TAB_PAGE_0_PROPERTY,
	HE_TAB_PAGE_TAB_PROPERTY,
	HE_TAB_PAGE_NUM_PROPERTIES
};
static GParamSpec* he_tab_page_properties[HE_TAB_PAGE_NUM_PROPERTIES];

struct _HeTabPagePrivate {
	HeTab* _tab;
};

static gint HeTabPage_private_offset;
static gpointer he_tab_page_parent_class = NULL;

static HeTabSwitcher* he_tab_page_get_tab_switcher (HeTabPage* self);
static void he_tab_page_finalize (GObject * obj);
static GType he_tab_page_get_type_once (void);
static void _vala_he_tab_page_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_he_tab_page_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_tab_page_get_instance_private (HeTabPage* self)
{
	return G_STRUCT_MEMBER_P (self, HeTabPage_private_offset);
}

HeTab*
he_tab_page_get_tab (HeTabPage* self)
{
	HeTab* result;
	HeTab* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tab;
	result = _tmp0_;
	return result;
}

void
he_tab_page_set_tab (HeTabPage* self,
                     HeTab* value)
{
	g_return_if_fail (self != NULL);
	self->priv->_tab = value;
	g_object_notify_by_pspec ((GObject *) self, he_tab_page_properties[HE_TAB_PAGE_TAB_PROPERTY]);
}

static HeTabSwitcher*
he_tab_page_get_tab_switcher (HeTabPage* self)
{
	HeTabSwitcher* result;
	GtkNotebook* _tmp0_ = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = gtk_widget_get_parent ((GtkWidget*) self);
	_tmp0_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_notebook_get_type ()) ? ((GtkNotebook*) _tmp1_) : NULL;
	_tmp2_ = NULL;
	if (_tmp0_ != NULL) {
		GtkWidget* _tmp3_;
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) _tmp0_);
		_tmp2_ = _tmp3_;
	}
	result = HE_IS_TAB_SWITCHER (_tmp2_) ? ((HeTabSwitcher*) _tmp2_) : NULL;
	return result;
}

/**
     * Create a new Tab Page. This should be handled automatically by the Tab generation code.
     *
     * @since 1.0
     */
HeTabPage*
he_tab_page_construct (GType object_type,
                       HeTab* tab)
{
	HeTabPage * self = NULL;
	g_return_val_if_fail (tab != NULL, NULL);
	self = (HeTabPage*) g_object_new (object_type, "tab", tab, NULL);
	return self;
}

HeTabPage*
he_tab_page_new (HeTab* tab)
{
	return he_tab_page_construct (HE_TYPE_TAB_PAGE, tab);
}

static void
he_tab_page_class_init (HeTabPageClass * klass,
                        gpointer klass_data)
{
	he_tab_page_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeTabPage_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_tab_page_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_tab_page_set_property;
	G_OBJECT_CLASS (klass)->finalize = he_tab_page_finalize;
	/**
	     * The Tab this page is associated with
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_PAGE_TAB_PROPERTY, he_tab_page_properties[HE_TAB_PAGE_TAB_PROPERTY] = g_param_spec_object ("tab", "tab", "tab", HE_TYPE_TAB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
}

static void
he_tab_page_instance_init (HeTabPage * self,
                           gpointer klass)
{
	self->priv = he_tab_page_get_instance_private (self);
	self->priv->_tab = NULL;
}

static void
he_tab_page_finalize (GObject * obj)
{
	HeTabPage * self;
	GtkWidget* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TAB_PAGE, HeTabPage);
	_tmp0_ = gtk_widget_get_first_child ((GtkWidget*) self);
	gtk_widget_unparent (_tmp0_);
	G_OBJECT_CLASS (he_tab_page_parent_class)->finalize (obj);
}

/**
 * Auxilary Class for handling the contents of Tabs
 */
static GType
he_tab_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTabPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_tab_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTabPage), 0, (GInstanceInitFunc) he_tab_page_instance_init, NULL };
	GType he_tab_page_type_id;
	he_tab_page_type_id = g_type_register_static (HE_TYPE_BIN, "HeTabPage", &g_define_type_info, 0);
	HeTabPage_private_offset = g_type_add_instance_private (he_tab_page_type_id, sizeof (HeTabPagePrivate));
	return he_tab_page_type_id;
}

GType
he_tab_page_get_type (void)
{
	static volatile gsize he_tab_page_type_id__once = 0;
	if (g_once_init_enter (&he_tab_page_type_id__once)) {
		GType he_tab_page_type_id;
		he_tab_page_type_id = he_tab_page_get_type_once ();
		g_once_init_leave (&he_tab_page_type_id__once, he_tab_page_type_id);
	}
	return he_tab_page_type_id__once;
}

static void
_vala_he_tab_page_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	HeTabPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB_PAGE, HeTabPage);
	switch (property_id) {
		case HE_TAB_PAGE_TAB_PROPERTY:
		g_value_set_object (value, he_tab_page_get_tab (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_tab_page_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	HeTabPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB_PAGE, HeTabPage);
	switch (property_id) {
		case HE_TAB_PAGE_TAB_PROPERTY:
		he_tab_page_set_tab (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

