/* TabSwitcher.c generated by valac 0.56.13, the Vala compiler
 * generated from TabSwitcher.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define HE_TAB_SWITCHER_MIN_TAB_WIDTH 80
#define HE_TAB_SWITCHER_MAX_TAB_WIDTH 150
#define HE_TAB_SWITCHER_ACTION_NEW_TAB "action-new-tab"

enum  {
	HE_TAB_SWITCHER_0_PROPERTY,
	HE_TAB_SWITCHER_N_TABS_PROPERTY,
	HE_TAB_SWITCHER_TABS_PROPERTY,
	HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY,
	HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY,
	HE_TAB_SWITCHER_CURRENT_PROPERTY,
	HE_TAB_SWITCHER_MENU_PROPERTY,
	HE_TAB_SWITCHER_ACTIONS_PROPERTY,
	HE_TAB_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* he_tab_switcher_properties[HE_TAB_SWITCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
enum  {
	HE_TAB_SWITCHER_TAB_ADDED_SIGNAL,
	HE_TAB_SWITCHER_TAB_REMOVED_SIGNAL,
	HE_TAB_SWITCHER_TAB_SWITCHED_SIGNAL,
	HE_TAB_SWITCHER_TAB_MOVED_SIGNAL,
	HE_TAB_SWITCHER_TAB_DUPLICATED_SIGNAL,
	HE_TAB_SWITCHER_NEW_TAB_REQUESTED_SIGNAL,
	HE_TAB_SWITCHER_CLOSE_TAB_REQUESTED_SIGNAL,
	HE_TAB_SWITCHER_NUM_SIGNALS
};
static guint he_tab_switcher_signals[HE_TAB_SWITCHER_NUM_SIGNALS] = {0};

struct _HeTabSwitcherPrivate {
	GList* _tabs;
	HeTabSwitcherTabBarBehavior _tab_bar_behavior;
	gboolean _allow_duplication;
	gboolean _allow_drag;
	gboolean _allow_pin;
	gboolean _allow_close;
	gboolean _allow_window;
	GMenu* _menu;
	GtkPopoverMenu* _popover;
	HeTab* old_tab;
	gint tab_width;
	GSimpleActionGroup* _actions;
};

struct _Block8Data {
	int _ref_count_;
	HeTabSwitcher* self;
	GtkGestureClick* click;
};

struct _Block9Data {
	int _ref_count_;
	HeTabSwitcher* self;
	HeTab* clicked_tab;
};

struct _Block10Data {
	int _ref_count_;
	HeTabSwitcher* self;
	gboolean is_to_the_right;
	HeTab* clicked_tab;
};

static gint HeTabSwitcher_private_offset;
static gpointer he_tab_switcher_parent_class = NULL;
static GtkBuildableIface * he_tab_switcher_gtk_buildable_parent_iface = NULL;

static void he_tab_switcher_action_new_tab (HeTabSwitcher* self);
static void _he_tab_switcher_action_new_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void he_tab_switcher_update_tabs_visibility (HeTabSwitcher* self);
static void he_tab_switcher_recalc_order (HeTabSwitcher* self);
static void he_tab_switcher_set_menu (HeTabSwitcher* self,
                               GMenu* value);
static GtkPopoverMenu* he_tab_switcher_get_popover (HeTabSwitcher* self);
static void he_tab_switcher_set_popover (HeTabSwitcher* self,
                                  GtkPopoverMenu* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void he_tab_switcher_handle_events (HeTabSwitcher* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda33_ (Block8Data* _data8_,
                  gint n_press,
                  gdouble x,
                  gdouble y);
static void ___lambda33__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                             gint n_press,
                                             gdouble x,
                                             gdouble y,
                                             gpointer self);
static void he_tab_switcher_on_switch_page (HeTabSwitcher* self,
                                     GtkWidget* page,
                                     guint pagenum);
VALA_EXTERN void he_tab_set_is_current_tab (HeTab* self,
                                gboolean value);
static void he_tab_switcher_on_page_added (HeTabSwitcher* self,
                                    GtkWidget* page,
                                    guint pagenum);
static void he_tab_switcher_insert_callbacks (HeTabSwitcher* self,
                                       HeTab* tab);
static void he_tab_switcher_on_page_removed (HeTabSwitcher* self,
                                      GtkWidget* page,
                                      guint pagenum);
static void he_tab_switcher_remove_callbacks (HeTabSwitcher* self,
                                       HeTab* tab);
static GtkNotebook* he_tab_switcher_on_create_window (HeTabSwitcher* self,
                                               GtkWidget* page);
static void he_tab_switcher_on_tab_closed (HeTabSwitcher* self,
                                    HeTab* tab);
static void _he_tab_switcher_on_tab_closed_he_tab_closed (HeTab* _sender,
                                                   gpointer self);
static void he_tab_switcher_on_close_others (HeTabSwitcher* self,
                                      HeTab* clicked_tab);
static void _he_tab_switcher_on_close_others_he_tab_close_others (HeTab* _sender,
                                                           gpointer self);
static void he_tab_switcher_on_close_others_right (HeTabSwitcher* self,
                                            HeTab* clicked_tab);
static void _he_tab_switcher_on_close_others_right_he_tab_close_others_right (HeTab* _sender,
                                                                       gpointer self);
static void he_tab_switcher_on_duplicate (HeTabSwitcher* self,
                                   HeTab* tab);
static void _he_tab_switcher_on_duplicate_he_tab_duplicate (HeTab* _sender,
                                                     gpointer self);
static void he_tab_switcher_on_pin (HeTabSwitcher* self,
                             HeTab* tab);
static void _he_tab_switcher_on_pin_he_tab_pin (HeTab* _sender,
                                         gpointer self);
static void he_tab_switcher_on_new_window (HeTabSwitcher* self,
                                    HeTab* tab);
static void _he_tab_switcher_on_new_window_he_tab_new_window (HeTab* _sender,
                                                       gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda34_ (Block9Data* _data9_,
                  HeTab* tab);
static void ___lambda34__gfunc (gconstpointer data,
                         gpointer self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda35_ (Block10Data* _data10_,
                  HeTab* tab);
static void ___lambda35__gfunc (gconstpointer data,
                         gpointer self);
static GObject * he_tab_switcher_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _he_tab_switcher___lambda36_ (HeTabSwitcher* self);
static void __he_tab_switcher___lambda36__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void _he_tab_switcher___lambda37_ (HeTabSwitcher* self);
static void _he_tab_switcher_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                               GtkWidget* page,
                                                               guint page_num,
                                                               gpointer self);
static void _he_tab_switcher_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                             GtkWidget* child,
                                                             guint page_num,
                                                             gpointer self);
static void _he_tab_switcher_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                                 GtkWidget* child,
                                                                 guint page_num,
                                                                 gpointer self);
static GtkNotebook* _he_tab_switcher_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                                           GtkWidget* page,
                                                                           gpointer self);
static void __he_tab_switcher___lambda37__gtk_widget_destroy (GtkWidget* _sender,
                                                       gpointer self);
static void he_tab_switcher_finalize (GObject * obj);
static GType he_tab_switcher_get_type_once (void);
static void _vala_he_tab_switcher_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_he_tab_switcher_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry HE_TAB_SWITCHER_ENTRIES[1] = {{HE_TAB_SWITCHER_ACTION_NEW_TAB, _he_tab_switcher_action_new_tab_gsimple_action_activate_callback}};

static inline gpointer
he_tab_switcher_get_instance_private (HeTabSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, HeTabSwitcher_private_offset);
}

/**
     * How the tab bar should behave
     */
static GType
he_tab_switcher_tab_bar_behavior_get_type_once (void)
{
	static const GEnumValue values[] = {{HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_ALWAYS, "HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_ALWAYS", "always"}, {HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_SINGLE, "HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_SINGLE", "single"}, {HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_NEVER, "HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_NEVER", "never"}, {0, NULL, NULL}};
	GType he_tab_switcher_tab_bar_behavior_type_id;
	he_tab_switcher_tab_bar_behavior_type_id = g_enum_register_static ("HeTabSwitcherTabBarBehavior", values);
	return he_tab_switcher_tab_bar_behavior_type_id;
}

GType
he_tab_switcher_tab_bar_behavior_get_type (void)
{
	static volatile gsize he_tab_switcher_tab_bar_behavior_type_id__once = 0;
	if (g_once_init_enter (&he_tab_switcher_tab_bar_behavior_type_id__once)) {
		GType he_tab_switcher_tab_bar_behavior_type_id;
		he_tab_switcher_tab_bar_behavior_type_id = he_tab_switcher_tab_bar_behavior_get_type_once ();
		g_once_init_leave (&he_tab_switcher_tab_bar_behavior_type_id__once, he_tab_switcher_tab_bar_behavior_type_id);
	}
	return he_tab_switcher_tab_bar_behavior_type_id__once;
}

static void
_he_tab_switcher_action_new_tab_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
	he_tab_switcher_action_new_tab ((HeTabSwitcher*) self);
}

gint
he_tab_switcher_get_n_tabs (HeTabSwitcher* self)
{
	gint result;
	GtkNotebook* _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->notebook;
	result = gtk_notebook_get_n_pages (_tmp0_);
	return result;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GList*
he_tab_switcher_get_tabs (HeTabSwitcher* self)
{
	GList* result;
	GList* _tmp9_;
	g_return_val_if_fail (self != NULL, NULL);
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
	self->priv->_tabs = NULL;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				GtkNotebook* _tmp4_;
				GtkNotebook* _tmp5_;
				GtkWidget* _tmp6_;
				GtkWidget* _tmp7_;
				HeTab* _tmp8_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = he_tab_switcher_get_n_tabs (self);
				_tmp3_ = _tmp2_;
				if (!(i < _tmp3_)) {
					break;
				}
				_tmp4_ = self->notebook;
				_tmp5_ = self->notebook;
				_tmp6_ = gtk_notebook_get_nth_page (_tmp5_, i);
				_tmp7_ = gtk_notebook_get_tab_label (_tmp4_, _tmp6_);
				_tmp8_ = _g_object_ref0 (HE_IS_TAB (_tmp7_) ? ((HeTab*) _tmp7_) : NULL);
				self->priv->_tabs = g_list_append (self->priv->_tabs, _tmp8_);
			}
		}
	}
	_tmp9_ = self->priv->_tabs;
	result = _tmp9_;
	return result;
}

HeTabSwitcherTabBarBehavior
he_tab_switcher_get_tab_bar_behavior (HeTabSwitcher* self)
{
	HeTabSwitcherTabBarBehavior result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_tab_bar_behavior;
	return result;
}

void
he_tab_switcher_set_tab_bar_behavior (HeTabSwitcher* self,
                                      HeTabSwitcherTabBarBehavior value)
{
	g_return_if_fail (self != NULL);
	self->priv->_tab_bar_behavior = value;
	he_tab_switcher_update_tabs_visibility (self);
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY]);
}

/**
     * The position in the switcher of the tab
     */
gint
he_tab_switcher_get_tab_position (HeTabSwitcher* self,
                                  HeTab* tab)
{
	GtkNotebook* _tmp0_;
	HeTabPage* _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (tab != NULL, 0);
	_tmp0_ = self->notebook;
	_tmp1_ = tab->page_container;
	result = gtk_notebook_page_num (_tmp0_, (GtkWidget*) _tmp1_);
	return result;
}

gboolean
he_tab_switcher_get_allow_duplicate_tabs (HeTabSwitcher* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_allow_duplication;
	return result;
}

void
he_tab_switcher_set_allow_duplicate_tabs (HeTabSwitcher* self,
                                          gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_allow_duplication = value;
	_tmp0_ = he_tab_switcher_get_tabs (self);
	_tmp1_ = _tmp0_;
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
		tab_collection = _tmp1_;
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
			HeTab* _tmp2_;
			HeTab* tab = NULL;
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
			tab = _tmp2_;
			{
				_g_object_unref0 (tab);
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY]);
}

gboolean
he_tab_switcher_get_allow_drag (HeTabSwitcher* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_allow_drag;
	return result;
}

void
he_tab_switcher_set_allow_drag (HeTabSwitcher* self,
                                gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_allow_drag = value;
	_tmp0_ = he_tab_switcher_get_tabs (self);
	_tmp1_ = _tmp0_;
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
		tab_collection = _tmp1_;
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
			HeTab* _tmp2_;
			HeTab* tab = NULL;
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
			tab = _tmp2_;
			{
				GtkNotebook* _tmp3_;
				HeTab* _tmp4_;
				HeTabPage* _tmp5_;
				_tmp3_ = self->notebook;
				_tmp4_ = tab;
				_tmp5_ = _tmp4_->page_container;
				gtk_notebook_set_tab_reorderable (_tmp3_, (GtkWidget*) _tmp5_, value);
				_g_object_unref0 (tab);
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY]);
}

gboolean
he_tab_switcher_get_allow_pinning (HeTabSwitcher* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_allow_pin;
	return result;
}

void
he_tab_switcher_set_allow_pinning (HeTabSwitcher* self,
                                   gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_allow_pin = value;
	_tmp0_ = he_tab_switcher_get_tabs (self);
	_tmp1_ = _tmp0_;
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
		tab_collection = _tmp1_;
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
			HeTab* _tmp2_;
			HeTab* tab = NULL;
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
			tab = _tmp2_;
			{
				HeTab* _tmp3_;
				_tmp3_ = tab;
				he_tab_set_can_pin (_tmp3_, value);
				_g_object_unref0 (tab);
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY]);
}

gboolean
he_tab_switcher_get_allow_closing (HeTabSwitcher* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_allow_close;
	return result;
}

void
he_tab_switcher_set_allow_closing (HeTabSwitcher* self,
                                   gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_allow_close = value;
	_tmp0_ = he_tab_switcher_get_tabs (self);
	_tmp1_ = _tmp0_;
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
		tab_collection = _tmp1_;
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
			HeTab* _tmp2_;
			HeTab* tab = NULL;
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
			tab = _tmp2_;
			{
				HeTab* _tmp3_;
				_tmp3_ = tab;
				he_tab_set_can_close (_tmp3_, value);
				_g_object_unref0 (tab);
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY]);
}

gboolean
he_tab_switcher_get_allow_new_window (HeTabSwitcher* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_allow_window;
	return result;
}

void
he_tab_switcher_set_allow_new_window (HeTabSwitcher* self,
                                      gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_allow_close = value;
	_tmp0_ = he_tab_switcher_get_tabs (self);
	_tmp1_ = _tmp0_;
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
		tab_collection = _tmp1_;
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
			HeTab* _tmp2_;
			HeTab* tab = NULL;
			_tmp2_ = _g_object_ref0 ((HeTab*) tab_it->data);
			tab = _tmp2_;
			{
				GtkNotebook* _tmp3_;
				HeTab* _tmp4_;
				HeTabPage* _tmp5_;
				_tmp3_ = self->notebook;
				_tmp4_ = tab;
				_tmp5_ = _tmp4_->page_container;
				gtk_notebook_set_tab_detachable (_tmp3_, (GtkWidget*) _tmp5_, value);
				_g_object_unref0 (tab);
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY]);
}

HeTab*
he_tab_switcher_get_current (HeTabSwitcher* self)
{
	HeTab* result;
	GList* _tmp0_;
	GList* _tmp1_;
	GtkNotebook* _tmp2_;
	gconstpointer _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = he_tab_switcher_get_tabs (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->notebook;
	_tmp3_ = g_list_nth_data (_tmp1_, (guint) gtk_notebook_get_current_page (_tmp2_));
	result = (HeTab*) _tmp3_;
	return result;
}

void
he_tab_switcher_set_current (HeTabSwitcher* self,
                             HeTab* value)
{
	GtkNotebook* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->notebook;
	_tmp1_ = he_tab_switcher_get_tabs (self);
	_tmp2_ = _tmp1_;
	gtk_notebook_set_current_page (_tmp0_, g_list_index (_tmp2_, value));
	g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_CURRENT_PROPERTY]);
}

/**
     * Insert a new tab into the TabSwitcher.
     *
     * To append a tab, you may use -1 as the index.
     */
guint
he_tab_switcher_insert_tab (HeTabSwitcher* self,
                            HeTab* tab,
                            gint index)
{
	gint _tmp0_ = 0;
	GtkNotebook* _tmp3_;
	HeTabPage* _tmp4_;
	GtkNotebook* _tmp5_;
	HeTabPage* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	GtkNotebook* _tmp9_;
	HeTabPage* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GtkWidget* _tmp15_;
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (tab != NULL, 0U);
	if (index <= -1) {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = he_tab_switcher_get_n_tabs (self);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = index;
	}
	_tmp3_ = self->notebook;
	_tmp4_ = tab->page_container;
	index = gtk_notebook_insert_page (_tmp3_, (GtkWidget*) _tmp4_, (GtkWidget*) tab, _tmp0_);
	_tmp5_ = self->notebook;
	_tmp6_ = tab->page_container;
	_tmp7_ = he_tab_switcher_get_allow_drag (self);
	_tmp8_ = _tmp7_;
	gtk_notebook_set_tab_reorderable (_tmp5_, (GtkWidget*) _tmp6_, _tmp8_);
	_tmp9_ = self->notebook;
	_tmp10_ = tab->page_container;
	_tmp11_ = he_tab_switcher_get_allow_new_window (self);
	_tmp12_ = _tmp11_;
	gtk_notebook_set_tab_detachable (_tmp9_, (GtkWidget*) _tmp10_, _tmp12_);
	_tmp13_ = he_tab_switcher_get_allow_pinning (self);
	_tmp14_ = _tmp13_;
	he_tab_set_can_pin (tab, _tmp14_);
	he_tab_set_pinned (tab, FALSE);
	_tmp15_ = gtk_widget_get_parent ((GtkWidget*) tab);
	gtk_widget_add_css_class (_tmp15_, "tab");
	gtk_widget_set_size_request ((GtkWidget*) tab, self->priv->tab_width, -1);
	he_tab_switcher_recalc_order (self);
	result = (guint) index;
	return result;
}

/**
     * Removes a tab from the TabSwitcher.
     */
void
he_tab_switcher_remove_tab (HeTabSwitcher* self,
                            HeTab* tab)
{
	gint pos = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tab != NULL);
	pos = he_tab_switcher_get_tab_position (self, tab);
	if (pos != -1) {
		GtkNotebook* _tmp0_;
		_tmp0_ = self->notebook;
		gtk_notebook_remove_page (_tmp0_, pos);
	}
}

GMenu*
he_tab_switcher_get_menu (HeTabSwitcher* self)
{
	GMenu* result;
	GMenu* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_menu;
	result = _tmp0_;
	return result;
}

static void
he_tab_switcher_set_menu (HeTabSwitcher* self,
                          GMenu* value)
{
	GMenu* old_value;
	g_return_if_fail (self != NULL);
	old_value = he_tab_switcher_get_menu (self);
	if (old_value != value) {
		GMenu* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_menu);
		self->priv->_menu = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_MENU_PROPERTY]);
	}
}

static GtkPopoverMenu*
he_tab_switcher_get_popover (HeTabSwitcher* self)
{
	GtkPopoverMenu* result;
	GtkPopoverMenu* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_popover;
	result = _tmp0_;
	return result;
}

static void
he_tab_switcher_set_popover (HeTabSwitcher* self,
                             GtkPopoverMenu* value)
{
	GtkPopoverMenu* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_popover);
	self->priv->_popover = _tmp0_;
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
	g_value_set_boolean (return_value, v_return);
}

GSimpleActionGroup*
he_tab_switcher_get_actions (HeTabSwitcher* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_actions;
	result = _tmp0_;
	return result;
}

static void
he_tab_switcher_set_actions (HeTabSwitcher* self,
                             GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
	g_return_if_fail (self != NULL);
	old_value = he_tab_switcher_get_actions (self);
	if (old_value != value) {
		GSimpleActionGroup* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_actions);
		self->priv->_actions = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, he_tab_switcher_properties[HE_TAB_SWITCHER_ACTIONS_PROPERTY]);
	}
}

static void
he_tab_switcher_action_new_tab (HeTabSwitcher* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_NEW_TAB_REQUESTED_SIGNAL], 0);
}

/**
     * Create a new TabSwitcher
     *
     * @since 1.0
     */
HeTabSwitcher*
he_tab_switcher_construct (GType object_type)
{
	HeTabSwitcher * self = NULL;
	self = (HeTabSwitcher*) he_bin_construct (object_type);
	he_tab_switcher_handle_events (self);
	return self;
}

HeTabSwitcher*
he_tab_switcher_new (void)
{
	return he_tab_switcher_construct (HE_TYPE_TAB_SWITCHER);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		HeTabSwitcher* self;
		self = _data8_->self;
		_g_object_unref0 (_data8_->click);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static void
__lambda33_ (Block8Data* _data8_,
             gint n_press,
             gdouble x,
             gdouble y)
{
	HeTabSwitcher* self;
	self = _data8_->self;
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) _data8_->click) == ((guint) GDK_BUTTON_SECONDARY)) {
		GdkRectangle rect = {0};
		GdkRectangle _tmp0_ = {0};
		GtkPopoverMenu* _tmp1_;
		GdkRectangle _tmp2_;
		GtkPopoverMenu* _tmp3_;
		_tmp0_.x = (gint) x;
		_tmp0_.y = (gint) y;
		_tmp0_.width = 0;
		_tmp0_.height = 0;
		rect = _tmp0_;
		_tmp1_ = self->priv->_popover;
		_tmp2_ = rect;
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp1_, &_tmp2_);
		_tmp3_ = self->priv->_popover;
		gtk_popover_popup ((GtkPopover*) _tmp3_);
	}
}

static void
___lambda33__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y,
                                        gpointer self)
{
	__lambda33_ (self, n_press, x, y);
}

static void
he_tab_switcher_handle_events (HeTabSwitcher* self)
{
	Block8Data* _data8_;
	GtkGestureClick* _tmp0_ = NULL;
	GtkEventController* _tmp1_;
	GtkPopoverMenu* _tmp2_;
	g_return_if_fail (self != NULL);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_data8_->self = g_object_ref (self);
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp0_, (guint) 0);
	_data8_->click = _tmp0_;
	_tmp1_ = _g_object_ref0 ((GtkEventController*) _data8_->click);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp1_);
	_tmp2_ = self->priv->_popover;
	gtk_widget_set_parent ((GtkWidget*) _tmp2_, (GtkWidget*) self);
	g_signal_connect_data (_data8_->click, "pressed", (GCallback) ___lambda33__gtk_gesture_click_pressed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	block8_data_unref (_data8_);
	_data8_ = NULL;
}

static void
he_tab_switcher_on_switch_page (HeTabSwitcher* self,
                                GtkWidget* page,
                                guint pagenum)
{
	HeTabPage* _tmp0_ = NULL;
	HeTab* _tmp1_ = NULL;
	HeTab* new_tab = NULL;
	HeTab* _tmp4_;
	HeTab* _tmp5_;
	HeTab* _tmp7_;
	HeTab* _tmp8_;
	HeTab* _tmp9_;
	HeTab* _tmp10_;
	HeTab* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = HE_IS_TAB_PAGE (page) ? ((HeTabPage*) page) : NULL;
	_tmp1_ = NULL;
	if (_tmp0_ != NULL) {
		HeTab* _tmp2_;
		HeTab* _tmp3_;
		_tmp2_ = he_tab_page_get_tab (_tmp0_);
		_tmp3_ = _tmp2_;
		_tmp1_ = _tmp3_;
	}
	_tmp4_ = _g_object_ref0 (_tmp1_);
	new_tab = _tmp4_;
	_tmp5_ = self->priv->old_tab;
	if (_tmp5_ != NULL) {
		HeTab* _tmp6_;
		_tmp6_ = self->priv->old_tab;
		he_tab_set_is_current_tab (_tmp6_, FALSE);
	}
	_tmp7_ = new_tab;
	he_tab_set_is_current_tab (_tmp7_, TRUE);
	_tmp8_ = self->priv->old_tab;
	_tmp9_ = new_tab;
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_SWITCHED_SIGNAL], 0, _tmp8_, _tmp9_);
	_tmp10_ = new_tab;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	_g_object_unref0 (self->priv->old_tab);
	self->priv->old_tab = _tmp11_;
	_g_object_unref0 (new_tab);
}

static void
he_tab_switcher_on_page_added (HeTabSwitcher* self,
                               GtkWidget* page,
                               guint pagenum)
{
	HeTabPage* _tmp0_ = NULL;
	HeTab* _tmp1_ = NULL;
	HeTab* t = NULL;
	HeTab* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = HE_IS_TAB_PAGE (page) ? ((HeTabPage*) page) : NULL;
	_tmp1_ = NULL;
	if (_tmp0_ != NULL) {
		HeTab* _tmp2_;
		HeTab* _tmp3_;
		_tmp2_ = he_tab_page_get_tab (_tmp0_);
		_tmp3_ = _tmp2_;
		_tmp1_ = _tmp3_;
	}
	_tmp4_ = _g_object_ref0 (_tmp1_);
	t = _tmp4_;
	he_tab_switcher_insert_callbacks (self, t);
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_ADDED_SIGNAL], 0, t);
	he_tab_switcher_update_tabs_visibility (self);
	_g_object_unref0 (t);
}

static void
he_tab_switcher_on_page_removed (HeTabSwitcher* self,
                                 GtkWidget* page,
                                 guint pagenum)
{
	HeTabPage* _tmp0_ = NULL;
	HeTab* _tmp1_ = NULL;
	HeTab* t = NULL;
	HeTab* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (page != NULL);
	_tmp0_ = HE_IS_TAB_PAGE (page) ? ((HeTabPage*) page) : NULL;
	_tmp1_ = NULL;
	if (_tmp0_ != NULL) {
		HeTab* _tmp2_;
		HeTab* _tmp3_;
		_tmp2_ = he_tab_page_get_tab (_tmp0_);
		_tmp3_ = _tmp2_;
		_tmp1_ = _tmp3_;
	}
	_tmp4_ = _g_object_ref0 (_tmp1_);
	t = _tmp4_;
	he_tab_switcher_remove_callbacks (self, t);
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_REMOVED_SIGNAL], 0, t);
	he_tab_switcher_update_tabs_visibility (self);
	_g_object_unref0 (t);
}

static GtkNotebook*
he_tab_switcher_on_create_window (HeTabSwitcher* self,
                                  GtkWidget* page)
{
	HeTab* tab = NULL;
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	HeTab* _tmp2_;
	GtkNotebook* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (page != NULL, NULL);
	_tmp0_ = self->notebook;
	_tmp1_ = gtk_notebook_get_tab_label (_tmp0_, page);
	_tmp2_ = _g_object_ref0 (HE_IS_TAB (_tmp1_) ? ((HeTab*) _tmp1_) : NULL);
	tab = _tmp2_;
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_MOVED_SIGNAL], 0, tab);
	he_tab_switcher_recalc_order (self);
	result = G_TYPE_CHECK_INSTANCE_CAST (NULL, gtk_notebook_get_type (), GtkNotebook);
	_g_object_unref0 (tab);
	return result;
}

static void
he_tab_switcher_recalc_order (HeTabSwitcher* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint pinned_tabs = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = he_tab_switcher_get_n_tabs (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 0) {
		return;
	}
	pinned_tabs = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GtkNotebook* _tmp4_;
				HeTabPage* _tmp5_ = NULL;
				GtkNotebook* _tmp6_;
				GtkWidget* _tmp7_;
				HeTab* _tmp8_ = NULL;
				gboolean _tmp11_;
				gboolean _tmp12_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = self->notebook;
				if (!(i < gtk_notebook_get_n_pages (_tmp4_))) {
					break;
				}
				_tmp6_ = self->notebook;
				_tmp7_ = gtk_notebook_get_nth_page (_tmp6_, i);
				_tmp5_ = HE_IS_TAB_PAGE (_tmp7_) ? ((HeTabPage*) _tmp7_) : NULL;
				_tmp8_ = NULL;
				if (_tmp5_ != NULL) {
					HeTab* _tmp9_;
					HeTab* _tmp10_;
					_tmp9_ = he_tab_page_get_tab (_tmp5_);
					_tmp10_ = _tmp9_;
					_tmp8_ = _tmp10_;
				}
				_tmp11_ = he_tab_get_pinned (_tmp8_);
				_tmp12_ = _tmp11_;
				if (_tmp12_) {
					gint _tmp13_;
					_tmp13_ = pinned_tabs;
					pinned_tabs = _tmp13_ + 1;
				}
			}
		}
	}
	{
		gint p = 0;
		p = 0;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				gint sel = 0;
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = p;
					p = _tmp15_ + 1;
				}
				_tmp14_ = FALSE;
				if (!(p < pinned_tabs)) {
					break;
				}
				sel = p;
				{
					gint i = 0;
					i = p;
					{
						gboolean _tmp16_ = FALSE;
						_tmp16_ = TRUE;
						while (TRUE) {
							GtkNotebook* _tmp18_;
							HeTabPage* _tmp19_ = NULL;
							GtkNotebook* _tmp20_;
							GtkWidget* _tmp21_;
							HeTab* _tmp22_ = NULL;
							gboolean _tmp25_;
							gboolean _tmp26_;
							if (!_tmp16_) {
								gint _tmp17_;
								_tmp17_ = i;
								i = _tmp17_ + 1;
							}
							_tmp16_ = FALSE;
							_tmp18_ = self->notebook;
							if (!(i < gtk_notebook_get_n_pages (_tmp18_))) {
								break;
							}
							_tmp20_ = self->notebook;
							_tmp21_ = gtk_notebook_get_nth_page (_tmp20_, i);
							_tmp19_ = HE_IS_TAB_PAGE (_tmp21_) ? ((HeTabPage*) _tmp21_) : NULL;
							_tmp22_ = NULL;
							if (_tmp19_ != NULL) {
								HeTab* _tmp23_;
								HeTab* _tmp24_;
								_tmp23_ = he_tab_page_get_tab (_tmp19_);
								_tmp24_ = _tmp23_;
								_tmp22_ = _tmp24_;
							}
							_tmp25_ = he_tab_get_pinned (_tmp22_);
							_tmp26_ = _tmp25_;
							if (_tmp26_) {
								sel = i;
								break;
							}
						}
					}
				}
				if (sel != p) {
					GtkNotebook* _tmp27_;
					GtkNotebook* _tmp28_;
					GtkWidget* _tmp29_;
					_tmp27_ = self->notebook;
					_tmp28_ = self->notebook;
					_tmp29_ = gtk_notebook_get_nth_page (_tmp28_, sel);
					gtk_notebook_reorder_child (_tmp27_, _tmp29_, p);
				}
			}
		}
	}
}

static void
_he_tab_switcher_on_tab_closed_he_tab_closed (HeTab* _sender,
                                              gpointer self)
{
	he_tab_switcher_on_tab_closed ((HeTabSwitcher*) self, _sender);
}

static void
_he_tab_switcher_on_close_others_he_tab_close_others (HeTab* _sender,
                                                      gpointer self)
{
	he_tab_switcher_on_close_others ((HeTabSwitcher*) self, _sender);
}

static void
_he_tab_switcher_on_close_others_right_he_tab_close_others_right (HeTab* _sender,
                                                                  gpointer self)
{
	he_tab_switcher_on_close_others_right ((HeTabSwitcher*) self, _sender);
}

static void
_he_tab_switcher_on_duplicate_he_tab_duplicate (HeTab* _sender,
                                                gpointer self)
{
	he_tab_switcher_on_duplicate ((HeTabSwitcher*) self, _sender);
}

static void
_he_tab_switcher_on_pin_he_tab_pin (HeTab* _sender,
                                    gpointer self)
{
	he_tab_switcher_on_pin ((HeTabSwitcher*) self, _sender);
}

static void
_he_tab_switcher_on_new_window_he_tab_new_window (HeTab* _sender,
                                                  gpointer self)
{
	he_tab_switcher_on_new_window ((HeTabSwitcher*) self, _sender);
}

static void
he_tab_switcher_insert_callbacks (HeTabSwitcher* self,
                                  HeTab* tab)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (tab != NULL);
	g_signal_connect_object (tab, "closed", (GCallback) _he_tab_switcher_on_tab_closed_he_tab_closed, self, 0);
	g_signal_connect_object (tab, "close-others", (GCallback) _he_tab_switcher_on_close_others_he_tab_close_others, self, 0);
	g_signal_connect_object (tab, "close-others-right", (GCallback) _he_tab_switcher_on_close_others_right_he_tab_close_others_right, self, 0);
	g_signal_connect_object (tab, "duplicate", (GCallback) _he_tab_switcher_on_duplicate_he_tab_duplicate, self, 0);
	g_signal_connect_object (tab, "pin", (GCallback) _he_tab_switcher_on_pin_he_tab_pin, self, 0);
	g_signal_connect_object (tab, "new-window", (GCallback) _he_tab_switcher_on_new_window_he_tab_new_window, self, 0);
}

static void
he_tab_switcher_remove_callbacks (HeTabSwitcher* self,
                                  HeTab* tab)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tab != NULL);
	g_signal_parse_name ("closed", HE_TYPE_TAB, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _he_tab_switcher_on_tab_closed_he_tab_closed, self);
	g_signal_parse_name ("close-others", HE_TYPE_TAB, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _he_tab_switcher_on_close_others_he_tab_close_others, self);
	g_signal_parse_name ("close-others-right", HE_TYPE_TAB, &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _he_tab_switcher_on_close_others_right_he_tab_close_others_right, self);
	g_signal_parse_name ("duplicate", HE_TYPE_TAB, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _he_tab_switcher_on_duplicate_he_tab_duplicate, self);
	g_signal_parse_name ("pin", HE_TYPE_TAB, &_tmp4_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _he_tab_switcher_on_pin_he_tab_pin, self);
	g_signal_parse_name ("new-window", HE_TYPE_TAB, &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _he_tab_switcher_on_new_window_he_tab_new_window, self);
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
	g_atomic_int_inc (&_data9_->_ref_count_);
	return _data9_;
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
		HeTabSwitcher* self;
		self = _data9_->self;
		_g_object_unref0 (_data9_->clicked_tab);
		_g_object_unref0 (self);
		g_slice_free (Block9Data, _data9_);
	}
}

static void
__lambda34_ (Block9Data* _data9_,
             HeTab* tab)
{
	HeTabSwitcher* self;
	self = _data9_->self;
	g_return_if_fail (tab != NULL);
	if (tab != _data9_->clicked_tab) {
		g_signal_emit_by_name (tab, "closed");
	}
}

static void
___lambda34__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda34_ (self, (HeTab*) data);
}

static void
he_tab_switcher_on_close_others (HeTabSwitcher* self,
                                 HeTab* clicked_tab)
{
	Block9Data* _data9_;
	HeTab* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (clicked_tab != NULL);
	_data9_ = g_slice_new0 (Block9Data);
	_data9_->_ref_count_ = 1;
	_data9_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (clicked_tab);
	_g_object_unref0 (_data9_->clicked_tab);
	_data9_->clicked_tab = _tmp0_;
	_tmp1_ = he_tab_switcher_get_tabs (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_copy (_tmp2_);
	_tmp4_ = _tmp3_;
	g_list_foreach (_tmp4_, ___lambda34__gfunc, _data9_);
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
	block9_data_unref (_data9_);
	_data9_ = NULL;
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		HeTabSwitcher* self;
		self = _data10_->self;
		_g_object_unref0 (_data10_->clicked_tab);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static void
__lambda35_ (Block10Data* _data10_,
             HeTab* tab)
{
	HeTabSwitcher* self;
	self = _data10_->self;
	g_return_if_fail (tab != NULL);
	if (_data10_->is_to_the_right) {
		g_signal_emit_by_name (tab, "closed");
	}
	if (tab == _data10_->clicked_tab) {
		_data10_->is_to_the_right = TRUE;
	}
}

static void
___lambda35__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda35_ (self, (HeTab*) data);
}

static void
he_tab_switcher_on_close_others_right (HeTabSwitcher* self,
                                       HeTab* clicked_tab)
{
	Block10Data* _data10_;
	HeTab* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (clicked_tab != NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (clicked_tab);
	_g_object_unref0 (_data10_->clicked_tab);
	_data10_->clicked_tab = _tmp0_;
	_data10_->is_to_the_right = FALSE;
	_tmp1_ = he_tab_switcher_get_tabs (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_copy (_tmp2_);
	_tmp4_ = _tmp3_;
	g_list_foreach (_tmp4_, ___lambda35__gfunc, _data10_);
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
	block10_data_unref (_data10_);
	_data10_ = NULL;
}

static void
he_tab_switcher_on_tab_closed (HeTabSwitcher* self,
                               HeTab* tab)
{
	gboolean _tmp0_ = FALSE;
	gint pos = 0;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tab != NULL);
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_CLOSE_TAB_REQUESTED_SIGNAL], 0, tab, &_tmp0_);
	if (!_tmp0_) {
		return;
	}
	pos = he_tab_switcher_get_tab_position (self, tab);
	he_tab_switcher_remove_tab (self, tab);
	if (pos != -1) {
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
		_tmp2_ = he_tab_get_page (tab);
		_tmp3_ = _tmp2_;
		_tmp4_ = gtk_widget_get_parent (_tmp3_);
		_tmp1_ = _tmp4_ != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GtkWidget* _tmp5_;
		GtkWidget* _tmp6_;
		_tmp5_ = he_tab_get_page (tab);
		_tmp6_ = _tmp5_;
		gtk_widget_unparent (_tmp6_);
	}
}

static void
he_tab_switcher_on_duplicate (HeTabSwitcher* self,
                              HeTab* tab)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (tab != NULL);
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_DUPLICATED_SIGNAL], 0, tab);
}

static void
he_tab_switcher_on_pin (HeTabSwitcher* self,
                        HeTab* tab)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tab != NULL);
	_tmp0_ = he_tab_switcher_get_allow_pinning (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	he_tab_switcher_recalc_order (self);
}

static void
he_tab_switcher_on_new_window (HeTabSwitcher* self,
                               HeTab* tab)
{
	GtkNotebook* _tmp0_;
	HeTabPage* _tmp1_;
	GtkNotebook* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tab != NULL);
	_tmp0_ = self->notebook;
	_tmp1_ = tab->page_container;
	g_signal_emit_by_name (_tmp0_, "create-window", (GtkWidget*) _tmp1_, &_tmp2_);
}

static void
he_tab_switcher_update_tabs_visibility (HeTabSwitcher* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->_tab_bar_behavior == HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_SINGLE) {
		GtkNotebook* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		_tmp0_ = self->notebook;
		_tmp1_ = he_tab_switcher_get_n_tabs (self);
		_tmp2_ = _tmp1_;
		gtk_notebook_set_show_tabs (_tmp0_, _tmp2_ > 1);
	} else {
		if (self->priv->_tab_bar_behavior == HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_NEVER) {
			GtkNotebook* _tmp3_;
			_tmp3_ = self->notebook;
			gtk_notebook_set_show_tabs (_tmp3_, FALSE);
		} else {
			if (self->priv->_tab_bar_behavior == HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_ALWAYS) {
				GtkNotebook* _tmp4_;
				_tmp4_ = self->notebook;
				gtk_notebook_set_show_tabs (_tmp4_, TRUE);
			}
		}
	}
}

static void
_he_tab_switcher___lambda36_ (HeTabSwitcher* self)
{
	g_signal_emit (self, he_tab_switcher_signals[HE_TAB_SWITCHER_NEW_TAB_REQUESTED_SIGNAL], 0);
}

static void
__he_tab_switcher___lambda36__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
	_he_tab_switcher___lambda36_ ((HeTabSwitcher*) self);
}

static void
_he_tab_switcher_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                          GtkWidget* page,
                                                          guint page_num,
                                                          gpointer self)
{
	he_tab_switcher_on_switch_page ((HeTabSwitcher*) self, page, page_num);
}

static void
_he_tab_switcher_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                        GtkWidget* child,
                                                        guint page_num,
                                                        gpointer self)
{
	he_tab_switcher_on_page_added ((HeTabSwitcher*) self, child, page_num);
}

static void
_he_tab_switcher_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                            GtkWidget* child,
                                                            guint page_num,
                                                            gpointer self)
{
	he_tab_switcher_on_page_removed ((HeTabSwitcher*) self, child, page_num);
}

static GtkNotebook*
_he_tab_switcher_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                              GtkWidget* page,
                                                              gpointer self)
{
	GtkNotebook* result;
	result = he_tab_switcher_on_create_window ((HeTabSwitcher*) self, page);
	return result;
}

static void
_he_tab_switcher___lambda37_ (HeTabSwitcher* self)
{
	GtkNotebook* _tmp0_;
	guint _tmp1_;
	GtkNotebook* _tmp2_;
	guint _tmp3_;
	GtkNotebook* _tmp4_;
	guint _tmp5_;
	GtkNotebook* _tmp6_;
	guint _tmp7_;
	_tmp0_ = self->notebook;
	g_signal_parse_name ("switch-page", gtk_notebook_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _he_tab_switcher_on_switch_page_gtk_notebook_switch_page, self);
	_tmp2_ = self->notebook;
	g_signal_parse_name ("page-added", gtk_notebook_get_type (), &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _he_tab_switcher_on_page_added_gtk_notebook_page_added, self);
	_tmp4_ = self->notebook;
	g_signal_parse_name ("page-removed", gtk_notebook_get_type (), &_tmp5_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _he_tab_switcher_on_page_removed_gtk_notebook_page_removed, self);
	_tmp6_ = self->notebook;
	g_signal_parse_name ("create-window", gtk_notebook_get_type (), &_tmp7_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _he_tab_switcher_on_create_window_gtk_notebook_create_window, self);
}

static void
__he_tab_switcher___lambda37__gtk_widget_destroy (GtkWidget* _sender,
                                                  gpointer self)
{
	_he_tab_switcher___lambda37_ ((HeTabSwitcher*) self);
}

static GObject *
he_tab_switcher_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeTabSwitcher * self;
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	GtkNotebook* _tmp2_;
	GtkNotebook* _tmp3_;
	HeDisclosureButton* add_button = NULL;
	HeDisclosureButton* _tmp4_;
	HeDisclosureButton* _tmp5_;
	HeDisclosureButton* _tmp6_;
	HeDisclosureButton* _tmp7_;
	HeDisclosureButton* _tmp8_;
	GtkNotebook* _tmp9_;
	HeDisclosureButton* _tmp10_;
	GMenu* _tmp11_;
	GMenu* _tmp12_;
	GMenu* _tmp13_;
	GtkPopoverMenu* _tmp14_;
	GtkPopoverMenu* _tmp15_;
	GSimpleActionGroup* _tmp16_;
	GSimpleActionGroup* _tmp17_;
	GSimpleActionGroup* _tmp18_;
	GSimpleActionGroup* _tmp19_;
	GMenu* _tmp20_;
	GtkPopoverMenu* _tmp21_;
	GMenu* _tmp22_;
	HeDisclosureButton* _tmp23_;
	GtkNotebook* _tmp24_;
	GtkNotebook* _tmp25_;
	GtkNotebook* _tmp26_;
	GtkNotebook* _tmp27_;
	GtkNotebook* _tmp28_;
	GtkNotebook* _tmp29_;
	GtkNotebook* _tmp30_;
	parent_class = G_OBJECT_CLASS (he_tab_switcher_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TAB_SWITCHER, HeTabSwitcher);
	_tmp0_ = (GtkNotebook*) gtk_notebook_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->notebook);
	self->notebook = _tmp0_;
	_tmp1_ = self->notebook;
	gtk_notebook_set_scrollable (_tmp1_, TRUE);
	_tmp2_ = self->notebook;
	gtk_notebook_set_show_border (_tmp2_, FALSE);
	self->priv->_tab_bar_behavior = HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_ALWAYS;
	_tmp3_ = self->notebook;
	gtk_widget_add_css_class ((GtkWidget*) _tmp3_, "tab-holder");
	_tmp4_ = he_disclosure_button_new_from_icon ("list-add-symbolic");
	g_object_ref_sink (_tmp4_);
	add_button = _tmp4_;
	_tmp5_ = add_button;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp5_, 6);
	_tmp6_ = add_button;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp6_, 6);
	_tmp7_ = add_button;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp7_, 6);
	_tmp8_ = add_button;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _ ("New Tab"));
	_tmp9_ = self->notebook;
	_tmp10_ = add_button;
	gtk_notebook_set_action_widget (_tmp9_, (GtkWidget*) _tmp10_, GTK_PACK_END);
	_tmp11_ = g_menu_new ();
	_tmp12_ = _tmp11_;
	he_tab_switcher_set_menu (self, _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = self->priv->_menu;
	_tmp14_ = (GtkPopoverMenu*) gtk_popover_menu_new_from_model ((GMenuModel*) _tmp13_);
	g_object_ref_sink (_tmp14_);
	_tmp15_ = _tmp14_;
	he_tab_switcher_set_popover (self, _tmp15_);
	_g_object_unref0 (_tmp15_);
	_tmp16_ = g_simple_action_group_new ();
	_tmp17_ = _tmp16_;
	he_tab_switcher_set_actions (self, _tmp17_);
	_g_object_unref0 (_tmp17_);
	_tmp18_ = self->priv->_actions;
	g_action_map_add_action_entries ((GActionMap*) _tmp18_, HE_TAB_SWITCHER_ENTRIES, (gint) G_N_ELEMENTS (HE_TAB_SWITCHER_ENTRIES), self);
	_tmp19_ = self->priv->_actions;
	gtk_widget_insert_action_group ((GtkWidget*) self, "hetabswitcher", (GActionGroup*) _tmp19_);
	_tmp20_ = self->priv->_menu;
	g_menu_append (_tmp20_, "New Tab", "hetabswitcher.action-new-tab");
	_tmp21_ = self->priv->_popover;
	_tmp22_ = self->priv->_menu;
	gtk_popover_menu_set_menu_model (_tmp21_, (GMenuModel*) _tmp22_);
	_tmp23_ = add_button;
	g_signal_connect_object ((GtkButton*) _tmp23_, "clicked", (GCallback) __he_tab_switcher___lambda36__gtk_button_clicked, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) __he_tab_switcher___lambda37__gtk_widget_destroy, self, 0);
	_tmp24_ = self->notebook;
	g_signal_connect_object (_tmp24_, "switch-page", (GCallback) _he_tab_switcher_on_switch_page_gtk_notebook_switch_page, self, 0);
	_tmp25_ = self->notebook;
	g_signal_connect_object (_tmp25_, "page-added", (GCallback) _he_tab_switcher_on_page_added_gtk_notebook_page_added, self, 0);
	_tmp26_ = self->notebook;
	g_signal_connect_object (_tmp26_, "page-removed", (GCallback) _he_tab_switcher_on_page_removed_gtk_notebook_page_removed, self, 0);
	_tmp27_ = self->notebook;
	g_signal_connect_object (_tmp27_, "create-window", (GCallback) _he_tab_switcher_on_create_window_gtk_notebook_create_window, self, 0);
	_tmp28_ = self->notebook;
	gtk_widget_set_parent ((GtkWidget*) _tmp28_, (GtkWidget*) self);
	_tmp29_ = self->notebook;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp29_, TRUE);
	_tmp30_ = self->notebook;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp30_, TRUE);
	_g_object_unref0 (add_button);
	return obj;
}

static void
he_tab_switcher_class_init (HeTabSwitcherClass * klass,
                            gpointer klass_data)
{
	he_tab_switcher_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeTabSwitcher_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_tab_switcher_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_tab_switcher_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_tab_switcher_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_tab_switcher_finalize;
	/**
	     * The number of tabs in the TabSwitcher
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_N_TABS_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_N_TABS_PROPERTY] = g_param_spec_int ("n-tabs", "n-tabs", "n-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	     * The list of tabs in the TabSwitcher
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_TABS_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_TABS_PROPERTY] = g_param_spec_pointer ("tabs", "tabs", "tabs", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	     * The behavior of the tab bar and its visibility
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY] = g_param_spec_enum ("tab-bar-behavior", "tab-bar-behavior", "tab-bar-behavior", HE_TAB_SWITCHER_TYPE_TAB_BAR_BEHAVIOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY] = g_param_spec_boolean ("allow-duplicate-tabs", "allow-duplicate-tabs", "allow-duplicate-tabs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY] = g_param_spec_boolean ("allow-drag", "allow-drag", "allow-drag", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY] = g_param_spec_boolean ("allow-pinning", "allow-pinning", "allow-pinning", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY] = g_param_spec_boolean ("allow-closing", "allow-closing", "allow-closing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY] = g_param_spec_boolean ("allow-new-window", "allow-new-window", "allow-new-window", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The current visible tab
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_CURRENT_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_CURRENT_PROPERTY] = g_param_spec_object ("current", "current", "current", HE_TYPE_TAB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * The menu appearing when the tab bar is clicked on a blank space
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_MENU_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", g_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TAB_SWITCHER_ACTIONS_PROPERTY, he_tab_switcher_properties[HE_TAB_SWITCHER_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_ADDED_SIGNAL] = g_signal_new ("tab-added", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, HE_TYPE_TAB);
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_REMOVED_SIGNAL] = g_signal_new ("tab-removed", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, HE_TYPE_TAB);
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_SWITCHED_SIGNAL] = g_signal_new ("tab-switched", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, HE_TYPE_TAB, HE_TYPE_TAB);
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_MOVED_SIGNAL] = g_signal_new ("tab-moved", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, HE_TYPE_TAB);
	he_tab_switcher_signals[HE_TAB_SWITCHER_TAB_DUPLICATED_SIGNAL] = g_signal_new ("tab-duplicated", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, HE_TYPE_TAB);
	he_tab_switcher_signals[HE_TAB_SWITCHER_NEW_TAB_REQUESTED_SIGNAL] = g_signal_new ("new-tab-requested", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	he_tab_switcher_signals[HE_TAB_SWITCHER_CLOSE_TAB_REQUESTED_SIGNAL] = g_signal_new ("close-tab-requested", HE_TYPE_TAB_SWITCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, HE_TYPE_TAB);
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_box_layout_get_type ());
}

static void
he_tab_switcher_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                              gpointer iface_data)
{
	he_tab_switcher_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
}

static void
he_tab_switcher_instance_init (HeTabSwitcher * self,
                               gpointer klass)
{
	self->priv = he_tab_switcher_get_instance_private (self);
	self->priv->_allow_duplication = FALSE;
	self->priv->_allow_drag = TRUE;
	self->priv->_allow_pin = TRUE;
	self->priv->_allow_close = TRUE;
	self->priv->_allow_window = FALSE;
	self->priv->tab_width = HE_TAB_SWITCHER_MAX_TAB_WIDTH;
}

static void
he_tab_switcher_finalize (GObject * obj)
{
	HeTabSwitcher * self;
	GtkNotebook* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TAB_SWITCHER, HeTabSwitcher);
	_tmp0_ = self->notebook;
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
	_g_object_unref0 (self->notebook);
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
	_g_object_unref0 (self->priv->_menu);
	_g_object_unref0 (self->priv->_popover);
	_g_object_unref0 (self->priv->old_tab);
	_g_object_unref0 (self->priv->_actions);
	G_OBJECT_CLASS (he_tab_switcher_parent_class)->finalize (obj);
}

/**
 * TabBar widget designed for a variable number of tabs.
 */
static GType
he_tab_switcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeTabSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_tab_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeTabSwitcher), 0, (GInstanceInitFunc) he_tab_switcher_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) he_tab_switcher_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType he_tab_switcher_type_id;
	he_tab_switcher_type_id = g_type_register_static (HE_TYPE_BIN, "HeTabSwitcher", &g_define_type_info, 0);
	g_type_add_interface_static (he_tab_switcher_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	HeTabSwitcher_private_offset = g_type_add_instance_private (he_tab_switcher_type_id, sizeof (HeTabSwitcherPrivate));
	return he_tab_switcher_type_id;
}

GType
he_tab_switcher_get_type (void)
{
	static volatile gsize he_tab_switcher_type_id__once = 0;
	if (g_once_init_enter (&he_tab_switcher_type_id__once)) {
		GType he_tab_switcher_type_id;
		he_tab_switcher_type_id = he_tab_switcher_get_type_once ();
		g_once_init_leave (&he_tab_switcher_type_id__once, he_tab_switcher_type_id);
	}
	return he_tab_switcher_type_id__once;
}

static void
_vala_he_tab_switcher_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	HeTabSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB_SWITCHER, HeTabSwitcher);
	switch (property_id) {
		case HE_TAB_SWITCHER_N_TABS_PROPERTY:
		g_value_set_int (value, he_tab_switcher_get_n_tabs (self));
		break;
		case HE_TAB_SWITCHER_TABS_PROPERTY:
		g_value_set_pointer (value, he_tab_switcher_get_tabs (self));
		break;
		case HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY:
		g_value_set_enum (value, he_tab_switcher_get_tab_bar_behavior (self));
		break;
		case HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY:
		g_value_set_boolean (value, he_tab_switcher_get_allow_duplicate_tabs (self));
		break;
		case HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY:
		g_value_set_boolean (value, he_tab_switcher_get_allow_drag (self));
		break;
		case HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY:
		g_value_set_boolean (value, he_tab_switcher_get_allow_pinning (self));
		break;
		case HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY:
		g_value_set_boolean (value, he_tab_switcher_get_allow_closing (self));
		break;
		case HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY:
		g_value_set_boolean (value, he_tab_switcher_get_allow_new_window (self));
		break;
		case HE_TAB_SWITCHER_CURRENT_PROPERTY:
		g_value_set_object (value, he_tab_switcher_get_current (self));
		break;
		case HE_TAB_SWITCHER_MENU_PROPERTY:
		g_value_set_object (value, he_tab_switcher_get_menu (self));
		break;
		case HE_TAB_SWITCHER_ACTIONS_PROPERTY:
		g_value_set_object (value, he_tab_switcher_get_actions (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_tab_switcher_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	HeTabSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TAB_SWITCHER, HeTabSwitcher);
	switch (property_id) {
		case HE_TAB_SWITCHER_TAB_BAR_BEHAVIOR_PROPERTY:
		he_tab_switcher_set_tab_bar_behavior (self, g_value_get_enum (value));
		break;
		case HE_TAB_SWITCHER_ALLOW_DUPLICATE_TABS_PROPERTY:
		he_tab_switcher_set_allow_duplicate_tabs (self, g_value_get_boolean (value));
		break;
		case HE_TAB_SWITCHER_ALLOW_DRAG_PROPERTY:
		he_tab_switcher_set_allow_drag (self, g_value_get_boolean (value));
		break;
		case HE_TAB_SWITCHER_ALLOW_PINNING_PROPERTY:
		he_tab_switcher_set_allow_pinning (self, g_value_get_boolean (value));
		break;
		case HE_TAB_SWITCHER_ALLOW_CLOSING_PROPERTY:
		he_tab_switcher_set_allow_closing (self, g_value_get_boolean (value));
		break;
		case HE_TAB_SWITCHER_ALLOW_NEW_WINDOW_PROPERTY:
		he_tab_switcher_set_allow_new_window (self, g_value_get_boolean (value));
		break;
		case HE_TAB_SWITCHER_CURRENT_PROPERTY:
		he_tab_switcher_set_current (self, g_value_get_object (value));
		break;
		case HE_TAB_SWITCHER_MENU_PROPERTY:
		he_tab_switcher_set_menu (self, g_value_get_object (value));
		break;
		case HE_TAB_SWITCHER_ACTIONS_PROPERTY:
		he_tab_switcher_set_actions (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

