/* Toast.c generated by valac 0.56.13, the Vala compiler
 * generated from Toast.vala, do not modify */

/*
* Copyright (c) 2022 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "libhelium-1.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

enum  {
	HE_TOAST_0_PROPERTY,
	HE_TOAST_LABEL_PROPERTY,
	HE_TOAST_DEFAULT_ACTION_PROPERTY,
	HE_TOAST_NUM_PROPERTIES
};
static GParamSpec* he_toast_properties[HE_TOAST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	HE_TOAST_CLOSED_SIGNAL,
	HE_TOAST_ACTION_SIGNAL,
	HE_TOAST_NUM_SIGNALS
};
static guint he_toast_signals[HE_TOAST_NUM_SIGNALS] = {0};

struct _HeToastPrivate {
	GtkRevealer* revealer;
	GtkLabel* notification_label;
	GtkButton* default_action_button;
	guint timeout_id;
	gchar* _label;
	gchar* _default_action;
};

static gint HeToast_private_offset;
static gpointer he_toast_parent_class = NULL;

static void he_toast_start_timeout (HeToast* self);
static gboolean __lambda51_ (HeToast* self);
static gboolean ___lambda51__gsource_func (gpointer self);
static void he_toast_stop_timeout (HeToast* self);
static GObject * he_toast_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
static void _he_toast___lambda52_ (HeToast* self);
static void __he_toast___lambda52__gtk_button_clicked (GtkButton* _sender,
                                                gpointer self);
static void _he_toast___lambda53_ (HeToast* self);
static void __he_toast___lambda53__gtk_button_clicked (GtkButton* _sender,
                                                gpointer self);
static void _he_toast___lambda54_ (HeToast* self);
static void __he_toast___lambda54__gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self);
static void _he_toast___lambda55_ (HeToast* self);
static void __he_toast___lambda55__gtk_event_controller_motion_leave (GtkEventControllerMotion* _sender,
                                                               gpointer self);
static void he_toast_finalize (GObject * obj);
static GType he_toast_get_type_once (void);
static void _vala_he_toast_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_he_toast_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
he_toast_get_instance_private (HeToast* self)
{
	return G_STRUCT_MEMBER_P (self, HeToast_private_offset);
}

const gchar*
he_toast_get_label (HeToast* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label;
	result = _tmp0_;
	return result;
}

void
he_toast_set_label (HeToast* self,
                    const gchar* value)
{
	GtkLabel* _tmp0_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->notification_label;
	if (_tmp0_ != NULL) {
		GtkLabel* _tmp1_;
		_tmp1_ = self->priv->notification_label;
		gtk_label_set_label (_tmp1_, value);
	}
	_tmp2_ = g_strdup (value);
	_g_free0 (self->priv->_label);
	self->priv->_label = _tmp2_;
	g_object_notify_by_pspec ((GObject *) self, he_toast_properties[HE_TOAST_LABEL_PROPERTY]);
}

const gchar*
he_toast_get_default_action (HeToast* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_action;
	result = _tmp0_;
	return result;
}

void
he_toast_set_default_action (HeToast* self,
                             const gchar* value)
{
	gboolean _tmp0_ = FALSE;
	GtkButton* _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, "") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = value == NULL;
	}
	if (_tmp0_) {
		GtkButton* _tmp1_;
		_tmp1_ = self->priv->default_action_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
	} else {
		GtkButton* _tmp2_;
		_tmp2_ = self->priv->default_action_button;
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	}
	_tmp3_ = self->priv->default_action_button;
	gtk_button_set_label (_tmp3_, value);
	_tmp4_ = g_strdup (value);
	_g_free0 (self->priv->_default_action);
	self->priv->_default_action = _tmp4_;
	g_object_notify_by_pspec ((GObject *) self, he_toast_properties[HE_TOAST_DEFAULT_ACTION_PROPERTY]);
}

/**
     * Creates a new Toast.
     * @param label The title of the Toast
     */
HeToast*
he_toast_construct (GType object_type,
                    const gchar* label)
{
	HeToast * self = NULL;
	g_return_val_if_fail (label != NULL, NULL);
	self = (HeToast*) g_object_new (object_type, "label", label, NULL);
	return self;
}

HeToast*
he_toast_new (const gchar* label)
{
	return he_toast_construct (HE_TYPE_TOAST, label);
}

static gboolean
__lambda51_ (HeToast* self)
{
	GtkRevealer* _tmp0_;
	gboolean result;
	_tmp0_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
	gtk_widget_set_visible ((GtkWidget*) self, FALSE);
	self->priv->timeout_id = (guint) 0;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda51__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda51_ ((HeToast*) self);
	return result;
}

static void
he_toast_start_timeout (HeToast* self)
{
	guint duration = 0U;
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->default_action_button;
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		duration = (guint) 3500;
	} else {
		duration = (guint) 2000;
	}
	self->priv->timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, duration, ___lambda51__gsource_func, g_object_ref (self), g_object_unref);
}

static void
he_toast_stop_timeout (HeToast* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->timeout_id != ((guint) 0)) {
		g_source_remove (self->priv->timeout_id);
		self->priv->timeout_id = (guint) 0;
	}
}

/**
     * Shows the Toast.
     *
     * @since 1.0
     */
void
he_toast_send_notification (HeToast* self)
{
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->revealer;
	_tmp1_ = gtk_revealer_get_child_revealed (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		GtkRevealer* _tmp3_;
		_tmp3_ = self->priv->revealer;
		gtk_revealer_set_reveal_child (_tmp3_, TRUE);
		gtk_widget_set_visible ((GtkWidget*) self, TRUE);
	}
	he_toast_stop_timeout (self);
	he_toast_start_timeout (self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_he_toast___lambda52_ (HeToast* self)
{
	GtkRevealer* _tmp0_;
	_tmp0_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
	gtk_widget_set_visible ((GtkWidget*) self, FALSE);
	he_toast_stop_timeout (self);
	g_signal_emit (self, he_toast_signals[HE_TOAST_CLOSED_SIGNAL], 0);
}

static void
__he_toast___lambda52__gtk_button_clicked (GtkButton* _sender,
                                           gpointer self)
{
	_he_toast___lambda52_ ((HeToast*) self);
}

static void
_he_toast___lambda53_ (HeToast* self)
{
	GtkRevealer* _tmp0_;
	_tmp0_ = self->priv->revealer;
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
	gtk_widget_set_visible ((GtkWidget*) self, FALSE);
	he_toast_stop_timeout (self);
	g_signal_emit (self, he_toast_signals[HE_TOAST_ACTION_SIGNAL], 0);
}

static void
__he_toast___lambda53__gtk_button_clicked (GtkButton* _sender,
                                           gpointer self)
{
	_he_toast___lambda53_ ((HeToast*) self);
}

static void
_he_toast___lambda54_ (HeToast* self)
{
	he_toast_stop_timeout (self);
}

static void
__he_toast___lambda54__gtk_event_controller_motion_enter (GtkEventControllerMotion* _sender,
                                                          gdouble x,
                                                          gdouble y,
                                                          gpointer self)
{
	_he_toast___lambda54_ ((HeToast*) self);
}

static void
_he_toast___lambda55_ (HeToast* self)
{
	he_toast_start_timeout (self);
}

static void
__he_toast___lambda55__gtk_event_controller_motion_leave (GtkEventControllerMotion* _sender,
                                                          gpointer self)
{
	_he_toast___lambda55_ ((HeToast*) self);
}

static GObject *
he_toast_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HeToast * self;
	HeFillButton* _tmp0_ = NULL;
	GtkButton* close_button = NULL;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkLabel* _tmp7_ = NULL;
	GtkLabel* _tmp8_;
	GtkBox* box = NULL;
	GtkBox* _tmp9_;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkLabel* _tmp12_;
	GtkBox* _tmp13_;
	GtkButton* _tmp14_;
	GtkBox* _tmp15_;
	GtkButton* _tmp16_;
	GtkEventControllerMotion* motion_controller = NULL;
	GtkEventControllerMotion* _tmp17_;
	GtkBox* _tmp18_;
	GtkWidget* _tmp19_;
	GtkRevealer* _tmp20_ = NULL;
	GtkRevealer* _tmp21_;
	GtkEventControllerMotion* _tmp22_;
	GtkEventController* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkEventControllerMotion* _tmp26_;
	GtkEventControllerMotion* _tmp27_;
	parent_class = G_OBJECT_CLASS (he_toast_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TOAST, HeToast);
	gtk_widget_add_css_class ((GtkWidget*) self, "toast-box");
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_START);
	gtk_widget_set_visible ((GtkWidget*) self, FALSE);
	_tmp0_ = he_fill_button_new ("");
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->default_action_button);
	self->priv->default_action_button = (GtkButton*) _tmp0_;
	_tmp1_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close-symbolic");
	g_object_ref_sink (_tmp1_);
	close_button = _tmp1_;
	_tmp2_ = close_button;
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
	_tmp3_ = close_button;
	gtk_widget_add_css_class ((GtkWidget*) _tmp3_, "flat");
	_tmp4_ = close_button;
	gtk_widget_add_css_class ((GtkWidget*) _tmp4_, "circular");
	_tmp5_ = he_toast_get_label (self);
	_tmp6_ = _tmp5_;
	_tmp7_ = (GtkLabel*) gtk_label_new (_tmp6_);
	gtk_label_set_wrap (_tmp7_, TRUE);
	gtk_label_set_wrap_mode (_tmp7_, PANGO_WRAP_WORD);
	gtk_label_set_xalign (_tmp7_, (gfloat) 0);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, TRUE);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->notification_label);
	self->priv->notification_label = _tmp7_;
	_tmp8_ = self->priv->notification_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "flat");
	_tmp9_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
	g_object_ref_sink (_tmp9_);
	box = _tmp9_;
	_tmp10_ = box;
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
	_tmp11_ = box;
	_tmp12_ = self->priv->notification_label;
	gtk_box_append (_tmp11_, (GtkWidget*) _tmp12_);
	_tmp13_ = box;
	_tmp14_ = self->priv->default_action_button;
	gtk_box_append (_tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = box;
	_tmp16_ = close_button;
	gtk_box_append (_tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ();
	motion_controller = _tmp17_;
	_tmp18_ = box;
	_tmp19_ = _g_object_ref0 ((GtkWidget*) _tmp18_);
	_tmp20_ = (GtkRevealer*) gtk_revealer_new ();
	gtk_revealer_set_child (_tmp20_, _tmp19_);
	_g_object_unref0 (_tmp19_);
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->revealer);
	self->priv->revealer = _tmp20_;
	_tmp21_ = self->priv->revealer;
	gtk_widget_set_parent ((GtkWidget*) _tmp21_, (GtkWidget*) self);
	_tmp22_ = motion_controller;
	_tmp23_ = _g_object_ref0 ((GtkEventController*) _tmp22_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp23_);
	_tmp24_ = close_button;
	g_signal_connect_object (_tmp24_, "clicked", (GCallback) __he_toast___lambda52__gtk_button_clicked, self, 0);
	_tmp25_ = self->priv->default_action_button;
	g_signal_connect_object (_tmp25_, "clicked", (GCallback) __he_toast___lambda53__gtk_button_clicked, self, 0);
	_tmp26_ = motion_controller;
	g_signal_connect_object (_tmp26_, "enter", (GCallback) __he_toast___lambda54__gtk_event_controller_motion_enter, self, 0);
	_tmp27_ = motion_controller;
	g_signal_connect_object (_tmp27_, "leave", (GCallback) __he_toast___lambda55__gtk_event_controller_motion_leave, self, 0);
	_g_object_unref0 (motion_controller);
	_g_object_unref0 (box);
	_g_object_unref0 (close_button);
	return obj;
}

static void
he_toast_class_init (HeToastClass * klass,
                     gpointer klass_data)
{
	he_toast_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HeToast_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_he_toast_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_he_toast_set_property;
	G_OBJECT_CLASS (klass)->constructor = he_toast_constructor;
	G_OBJECT_CLASS (klass)->finalize = he_toast_finalize;
	/**
	     * The notification text label to be displayed inside of #this
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TOAST_LABEL_PROPERTY, he_toast_properties[HE_TOAST_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HE_TOAST_DEFAULT_ACTION_PROPERTY, he_toast_properties[HE_TOAST_DEFAULT_ACTION_PROPERTY] = g_param_spec_string ("default-action", "default-action", "default-action", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Emitted when the Toast is closed by activating the close button
	     */
	he_toast_signals[HE_TOAST_CLOSED_SIGNAL] = g_signal_new ("closed", HE_TYPE_TOAST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	     * Emitted when the default action button is activated
	     */
	he_toast_signals[HE_TOAST_ACTION_SIGNAL] = g_signal_new ("action", HE_TYPE_TOAST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gtk_widget_class_set_layout_manager_type (GTK_WIDGET_CLASS (klass), gtk_bin_layout_get_type ());
}

static void
he_toast_instance_init (HeToast * self,
                        gpointer klass)
{
	self->priv = he_toast_get_instance_private (self);
}

static void
he_toast_finalize (GObject * obj)
{
	HeToast * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HE_TYPE_TOAST, HeToast);
	_g_object_unref0 (self->priv->revealer);
	_g_object_unref0 (self->priv->notification_label);
	_g_object_unref0 (self->priv->default_action_button);
	_g_free0 (self->priv->_label);
	_g_free0 (self->priv->_default_action);
	G_OBJECT_CLASS (he_toast_parent_class)->finalize (obj);
}

/**
 * A Toast is a widget containing a quick little message for the user with an optional action button.
 */
static GType
he_toast_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HeToastClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) he_toast_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HeToast), 0, (GInstanceInitFunc) he_toast_instance_init, NULL };
	GType he_toast_type_id;
	he_toast_type_id = g_type_register_static (HE_TYPE_BIN, "HeToast", &g_define_type_info, 0);
	HeToast_private_offset = g_type_add_instance_private (he_toast_type_id, sizeof (HeToastPrivate));
	return he_toast_type_id;
}

GType
he_toast_get_type (void)
{
	static volatile gsize he_toast_type_id__once = 0;
	if (g_once_init_enter (&he_toast_type_id__once)) {
		GType he_toast_type_id;
		he_toast_type_id = he_toast_get_type_once ();
		g_once_init_leave (&he_toast_type_id__once, he_toast_type_id);
	}
	return he_toast_type_id__once;
}

static void
_vala_he_toast_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	HeToast * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TOAST, HeToast);
	switch (property_id) {
		case HE_TOAST_LABEL_PROPERTY:
		g_value_set_string (value, he_toast_get_label (self));
		break;
		case HE_TOAST_DEFAULT_ACTION_PROPERTY:
		g_value_set_string (value, he_toast_get_default_action (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_he_toast_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	HeToast * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, HE_TYPE_TOAST, HeToast);
	switch (property_id) {
		case HE_TOAST_LABEL_PROPERTY:
		he_toast_set_label (self, g_value_get_string (value));
		break;
		case HE_TOAST_DEFAULT_ACTION_PROPERTY:
		he_toast_set_default_action (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

